Package: compcodeR
Type: Package
Title: RNAseq data simulation, differential expression analysis and
        performance comparison of differential expression methods
Version: 1.49.0
Authors@R: c(
    person("Charlotte", "Soneson", role = c("aut", "cre"), 
           email = "charlottesoneson@gmail.com", comment = c(ORCID = "0000-0003-3833-2169")),
    person("Paul", "Bastide", role = "aut",
           email = "paul.bastide@umontpellier.fr", comment = c(ORCID = "0000-0002-8084-9893")),
    person("Mélina", "Gallopin", role = "aut",
           email = "melina.gallopin@u-psud.fr", comment = c(ORCID = "0000-0002-2431-7825 "))
           )
Description: This package provides extensive functionality for
    comparing results obtained by different methods for
    differential expression analysis of RNAseq data. It also
    contains functions for simulating count data. Finally, it provides 
    convenient interfaces to several packages for performing the 
    differential expression analysis. These can also be used as templates
    for setting up and running a user-defined differential analysis 
    workflow within the framework of the package.
Depends: R (>= 4.0), sm
Imports: knitr (>= 1.2), markdown, ROCR, lattice (>= 0.16), gplots,
        gtools, caTools, grid, KernSmooth, MASS, ggplot2, stringr,
        modeest, edgeR, limma, vioplot, methods, stats, utils, ape,
        phylolm, matrixStats, grDevices, graphics, rmarkdown, shiny,
        shinydashboard
Suggests: BiocStyle, EBSeq, DESeq2 (>= 1.1.31), genefilter, NOISeq,
        TCC, NBPSeq (>= 0.3.0), phytools, phangorn, testthat, ggtree,
        tidytree, statmod, covr, sva, tcltk
Enhances: rpanel, DSS
License: GPL (>= 2)
VignetteBuilder: knitr
biocViews: ImmunoOncology, RNASeq, DifferentialExpression
RoxygenNote: 7.2.3
URL: https://github.com/csoneson/compcodeR
BugReports: https://github.com/csoneson/compcodeR/issues
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/compcodeR
git_branch: devel
git_last_commit: 734da12
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:57:51 UTC; biocbuild
Author: Charlotte Soneson [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-3833-2169>),
  Paul Bastide [aut] (ORCID: <https://orcid.org/0000-0002-8084-9893>),
  Mélina Gallopin [aut] (ORCID: <https://orcid.org/0000-0002-2431-7825>)
Maintainer: Charlotte Soneson <charlottesoneson@gmail.com>

#' @title Get the tree from a phyloCompData object
#'
#' @description
#' Return the tree of a \code{phyloCompData} object.
#' If no tree, return a star tree with unit height, and throw a warning.
#' 
#' @param cdata a phyloCompData object.
#' 
#' @return A tree of class \code{phylo}
#' 
#' @keywords internal
#' 
getTree <- function(cdata) {
  if (is.null(phylo.tree(cdata)) || length(phylo.tree(cdata)) == 0) {
    message("There were no tree in the data object. Using a star tree of unit height in phylolm.")
    ntaxa <- info.parameters(cdata)$samples.per.cond * 2
    tree <- ape::stree(ntaxa, "star")
    tree$edge.length <- rep(1, nrow(tree$edge))
    tree$tip.label <- rownames(sample.annotations(cdata))
    return(tree)
  } else {
    tree <- phylo.tree(cdata)
    if (!ape::is.ultrametric(tree)) stop("The tree must be ultrametric.")
    return(tree)
  }
}

#' @title Extract phylolm results
#'
#' @description
#' Extract results from a phylolm object.
#' The coefficient of interest must be named "condition".
#' 
#' @param phylo_lm_obj a phylolm object.
#' 
#' @return A list, with:
#' \describe{
#' \item{pvalue}{the p value of the differential expression.}
#' \item{logFC}{the log fold change of the differential expression.}
#' \item{score}{1 - pvalue.}
#' }
#' 
#' @keywords internal
#' 
extract_results_phylolm <- function(phylo_lm_obj) {
  res <- as.data.frame(summary(phylo_lm_obj)$coefficients)
  result.table <- data.frame('pvalue' = res['condition2', 'p.value'],
                             'logFC' = res['condition2', 'Estimate'],
                             'score' = 1 - res['condition2', 'p.value'])
  return(result.table)
}

#' @title Perform the phylolm analysis
#'
#' @description
#' Perform the phylolm analysis for a given gene.
#' 
#' @param dat the data associated with a gene
#' @param design_data design matrix
#' @param design_formula design formula
#' @param tree phylogenetic tree
#' @param model the model to be used in phylolm
#' @param measurement_error boolean
#' 
#' @return A list, with:
#' \describe{
#' \item{pvalue}{the p value of the differential expression.}
#' \item{logFC}{the log fold change of the differential expression.}
#' \item{score}{1 - pvalue.}
#' }
#' 
#' @keywords internal
#' 
phylolm_analysis <- function(dat, design_data, design_formula, tree, model, measurement_error, ...) {
  data_reg <- design_data
  data_reg$expr <- dat
  levels(data_reg$condition) <- c(1, 2)
  res <- try(extract_results_phylolm(phylolm::phylolm(paste('expr', paste(as.character(design_formula), collapse = '')),
                                                      data = data_reg,
                                                      phy = tree,
                                                      model = model,
                                                      measurement_error = measurement_error, 
                                                      ...)))
  if (inherits(res, 'try-error')) {
    if (model == 'BM' && measurement_error) {
      res <- try(extract_results_phylolm(phylolm::phylolm(paste('expr', paste(as.character(design_formula), collapse = '')),
                                                          data = data_reg,
                                                          phy = tree,
                                                          model = 'lambda',
                                                          measurement_error = FALSE, 
                                                          ...)))
    }
  }
  if (inherits(res, 'try-error')) {
    res <- data.frame('pvalue' = 1.0,
                      'logFC' = 0.0,
                      'score' = 0.0)
    warning(paste0('A gene produced an error.'))
  }
  return(res)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with \code{\link[phylolm]{phylolm}}.
#' 
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the phylolm package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#' 
#' For more information about the methods and the interpretation of the parameters, see the \code{\link[phylolm]{phylolm}} package and the corresponding publications. 
#' 
#' @param data.path The path to a .rds file containing the \code{phyloCompData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} of the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}
#' @param model The model for trait evolution on the tree. Default to "BM".
#' @param measurement_error A logical value indicating whether there is measurement error. Default to TRUE.
#' @param extra.design.covariates A vector containing the names of extra control variables to be passed to the design matrix of \code{phyolm}. All the covariates need to be a column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object, with a matching column name. The covariates can be a numeric vector, or a factor. Note that "condition" factor column is always included, and should not be added here. See Details.
#' @param length.normalization one of "none" (no correction), "TPM" or "RPKM" (default). See details.
#' @param data.transformation one of "log2", "asin(sqrt)" or "sqrt". Data transformation to apply to the normalized data.
#' @param ... Further arguments to be passed to function \code{\link[phylolm]{phylolm}}.
#' 
#' @details 
#' The \code{length.matrix} field of the \code{phyloCompData} object 
#' is used to normalize the counts, using one of the following formulas:
#' * \code{length.normalization="none"} : \eqn{CPM_{gi} = \frac{N_{gi} + 0.5}{NF_i \times \sum_{g} N_{gi} + 1} \times 10^6}
#' * \code{length.normalization="TPM"} : \eqn{TPM_{gi} = \frac{(N_{gi} + 0.5) / L_{gi}}{NF_i \times \sum_{g} N_{gi}/L_{gi} + 1} \times 10^6}
#' * \code{length.normalization="RPKM"} : \eqn{RPKM_{gi} = \frac{(N_{gi} + 0.5) / L_{gi}}{NF_i \times \sum_{g} N_{gi} + 1} \times 10^9}
#' 
#' where \eqn{N_{gi}} is the count for gene g and sample i,
#' where \eqn{L_{gi}} is the length of gene g in sample i,
#' and \eqn{NF_i} is the normalization for sample i,
#' normalized using \code{calcNormFactors} of the \code{edgeR} package.
#' 
#' The function specified by the \code{data.transformation} is then applied
#' to the normalized count matrix.
#' 
#' The "\eqn{+0.5}" and "\eqn{+1}" are taken from Law et al 2014,
#' and dropped from the normalization 
#' when the transformation is something else than \code{log2}.
#' 
#' The "\eqn{\times 10^6}" and "\eqn{\times 10^9}" factors are omitted when
#' the \code{asin(sqrt)} transformation is taken, as \eqn{asin} can only
#' be applied to real numbers smaller than 1.
#' 
#' The \code{design} model used in the \code{\link[phylolm]{phylolm}}
#' uses the "condition" column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object
#' as well as all the covariates named in \code{extra.design.covariates}.
#' For example, if \code{extra.design.covariates = c("var1", "var2")}, then
#' \code{sample.annotations} must have two columns named "var1" and "var2", and the design formula
#' in the \code{\link[phylolm]{phylolm}} function will be:
#' \code{~ condition + var1 + var2}.
#' 
#' @export 
#' @author Charlotte Soneson, Paul Bastide, Mélina Gallopin
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references 
#' Ho, L. S. T. and Ane, C. 2014. "A linear-time algorithm for Gaussian and non-Gaussian trait evolution models". Systematic Biology 63(3):397-408.
#' 
#' Law, C.W., Chen, Y., Shi, W. et al. (2014) voom: precision weights unlock linear model analysis tools for RNA-seq read counts. Genome Biol 15, R29.
#'
#' Musser, JM, Wagner, GP. (2015): Character trees from transcriptome data: Origin and individuation of morphological characters and the so‐called “species signal”. J. Exp. Zool. (Mol. Dev. Evol.) 324B: 588– 604.
#' 
#' @examples
#' try(
#' if (require(ape) && require(phylolm)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' set.seed(20200317)
#' tree <- rphylo(10, 0.1, 0)
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                     samples.per.cond = 5, n.diffexp = 100, 
#'                                     tree = tree,
#'                                     id.species = 1:10,
#'                                     lengths.relmeans = rpois(1000, 1000),
#'                                     lengths.dispersions = rgamma(1000, 1, 1),
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' ## Add covariates
#' ## Model fitted is count.matrix ~ condition + test_factor + test_reg
#' sample.annotations(mydata.obj)$test_factor <- factor(rep(1:2, each = 5))
#' sample.annotations(mydata.obj)$test_reg <- rnorm(10, 0, 1)
#' saveRDS(mydata.obj, file.path(tmpdir, "mydata.rds"))
#' ## Diff Exp
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "DESeq2", 
#'            Rmdfunction = "phylolm.createRmd", 
#'            output.directory = tmpdir,
#'            norm.method = "TMM",
#'            extra.design.covariates = c("test_factor", "test_reg"),
#'            length.normalization = "RPKM")
#' })
phylolm.createRmd <- function(data.path, result.path, codefile, 
                              norm.method,
                              model = "BM", measurement_error = TRUE,
                              extra.design.covariates = NULL,
                              length.normalization = "RPKM",
                              data.transformation = "log2",
                              ...) {
  codefile <- file(codefile, open = 'w')
  writeLines("### phylolm", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = TRUE, error = TRUE, warning = TRUE}", 
               "require(phylolm)", 
               "require(limma)", 
               "require(edgeR)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTophyloCompData(cdata)", codefile)
  }
  
  writeLines(c("is.valid <- check_phyloCompData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid phyloCompData object.')"),
             codefile)
  ## Design for normalization
  writeLines(c("", "# Design"),codefile)
  if (is.null(extra.design.covariates)) {
    writeLines(c(
      "design_formula <- as.formula(~ condition)",
      "design_data <- sample.annotations(cdata)[, 'condition', drop = FALSE]"),
      codefile)
  } else {
    writeLines(c(
      paste0("design_formula <- as.formula(paste(' ~ ', paste(c('", paste(extra.design.covariates, collapse = "', '"), "'), collapse= '+'), '+ condition'))"),
      paste0("design_data <- sample.annotations(cdata)[, c('", paste(extra.design.covariates, collapse = "', '"), "', 'condition'), drop = FALSE]")),
      codefile)
  }
  writeLines(c(
    "design_data$condition <- factor(design_data$condition)",
    "design <- model.matrix(design_formula, design_data)"),
    codefile)
  writeNormalization(norm.method, length.normalization, data.transformation, codefile)
  ## Functions to apply phylolm
  writeLines(c("", "# Wrapper functions"),codefile)
  ff <- deparse(extract_results_phylolm)
  ff[1] <- paste0("extract_results_phylolm <- ", ff[1])
  writeLines(ff, codefile)
  ff <- deparse(phylolm_analysis)
  ff[1] <- paste0("phylolm_analysis <- ", ff[1])
  writeLines(ff, codefile)
  ## Apply analysis
  writeLines(c("", "# Analysis"),codefile)
  extra_args <- eval(substitute(alist(...)))
  extra_args <- sapply(extra_args, function(x) paste(" = ", x))
  extra_args <- paste(names(extra_args), extra_args, collapse = ", ")
  writeLines(c("tree <- getTree(cdata)"),codefile)
  writeLines(c(
    paste0("phylolm.results_list <- apply(data.trans, 1, phylolm_analysis, design_data = design_data, design_formula = design_formula, tree = tree, model = '", model, "', measurement_error = ", measurement_error, ", ", extra_args, ")"),
    "result.table <- do.call(rbind, phylolm.results_list)"),
    codefile)
  writeLines(c(
    "result.table$adjpvalue <- p.adjust(result.table$pvalue, 'BH')"),
    codefile)
  writeLines(c("", "# Save the results"),codefile)
  writeLines(c(
    "rownames(result.table) <- rownames(count.matrix(cdata))",
    "result.table(cdata) <- result.table", 
    "package.version(cdata) <- paste('phylolm,', packageVersion('phylolm'))",
    "package.version(cdata) <- paste('limma,', packageVersion('limma'))",
    "analysis.date(cdata) <- date()",
    paste("method.names(cdata) <- list('short.name' = 'phylolm', 'full.name' = '",
          paste('phylolm', packageVersion('limma'), packageVersion('phylolm'), '.', norm.method, '.',
                model, '.',
                ifelse(!is.null(measurement_error), 'me', 'nome'), '.',
                "lengthNorm.", length.normalization, '.',
                "dataTrans.", data.transformation,
                ifelse(!is.null(extra.design.covariates), paste0(".", paste(extra.design.covariates, collapse = ".")), ""),
                sep = ''),
          "')", sep = ''),
    "is.valid <- check_compData_results(cdata)",
    "if (!(is.valid == TRUE)) stop('Not a valid phyloCompData result object.')",
    paste("saveRDS(cdata, '", result.path, "')", sep = "")),
    codefile)  
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to normalize data.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} of the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}
#' @param length.normalization one of "none" (no correction), "TPM", "RPKM" (default). See details.
#' @param data.transformation one of "log2", "asin(sqrt)" or "sqrt." Data transformation to apply to the normalized data.
#' @param codefile 
#' 
#' @details 
#' The \code{length.matrix} field of the \code{phyloCompData}
#' object is used to normalize the counts. 
#' \describe{
#' \item{\code{none}:}{No length normalization.}
#' \item{\code{TPM}:}{The raw counts are divided by the length of their associated genes before normalization by \code{voom}.}
#' \item{\code{RPKM}:}{The log2 length is substracted to the log2 CPM computed by \code{voom} for each gene and sample.}
#' }
#' 
#' @keywords internal
#' 
writeNormalization <- function(norm.method, length.normalization, data.transformation, codefile) {
  writeLines(c("", "# Normalisation"),codefile)
  length.normalization <- match.arg(length.normalization, c("RPKM", "TPM", "none"))
  data.transformation <- match.arg(data.transformation, c("log2", "asin(sqrt)", "sqrt"))
  if (length.normalization == "none") {
    writeLines(c(paste("nf <- edgeR::calcNormFactors(count.matrix(cdata), method = '", norm.method, "')", sep = ''),
                 "lib.size <- colSums(count.matrix(cdata)) * nf"),
               codefile)
    if (data.transformation == "log2") {
      writeLines("data.norm <- sweep(count.matrix(cdata) + 0.5, 2, lib.size + 1, '/')", codefile)
    } else {
      writeLines("data.norm <- sweep(count.matrix(cdata), 2, lib.size, '/')", codefile)
    }
    if (data.transformation != "asin(sqrt)") writeLines("data.norm <- data.norm * 1e6", codefile)
  } else if (length.normalization == "TPM") {
    writeLines(c(paste("nf <- edgeR::calcNormFactors(count.matrix(cdata) / length.matrix(cdata), method = '", norm.method, "')", sep = ''),
                 "lib.size <- colSums(count.matrix(cdata) / length.matrix(cdata)) * nf"),
               codefile)
    if (data.transformation == "log2") {
      writeLines("data.norm <- sweep((count.matrix(cdata) + 0.5) / length.matrix(cdata), 2, lib.size + 1, '/')", codefile)
    } else {
      writeLines("data.norm <- sweep((count.matrix(cdata)) / length.matrix(cdata), 2, lib.size, '/')", codefile)
    }
    if (data.transformation != "asin(sqrt)") writeLines("data.norm <- data.norm * 1e6", codefile)
  } else if (length.normalization == "RPKM") {
    writeLines(c(paste("nf <- edgeR::calcNormFactors(count.matrix(cdata), method = '", norm.method, "')", sep = ''),
                 "lib.size <- colSums(count.matrix(cdata)) * nf"),
               codefile)
    if (data.transformation == "log2") {
      writeLines("data.norm <- sweep((count.matrix(cdata) + 0.5) / length.matrix(cdata), 2, lib.size + 1, '/')", codefile)
    } else {
      writeLines("data.norm <- sweep((count.matrix(cdata)) / length.matrix(cdata), 2, lib.size, '/')", codefile)
    }
    if (data.transformation != "asin(sqrt)") writeLines("data.norm <- data.norm * 1e9", codefile)
  }
  writeLines(c("", "# Transformation"),codefile)
  if (data.transformation == "log2") {
    writeLines("data.trans <- log2(data.norm)", codefile)
  } else if (data.transformation == "asin(sqrt)") {
    writeLines("data.trans <- asin(sqrt(data.norm))", codefile)
  } else if (data.transformation == "sqrt") {
    writeLines("data.trans <- sqrt(data.norm)", codefile)
  }
  writeLines("rownames(data.trans) <- rownames(count.matrix(cdata))", codefile)
}

#' List available *.createRmd functions
#'
#' Print a list of all \code{*.createRmd} functions that are available in the search path. These functions can be used together with the \code{\link{runDiffExp}} function to perform differential expression analysis. Consult the help pages for the respective functions for more information.
#' @export
#' @author Charlotte Soneson
#' @examples
#' listcreateRmd()
#'
#' @importFrom stats cor hclust as.dist runif rexp median loess predict na.omit rnbinom rpois rnorm sd lm pf pt qf qt
#' @importFrom grDevices heat.colors
#' @importFrom graphics par lines legend title axis
#'
listcreateRmd <- function() {
  s <- unlist(lapply(search(), ls, all.names = TRUE))
  print(unname(s[grep("\\.createRmd$", s)]))
}

#' Generate a .Rmd file containing code to perform differential expression analysis with EBSeq
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the \code{EBSeq} package. The code is written to a .Rmd file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the meaning of the parameters, see the \code{EBSeq} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"median"} and \code{"quantile"}.
#' @references
#' Leng N, Dawson JA, Thomson JA, Ruotti V, Rissman AI, Smits BMG, Haag JD, Gould MN, Stewart RM and Kendziorski C (2013): EBSeq: An empirical Bayes hierarchical model for inference in RNA-seq experiments. Bioinformatics
#' @author Charlotte Soneson
#' @return The function generates a .Rmd file containing the differential expression code. This file can be executed using e.g. the \code{knitr} package.
#' @export
#' @examples
#' try(
#' if (require(EBSeq)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "EBSeq",
#'            Rmdfunction = "EBSeq.createRmd",
#'            output.directory = tmpdir, norm.method = "median")
#' }
#' )
#' @importFrom utils packageVersion
EBSeq.createRmd <- function(data.path, result.path, codefile,
                            norm.method) {
  codefile <- file(codefile, open = 'w')
  writeLines("### EBSeq", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = TRUE, error = TRUE, warning = TRUE}",
               "require(EBSeq)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')"),
             codefile)
  if (norm.method == "median") {
    writeLines("sizes <- MedianNorm(count.matrix(cdata))", codefile)
  } else if (norm.method == "quantile") {
    writeLines("sizes <- QuantileNorm(count.matrix(cdata), .75)", codefile)
  }
  writeLines(c("EBSeq.test <- EBTest(Data = count.matrix(cdata), Conditions = factor(sample.annotations(cdata)$condition), sizeFactors = sizes, maxround = 10)",
               "EBSeq.ppmat <- GetPPMat(EBSeq.test)",
               "EBSeq.posteriors.DE <- EBSeq.ppmat[, 'PPDE']",
               "EBSeq.lfdr <- 1 - EBSeq.ppmat[, 'PPDE']",
               "EBSeq.FDR <- rep(NA, length(EBSeq.lfdr))",
               "for (l in 1:length(EBSeq.FDR)) {",
               "EBSeq.FDR[l] <- mean(EBSeq.lfdr[which(EBSeq.lfdr <= EBSeq.lfdr[l])])",
               "}"), codefile)
  writeLines(c("EBSeq.score <- 1 - EBSeq.FDR",
               "result.table <- data.frame('FDR' = EBSeq.FDR, 'lfdr' = EBSeq.lfdr, 'score' = EBSeq.score, 'posterior.DE' = EBSeq.posteriors.DE)",
               "result.table <- result.table[match(rownames(count.matrix(cdata)), rownames(result.table)), ]",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('EBSeq,', packageVersion('EBSeq'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'EBSeq', 'full.name' = '", paste('EBSeq.', utils::packageVersion('EBSeq'), '.', norm.method, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with the edgeR exact test
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the exact test functionality from the edgeR package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{edgeR} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}.
#' @param trend.method The method used to estimate the trend in the mean-dispersion relationship. Possible values are \code{"none"}, \code{"movingave"} and \code{"loess"}
#' @param disp.type The type of dispersion estimate used. Possible values are \code{"common"}, \code{"trended"} and \code{"tagwise"}.
#' @references
#' Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140
#' @export
#' @author Charlotte Soneson
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "edgeR.exact",
#'            Rmdfunction = "edgeR.exact.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM",
#'            trend.method = "movingave", disp.type = "tagwise")
#' @importFrom utils packageVersion
edgeR.exact.createRmd <- function(data.path, result.path, codefile,
                                  norm.method, trend.method, disp.type) {
  ## Write the code for applying edgeR exact test to an Rmd file
  codefile <- file(codefile, open = "w")
  writeLines("### edgeR", codefile)
  writeLines(paste("Data file: ", data.path, sep = ""), codefile)

  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(edgeR)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               "edgeR.dgelist <- edgeR::DGEList(counts = count.matrix(cdata), group = factor(sample.annotations(cdata)$condition))",
               paste("edgeR.dgelist <- edgeR::calcNormFactors(edgeR.dgelist, method = '", norm.method, "')", sep = ''),
               "edgeR.dgelist <- edgeR::estimateCommonDisp(edgeR.dgelist)"), codefile)
  if (disp.type == 'tagwise') {
    writeLines(c(paste("edgeR.dgelist <- edgeR::estimateTagwiseDisp(edgeR.dgelist, trend = '", trend.method, "')", sep = ''),
                 "dispersion.S1 <- edgeR.dgelist$tagwise.dispersion",
                 "dispersion.S2 <- edgeR.dgelist$tagwise.dispersion"), codefile)
  } else {
    if (disp.type == 'common') {
      writeLines(c("dispersion.S1 <- rep(edgeR.dgelist$common.dispersion, nrow(count.matrix(cdata)))",
                   "dispersion.S2 <- rep(edgeR.dgelist$common.dispersion, nrow(count.matrix(cdata)))"), codefile)
    } else if (disp.type == 'trended') {
      writeLines(c("edgeR.dgelist <- edgeR::estimateTrendedDisp(edgeR.dgelist)",
                   "dispersion.S1 <- edgeR.dgelist$trended.dispersion",
                   "dispersion.S2 <- edgeR.dgelist$trended.dispersion"), codefile)
    }
  }
  writeLines(c("edgeR.exacttest <- edgeR::exactTest(edgeR.dgelist)",
               "edgeR.pvalues <- edgeR.exacttest$table$PValue",
               "edgeR.adjpvalues <- p.adjust(edgeR.pvalues, method = 'BH')",
               "edgeR.logFC <- edgeR.exacttest$table$logFC",
               "edgeR.score <- 1 - edgeR.pvalues",
               "result.table <- data.frame('pvalue' = edgeR.pvalues, 'adjpvalue' = edgeR.adjpvalues, 'logFC' = edgeR.logFC, 'score' = edgeR.score, 'dispersion.S1' = dispersion.S1, 'dispersion.S2' = dispersion.S2)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('edgeR,', packageVersion('edgeR'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'edgeR', 'full.name' = '", paste('edgeR.', utils::packageVersion('edgeR'), '.exact.', norm.method, '.', trend.method, '.', disp.type, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with the edgeR GLM approach
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the GLM functionality from the edgeR package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{edgeR} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}.
#' @param disp.type The type of dispersion estimate used. Possible values are \code{"common"}, \code{"trended"} and \code{"tagwise"}.
#' @param disp.method The method used to estimate the dispersion. Possible values are \code{"CoxReid"}, \code{"Pearson"} and \code{"deviance"}.
#' @param trended Logical parameter indicating whether or not a trended dispersion estimate should be used.
#' @references
#' Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140
#' @export
#' @author Charlotte Soneson
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "edgeR.GLM",
#'            Rmdfunction = "edgeR.GLM.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM",
#'            disp.type = "tagwise", disp.method = "CoxReid",
#'            trended = TRUE)
#' @importFrom utils packageVersion
edgeR.GLM.createRmd <- function(data.path, result.path, codefile,
                                norm.method, disp.type, disp.method, trended) {
  codefile <- file(codefile, open = "w")
  writeLines("### edgeR", codefile)
  writeLines(paste("Data file: ", data.path, sep = ""), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(edgeR)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               "edgeR.dgelist <- edgeR::DGEList(counts = count.matrix(cdata), group = factor(sample.annotations(cdata)$condition))",
               paste("edgeR.dgelist <- edgeR::calcNormFactors(edgeR.dgelist, method = '", norm.method, "')", sep = ''),
               paste("edgeR.dgelist <- edgeR::estimateGLMCommonDisp(edgeR.dgelist, design = model.matrix(~factor(sample.annotations(cdata)$condition)), method = '", disp.method, "')", sep = '')), codefile)
  if ((disp.type == 'tagwise' & trended == TRUE) | disp.type == 'trended') {
    writeLines("edgeR.dgelist <- edgeR::estimateGLMTrendedDisp(edgeR.dgelist, design = model.matrix(~factor(sample.annotations(cdata)$condition)), method = 'auto')", codefile)
  }
  if (disp.type == 'tagwise') {
    writeLines(paste("edgeR.dgelist <- edgeR::estimateGLMTagwiseDisp(edgeR.dgelist, design = model.matrix(~factor(sample.annotations(cdata)$condition)), trend = ", trended, ")", sep = ''), codefile)
  }
  if (disp.type == 'common') {
    writeLines(c("dispersion.S1 <- rep(edgeR.dgelist$common.dispersion, nrow(count.matrix(cdata)))",
                 "dispersion.S2 <- rep(edgeR.dgelist$common.dispersion, nrow(count.matrix(cdata)))"), codefile)
  } else {
    if (disp.type == 'trended') {
      writeLines(c("dispersion.S1 <- edgeR.dgelist$trended.dispersion",
                   "dispersion.S2 <- edgeR.dgelist$trended.dispersion"), codefile)
    } else {
      writeLines(c("dispersion.S1 <- edgeR.dgelist$tagwise.dispersion",
                   "dispersion.S2 <- edgeR.dgelist$tagwise.dispersion"), codefile)
    }
  }
  writeLines(c("edgeR.glmfit <- edgeR::glmFit(edgeR.dgelist, design = model.matrix(~factor(sample.annotations(cdata)$condition)))",
               "edgeR.glmlrt <- edgeR::glmLRT(edgeR.glmfit, coef = 2)",
               "edgeR.pvalues <- edgeR.glmlrt$table$PValue",
               "edgeR.adjpvalues <- p.adjust(edgeR.pvalues, method = 'BH')",
               "edgeR.logFC <- edgeR.glmlrt$table$logFC",
               "edgeR.score <- 1 - edgeR.pvalues",
               "result.table <- data.frame('pvalue' = edgeR.pvalues, 'adjpvalue' = edgeR.adjpvalues, 'logFC' = edgeR.logFC, 'score' = edgeR.score, 'dispersion.S1' = dispersion.S1, 'dispersion.S2' = dispersion.S2)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('edgeR,', packageVersion('edgeR'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'edgeR', 'full.name' = '", paste('edgeR.', utils::packageVersion('edgeR'), '.GLM.', norm.method, '.', as.vector(ifelse(trended == TRUE, 'trend', 'notrend')), '.', disp.method, '.', disp.type, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}


#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with DESeq2
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the DESeq2 package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{DESeq2} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param fit.type The fitting method used to get the dispersion-mean relationship. Possible values are \code{"parametric"}, \code{"local"} and \code{"mean"}.
#' @param test The test to use. Possible values are \code{"Wald"} and \code{"LRT"}.
#' @param beta.prior Whether or not to put a zero-mean normal prior on the non-intercept coefficients. Default is \code{TRUE}.
#' @param independent.filtering Whether or not to perform independent filtering of the data. With independent filtering=TRUE, the adjusted p-values for genes not passing the filter threshold are set to NA.
#' @param cooks.cutoff The cutoff value for the Cook's distance to consider a value to be an outlier. Set to Inf or FALSE to disable outlier detection. For genes with detected outliers, the p-value and adjusted p-value will be set to NA.
#' @param impute.outliers Whether or not the outliers should be replaced by a trimmed mean and the analysis rerun.
#' @param nas.as.ones Whether or not adjusted p values that are returned as \code{NA} by \code{DESeq2} should be set to \code{1}. This option is useful for comparisons with other methods. For more details, see section "I want to benchmark DESeq2 comparing to other DE tools" from the \code{DESeq2} vignette (available by running \code{vignette("DESeq2", package = "DESeq2")}). Default to \code{FALSE}.
#'
#' @export
#' @author Charlotte Soneson
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references
#' Anders S and Huber W (2010): Differential expression analysis for sequence count data. Genome Biology 11:R106
#' @examples
#' try(
#' if (require(DESeq2)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "DESeq2",
#'            Rmdfunction = "DESeq2.createRmd",
#'            output.directory = tmpdir, fit.type = "parametric",
#'            test = "Wald")
#' })
#' @importFrom utils packageVersion
DESeq2.createRmd <- function(data.path, result.path, codefile,
                             fit.type, test, beta.prior = TRUE,
                             independent.filtering = TRUE, cooks.cutoff = TRUE,
                             impute.outliers = TRUE,
                             nas.as.ones = FALSE) {
  codefile <- file(codefile, open = 'w')
  writeLines("### DESeq2", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = TRUE, error = TRUE, warning = TRUE}",
               "require(DESeq2)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               "DESeq2.ds <- DESeq2::DESeqDataSetFromMatrix(countData = count.matrix(cdata), colData = data.frame(condition = factor(sample.annotations(cdata)$condition)), design = ~ condition)",
               paste("DESeq2.ds <- DESeq2::DESeq(DESeq2.ds, fitType = '", fit.type, "', test = '", test, "', betaPrior = ", beta.prior, ")", sep = "")), codefile)
  if (impute.outliers == TRUE) {
    writeLines(c("DESeq2.ds.clean <- DESeq2::replaceOutliersWithTrimmedMean(DESeq2.ds)",
                 paste("DESeq2.ds.clean <- DESeq2::DESeq(DESeq2.ds.clean, fitType = '", fit.type, "', test = '", test, "', betaPrior = ", beta.prior, ")", sep = ""),
                 "DESeq2.ds <- DESeq2.ds.clean"), codefile)
  }
  writeLines(paste("DESeq2.results <- DESeq2::results(DESeq2.ds, independentFiltering = ", independent.filtering, ", cooksCutoff = ", cooks.cutoff, ")", sep = ""),
             codefile)
  if (nas.as.ones) {
    # see https://bioconductor.org/packages/release/bioc/vignettes/DESeq2/inst/doc/DESeq2.html#i-want-to-benchmark-deseq2-comparing-to-other-de-tools.
    message("As `nas.as.ones=TRUE`, all NAs in adjusted p values are replaced by 1 to allow for benchmarking with other methods. For more details, see section 'I want to benchmark DESeq2 comparing to other DE tools' from the `DESeq2` vignette (available by running `vignette('DESeq2', package = 'DESeq2')`)")
    writeLines("DESeq2.results$padj <- ifelse(is.na(DESeq2.results$padj), 1, DESeq2.results$padj)", codefile)
  } else {
    message("As `nas.as.ones=FALSE`, there might be some NAs in the adjusted p values computed by DESeq2. This might bias the comparison of the results with other methods. For more details, see section 'I want to benchmark DESeq2 comparing to other DE tools' from the `DESeq2` vignette (available by running `vignette('DESeq2', package = 'DESeq2')`)")
  }
  writeLines(c("DESeq2.pvalues <- DESeq2.results$pvalue",
               "DESeq2.adjpvalues <- DESeq2.results$padj",
               "DESeq2.logFC <- DESeq2.results$log2FoldChange",
               "DESeq2.score <- 1 - DESeq2.pvalues",
               "result.table <- data.frame('pvalue' = DESeq2.pvalues, 'adjpvalue' = DESeq2.adjpvalues, 'logFC' = DESeq2.logFC, 'score' = DESeq2.score)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('DESeq2,', packageVersion('DESeq2'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'DESeq2', 'full.name' = '", paste('DESeq2.', utils::packageVersion('DESeq2'), '.', fit.type, '.', test, '.', ifelse(beta.prior == TRUE, 'bp', 'nobp'), '.', ifelse(independent.filtering == TRUE, 'indf', 'noindf'), paste(".cook_", cooks.cutoff, sep = ""), ifelse(impute.outliers, ".imp", ".noimp"), sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with voom+limma
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) by applying the voom transformation (from the limma package) followed by differential expression analysis with limma. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{limma} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} of the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}
#' @export
#' @author Charlotte Soneson
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references
#' Smyth GK (2005): Limma: linear models for microarray data. In: 'Bioinformatics and Computational Biology Solutions using R and Bioconductor'. R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W. Huber (eds), Springer, New York, pages 397-420
#'
#'  Law CW, Chen Y, Shi W and Smyth GK (2014): voom: precision weights unlock linear model analysis tools for RNA-seq read counts. Genome Biology 15, R29
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.limma",
#'            Rmdfunction = "voom.limma.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM")
#' @importFrom utils packageVersion
voom.limma.createRmd <- function(data.path, result.path, codefile, norm.method) {
  codefile <- file(codefile, open = 'w')
  writeLines("### voom + limma", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(limma)",
               "require(edgeR)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               paste("nf <- edgeR::calcNormFactors(count.matrix(cdata), method = '", norm.method, "')", sep = ''),
               "voom.data <- limma::voom(count.matrix(cdata), design = model.matrix(~factor(sample.annotations(cdata)$condition)), lib.size = colSums(count.matrix(cdata)) * nf)",
               "voom.data$genes <- rownames(count.matrix(cdata))",
               "voom.fitlimma <- limma::lmFit(voom.data, design = model.matrix(~factor(sample.annotations(cdata)$condition)))",
               "voom.fitbayes <- limma::eBayes(voom.fitlimma)",
               "voom.pvalues <- voom.fitbayes$p.value[, 2]",
               "voom.adjpvalues <- p.adjust(voom.pvalues, method = 'BH')",
               "voom.logFC <- voom.fitbayes$coefficients[, 2]",
               "voom.score <- 1 - voom.pvalues",
               "result.table <- data.frame('pvalue' = voom.pvalues, 'adjpvalue' = voom.adjpvalues, 'logFC' = voom.logFC, 'score' = voom.score)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('limma,', packageVersion('limma'), ';', 'edgeR,', packageVersion('edgeR'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'voom', 'full.name' = '",
                     paste('voom.', utils::packageVersion('limma'), '.limma.', norm.method, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with baySeq
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the \code{baySeq} package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{baySeq} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"quantile"}, \code{"total"} and \code{"edgeR"}.
#' @param equaldisp Logical parameter indicating whether or not equal dispersion should be assumed across all conditions.
#' @param sample.size The size of the sample used to estimate the priors (default 5000).
#' @param estimation The approach used to estimate the priors. Possible values are \code{"QL"} (default), \code{"ML"} and \code{"edgeR"}.
#' @param pET The method used to re-estimate the priors. Possible values are \code{"BIC"} (default), \code{"none"} and \code{"iteratively"}.
#' @noRd
#' @author Charlotte Soneson
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references
#' Hardcastle TJ (2012): baySeq: Empirical Bayesian analysis of patterns of differential expression in count data. R package
#'
#' Hardcastle TJ and Kelly KA (2010): baySeq: Empirical Bayesian methods for identifying differential expression in sequence count data. BMC Bioinformatics 11:422
#' @examples
#' try(
#' if (require(baySeq)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' ## Note! In the interest of speed, we set sample.size=10 in this example.
#' ## In a real analysis, much larger sample sizes are recommended (the default is 5000).
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "baySeq",
#'            Rmdfunction = "baySeq.createRmd",
#'            output.directory = tmpdir, norm.method = "edgeR",
#'            equaldisp = TRUE, sample.size = 10)
#' })
#' @importFrom utils packageVersion
baySeq.createRmd <- function(data.path, result.path, codefile,
                             norm.method, equaldisp, sample.size = 5000,
                             estimation = "QL", pET = "BIC") {
  codefile <- file(codefile, open = 'w')
  writeLines("### baySeq", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = TRUE, error = TRUE, warning = TRUE}",
               "require(baySeq)",
               "require(edgeR)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               "baySeq.cd <- new('countData', data = count.matrix(cdata), replicates = sample.annotations(cdata)$condition, groups = list(NDE = rep(1, length(sample.annotations(cdata)$condition)), DE = sample.annotations(cdata)$condition))",
               paste("libsizes(baySeq.cd) <- baySeq::getLibsizes(baySeq.cd, estimationType = '", norm.method, "')", sep = '')), codefile)
  writeLines(c(paste("baySeq.cd <- baySeq::getPriors.NB(baySeq.cd, samplesize =", sample.size, ", equalDispersions = ", equaldisp, ", estimation = '", estimation, "', cl = NULL)", sep = ''),
               paste("baySeq.cd <- baySeq::getLikelihoods(baySeq.cd, prs = c(0.5, 0.5), pET = '", pET, "', cl = NULL)", sep = '')), codefile)
  writeLines(c("baySeq.posteriors.DE <- exp(baySeq.cd@posteriors)[, 'DE']",
               "baySeq.FDR <- baySeq::topCounts(baySeq.cd, group = 'DE', FDR = 1)$FDR.DE[match(rownames(count.matrix(cdata)), rownames(baySeq::topCounts(baySeq.cd, group = 'DE', FDR = 1)))]",
               "baySeq.score <- 1 - baySeq.FDR",
               "result.table <- data.frame('FDR' = baySeq.FDR, 'score' = baySeq.score, 'posterior.DE' = baySeq.posteriors.DE)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('baySeq,', packageVersion('baySeq'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'baySeq', 'full.name' = '", paste('baySeq.', utils::packageVersion('baySeq'), '.', norm.method, '.', ifelse(equaldisp == TRUE, 'equaldisp', 'nonequaldisp'), '.samplesize', sample.size, '.', estimation, '.', pET, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}


#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with voom+t-test
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) by applying the voom transformation (from the \code{limma} package) followed by differential expression analysis with a t-test. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{limma} and \code{edgeR} packages and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} function from the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}.
#' @export
#' @author Charlotte Soneson
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references
#' Smyth GK (2005): Limma: linear models for microarray data. In: 'Bioinformatics and Computational Biology Solutions using R and Bioconductor'. R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W. Huber (eds), Springer, New York, pages 397-420
#'
#' Law CW, Chen Y, Shi W and Smyth GK (2014): voom: precision weights unlock linear model analysis tools for RNA-seq read counts. Genome Biology 15, R29
#' @examples
#' try(
#' if (require(genefilter)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.ttest",
#'            Rmdfunction = "voom.ttest.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM")
#' })
#' @importFrom utils packageVersion
voom.ttest.createRmd <- function(data.path, result.path, codefile, norm.method) {
  codefile <- file(codefile, open = 'w')
  writeLines("### voom (t-test)", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(limma)",
               "require(edgeR)",
               "require(genefilter)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               paste("nf <- edgeR::calcNormFactors(count.matrix(cdata), method = '", norm.method, "')", sep = ''),
               "voom.data <- limma::voom(count.matrix(cdata), design = model.matrix(~factor(sample.annotations(cdata)$condition)), lib.size = colSums(count.matrix(cdata)) * nf)",
               "voom.data$genes <- rownames(count.matrix(cdata))",
               "voom.ttest <- genefilter::rowttests(voom.data$E, factor(sample.annotations(cdata)$condition))",
               "voom.pvalues <- voom.ttest$p.value",
               "voom.adjpvalues <- p.adjust(voom.pvalues, method = 'BH')",
               "voom.logFC <- voom.ttest$dm",
               "voom.score <- 1 - voom.pvalues",
               "result.table <- data.frame('pvalue' = voom.pvalues, 'adjpvalue' = voom.adjpvalues, 'logFC' = voom.logFC, 'score' = voom.score)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('limma,', packageVersion('limma'), ';', 'edgeR,', packageVersion('edgeR'), ';', 'genefilter,', packageVersion('genefilter'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'voom', 'full.name' = '",
                     paste('voom.', utils::packageVersion('limma'), '.ttest.', norm.method, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with limma after log-transforming the counts per million (cpm)
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using limma, after preprocessing the counts by computing the counts per million (cpm) and applying a logarithmic transformation. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{edgeR} and \code{limma} packages and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} function from the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}
#' @export
#' @author Charlotte Soneson
#' @references
#' Smyth GK (2005): Limma: linear models for microarray data. In: 'Bioinformatics and Computational Biology Solutions using R and Bioconductor'. R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W. Huber (eds), Springer, New York, pages 397-420
#'
#' Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140
#'
#' Robinson MD and Oshlack A  (2010): A scaling normalization method for differential expression analysis of RNA-seq data. Genome Biology 11:R25
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "logcpm.limma",
#'            Rmdfunction = "logcpm.limma.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM")
#' @importFrom utils packageVersion
logcpm.limma.createRmd <- function(data.path, result.path, codefile, norm.method) {
  codefile <- file(codefile, open = 'w')
  writeLines("### log(cpm) + limma", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(limma)",
               "require(edgeR)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               paste("nf <- edgeR::calcNormFactors(count.matrix(cdata), method = '", norm.method, "')", sep = ''),
               "logcpm.data <- log2(sweep((count.matrix(cdata) + 0.5), 2, colSums(count.matrix(cdata)) * nf, '/')*1e6)",
               "rownames(logcpm.data) <- rownames(count.matrix(cdata))",
               "logcpm.fitlimma <- limma::lmFit(logcpm.data, design = model.matrix(~factor(sample.annotations(cdata)$condition)))",
               "logcpm.fitbayes <- limma::eBayes(logcpm.fitlimma)",
               "logcpm.pvalues <- logcpm.fitbayes$p.value[, 2]",
               "logcpm.adjpvalues <- p.adjust(logcpm.pvalues, method = 'BH')",
               "logcpm.logFC <- logcpm.fitbayes$coefficients[, 2]",
               "logcpm.score <- 1 - logcpm.pvalues",
               "result.table <- data.frame('pvalue' = logcpm.pvalues, 'adjpvalue' = logcpm.adjpvalues, 'logFC' = logcpm.logFC, 'score' = logcpm.score)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('limma,', packageVersion('limma'), ';', 'edgeR,', packageVersion('edgeR'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'logcpm.limma', 'full.name' = '",
                     paste('logcpm.limma.', utils::packageVersion('limma'), '.', norm.method, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with limma after square root-transforming the counts per million (cpm)
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using limma, after preprocessing the counts by computing the counts per million (cpm) and applying a square-root transformation. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{edgeR} and \code{limma} packages and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} function from the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}.
#' @export
#' @author Charlotte Soneson
#' @references
#' Smyth GK (2005): Limma: linear models for microarray data. In: 'Bioinformatics and Computational Biology Solutions using R and Bioconductor'. R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W. Huber (eds), Springer, New York, pages 397-420
#'
#' Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140
#'
#' Robinson MD and Oshlack A (2010): A scaling normalization method for differential expression analysis of RNA-seq data. Genome Biology 11:R25
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "sqrtcpm.limma",
#'            Rmdfunction = "sqrtcpm.limma.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM")
#' @importFrom utils packageVersion
sqrtcpm.limma.createRmd <- function(data.path, result.path, codefile, norm.method) {
  codefile <- file(codefile, open = 'w')
  writeLines("### sqrt(cpm) + limma", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(limma)",
               "require(edgeR)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               paste("nf <- edgeR::calcNormFactors(count.matrix(cdata), method = '", norm.method, "')", sep = ''),
               "sqrtcpm.data <- sqrt(sweep((count.matrix(cdata) + 0.5), 2, colSums(count.matrix(cdata)) * nf, '/')*1e6)",
               "rownames(sqrtcpm.data) <- rownames(count.matrix(cdata))",
               "sqrtcpm.fitlimma <- limma::lmFit(sqrtcpm.data, design = model.matrix(~factor(sample.annotations(cdata)$condition)))",
               "sqrtcpm.fitbayes <- limma::eBayes(sqrtcpm.fitlimma)",
               "sqrtcpm.pvalues <- sqrtcpm.fitbayes$p.value[, 2]",
               "sqrtcpm.adjpvalues <- p.adjust(sqrtcpm.pvalues, method = 'BH')",
               "sqrtcpm.logFC <- sqrtcpm.fitbayes$coefficients[, 2]",
               "sqrtcpm.score <- 1 - sqrtcpm.pvalues",
               "result.table <- data.frame('pvalue' = sqrtcpm.pvalues, 'adjpvalue' = sqrtcpm.adjpvalues, 'logFC' = sqrtcpm.logFC, 'score' = sqrtcpm.score)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('limma,', packageVersion('limma'), ';', 'edgeR,', packageVersion('edgeR'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'sqrtcpm.limma', 'full.name' = '",
                     paste('sqrtcpm.limma.', utils::packageVersion('limma'), '.', norm.method, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with a t-test
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using a t-test, applied to the normalized counts. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{edgeR} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} function from the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}
#' @export
#' @author Charlotte Soneson
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references
#' Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140
#'
#' Robinson MD and Oshlack A (2010): A scaling normalization method for differential expression analysis of RNA-seq data. Genome Biology 11:R25
#' @examples
#' try(
#' if (require(genefilter)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "ttest",
#'            Rmdfunction = "ttest.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM")
#' })
#' @importFrom utils packageVersion
ttest.createRmd <- function(data.path, result.path, codefile, norm.method) {
  codefile <- file(codefile, open = 'w')
  writeLines("### t-test", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(genefilter)",
               "require(edgeR)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               paste("nf <- edgeR::calcNormFactors(count.matrix(cdata), method = '", norm.method, "') * colSums(count.matrix(cdata))/exp(mean(log(colSums(count.matrix(cdata)))))", sep = ''),
               "count.matrix <- round(sweep(count.matrix(cdata), 2, nf, '/'))",
               "ttest.result <- genefilter::rowttests(count.matrix, factor(sample.annotations(cdata)$condition))",
               "ttest.pvalues <- ttest.result$p.value",
               "ttest.adjpvalues <- p.adjust(ttest.pvalues, method = 'BH')",
               "ttest.logFC <- ttest.result$dm",
               "ttest.score <- 1 - ttest.pvalues",
               "result.table <- data.frame('pvalue' = ttest.pvalues, 'adjpvalue' = ttest.adjpvalues, 'logFC' = ttest.logFC, 'score' = ttest.score)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('edgeR,', packageVersion('edgeR'), ';', 'genefilter,', packageVersion('genefilter'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'ttest', 'full.name' = 'ttest.", utils::packageVersion('genefilter'), '.', norm.method, "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with NOISeq
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using \code{NOISeq}. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{NOISeq} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} function from the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}.
#' @export
#' @author Charlotte Soneson
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references
#' Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140
#'
#' Robinson MD and Oshlack A (2010): A scaling normalization method for differential expression analysis of RNA-seq data. Genome Biology 11:R25
#'
#' Tarazona S, Furio-Tari P, Ferrer A and Conesa A (2012): NOISeq: Exploratory analysis and differential expression for RNA-seq data. R package
#'
#' Tarazona S, Garcia-Alcalde F, Dopazo J, Ferrer A and Conesa A (2011): Differential expression in RNA-seq: a matter of depth. Genome Res 21(12), 2213-2223
#' @examples
#' try(
#' if (require(NOISeq)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "NOISeq",
#'            Rmdfunction = "NOISeq.prenorm.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM")
#' })
#' @importFrom utils packageVersion
NOISeq.prenorm.createRmd <- function(data.path, result.path, codefile, norm.method) {
  codefile <- file(codefile, open = 'w')
  cdata <- readRDS(data.path)
  writeLines("### NOISeq", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(edgeR)",
               "require(NOISeq)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(cdata)) {
    cdata <- convertListTocompData(cdata)
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               paste("nf <- edgeR::calcNormFactors(count.matrix(cdata), method = '", norm.method, "') * colSums(count.matrix(cdata))/exp(mean(log(colSums(count.matrix(cdata)))))", sep = ''),
               "count.matrix <- round(sweep(count.matrix(cdata), 2, nf, '/'))",
               "inp.data <- NOISeq::readData(count.matrix, factors = sample.annotations(cdata))",
               paste("NOISeq.test <- NOISeq::noiseqbio(inp.data, k = 0.5, norm = 'n', nclust = 15, factor = 'condition', conditions = c('", unique(as.character(sample.annotations(cdata)$condition))[1], "', '", unique(as.character(sample.annotations(cdata)$condition))[2], "'), filter = 0)@results", sep = ""),
               ##               paste("NOISeq.test = noiseqbio(inp.data, k = 0.5, norm = 'n', nclust = 15, factor = 'condition', conditions = c(unique(as.character(sample.annotations(cdata)$condition))[1], unique(as.character(sample.annotations(cdata)$condition))[2]), filter = 0)@results", sep = ""),
               "NOISeq.prob <- NOISeq.test[[1]]$prob",
               "NOISeq.statistic <- NOISeq.test[[1]]$theta",
               "NOISeq.score <- NOISeq.prob",
               "result.table <- data.frame('probabilities' = NOISeq.prob, 'statistic' = NOISeq.statistic, 'score' = NOISeq.score, 'FDR' = 1 - NOISeq.prob)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('NOISeq,', packageVersion('NOISeq'), ';', 'edgeR,', packageVersion('edgeR'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'NOISeq', 'full.name' = '",
                     paste('NOISeq.', utils::packageVersion('NOISeq'), '.', norm.method, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with NBPSeq
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using \code{NBPSeq}. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{NBPSeq} and \code{edgeR} packages and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} function from the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}.
#' @param disp.method The method to use to estimate the dispersion values. Possible values are \code{"NBP"} and \code{"NB2"}.
#' @export
#' @author Charlotte Soneson
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references
#' Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140
#'
#' Robinson MD and Oshlack A (2010): A scaling normalization method for differential expression analysis of RNA-seq data. Genome Biology 11:R25
#'
#' Di Y, Schafer DW, Cumbie JS, and Chang JH (2011): The NBP Negative Binomial Model for Assessing Differential Gene Expression from RNA-Seq. Statistical Applications in Genetics and Molecular Biology 10(1), 1-28
#' @examples
#' try(
#' if (require(NBPSeq)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "NBPSeq",
#'            Rmdfunction = "NBPSeq.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM", disp.method = "NBP")
#' })
#' @importFrom utils packageVersion
NBPSeq.createRmd <- function(data.path, result.path, codefile, norm.method, disp.method) {
  codefile <- file(codefile, open = 'w')
  writeLines("### NBPSeq", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(edgeR)",
               "require(NBPSeq)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               paste("nf <- edgeR::calcNormFactors(count.matrix(cdata), method = '", norm.method, "')", sep = ''),
               paste("NBPSeq.test <- NBPSeq::nbp.test(count.matrix(cdata), grp.ids = sample.annotations(cdata)$condition, grp1 = levels(factor(sample.annotations(cdata)$condition))[1], grp2 = levels(factor(sample.annotations(cdata)$condition))[2], norm.factors = nf, model.disp = '", disp.method, "', print.level = 5)", sep = ''),
               "NBPSeq.pvalues <- NBPSeq.test$p.values",
               "NBPSeq.adjpvalues <- NBPSeq.test$q.values",
               "NBPSeq.pvalues[which(is.na(NBPSeq.pvalues))] <- 1",
               "NBPSeq.adjpvalues[which(is.na(NBPSeq.adjpvalues))] <- 1",
               "NBPSeq.logFC <- NBPSeq.test$log.fc",
               "NBPSeq.score <- 1 - NBPSeq.pvalues",
               "result.table <- data.frame('pvalue' = NBPSeq.pvalues, 'adjpvalue' = NBPSeq.adjpvalues, 'logFC' = NBPSeq.logFC, 'score' = NBPSeq.score)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('NBPSeq,', packageVersion('NBPSeq'), ';', 'edgeR,', packageVersion('edgeR'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'NBPSeq', 'full.name' = '",
                     paste('NBPSeq.', utils::packageVersion('NBPSeq'), '.', norm.method, '.', disp.method, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with DSS
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the DSS package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{DSS} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"quantile"}, \code{"total"} and \code{"median"}.
#' @param disp.trend A logical parameter indicating whether or not to include a trend in the dispersion estimation.
#' @export
#' @author Charlotte Soneson
#' @references
#' Wu H, Wang C and Wu Z (2013): A new shrinkage estimator for dispersion improves differential expression detection in RNA-seq data. Biostatistics 14(2), 232-243
#' @examples
#' try(
#' if (require(DSS)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "DSS",
#'            Rmdfunction = "DSS.createRmd",
#'            output.directory = tmpdir, norm.method = "quantile",
#'            disp.trend = TRUE)
#' })
#' @importFrom utils packageVersion
DSS.createRmd <- function(data.path, result.path, codefile, norm.method, disp.trend) {
  codefile <- file(codefile, open = 'w')
  writeLines("### DSS", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(DSS)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               "designs <- sample.annotations(cdata)$condition",
               "names(designs) <- rownames(sample.annotations(cdata))",
               "DSS.seqData <- DSS::newSeqCountSet(count.matrix(cdata), designs)",
               paste("DSS.seqData <- DSS::estNormFactors(DSS.seqData, method = '", norm.method, "')", sep = ''),
               paste("DSS.seqData <- DSS::estDispersion(DSS.seqData, trend = ", disp.trend, ")", sep = ''),
               "DSS.test <- DSS::waldTest(DSS.seqData, levels(factor(sample.annotations(cdata)$condition))[1], levels(factor(sample.annotations(cdata)$condition))[2])",
               "DSS.test <- DSS.test[match(rownames(count.matrix(cdata)), rownames(DSS.test)), ]",
               "DSS.pvalues <- DSS.test[, 'pval']",
               "DSS.adjpvalues <- DSS.test[, 'fdr']",
               "DSS.logFC <- DSS.test[, 'lfc']",
               "DSS.statistic <- DSS.test[, 'stats']",
               "DSS.score <- 1 - DSS.pvalues",
               "result.table <- data.frame('pvalue' = DSS.pvalues, 'adjpvalue' = DSS.adjpvalues, 'logFC' = DSS.logFC, 'statistic' = DSS.statistic, 'score' = DSS.score)",
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('DSS,', packageVersion('DSS'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'DSS', 'full.name' = '",
                     paste('DSS.', utils::packageVersion('DSS'), '.', norm.method, '.', ifelse(disp.trend, 'trend', 'notrend'), sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with TCC
#'
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the TCC package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#'
#' For more information about the methods and the interpretation of the parameters, see the \code{TCC} package and the corresponding publications.
#'
#' @param data.path The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.
#' @param result.path The path to the file where the result object will be saved.
#' @param codefile The path to the file where the code will be written.
#' @param norm.method The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"tmm"}, and \code{"deseq"}.
#' @param test.method The method used in TCC to find differentially expressed genes. Possible values are \code{"edger"}, \code{"deseq"} and \code{"bayseq"}.
#' @param iteration The number of iterations used to find the normalization factors. Default value is 3.
#' @param normFDR The FDR cutoff for calling differentially expressed genes in the computation of the normalization factors. Default value is 0.1.
#' @param floorPDEG The minimum value to be eliminated as potential differentially expressed genes before performing step 3 in the TCC algorithm. Default value is 0.05.
#' @export
#' @author Charlotte Soneson
#' @references
#' Kadota K, Nishiyama T, and Shimizu K. A normalization strategy for comparing tag count data. Algorithms Mol Biol. 7:5, 2012.
#'
#' Sun J, Nishiyama T, Shimizu K, and Kadota K. TCC: an R package for comparing tag count data with robust normalization strategies. BMC Bioinformatics 14:219, 2013.
#' @examples
#' try(
#' if (require(TCC)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "TCC",
#'            Rmdfunction = "TCC.createRmd",
#'            output.directory = tmpdir, norm.method = "tmm",
#'            test.method = "edger")
#' })
#' @importFrom utils packageVersion
TCC.createRmd <- function(data.path, result.path, codefile, norm.method,
                          test.method, iteration = 3,
                          normFDR = 0.1, floorPDEG = 0.05) {
  codefile <- file(codefile, open = 'w')
  writeLines("### TCC", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(TCC)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTocompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_compData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData object.')",
               "TCC.data <- new('TCC', count.matrix(cdata), sample.annotations(cdata)$condition)",
               paste("TCC.data = TCC::calcNormFactors(TCC.data, norm.method = '", norm.method, "', test.method = '", test.method, "', iteration = ", iteration, ", FDR = ", normFDR, ", floorPDEG = ", floorPDEG, ")", sep = ""),
               paste("TCC.results <- TCC::estimateDE(TCC.data, test.method = '", test.method, "', FDR = 1)", sep = "")), codefile)
  if (test.method %in% c("edger", "deseq")) {
    writeLines(c("TCC.pvalues <- TCC.results$stat$p.value",
                 "TCC.adjpvalues <- TCC.results$stat$q.value",
                 "TCC.score <- 1 - TCC.pvalues",
                 "result.table <- data.frame('pvalue' = TCC.pvalues, 'adjpvalue' = TCC.adjpvalues, 'score' = TCC.score)"), codefile)
  } else if (test.method == "bayseq") {
    writeLines(c("TCC.posteriors.DE <- 1 - TCC.results$stat$p.value",
                 "TCC.FDR <- TCC.results$stat$q.value",
                 "TCC.score <- 1 - TCC.FDR",
                 "result.table <- data.frame('posterior.DE' = TCC.posteriors.DE, 'FDR' = TCC.FDR, 'score' = TCC.score)"), codefile)
  }
  writeLines(c("rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('TCC,', packageVersion('TCC'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'TCC', 'full.name' = '",
                     paste('TCC.', utils::packageVersion('TCC'), '.', norm.method, '.', test.method, '.iter', iteration, '.normFDR', normFDR, '.floorPDEG', floorPDEG, sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid compData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' @title Simulate Tree Structured Counts
#'
#' @description
#' Simulate a tree structured matrix of counts according to a Poisson-lognormal
#' model, with the log parameter of the poisson following a Brownian Motion (BM)
#' on the tree with noise.
#'
#' @details
#' For each gene, the log-lambda parameter evolves like a BM on the tree,
#' with an extra independent variance noise that can depend on the species.
#' Each gene has its own tree variance for the BM.
#' Each gene and each species has its own mean.
#' The counts for each gene and each species are then obtained as a Poisson draw
#' with a different lambda parameter, as generated by the BM.
#' 
#' @param tree A phylogenetic tree with n tips.
#' @param log_means a matrix with the number of genes p rows and the number of
#' species n columns. Column names should match the tree taxa names.
#' @param log_variance_phylo a vector of length p of phylogenetic variances for 
#' the BM in the log space for each gene.
#' @param log_variance_sample a matrix of size p x n of environmental variances
#' for individual variations in the log space, for each gene and species.
#' Column names should match the tree taxa names.
#' 
#' @return A list, with:
#' \describe{
#' \item{log_lambda}{the p x n matrix of log-lambda simulated by the BM on the tree.}
#' \item{counts}{the p x n matrix of counts with corresponding Poisson draws.}
#' }
#' 
#' @keywords internal
#' 
simulatePhyloPoissonLogNormal <- function(tree, log_means, log_variance_phylo, log_variance_sample, model.process = "BM", selection.strength = 0) {
  
  ## Check for packages
  if (!requireNamespace("ape", quietly = TRUE) || !requireNamespace("phylolm", quietly = TRUE)) {
    stop("Packages 'ape' and 'phylolm' are needed for tree simulations.", call. = FALSE)
  }
  
  ## Check means
  log_means <- checkParamMatrix(log_means, "log means", tree)
  log_variance_sample <- checkParamMatrix(log_variance_sample, "log variance sample", tree)
  
  N <- length(tree$tip.label)
  P <- nrow(log_means)
  
  ## Check Dimension
  if (nrow(log_variance_sample) != P || length(log_variance_phylo) != P) {
    stop("`log_means` and `log_variance_sample should have as many rows as the length of `log_variance_phylo`.")
  }
  
  ## Phylogenetic simulation of log(lambda)
  resids <- phylolm::rTrait(n = P,
                            phy = tree,
                            model = model.process,
                            parameters = list(sigma2 = 1, ancestral.state = 0, optimal.value = 0, alpha = selection.strength),
                            plot.tree = FALSE)
  
  log_sd_phylo <- scale_variance_process(log_variance_phylo, tree, model.process, selection.strength)
  
  ## phylo variances
  resids <- resids * log_sd_phylo
  
  ## resid variances
  resids <- t(resids) + matrix(rnorm(N * P, mean = 0, sd = sqrt(log_variance_sample)), ncol = N)
  
  ## Expectations
  log_lambda <- resids + log_means
  
  ## Poisson
  counts <- matrix(rpois(N * P, exp(log_lambda)), ncol = N)
  
  ## Names
  colnames(counts) <- colnames(log_lambda) <- tree$tip.label
  
  return(list(log_lambda = log_lambda,
              counts = counts))
}

#' @title Check Matrix Parameter
#'
#' @description
#' Check that the parameters are compatible with the tree. Throws an error if not.
#' 
#' @param x matrix of parameters being tested.
#' @param name name of the parameter.
#' @param tree A phylogenetic tree with n tips.
#' 
#' @keywords internal
#' 
checkParamMatrix <- function(x, name, tree) {
  N <- length(tree$tip.label)
  
  if (ncol(x) != N) {
    stop(paste0("`", name, "` should have as many columns as the number of taxa in the tree."))
  }
  if (is.null(tree$tip.label)) stop("The tips of the phylogeny are not named.")
  if (is.null(colnames(x))){
    warning(paste0("Columns of `", name, "` are not named. I'm naming them, assuming they are in the same order as the tree."))
    colnames(x) <- tree$tip.label
  } else {
    if (!all(tree$tip.label == colnames(x))){
      correspondances <- match(tree$tip.label, colnames(x))
      if (length(na.omit(unique(correspondances))) != length(tree$tip.label)){
        stop(paste0("`", name, "` names do not match the tip labels."))
      }
      warning(paste0("`", name, "` was not sorted in the correct order, when compared with the tips label. I am re-ordering it."))
      x <- x[, correspondances, drop = FALSE]
    }
  }
  return(x)
}

#' @title Check Vector Parameter
#'
#' @description
#' Check that the parameters are compatible with the tree. Throws an error if not.
#' 
#' @param x vector of parameters being tested.
#' @param name name of the parameter.
#' @param tree A phylogenetic tree with n tips.
#' 
#' @keywords internal
#' 
checkParamVector <- function(x, name, tree) {
  N <- length(tree$tip.label)
  
  if (length(x) != N) {
    stop(paste0("`", name, "` should have the same length as the number of taxa in the tree."))
  }
  if (is.null(tree$tip.label)) stop("The tips of the phylogeny are not named.")
  if (is.null(names(x))){
    warning(paste0("`", name, "` is not named. I'm naming them, assuming they are in the same order as the tree."))
    names(x) <- tree$tip.label
  } else {
    if (!all(tree$tip.label == names(x))){
      correspondances <- match(tree$tip.label, names(x))
      if (length(na.omit(unique(correspondances))) != length(tree$tip.label)){
        stop(paste0("`", name, "` names do not match the tip labels."))
      }
      warning(paste0("`", name, "` was not sorted in the correct order, when compared with the tips label. I am re-ordering it."))
      x <- x[correspondances]
    }
  }
  return(x)
}

#' @title Check Species
#'
#' @description
#' Check that the parameters are compatible with the tree. Throws an error if not.
#' 
#' @inheritParams checkParamVector
#' 
#' @keywords internal
#' 
checkSpecies <- function(x, name, tree, tol, check.id.species) {
  x <- checkParamVector(x, name, tree)
  if (check.id.species) {
    related_matrices <- sapply(x, function(i) i == x)
    if (!all(related_matrices == (ape::cophenetic.phylo(tree) <= tol))) {
      stop("The provided species do not match with the tree branch lengths. Please check the 'id.species' vector.")
    }
  }
  return(x)
}

#' @title Add replicates to a tree
#'
#' @description
#' Utility function to add replicates to a tree, as tips with zero length branches.
#' 
#' @param tree A phylogenetic tree with n tips.
#' @param r the number of replicates too add at each species.
#' 
#' @return A phylogenetic tree with n * r tips, and clusters of tips with zero branch lengths.
#' 
#' @keywords internal
#' 
add_replicates <- function(tree, r) {
  if (!requireNamespace("phytools", quietly = TRUE)) {
    stop("Package 'phytools' is needed for function 'add_replicates'.", call. = FALSE)
  }
  tree_rep <- tree
  # Add replicates
  for (tip_label in tree$tip.label) {
    for (rep in seq_len(r)) {
      tree_rep <- phytools::bind.tip(tree_rep, tip.label = paste0(tip_label, "_", rep),
                                     where = which(tree_rep$tip.label == tip_label))
    }
  }
  # Remove original tips
  tree_rep <- ape::drop.tip(tree_rep, tree$tip.label)
  return(tree_rep)
}

#' @title Compute log means and variances
#'
#' @description 
#' From the parameters of a negative binomial (count_means and count_dispersions),
#' compute the parameters of a phylogenetic Poisson log-normal with the
#' same expectations and variances.
#' 
#' @param count_means a matrix with the number of genes p rows and the number of
#' species n columns. Column names should match the tree taxa names.
#' @param count_dispersions a matrix of size p x n, for each gene and species.
#' Column names should match the tree taxa names.
#' 
#' @return A list, with:
#' \describe{
#' \item{log_means}{the p x n matrix of log-means for Poisson-lognormal simulations.}
#' \item{log_variance_phylo}{the p vector of phylogenetic log-variances for Poisson-lognormal simulations.}
#' \item{log_variance_sample}{the p x n matrix of environmental log-variances for Poisson-lognormal simulations.}
#' }
#' 
#' @keywords internal
#' 
get_poisson_log_normal_parameters <- function(count_means, count_dispersions, prop.var.tree) {
  N <- ncol(count_means)
  P <- nrow(count_means)
  
  ## Check Dimension
  if (nrow(count_dispersions) != P || ncol(count_dispersions) != N) {
    stop("`count_means` and `count_dispersions` should have the same dimensions.")
  }
  
  ## Check Proportion
  if (!is.vector(prop.var.tree)) {
    stop("`prop.var.tree` should be a vector.")
  }
  if (length(prop.var.tree) != P) {
    if (length(prop.var.tree) != 1) stop("`prop.var.tree` should be a vector of length the number of genes, or a scalar (in which case it will be recycled).")
  }
  if (any(prop.var.tree > 1.0 | prop.var.tree < 0.0)) {
    stop("`prop.var.tree` should be between 0 and 1.")
  }
  
  ## Parameters of the PLN
  params_PLN <- NB_to_PLN(count_means, count_dispersions)
  log_means <- params_PLN$log_means_pln
  log_variances_all <- params_PLN$log_variances_pln
  
  ## Phylo variances
  ## Check for packages
  if (!requireNamespace("matrixStats", quietly = TRUE)) {
    log_variance_phylo <- apply(log_variances_all, 1, min) * prop.var.tree
  } else {
    log_variance_phylo <- matrixStats::rowMins(log_variances_all) * prop.var.tree
  }
  
  ## Sample variances
  log_variance_sample <- log_variances_all - log_variance_phylo %*% t(rep(1, N))
  
  return(list(log_means = log_means,
              log_variance_phylo = log_variance_phylo,
              log_variance_sample = log_variance_sample))
}

#' @title Negative Binomial to Poisson Log-Normal
#'
#' @description 
#' From the parameters of a negative binomial (mean and dispersion),
#' compute the parameters of a Poisson log-normal with the
#' same expectation and variance.
#' 
#' @param mean mean of the negative binomial.
#' @param dispersion dispersion of the negative binomial.
#' 
#' @return A list, with:
#' \describe{
#' \item{log_means_pln}{Mean of the Poisson log normal in the log space.}
#' \item{log_variances_pln}{Variance of the Poisson log normal in the log space.}
#' }
#' 
#' @keywords internal
#' 
NB_to_PLN <- function(mean, dispersion) {
  ## Variance in log space
  log_variances_pln <- log(1 + dispersion)
  ## Mean in log space
  log_means_pln <- log(mean) - 0.5 * log_variances_pln
  
  return(list(log_means_pln = log_means_pln,
              log_variances_pln = log_variances_pln))
}

#' @title Simulate the Data using the tree
#'
#' @description 
#' Use the Phylogenetic Poisson Log Normal model to simulate the data.
#' 
#' @inheritParams generateSyntheticData 
#' @inheritParams simulateData
#' 
#' @return Z a matrix with the data
#' 
#' @keywords internal
#' 
simulateDataPhylo <- function(count_means,
                              count_dispersions,
                              tree, prop.var.tree,
                              model.process = "BM", selection.strength = 0) {
  ### Initialize data matrix
  colnames(count_means) <- colnames(count_dispersions) <- tree$tip.label
  
  ### Get Equivalent Phylogenetic Poisson log-normal parameters
  params_poisson_lognormal <- get_poisson_log_normal_parameters(count_means, count_dispersions, prop.var.tree)
  
  ### Simulate Data
  res_sim <- simulatePhyloPoissonLogNormal(tree,
                                           params_poisson_lognormal$log_means,
                                           params_poisson_lognormal$log_variance_phylo,
                                           params_poisson_lognormal$log_variance_sample,
                                           model.process = model.process,
                                           selection.strength = selection.strength)
  return(res_sim$counts)
}

#' @title Scale the variances
#'
#' @description 
#' Scale the variances of the process simulation so that they are equal to log_variance_phylo.
#' 
#' @inheritParams generateSyntheticData 
#' @inheritParams simulateData
#' 
#' @return A matrix N * P of factors to multiply the simulated phylogenetic residuals.
#' 
#' @keywords internal
#' 
scale_variance_process <- function(log_variance_phylo, tree, model.process, selection.strength) {
  fac <- get_model_factor(model.process, selection.strength, tree)
  return(fac %*% t(sqrt(log_variance_phylo)))
}

#' @title Get the scaling factor
#'
#' @description 
#' Get the scaling factors.
#' 
#' @inheritParams generateSyntheticData 
#' 
#' @return A vector N of factors.
#' 
#' @keywords internal
#' 
get_model_factor <- function(model.process, selection.strength, tree) {
  heights <- ape::node.depth.edgelength(tree)[1:length(tree$tip.label)]
  if (model.process == "BM" || selection.strength == 0) {
    return(sqrt(1 / heights))
  } else if (model.process == "OU") {
    return(sqrt(1 / expm1(-2 * selection.strength * heights) * (-2 * selection.strength)))
  } else {
    stop("Process not yet implemented.")
  }
}

#' @title Simulate a length matrix with a phylo model
#'
#' @description 
#' Simulate a length matrix of size n.vars times n.sample, with the length of
#' each gene in each sample. 
#' 
#' @param tree The phylogeneti tree.
#' @param id.species An n.sample vector, indicating the species of each sample.
#' @param lengths.relmeans A vector of mean values to use in the simulation of
#' lengths from the Negative Binomial distribution.
#' @param lengths.dispersions A vector or matrix of dispersions to use in the
#' simulation of data from the Negative Binomial distribution.
#' @param lengths.lambda A vector of heritability parameters to use in the
#' simulation of data from the lambda model.
#' 
#' @return A matrix of the same size as 'length_matrix', with normalization
#' factors to be applied for each sample and each gene.
#' 
#' @keywords internal
#'
generateLengthsPhylo <- function(tree, id.species, lengths.relmeans, lengths.dispersions) {
  tree_sp <- trim_tree(tree, id.species)
  ntaxa <- length(unique(id.species))
  params_simus <- getNegativeBinomialParameters(n.vars = length(lengths.relmeans),
                                                S1 = 1:ntaxa, prob.S1 = lengths.relmeans, sum.S1 = 1.0, truedispersions.S1 = lengths.dispersions, nfact_length.S1 = matrix(NA, 0, 0),
                                                S2 = NULL, prob.S2 = 0, sum.S2 = 0, truedispersions.S2 = 0, nfact_length.S2 = matrix(NA, 0, 0),
                                                seq.depths = rep(1.0, ntaxa))
  lengths_unique <- simulateDataPhylo(params_simus$count_means,
                                      params_simus$count_dispersions,
                                      tree = tree_sp, prop.var.tree = 1.0,
                                      model.process = "BM", selection.strength = 0) 
  length_matrix <- lengths_unique[, id.species]
  return(length_matrix)
}

trim_tree <- function(tree, id.species) {
  tips_to_keep <- tree$tip.label[!duplicated(id.species)]
  tree_sp <- ape::keep.tip(tree, tips_to_keep)
  tree_sp$tip.label <- as.character(unique(id.species))
  return(tree_sp)
}

#' @title Effective Sample Size
#'
#' @description 
#' Sample size so that the variance of the estimator is sigma^2 / nEff.
#' 
#' @param tree A phylogenetic tree. If \code{NULL}, samples are assumed to be iid.
#' @param id.condition A named vector giving the state of each tip (sample).
#' @param model The trait evolution model. One of "BM" or "OU".
#' @param selection.strength If \code{model="OU"}, the selection strength parameter.
#' 
#' @return The effective sample size.
#' 
#' @keywords internal
#' 
nEffNaive <- function(tree, id.condition, model, selection.strength) {
  if (length(unique(id.condition)) != 2) stop("There should be only two conditions")
  if (is.null(tree)) {
    n <- length(id.condition)
    id_cond_uni <- id.condition
    Vinv <- diag(1, n)
  } else {
    # Check vector order
    id.condition <- checkParamVector(id.condition, "id.condition", tree)
    # tree
    tree_uni <- prune_tree_one_obs(tree)
    id_cond_uni <- id.condition[tree_uni$tip.label]
    n <- length(tree_uni$tip.label)
    if (model == "OU") model <- "OUfixedRoot"
    V <- ape::vcv(phylolm::transf.branch.lengths(tree_uni, model = model, list(alpha = selection.strength))$tree)
    Vinv <- try(solve(V))
    if (inherits(Vinv, 'try-error')) Vinv <- ginv(V)
  }
  # Intercept
  X <- rep(1, n)
  # Model matrix
  Z <- stats::model.matrix(~factor(id_cond_uni))[, -1, drop = FALSE]
  # Variance of the condition
  X <- cbind(X, Z)
  nEff <- 1 / solve(t(X) %*% Vinv %*% X)[2, 2]
  return(nEff)
}

nEffSchur <- function(tree, id.condition, model, selection.strength) {
  if (length(unique(id.condition)) != 2) stop("There should be only two conditions")
  if (is.null(tree)) {
    n <- length(id.condition)
    id_cond_uni <- id.condition
    Vinv <- diag(1, n)
  } else {
    # Check vector order
    id.condition <- checkParamVector(id.condition, "id.condition", tree)
    # tree
    tree_uni <- prune_tree_one_obs(tree)
    id_cond_uni <- id.condition[tree_uni$tip.label]
    n <- length(tree_uni$tip.label)
    if (model == "OU") model <- "OUfixedRoot"
    V <- ape::vcv(phylolm::transf.branch.lengths(tree_uni, model = model, list(alpha = selection.strength))$tree)
    Vinv <- try(solve(V))
    if (inherits(Vinv, 'try-error')) Vinv <- ginv(V)
  }
  # Intercept
  X <- rep(1, n)
  # Model matrix
  Z <- stats::model.matrix(~factor(id_cond_uni))[, -1, drop = FALSE]
  # Variance of the condition
  X <- cbind(X, Z)
  M <- t(X) %*% Vinv %*% X
  nEff <- det(M) / M[1,1]
  return(nEff)
}

nEffPhylolm <- function(tree, id.condition, model, selection.strength) {
  if (length(unique(id.condition)) != 2) stop("There should be only two conditions")
  if (is.null(tree)) return(nEffNaive(tree, id.condition, model, selection.strength))
  # Check vector order
  id.condition <- checkParamVector(id.condition, "id.condition", tree)
  # tree
  tree_uni <- prune_tree_one_obs(tree)
  id_cond_uni <- id.condition[tree_uni$tip.label]
  n <- length(tree_uni$tip.label)
  # phylolm
  e1 <- rnorm(n)
  names(e1) <- tree_uni$tip.label
  if (model == "OU") model <- "OUfixedRoot"
  tree_trans <- phylolm::transf.branch.lengths(tree_uni, model = model, list(alpha = selection.strength))$tree
  phyfit <- phylolm::phylolm(e1 ~ 1 + as.factor(id_cond_uni), phy = tree_trans)
  nEff <- 1 / (phyfit$vcov[2, 2] / phyfit$sigma2 / n * (n - 2))
  return(nEff)
}

#' @title Effective Sample Size Ratio
#'
#' @description 
#' Ratio between the tree sample size and the sample size of the equivalent problem
#' with independent measures. A result larger than one indicates a problem that is
#' made "easier" by the tree structure. Note that it strongly depends on the 
#' tip conditions (see examples).
#' 
#' @param tree A phylogenetic tree. If \code{NULL}, samples are assumed to be iid.
#' @param id.condition A named vector giving the state of each tip (sample).
#' @param model The trait evolution model. One of "BM" or "OU".
#' @param selection.strength If \code{model="OU"}, the selection strength parameter.
#' 
#' @return The ratio of sample sizes.
#' 
#' @examples 
#' set.seed(1289)
#' ## Ballanced tree
#' ntips <- 2^5
#' tree <- ape::compute.brlen(ape::stree(ntips, "balanced"))
#' ## Alt cond : nEff greater than 1
#' id_cond <- rep(rep(0:1, each = 2), ntips / 4)
#' names(id_cond) <- tree$tip.label
#' plot(tree); ape::tiplabels(pch = 21, col = id_cond, bg = id_cond)
#' compcodeR:::nEffRatio(tree, id_cond, "BM", 0)
#' ## Bloc cond : nEff smaller than 1
#' id_cond <- rep(0:1, each = ntips / 2)
#' names(id_cond) <- tree$tip.label
#' plot(tree); ape::tiplabels(pch = 21, col = id_cond, bg = id_cond)
#' compcodeR:::nEffRatio(tree, id_cond, "BM", 0)
#' 
#' @keywords internal
#' 
nEffRatio <- function(tree, id.condition, model, selection.strength) {
  if (is.null(tree)) {
    n <- length(id.condition)
  } else {
    n <- length(prune_tree_one_obs(tree)$tip.label)
  }
  return(nEffNaive(tree, id.condition, model, selection.strength) / (n / 4))
}

prune_tree_one_obs <- function(tree) {
  C <- ape::cophenetic.phylo(tree)
  C <- apply(C, c(1, 2), function(x) isTRUE(all.equal(x, 0)))
  duplicated_species <- colnames(C)[duplicated(C)]
  tree_unique <- ape::drop.tip(tree, duplicated_species)
  return(tree_unique)
}

context("Lengths and length factors")

test_that("computeFactorLengths is equivalent to trueProba", {
  set.seed(20200430)
  
  n.sample <- 3
  n.vars <- 5
  
  ## Mock data
  count.matrix <- matrix(c(5,3,8,17,23,42,10,13,27,752,615,1203,1507,1225,2455), ncol = n.sample, byrow = T)
  truemeans <- rowMeans(count.matrix)
  leng <- matrix(c(rep(1000, 2 * n.vars - 1), 2000, 1:n.vars*1000), ncol = n.sample, byrow = F)
  
  ## True proba
  trueMeansLeng <- diag(truemeans) %*% leng
  trueProbas <- trueMeansLeng %*% diag(1 / colSums(trueMeansLeng))
  
  ## nfact
  lfact <- computeFactorLengths(leng, truemeans, sum(truemeans))
  
  ## Equal
  expect_equal(trueProbas, diag(truemeans / sum(truemeans)) %*% lfact)
  
  ## Sequencing depths
  seqdepth <- 2500
  nfacts <- runif(n.sample, min = 0.7, max = 1.4)
  seq.depths <- nfacts * seqdepth
  
  ## expectations
  exp_1 <- trueProbas %*% diag(seq.depths)
  expect_equal(colSums(exp_1), seq.depths)
  
  exp_2 <- diag(truemeans / sum(truemeans)) %*% lfact %*% diag(seq.depths)
  expect_equal(exp_1, exp_2)
})

test_that("computeFactorLengths is equivalent to trueProba", {
  skip_if_not_installed("phytools")
  set.seed(20200430)
  
  ntaxa <- 10
  nrep <- 3
  n.sample <- ntaxa * nrep
  n.vars <- 50
  
  ## Mock tree
  set.seed("17900714")
  tree <- ape::rphylo(ntaxa, birth = 0.1, death = 0)
  # rescale to unit height
  tree$edge.length <- tree$edge.length / max(ape::node.depth.edgelength(tree))
  # rename tims
  tree$tip.label <- paste0("t", 1:ntaxa)
  tree <- add_replicates(tree, nrep)
  
  id.species <- rep(1:ntaxa, each = nrep)
  names(id.species) <- tree$tip.label
  id.species <- as.factor(id.species)
  
  id.species <- checkSpecies(id.species, "id.species", tree, 1e-10, TRUE)
  
  ## Mock data
  count.matrix <- matrix(rpois(n.sample * n.vars, 1:10 * 10), ncol = n.sample, byrow = T)
  truemeans <- rowMeans(count.matrix)
  leng <- matrix(c(rep(1000, 2 * n.vars - 1), 2000, 1:n.vars*1000), ncol = n.sample, byrow = F)
  lengths.relmeans <- 1:n.vars * 1000
  lengths.dispersions <- 1:n.vars / 10
  leng <- generateLengths(id.species, lengths.relmeans, lengths.dispersions)
  
  expect_equal(leng[, 1], leng[, 2])
  expect_equal(leng[, 4], leng[, 5])
  
  ## True proba
  trueMeansLeng <- diag(truemeans) %*% leng
  trueProbas <- trueMeansLeng %*% diag(1 / colSums(trueMeansLeng))
  
  ## nfact
  lfact <- computeFactorLengths(leng, truemeans, sum(truemeans))
  
  ## Equal
  expect_equal(trueProbas, diag(truemeans / sum(truemeans)) %*% lfact)
  
  ## Sequencing depths
  seqdepth <- 2500
  nfacts <- runif(n.sample, min = 0.7, max = 1.4)
  seq.depths <- nfacts * seqdepth
  
  ## expectations
  exp_1 <- trueProbas %*% diag(seq.depths)
  expect_equal(colSums(exp_1), seq.depths)
  
  exp_2 <- diag(truemeans / sum(truemeans)) %*% lfact %*% diag(seq.depths)
  expect_equal(exp_1, exp_2)
})

context("Negative Binomial to Poisson Log Normal")

test_that("NB to PLN simple", {
  set.seed(18420318)
  
  n <- 20000000
  
  ## NB
  mean_nb <- 500
  dispersion_nb <- 0.2
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- rnbinom(n = n,
                       mu = mean_nb, 
                       size = 1 / dispersion_nb)
  
  ## PLN
  params_PLN <- NB_to_PLN(mean_nb, dispersion_nb)
  
  sample_ln <- rnorm(n = n,
                      mean = params_PLN$log_means_pln,
                      sd = sqrt(params_PLN$log_variances_pln))
  sample_pln <- rpois(n, exp(sample_ln))
  
  ## Comparison
  expect_equal(mean(sample_nb) - mean_nb, 0, tolerance = 0.05)
  expect_equal(sd(sample_nb) - sd_nb, 0, tolerance = 0.05)
  
  expect_equal(mean(sample_pln) - mean_nb, 0, tolerance = 0.05)
  expect_equal(sd(sample_pln) - sd_nb, 0, tolerance = 0.07)
})

test_that("NB to PLN phylo - errors", {
  skip_if_not_installed("phylolm")
  
  set.seed(18420318)
  
  ## Parameters
  n <- 20
  ntaxa <- 8
  
  ## Tree
  tree <- ape::read.tree(text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);")

  ## NB
  mean_nb <- 1:ntaxa * 100
  dispersion_nb <- 1:ntaxa/2 / 100
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- t(matrix(rnbinom(n = ntaxa * n,
                                mu = mean_nb, 
                                size = 1 / dispersion_nb), nrow = ntaxa))
  
  ## PLN
  names(mean_nb) <- tree$tip.label
  names(dispersion_nb) <- tree$tip.label
  
  expect_error(get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), 1.2),
               "`prop.var.tree` should be between 0 and 1.")
  
  expect_error(get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), c(0.1, 0.2)),
               "should be a vector of length the number of genes")
  
  expect_error(get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), matrix(0.1, 2, 2)),
               "`prop.var.tree` should be a vector")
  
  params_PLN <- get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), 1.0)
  
  expect_error(simulatePhyloPoissonLogNormal(tree, params_PLN$log_means[1:10, ], params_PLN$log_variance_phylo, params_PLN$log_variance_sample),
               "`log_means` and `log_variance_sample should have as many rows as the length of `log_variance_phylo`.")
  
  expect_error(simulatePhyloPoissonLogNormal(tree, params_PLN$log_means[, 3:8], params_PLN$log_variance_phylo, params_PLN$log_variance_sample),
               "log means` should have as many columns as the number of taxa in the tree.")
  
  expect_warning(simulatePhyloPoissonLogNormal(tree, params_PLN$log_means[, c(2, 1, 3:8)], params_PLN$log_variance_phylo, params_PLN$log_variance_sample),
               "`log means` was not sorted in the correct order, when compared with the tips label. I am re-ordering it.")
  
  pplm <- params_PLN$log_means
  colnames(pplm) <- c("W", colnames(params_PLN$log_means[, 2:8]))
  expect_error(simulatePhyloPoissonLogNormal(tree, pplm, params_PLN$log_variance_phylo, params_PLN$log_variance_sample),
                 "`log means` names do not match the tip labels.")
  
  
})

test_that("NB to PLN phylo - star tree", {
  skip_if_not_installed("phangorn")
  skip_if_not_installed("phylolm")
  
  set.seed(18420318)
  
  ## Parameters
  n <- 200000
  ntaxa <- 4
  
  ## Tree
  tree <- ape::stree(ntaxa, type = "star")
  tree <- ape::compute.brlen(tree, runif, min = 0, max = 1)
  tree <- phangorn::nnls.tree(ape::cophenetic.phylo(tree), tree, rooted = TRUE, trace = 0) # force ultrametric
  tree$edge.length <- tree$edge.length / max(ape::node.depth.edgelength(tree))
  
  ## NB
  mean_nb <- 1:ntaxa * 100
  dispersion_nb <- 1:ntaxa/2 / 100
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- t(matrix(rnbinom(n = ntaxa * n,
                                mu = mean_nb, 
                                size = 1 / dispersion_nb), nrow = ntaxa))
  
  ## PLN
  names(mean_nb) <- tree$tip.label
  names(dispersion_nb) <- tree$tip.label
  
  params_PLN <- get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), 1.0)
  
  sample_ppln <- simulatePhyloPoissonLogNormal(tree, params_PLN$log_means, params_PLN$log_variance_phylo, params_PLN$log_variance_sample)
  
  sample_ln <- sample_ppln$log_lambda
  sample_pln <- sample_ppln$counts
  rm(sample_ppln)
  
  mean_ln <- params_PLN$log_means[1, ]
  sd_ln <- sqrt((params_PLN$log_variance_phylo + params_PLN$log_variance_sample)[1, ])
  
  ## Comparisons NB
  expect_equivalent(colMeans(sample_nb) - mean_nb, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_nb) - sd_nb, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparison log lambda
  expect_equivalent(colMeans(sample_ln) - mean_ln, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_ln) - sd_ln, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparisons PLN
  expect_equivalent(colMeans(sample_pln) - mean_nb, rep(0, ntaxa), tolerance = 0.1)
  expect_equivalent(matrixStats::colSds(sample_pln) - sd_nb, rep(0, ntaxa), tolerance = 0.1)
})

test_that("NB to PLN phylo - random tree", {
  skip_if_not_installed("phangorn")
  skip_if_not_installed("phylolm")
  
  set.seed(18420318)
  
  ## Parameters
  n <- 1000000
  ntaxa <- 4
  
  ## Tree
  tree <- ape::rtree(ntaxa)
  tree <- ape::compute.brlen(tree, runif, min = 0, max = 1)
  tree <- phangorn::nnls.tree(ape::cophenetic.phylo(tree), tree, rooted = TRUE, trace = 0) # force ultrametric
  tree$edge.length <- tree$edge.length / max(ape::node.depth.edgelength(tree))
  
  ## NB
  mean_nb <- 1:ntaxa * 100
  dispersion_nb <- 1:ntaxa/2 / 100
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- t(matrix(rnbinom(n = ntaxa * n,
                                mu = mean_nb, 
                                size = 1 / dispersion_nb), nrow = ntaxa))
  
  ## PLN
  names(mean_nb) <- tree$tip.label
  names(dispersion_nb) <- tree$tip.label
  
  prop.var.tree <- 1.0
  
  params_PLN <- get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), prop.var.tree)
  
  sample_ppln <- simulatePhyloPoissonLogNormal(tree, params_PLN$log_means, params_PLN$log_variance_phylo, params_PLN$log_variance_sample)
  
  sample_ln <- sample_ppln$log_lambda
  sample_pln <- sample_ppln$counts
  rm(sample_ppln)
  
  mean_ln <- params_PLN$log_means[1, ]
  sd_ln <- sqrt((params_PLN$log_variance_phylo + params_PLN$log_variance_sample)[1, ])
  
  ## Comparisons NB
  expect_equivalent(colMeans(sample_nb) - mean_nb, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_nb) - sd_nb, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparison log lambda
  expect_equivalent(colMeans(sample_ln) - mean_ln, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_ln) - sd_ln, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparisons PLN
  expect_equivalent(colMeans(sample_pln) - mean_nb, rep(0, ntaxa), tolerance = 0.1)
  expect_equivalent(matrixStats::colSds(sample_pln) - sd_nb, rep(0, ntaxa), tolerance = 0.1)
  
  ## Phylogenetic covariances
  C_tree <- ape::vcv(tree)
  V_ln <- C_tree * params_PLN$log_variance_phylo[1] + diag(params_PLN$log_variance_sample[1, ])
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      if (V_ln[i, j] != 0) {
        expect_equivalent(cov(sample_ln[, i], sample_ln[, j]), V_ln[i, j], tolerance = 0.0001, scale = V_ln[i, j])
      } else {
        expect_equivalent(cov(sample_ln[, i], sample_ln[, j]) - V_ln[i, j], 0, tolerance = 0.0001)
      }
    }
  }
  
  ## Phylogenetic covariances - Pagel
  V_ln_pagel <- (params_PLN$log_variance_phylo[1] + params_PLN$log_variance_sample[1, 1]) * ape::vcv(phylolm::transf.branch.lengths(tree, model = "lambda", list(lambda = prop.var.tree))$tree)
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      expect_equal(V_ln_pagel[i, j], V_ln[i, j], scale = V_ln[i, j])
    }
  }
  
  ## Phylogenetic covariances for Counts
  V_tot <- (exp(V_ln) - 1) * mean_nb %*% t(mean_nb)
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      if (V_tot[i, j] != 0) {
        expect_equivalent(cov(sample_pln[, i], sample_pln[, j]), V_tot[i, j], tolerance = 0.1, scale = V_tot[i, j])
      } else {
        expect_equivalent(cov(sample_pln[, i], sample_pln[, j]) - V_tot[i, j], 0, tolerance = 1.0)
      }
    }
  }
})

test_that("NB to PLN phylo - star tree with repetitions", {
  skip_if_not_installed("phangorn")
  skip_if_not_installed("phytools")
  skip_if_not_installed("phylolm")
  
  set.seed(18420318)
  
  ## Parameters
  n <- 3000000
  ntaxa <- 2
  
  ## Tree
  tree <- ape::stree(ntaxa, type = "star")
  tree <- ape::compute.brlen(tree, 1.0)
  
  ## Repetitions
  r <- 2
  ntaxa <- r * ntaxa
  
  tree <- add_replicates(tree, r)
  
  ## NB
  mean_nb <- 1:ntaxa * 100
  dispersion_nb <- 1:ntaxa/2 / 100
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- t(matrix(rnbinom(n = ntaxa * n,
                                mu = mean_nb, 
                                size = 1 / dispersion_nb), nrow = ntaxa))
  
  ## PLN
  names(mean_nb) <- tree$tip.label
  names(dispersion_nb) <- tree$tip.label
  
  prop.var.tree <- 0.5
  
  params_PLN <- get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), prop.var.tree)
  
  sample_ppln <- simulatePhyloPoissonLogNormal(tree, params_PLN$log_means, params_PLN$log_variance_phylo, params_PLN$log_variance_sample)
  
  sample_ln <- sample_ppln$log_lambda
  sample_pln <- sample_ppln$counts
  rm(sample_ppln)
  
  mean_ln <- params_PLN$log_means[1, ]
  sd_ln <- sqrt((params_PLN$log_variance_phylo + params_PLN$log_variance_sample)[1, ])
  
  ## Comparisons NB
  expect_equivalent(colMeans(sample_nb) - mean_nb, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_nb) - sd_nb, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparison log lambda
  expect_equivalent(colMeans(sample_ln) - mean_ln, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_ln) - sd_ln, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparisons PLN
  expect_equivalent(colMeans(sample_pln) - mean_nb, rep(0, ntaxa), tolerance = 0.1)
  expect_equivalent(matrixStats::colSds(sample_pln) - sd_nb, rep(0, ntaxa), tolerance = 0.1)
  
  ## Phylogenetic covariances
  C_tree <- ape::vcv(tree)
  V_ln <- C_tree * params_PLN$log_variance_phylo[1] + diag(params_PLN$log_variance_sample[1, ])
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      if (V_ln[i, j] != 0) {
        expect_equivalent(cov(sample_ln[, i], sample_ln[, j]), V_ln[i, j], tolerance = 0.0001, scale = V_ln[i, j])
      } else {
        expect_equivalent(cov(sample_ln[, i], sample_ln[, j]) - V_ln[i, j], 0, tolerance = 0.0001)
      }
    }
  }
  
  ## Phylogenetic covariances - Pagel
  V_ln_pagel <- (params_PLN$log_variance_phylo[1] + params_PLN$log_variance_sample[1, 1]) * ape::vcv(phylolm::transf.branch.lengths(tree, model = "lambda", list(lambda = prop.var.tree))$tree)
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
        expect_equal(V_ln_pagel[i, j], V_ln[i, j], scale = V_ln[i, j])
    }
  }
  
  ## Phylogenetic covariances for Counts
  V_tot <- (exp(V_ln) - 1) * mean_nb %*% t(mean_nb)
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      if (V_tot[i, j] != 0) {
        expect_equivalent(cov(sample_pln[, i], sample_pln[, j]), V_tot[i, j], tolerance = 0.05, scale = V_tot[i, j])
      } else {
        expect_equivalent(cov(sample_pln[, i], sample_pln[, j]) - V_tot[i, j], 0, tolerance = 0.6)
      }
    }
  }
})

test_that("NB to PLN phylo - random tree - OU", {
  skip_if_not_installed("phangorn")
  skip_if_not_installed("phylolm")
  
  set.seed(18420318)
  
  ## Parameters
  n <- 3000000
  ntaxa <- 4
  selection.strength <- 1
  
  ## Tree
  tree <- ape::rtree(ntaxa)
  tree <- ape::compute.brlen(tree, runif, min = 0, max = 1)
  tree <- phangorn::nnls.tree(ape::cophenetic.phylo(tree), tree, rooted = TRUE, trace = 0) # force ultrametric
  tree_height <- ape::vcv(tree)[1, 1]
  
  ## NB
  mean_nb <- 1:ntaxa * 100
  dispersion_nb <- 1:ntaxa/2 / 100
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- t(matrix(rnbinom(n = ntaxa * n,
                                mu = mean_nb, 
                                size = 1 / dispersion_nb), nrow = ntaxa))
  
  ## PLN
  names(mean_nb) <- tree$tip.label
  names(dispersion_nb) <- tree$tip.label
  
  prop.var.tree <- 0.7
  
  params_PLN <- get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), prop.var.tree)
  
  sample_ppln <- simulatePhyloPoissonLogNormal(tree,
                                               params_PLN$log_means,
                                               params_PLN$log_variance_phylo,
                                               params_PLN$log_variance_sample,
                                               model.process = "OU",
                                               selection.strength = selection.strength)
  
  sample_ln <- sample_ppln$log_lambda
  sample_pln <- sample_ppln$counts
  rm(sample_ppln)
  
  mean_ln <- params_PLN$log_means[1, ]
  sd_ln <- sqrt((params_PLN$log_variance_phylo + params_PLN$log_variance_sample)[1, ])
  
  ## Comparisons NB
  expect_equivalent(colMeans(sample_nb) - mean_nb, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_nb) - sd_nb, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparison log lambda
  expect_equivalent(colMeans(sample_ln) - mean_ln, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_ln) - sd_ln, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparisons PLN
  expect_equivalent(colMeans(sample_pln) - mean_nb, rep(0, ntaxa), tolerance = 0.1)
  expect_equivalent(matrixStats::colSds(sample_pln) - sd_nb, rep(0, ntaxa), tolerance = 0.1)
  
  ## Phylogenetic covariances
  C_tree <- ape::vcv(phylolm::transf.branch.lengths(tree, model = "OUfixedRoot", parameters = list(alpha = selection.strength))$tree)
  V_ln <- C_tree * params_PLN$log_variance_phylo[1] / -expm1(-2 * selection.strength * tree_height) + diag(params_PLN$log_variance_sample[1, ])
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      if (V_ln[i, j] != 0) {
        expect_equivalent(cov(sample_ln[, i], sample_ln[, j]), V_ln[i, j], tolerance = 0.00001, scale = V_ln[i, j])
      } else {
        expect_equivalent(cov(sample_ln[, i], sample_ln[, j]) - V_ln[i, j], 0, tolerance = 0.0001)
      }
    }
  }
  
  ## Phylogenetic covariances for Counts
  V_tot <- (exp(V_ln) - 1) * mean_nb %*% t(mean_nb)
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      if (V_tot[i, j] != 0) {
        expect_equivalent(cov(sample_pln[, i], sample_pln[, j]), V_tot[i, j], tolerance = 0.06, scale = V_tot[i, j])
      } else {
        expect_equivalent(cov(sample_pln[, i], sample_pln[, j]) - V_tot[i, j], 0, tolerance = 1.0)
      }
    }
  }
})

test_that("NB to PLN phylo - random tree - Not Unit Length", {
  skip_if_not_installed("phangorn")
  skip_if_not_installed("phylolm")
  
  set.seed(18420318)
  
  ## Parameters
  n <- 4000000
  ntaxa <- 4
  selection.strength <- 1
  
  ## Tree
  tree <- ape::rtree(ntaxa)
  tree <- ape::compute.brlen(tree, runif, min = 0, max = 1)
  tree <- phangorn::nnls.tree(ape::cophenetic.phylo(tree), tree, rooted = TRUE, trace = 0) # force ultrametric
  tree_height <- ape::vcv(tree)[1, 1]

  ## NB
  mean_nb <- 1:ntaxa * 100
  dispersion_nb <- 1:ntaxa/2 / 100
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- t(matrix(rnbinom(n = ntaxa * n,
                                mu = mean_nb, 
                                size = 1 / dispersion_nb), nrow = ntaxa))
  
  ## PLN
  names(mean_nb) <- tree$tip.label
  names(dispersion_nb) <- tree$tip.label
  
  prop.var.tree <- 1.0
  
  params_PLN <- get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), prop.var.tree)
  
  sample_ppln <- simulatePhyloPoissonLogNormal(tree,
                                               params_PLN$log_means,
                                               params_PLN$log_variance_phylo,
                                               params_PLN$log_variance_sample)
  
  sample_ln <- sample_ppln$log_lambda
  sample_pln <- sample_ppln$counts
  rm(sample_ppln)
  
  mean_ln <- params_PLN$log_means[1, ]
  sd_ln <- sqrt((params_PLN$log_variance_phylo + params_PLN$log_variance_sample)[1, ])
  
  ## Comparisons NB
  expect_equivalent(colMeans(sample_nb) - mean_nb, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_nb) - sd_nb, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparison log lambda
  expect_equivalent(colMeans(sample_ln) - mean_ln, rep(0, ntaxa), tolerance = 0.05)
  expect_equivalent(matrixStats::colSds(sample_ln) - sd_ln, rep(0, ntaxa), tolerance = 0.05)
  
  ## Comparisons PLN
  expect_equivalent(colMeans(sample_pln) - mean_nb, rep(0, ntaxa), tolerance = 0.1)
  expect_equivalent(matrixStats::colSds(sample_pln) - sd_nb, rep(0, ntaxa), tolerance = 0.1)
  
  ## Phylogenetic covariances
  C_tree <- ape::vcv(tree)
  V_ln <- C_tree * params_PLN$log_variance_phylo[1] / tree_height + diag(params_PLN$log_variance_sample[1, ])
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      if (V_ln[i, j] != 0) {
        expect_equivalent(cov(sample_ln[, i], sample_ln[, j]), V_ln[i, j], tolerance = 0.0001, scale = V_ln[i, j])
      } else {
        expect_equivalent(cov(sample_ln[, i], sample_ln[, j]) - V_ln[i, j], 0, tolerance = 0.0001)
      }
    }
  }
  
  ## Phylogenetic covariances - Pagel
  V_ln_pagel <- (params_PLN$log_variance_phylo[1] * tree_height / prop.var.tree) * ape::vcv(phylolm::transf.branch.lengths(tree, model = "lambda", list(lambda = prop.var.tree))$tree)
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      expect_equal(V_ln_pagel[i, j], V_ln[i, j], tolerance = 1e-4)
    }
  }
  
  ## Phylogenetic covariances for Counts
  V_tot <- (exp(V_ln) - 1) * mean_nb %*% t(mean_nb)
  for (i in 1:(ntaxa-1)) {
    for (j in (i+1):ntaxa) {
      if (V_tot[i, j] != 0) {
        expect_equivalent(cov(sample_pln[, i], sample_pln[, j]), V_tot[i, j], tolerance = 0.06, scale = V_tot[i, j])
      } else {
        expect_equivalent(cov(sample_pln[, i], sample_pln[, j]) - V_tot[i, j], 0, tolerance = 1.0)
      }
    }
  }
})

test_that("NB to PLN phylo - random tree - Not Unit Length - With Rep - Uniform disp", {
  skip_if_not_installed("phangorn")
  skip_if_not_installed("phylolm")
  
  set.seed(18420318)
  
  ## Parameters
  n <- 1
  ntaxa <- 10
  selection.strength <- 1
  
  ## Tree
  tree <- ape::rtree(ntaxa)
  tree <- ape::compute.brlen(tree, runif, min = 0, max = 1)
  tree <- phangorn::nnls.tree(ape::cophenetic.phylo(tree), tree, rooted = TRUE, trace = 0) # force ultrametric
  tree_height <- ape::vcv(tree)[1, 1]
  
  ## Repetitions
  r <- 2
  ntaxa <- r * ntaxa
  tree <- add_replicates(tree, r)
  
  ## NB
  mean_nb <- 1:ntaxa * 100
  dispersion_nb <- rep(1,ntaxa)/2 / 100
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- t(matrix(rnbinom(n = ntaxa * n,
                                mu = mean_nb, 
                                size = 1 / dispersion_nb), nrow = ntaxa))
  
  ## PLN
  names(mean_nb) <- tree$tip.label
  names(dispersion_nb) <- tree$tip.label
  
  prop.var.tree <- 0.6
  
  params_PLN <- get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), prop.var.tree)
  
  sample_ppln <- simulatePhyloPoissonLogNormal(tree,
                                               params_PLN$log_means,
                                               params_PLN$log_variance_phylo,
                                               params_PLN$log_variance_sample)
  
  sample_ln <- sample_ppln$log_lambda
  sample_pln <- sample_ppln$counts
  rm(sample_ppln)
  
  mean_ln <- params_PLN$log_means[1, ]
  sd_ln <- sqrt((params_PLN$log_variance_phylo + params_PLN$log_variance_sample)[1, ])
  

  ## Phylogenetic covariances
  C_tree <- ape::vcv(tree)
  V_ln <- C_tree * params_PLN$log_variance_phylo[1] / tree_height + diag(params_PLN$log_variance_sample[1, ])
  
  ## Phylogenetic covariances - Pagel
  V_ln_pagel <- (params_PLN$log_variance_phylo[1] / tree_height / prop.var.tree) * ape::vcv(phylolm::transf.branch.lengths(tree, model = "lambda", list(lambda = prop.var.tree))$tree)
  expect_equal(V_ln_pagel, V_ln)
  
})

test_that("NB to PLN phylo - random tree - OU - Not Unit Length - With Rep - Uniform disp", {
  skip_if_not_installed("phangorn")
  skip_if_not_installed("phylolm")
  
  set.seed(18420318)
  
  ## Parameters
  n <- 1
  ntaxa <- 10
  selection.strength <- 1
  
  ## Tree
  tree <- ape::rtree(ntaxa)
  tree <- ape::compute.brlen(tree, runif, min = 0, max = 1)
  tree <- phangorn::nnls.tree(ape::cophenetic.phylo(tree), tree, rooted = TRUE, trace = 0) # force ultrametric
  tree_height <- ape::vcv(tree)[1, 1]
  
  ## Repetitions
  r <- 2
  ntaxa <- r * ntaxa
  tree <- add_replicates(tree, r)
  
  ## NB
  mean_nb <- 1:ntaxa * 100
  dispersion_nb <- rep(1,ntaxa)/2 / 100
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- t(matrix(rnbinom(n = ntaxa * n,
                                mu = mean_nb, 
                                size = 1 / dispersion_nb), nrow = ntaxa))
  
  ## PLN
  names(mean_nb) <- tree$tip.label
  names(dispersion_nb) <- tree$tip.label
  
  prop.var.tree <- 0.6
  
  params_PLN <- get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), prop.var.tree)
  
  sample_ppln <- simulatePhyloPoissonLogNormal(tree,
                                               params_PLN$log_means,
                                               params_PLN$log_variance_phylo,
                                               params_PLN$log_variance_sample,
                                               model.process = "OU",
                                               selection.strength = selection.strength)
  
  sample_ln <- sample_ppln$log_lambda
  sample_pln <- sample_ppln$counts
  rm(sample_ppln)
  
  mean_ln <- params_PLN$log_means[1, ]
  sd_ln <- sqrt((params_PLN$log_variance_phylo + params_PLN$log_variance_sample)[1, ])
  
  
  ## Phylogenetic covariances
  C_tree <- ape::vcv(phylolm::transf.branch.lengths(tree, model = "OUfixedRoot", parameters = list(alpha = selection.strength))$tree)
  V_ln <- C_tree * params_PLN$log_variance_phylo[1] / -expm1(-2 * selection.strength * tree_height) + diag(params_PLN$log_variance_sample[1, ])
  
  ## Phylogenetic covariances - Pagel
  tree_ou <- phylolm::transf.branch.lengths(tree, model = "OUfixedRoot", list(alpha = selection.strength))$tree
  V_ln_pagel <- (params_PLN$log_variance_phylo[1] / -expm1(-2 * selection.strength * tree_height) / prop.var.tree) * ape::vcv(phylolm::transf.branch.lengths(tree_ou, model = "lambda", list(lambda = prop.var.tree))$tree)
  
  expect_equal(V_ln_pagel, V_ln)
  
})

test_that("NB to PLN phylo - random tree - variable prop.var.tree", {
  skip_if_not_installed("phangorn")
  skip_if_not_installed("phylolm")
  
  set.seed(18420318)
  
  ## Parameters
  n <- 10000
  ntaxa <- 4
  
  ## Tree
  tree <- ape::rtree(ntaxa)
  tree <- ape::compute.brlen(tree, runif, min = 0, max = 1)
  tree <- phangorn::nnls.tree(ape::cophenetic.phylo(tree), tree, rooted = TRUE, trace = 0) # force ultrametric
  tree$edge.length <- tree$edge.length / max(ape::node.depth.edgelength(tree))
  
  ## NB
  mean_nb <- 1:ntaxa * 100
  dispersion_nb <- 1:ntaxa/2 / 100
  
  sd_nb <- sqrt(mean_nb + dispersion_nb * mean_nb^2)
  
  sample_nb <- t(matrix(rnbinom(n = ntaxa * n,
                                mu = mean_nb, 
                                size = 1 / dispersion_nb), nrow = ntaxa))
  
  ## PLN
  names(mean_nb) <- tree$tip.label
  names(dispersion_nb) <- tree$tip.label
  
  prop.var.tree <- runif(n)
  
  params_PLN <- get_poisson_log_normal_parameters(rep(1, n) %*% t(mean_nb), rep(1, n) %*% t(dispersion_nb), prop.var.tree)
  
  sample_ppln <- simulatePhyloPoissonLogNormal(tree, params_PLN$log_means, params_PLN$log_variance_phylo, params_PLN$log_variance_sample)
  
  sample_ln <- sample_ppln$log_lambda
  sample_pln <- sample_ppln$counts
  rm(sample_ppln)
  
  mean_ln <- params_PLN$log_means[1, ]
  sd_ln <- sqrt((params_PLN$log_variance_phylo + params_PLN$log_variance_sample)[1, ])
  
  ## Comparisons NB
  expect_equivalent(colMeans(sample_nb), mean_nb, tolerance = 0.001)
  expect_equivalent(matrixStats::colSds(sample_nb), sd_nb, tolerance = 0.01)
  
  ## Comparison log lambda
  expect_equivalent(colMeans(sample_ln),mean_ln, tolerance = 0.001)
  expect_equivalent(matrixStats::colSds(sample_ln), sd_ln, tolerance = 0.01)
  
  ## Comparisons PLN
  expect_equivalent(colMeans(sample_pln), mean_nb, tolerance = 0.001)
  expect_equivalent(matrixStats::colSds(sample_pln), sd_nb, tolerance = 0.05)
  
  ## Always the same total variance
  for (i in 1:ntaxa) {
    expect_equivalent(params_PLN$log_variance_phylo + params_PLN$log_variance_sample[, i],
                      rep(params_PLN$log_variance_phylo[1] + params_PLN$log_variance_sample[1, i], n))
  }
  
  ## Phylogenetic covariances - Pagel
  C_tree <- ape::vcv(tree)
  for (ng in sample(n, 100)) { ## test for only 100 genes at random
    V_ln <- C_tree * params_PLN$log_variance_phylo[ng] + diag(params_PLN$log_variance_sample[ng, ])
    V_ln_pagel <- (params_PLN$log_variance_phylo[ng] + params_PLN$log_variance_sample[ng, 1]) * ape::vcv(phylolm::transf.branch.lengths(tree, model = "lambda", list(lambda = prop.var.tree[ng]))$tree)
    for (i in 1:(ntaxa-1)) {
      for (j in (i+1):ntaxa) {
        expect_equal(V_ln_pagel[i, j], V_ln[i, j], scale = V_ln[i, j])
      }
    }
  }

})

context("Moments of the Negative Binomial and Poisson Log Normal are the same")

test_that("Moments of the Negative Binomial and Log Normal are the same", {
  
  tdir <- tempdir()
  
  ## Tree and conds
  n <- 20
  tree <- ape::stree(n)
  tree$edge.length <- rep(10, nrow(tree$edge))
  
  id_species <- tree$tip.label
  id_species <- factor(id_species)
  names(id_species) <- tree$tip.label
  
  ## Condn alternate tips
  species_names <- tree$tip.label
  cond_species <- rep(c(1, 2), length(species_names) / 2)
  names(cond_species) <- species_names
  
  id_cond <- id_species
  id_cond <- cond_species[as.vector(id_cond)]
  id_cond <- as.factor(id_cond)
  
  ## Parameters
  n.vars <- 1000
  relmean <- 100
  reldisp <- 0.1
  seqdepth <- 10000
  
  true_mean <- seqdepth / n.vars
  true_var <- reldisp * true_mean^2 + true_mean
  true_sd <- sqrt(true_var)
  
  ## No tree
  set.seed(18570823)
  dataset <- "no_tree"
  no_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                  n.vars = n.vars,
                                                  samples.per.cond = n / 2,
                                                  n.diffexp = 0,
                                                  repl.id = 1,
                                                  seqdepth = seqdepth,
                                                  minfact = 1,
                                                  maxfact = 1,
                                                  relmeans = rep(relmean, n.vars),
                                                  dispersions = rep(reldisp, n.vars),
                                                  fraction.upregulated = 1,
                                                  between.group.diffdisp = FALSE,
                                                  filter.threshold.total = 1,
                                                  filter.threshold.mediancpm = 0,
                                                  fraction.non.overdispersed = 0,
                                                  random.outlier.high.prob = 0,
                                                  random.outlier.low.prob = 0,
                                                  single.outlier.high.prob = 0,
                                                  single.outlier.low.prob = 0,
                                                  effect.size = 1,
                                                  output.file = file.path(tdir, "tmp.rds"),
                                                  id.condition = id_cond,
                                                  id.species = id_species,
                                                  lengths.relmeans = NULL,
                                                  lengths.dispersions = NULL,
                                                  lengths.phylo = FALSE
  )
  
  ## us tree
  set.seed(18570823)
  dataset <- "tree"
  us_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                  n.vars = n.vars,
                                                  samples.per.cond = n / 2,
                                                  n.diffexp = 0,
                                                  repl.id = 1,
                                                  seqdepth = seqdepth,
                                                  minfact = 1,
                                                  maxfact = 1,
                                                  relmeans = rep(relmean, n.vars),
                                                  dispersions = rep(reldisp, n.vars),
                                                  fraction.upregulated = 1,
                                                  between.group.diffdisp = FALSE,
                                                  filter.threshold.total = 1,
                                                  filter.threshold.mediancpm = 0,
                                                  fraction.non.overdispersed = 0,
                                                  random.outlier.high.prob = 0,
                                                  random.outlier.low.prob = 0,
                                                  single.outlier.high.prob = 0,
                                                  single.outlier.low.prob = 0,
                                                  effect.size = 1,
                                                  output.file = file.path(tdir, "tmp.rds"),
                                                  tree = tree,
                                                  id.condition = id_cond,
                                                  id.species = id_species,
                                                  lengths.relmeans = NULL,
                                                  lengths.dispersions = NULL,
                                                  lengths.phylo = FALSE
  )
  
  
  ## Comparisons
  mean_no_tree <- mean(no_tree_sim@count.matrix)
  sd_no_tree <- sd(no_tree_sim@count.matrix)
  
  mean_us_tree <- mean(us_tree_sim@count.matrix)
  sd_us_tree <- sd(us_tree_sim@count.matrix)
  
  testthat::expect_equal(mean_no_tree, true_mean, tol = 1e-2)
  testthat::expect_equal(mean_us_tree, true_mean, tol = 1e-2)

  testthat::expect_equal(sd_no_tree, true_sd, tol = 1e-2)
  testthat::expect_equal(sd_us_tree, true_sd, tol = 1e-2)

  ## Correlation Comparisons
  corup <- function(x, ...) {
    cc <- cor(x, ...)
    return(cc[upper.tri(cc)])
  }
  # Pearson correlations are equal
  cor_no_tree <- corup(no_tree_sim@count.matrix)
  cor_tree <- corup(us_tree_sim@count.matrix)
  testthat::expect_equal(median(cor_no_tree), median(cor_tree), tol = 1e-2)
  # Spearman correlations are equal
  cor_no_tree <- corup(no_tree_sim@count.matrix, method = "spearman")
  cor_tree <- corup(us_tree_sim@count.matrix, method = "spearman")
  testthat::expect_equal(median(cor_no_tree), median(cor_tree), tol = 1e-2)

})

test_that("Moments of the Negative Binomial and Log Normal are the same, with shift", {
  
  tdir <- tempdir()
  
  ## Tree and conds
  n <- 20
  tree <- ape::stree(n)
  tree$edge.length <- rep(10, nrow(tree$edge))
  
  id_species <- tree$tip.label
  id_species <- factor(id_species)
  names(id_species) <- tree$tip.label
  
  ## Condn alternate tips
  species_names <- tree$tip.label
  cond_species <- rep(c(1, 2), length(species_names) / 2)
  names(cond_species) <- species_names
  
  id_cond <- id_species
  id_cond <- cond_species[as.vector(id_cond)]
  id_cond <- as.factor(id_cond)
  
  ## Parameters
  n.vars <- 5000
  relmean <- 100
  reldisp <- 0.1
  seqdepth <- 50000
  
  n.diffexp <- n.vars / 2
  effect.size <- 10
  
  true_mean_1 <- seqdepth / n.vars
  true_mean_2 <- 2 * seqdepth * (effect.size + 1) / n.vars / (effect.size + 2)
  true_var_1 <- reldisp * true_mean_1^2 + true_mean_1
  true_sd_1 <- sqrt(true_var_1)
  true_var_2 <- reldisp * true_mean_2^2 + true_mean_2
  true_sd_2 <- sqrt(true_var_2)
  
  ## No tree
  set.seed(18570823)
  dataset <- "no_tree"
  no_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                  n.vars = n.vars,
                                                  samples.per.cond = n / 2,
                                                  n.diffexp = n.diffexp,
                                                  repl.id = 1,
                                                  seqdepth = seqdepth,
                                                  minfact = 1,
                                                  maxfact = 1,
                                                  relmeans = rep(relmean, n.vars),
                                                  dispersions = rep(reldisp, n.vars),
                                                  fraction.upregulated = 1,
                                                  between.group.diffdisp = FALSE,
                                                  filter.threshold.total = 1,
                                                  filter.threshold.mediancpm = 0,
                                                  fraction.non.overdispersed = 0,
                                                  random.outlier.high.prob = 0,
                                                  random.outlier.low.prob = 0,
                                                  single.outlier.high.prob = 0,
                                                  single.outlier.low.prob = 0,
                                                  effect.size = effect.size,
                                                  output.file = file.path(tdir, "tmp.rds"),
                                                  id.condition = id_cond,
                                                  id.species = id_species,
                                                  lengths.relmeans = NULL,
                                                  lengths.dispersions = NULL,
                                                  lengths.phylo = FALSE
  )
  
  ## us tree
  set.seed(18570823)
  dataset <- "tree"
  us_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                  n.vars = n.vars,
                                                  samples.per.cond = n / 2,
                                                  n.diffexp = n.diffexp,
                                                  repl.id = 1,
                                                  seqdepth = seqdepth,
                                                  minfact = 1,
                                                  maxfact = 1,
                                                  relmeans = rep(relmean, n.vars),
                                                  dispersions = rep(reldisp, n.vars),
                                                  fraction.upregulated = 1,
                                                  between.group.diffdisp = FALSE,
                                                  filter.threshold.total = 1,
                                                  filter.threshold.mediancpm = 0,
                                                  fraction.non.overdispersed = 0,
                                                  random.outlier.high.prob = 0,
                                                  random.outlier.low.prob = 0,
                                                  single.outlier.high.prob = 0,
                                                  single.outlier.low.prob = 0,
                                                  effect.size = effect.size,
                                                  output.file = file.path(tdir, "tmp.rds"),
                                                  tree = tree,
                                                  id.condition = id_cond,
                                                  id.species = id_species,
                                                  lengths.relmeans = NULL,
                                                  lengths.dispersions = NULL,
                                                  lengths.phylo = FALSE
  )
  
  
  ## Comparisons
  mean_no_tree <- colMeans(no_tree_sim@count.matrix[1:n.diffexp, ])
  sd_no_tree <- matrixStats::colSds(no_tree_sim@count.matrix[1:n.diffexp, ])
  
  true_no_tree <- no_tree_sim@variable.annotations$truemeans.S2[1:n.diffexp] / sum(no_tree_sim@variable.annotations$truemeans.S2) * seqdepth
  mean_real_no_tree <- mean(true_no_tree)
  sd_real_no_tree <- sd(true_no_tree)
  
  mean_us_tree <- colMeans(us_tree_sim@count.matrix[1:n.diffexp, ])
  sd_us_tree <-  matrixStats::colSds(us_tree_sim@count.matrix[1:n.diffexp, ])
  
  true_us_tree <- us_tree_sim@variable.annotations$truemeans.S2[1:n.diffexp] / sum(us_tree_sim@variable.annotations$truemeans.S2) * seqdepth
  mean_real_us_tree <- mean(true_us_tree)
  sd_real_us_tree <- sd(true_us_tree)
  
  testthat::expect_equal(mean(mean_no_tree[id_cond == 1]), true_mean_1, tol = 1e-2)
  testthat::expect_equal(mean(mean_no_tree[id_cond == 2]), true_mean_2, tol = 1e-2)
  testthat::expect_equal(mean(mean_no_tree[id_cond == 2]), mean_real_no_tree, tol = 1e-2)
  
  testthat::expect_equal(mean(mean_us_tree[id_cond == 1]), true_mean_1, tol = 1e-2)
  testthat::expect_equal(mean(mean_us_tree[id_cond == 2]), true_mean_2, tol = 1e-2)
  testthat::expect_equal(mean(mean_us_tree[id_cond == 2]), mean_real_no_tree, tol = 1e-2)
  
  testthat::expect_equal(mean(sd_no_tree[id_cond == 1]), true_sd_1, tol = 1e-2)
  testthat::expect_equal(mean(sd_us_tree[id_cond == 1]), true_sd_1, tol = 1e-2)

  testthat::expect_equal(mean(sd_no_tree[id_cond == 2]),
                         mean(sd_us_tree[id_cond == 2]), tol = 1e-2)
  
  ## Correlation Comparisons
  corup <- function(x, ...) {
    cc <- cor(x, ...)
    return(cc[upper.tri(cc)])
  }
  # Pearson correlations are equal
  cor_no_tree <- corup(no_tree_sim@count.matrix)
  cor_tree <- corup(us_tree_sim@count.matrix)
  testthat::expect_equal(median(cor_no_tree), median(cor_tree), tol = 1e-2)
  # Spearman correlations are equal
  cor_no_tree <- corup(no_tree_sim@count.matrix, method = "spearman")
  cor_tree <- corup(us_tree_sim@count.matrix, method = "spearman")
  testthat::expect_equal(median(cor_no_tree), median(cor_tree), tol = 1e-2)
  
})

test_that("Moments of the Negative Binomial and Log Normal are the same, varying mean", {
  
  tdir <- tempdir()
  
  ## Tree and conds
  n <- 14
  tree <- ape::stree(n)
  tree$edge.length <- rep(1, nrow(tree$edge))
  id_species <- tree$tip.label
  id_species <- factor(id_species)
  
  tree$tip.label <- paste0(tree$tip.label, "_rep")
  
  names(id_species) <- tree$tip.label
  
  ## Condn alternate tips
  species_names <- tree$tip.label
  cond_species <-  c(2, 1, 2, 1, 2, 2, 1, 1, 2, 2, 1, 1, 1, 1) #rep(c(1, 2), length(species_names) / 2)
  names(cond_species) <- species_names
  
  id_cond <- cond_species
  id_cond <- as.factor(id_cond)
  
  effect.size <- 0
  
  ## Parameters
  set.seed(18570823)
  n.vars <- 3560
  length.mu.phi.estimates <- readRDS(system.file("extdata", "Stern2018.Length.Mu.Phi.Estimates.rds", package = "compcodeR"))
  relmean <- length.mu.phi.estimates$stern2018.length.mu
  reldisp <- length.mu.phi.estimates$stern2018.length.phi
  seqdepth <- 2000000
  
  n.diffexp <- 0
  
  nrep <- 1
  
  ## No tree
  set.seed(18570821)
  dataset <- "no_tree"
  count_no_tree <- array(NA, dim = c(n.vars, n, nrep))
  for (rep in 1:nrep) {
    no_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                    n.vars = n.vars,
                                                    samples.per.cond = n / 2,
                                                    n.diffexp = n.diffexp,
                                                    repl.id = 1,
                                                    seqdepth = seqdepth,
                                                    minfact = 1,
                                                    maxfact = 1,
                                                    relmeans = relmean,
                                                    dispersions = reldisp,
                                                    fraction.upregulated = 0.5,
                                                    between.group.diffdisp = FALSE,
                                                    filter.threshold.total = 1,
                                                    filter.threshold.mediancpm = 0,
                                                    fraction.non.overdispersed = 0,
                                                    random.outlier.high.prob = 0,
                                                    random.outlier.low.prob = 0,
                                                    single.outlier.high.prob = 0,
                                                    single.outlier.low.prob = 0,
                                                    effect.size = effect.size,
                                                    output.file = file.path(tdir, "tmp.rds"),
                                                    # tree = tree,
                                                    # model.process = "BM",
                                                    id.condition = id_cond,
                                                    id.species = id_species,
                                                    lengths.relmeans = NULL,
                                                    lengths.dispersions = NULL,
                                                    lengths.phylo = FALSE
    )
    count_no_tree[, , rep] <- no_tree_sim@count.matrix
  }
  
  ## us tree
  set.seed(18570821)
  dataset <- "tree"
  count_tree <- array(NA, dim = c(n.vars, n, nrep))
  for (rep in 1:nrep) {
    us_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                    n.vars = n.vars,
                                                    samples.per.cond = n / 2,
                                                    n.diffexp = n.diffexp,
                                                    repl.id = 1,
                                                    seqdepth = seqdepth,
                                                    minfact = 1,
                                                    maxfact = 1,
                                                    relmeans = relmean,
                                                    dispersions = reldisp,
                                                    fraction.upregulated = 0.5,
                                                    between.group.diffdisp = FALSE,
                                                    filter.threshold.total = 1,
                                                    filter.threshold.mediancpm = 0,
                                                    fraction.non.overdispersed = 0,
                                                    random.outlier.high.prob = 0,
                                                    random.outlier.low.prob = 0,
                                                    single.outlier.high.prob = 0,
                                                    single.outlier.low.prob = 0,
                                                    effect.size = effect.size,
                                                    output.file = file.path(tdir, "tmp.rds"),
                                                    tree = tree,
                                                    model.process = "BM",
                                                    prop.var.tree = 1.0,
                                                    id.condition = id_cond,
                                                    id.species = id_species,
                                                    lengths.relmeans = NULL,
                                                    lengths.dispersions = NULL,
                                                    lengths.phylo = FALSE
    )
    count_tree[, , rep] <- us_tree_sim@count.matrix
  }
  
  ## Correlation Comparisons
  corup <- function(x, ...) {
    cc <- cor(x, ...)
    return(cc[upper.tri(cc)])
  }
  # Pearson correlations are equal
  cor_no_tree <- rowMeans(apply(count_no_tree, 3, corup))
  cor_tree <- rowMeans(apply(count_tree, 3, corup))
  testthat::expect_equal(median(cor_no_tree), median(cor_tree), tol = 1e-2)
  # But Spearman are not correlations not are equal
  cor_no_tree <- rowMeans(apply(count_no_tree, 3, corup, method = "spearman"))
  cor_tree <- rowMeans(apply(count_tree, 3, corup, method = "spearman"))
  testthat::expect_true(median(cor_no_tree) <= median(cor_tree))
  
})

test_that("Moments of the Negative Binomial and Log Normal are the same, with shift, random tree", {
  
  tdir <- tempdir()
  
  ## Tree and conds
  n <- 20
  set.seed(1789)
  tree <- tree <- ape::rphylo(n, 1, 0)
  
  id_species <- tree$tip.label
  id_species <- factor(id_species)
  names(id_species) <- tree$tip.label
  
  ## Condn alternate tips
  species_names <- tree$tip.label
  cond_species <- rep(c(1, 2), length(species_names) / 2)
  names(cond_species) <- species_names
  
  id_cond <- id_species
  id_cond <- cond_species[as.vector(id_cond)]
  id_cond <- as.factor(id_cond)
  
  ## Parameters
  n.vars <- 5000
  relmean <- 100
  reldisp <- 0.1
  seqdepth <- 50000
  
  n.diffexp <- n.vars / 2
  effect.size <- 10
  
  true_mean_1 <- seqdepth / n.vars
  true_mean_2 <- 2 * seqdepth * (effect.size + 1) / n.vars / (effect.size + 2)
  true_var_1 <- reldisp * true_mean_1^2 + true_mean_1
  true_sd_1 <- sqrt(true_var_1)
  true_var_2 <- reldisp * true_mean_2^2 + true_mean_2
  true_sd_2 <- sqrt(true_var_2)
  
  ## No tree
  set.seed(18570823)
  dataset <- "no_tree"
  no_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                  n.vars = n.vars,
                                                  samples.per.cond = n / 2,
                                                  n.diffexp = n.diffexp,
                                                  repl.id = 1,
                                                  seqdepth = seqdepth,
                                                  minfact = 1,
                                                  maxfact = 1,
                                                  relmeans = rep(relmean, n.vars),
                                                  dispersions = rep(reldisp, n.vars),
                                                  fraction.upregulated = 1,
                                                  between.group.diffdisp = FALSE,
                                                  filter.threshold.total = 1,
                                                  filter.threshold.mediancpm = 0,
                                                  fraction.non.overdispersed = 0,
                                                  random.outlier.high.prob = 0,
                                                  random.outlier.low.prob = 0,
                                                  single.outlier.high.prob = 0,
                                                  single.outlier.low.prob = 0,
                                                  effect.size = effect.size,
                                                  output.file = file.path(tdir, "tmp.rds"),
                                                  id.condition = id_cond,
                                                  id.species = id_species,
                                                  lengths.relmeans = NULL,
                                                  lengths.dispersions = NULL,
                                                  lengths.phylo = FALSE
  )
  
  ## us tree
  set.seed(18570823)
  dataset <- "tree"
  us_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                  n.vars = n.vars,
                                                  samples.per.cond = n / 2,
                                                  n.diffexp = n.diffexp,
                                                  repl.id = 1,
                                                  seqdepth = seqdepth,
                                                  minfact = 1,
                                                  maxfact = 1,
                                                  relmeans = rep(relmean, n.vars),
                                                  dispersions = rep(reldisp, n.vars),
                                                  fraction.upregulated = 1,
                                                  between.group.diffdisp = FALSE,
                                                  filter.threshold.total = 1,
                                                  filter.threshold.mediancpm = 0,
                                                  fraction.non.overdispersed = 0,
                                                  random.outlier.high.prob = 0,
                                                  random.outlier.low.prob = 0,
                                                  single.outlier.high.prob = 0,
                                                  single.outlier.low.prob = 0,
                                                  effect.size = effect.size,
                                                  output.file = file.path(tdir, "tmp.rds"),
                                                  tree = tree,
                                                  id.condition = id_cond,
                                                  id.species = id_species,
                                                  lengths.relmeans = NULL,
                                                  lengths.dispersions = NULL,
                                                  lengths.phylo = FALSE
  )
  
  
  ## Comparisons
  mean_no_tree <- colMeans(no_tree_sim@count.matrix[1:n.diffexp, ])
  sd_no_tree <- matrixStats::colSds(no_tree_sim@count.matrix[1:n.diffexp, ])
  
  mean_us_tree <- colMeans(us_tree_sim@count.matrix[1:n.diffexp, ])
  sd_us_tree <-  matrixStats::colSds(us_tree_sim@count.matrix[1:n.diffexp, ])
  
  testthat::expect_equal(mean(mean_no_tree[id_cond == 1]), true_mean_1, tol = 1e-2)
  testthat::expect_equal(mean(mean_no_tree[id_cond == 2]), true_mean_2, tol = 1e-2)
  
  testthat::expect_equal(mean(mean_us_tree[id_cond == 1]), true_mean_1, tol = 1e-2)
  testthat::expect_equal(mean(mean_us_tree[id_cond == 2]), true_mean_2, tol = 1e-2)
  
  testthat::expect_equal(mean(sd_no_tree[id_cond == 1]), true_sd_1, tol = 1e-2)
  testthat::expect_equal(mean(sd_us_tree[id_cond == 1]), true_sd_1, tol = 1e-2)
  
  testthat::expect_equal(mean(sd_no_tree[id_cond == 2]),
                         mean(sd_us_tree[id_cond == 2]), tol = 1e-2)
  
})

test_that("Moments of the Negative Binomial and Log Normal are the same, with shift, random tree, with replicates and varying prop.var.tree", {
  skip_if_not_installed("phytools")
  
  tdir <- tempdir()
  
  ## Tree and conds
  n <- 20
  set.seed(1789)
  tree_norep <- ape::rphylo(n, 1, 0)
  
  r <- 2
  n <- r * n
  
  tree <- add_replicates(tree_norep, r)
  
  id_species <- sub("_.*$", "", tree$tip.label)
  id_species <- factor(id_species)
  names(id_species) <- tree$tip.label
  
  ## Condn alternate tips
  species_names <- unique(sub("_.*$", "", tree$tip.label))
  cond_species <- rep(c(1, 2), length(species_names) / 2)
  names(cond_species) <- species_names
  
  id_cond <- id_species
  id_cond <- cond_species[as.vector(id_cond)]
  id_cond <- as.factor(id_cond)
  names(id_cond) <- names(id_species)
  
  ## Parameters
  n.vars <- 5000
  relmean <- 100
  reldisp <- 0.1
  seqdepth <- 50000
  
  n.diffexp <- n.vars / 2
  effect.size <- 2
  
  true_mean_1 <- seqdepth / n.vars
  true_mean_2 <- 2 * seqdepth * (effect.size + 1) / n.vars / (effect.size + 2)
  true_var_1 <- reldisp * true_mean_1^2 + true_mean_1
  true_sd_1 <- sqrt(true_var_1)
  true_var_2 <- reldisp * true_mean_2^2 + true_mean_2
  true_sd_2 <- sqrt(true_var_2)
  
  ## No tree
  set.seed(18570823)
  dataset <- "no_tree"
  no_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                  n.vars = n.vars,
                                                  samples.per.cond = n / 2,
                                                  n.diffexp = n.diffexp,
                                                  repl.id = 1,
                                                  seqdepth = seqdepth,
                                                  minfact = 1,
                                                  maxfact = 1,
                                                  relmeans = rep(relmean, n.vars),
                                                  dispersions = rep(reldisp, n.vars),
                                                  fraction.upregulated = 1,
                                                  between.group.diffdisp = FALSE,
                                                  filter.threshold.total = 1,
                                                  filter.threshold.mediancpm = 0,
                                                  fraction.non.overdispersed = 0,
                                                  random.outlier.high.prob = 0,
                                                  random.outlier.low.prob = 0,
                                                  single.outlier.high.prob = 0,
                                                  single.outlier.low.prob = 0,
                                                  effect.size = effect.size,
                                                  output.file = file.path(tdir, "tmp.rds"),
                                                  id.condition = id_cond,
                                                  id.species = id_species,
                                                  lengths.relmeans = NULL,
                                                  lengths.dispersions = NULL,
                                                  lengths.phylo = FALSE
  )
  
  ## us tree
  set.seed(18570823)
  dataset <- "tree"
  us_tree_sim <- compcodeR::generateSyntheticData(dataset = dataset,
                                                  n.vars = n.vars,
                                                  samples.per.cond = n / 2,
                                                  n.diffexp = n.diffexp,
                                                  repl.id = 1,
                                                  seqdepth = seqdepth,
                                                  minfact = 1,
                                                  maxfact = 1,
                                                  relmeans = rep(relmean, n.vars),
                                                  dispersions = rep(reldisp, n.vars),
                                                  fraction.upregulated = 1,
                                                  between.group.diffdisp = FALSE,
                                                  filter.threshold.total = 1,
                                                  filter.threshold.mediancpm = 0,
                                                  fraction.non.overdispersed = 0,
                                                  random.outlier.high.prob = 0,
                                                  random.outlier.low.prob = 0,
                                                  single.outlier.high.prob = 0,
                                                  single.outlier.low.prob = 0,
                                                  effect.size = effect.size,
                                                  output.file = file.path(tdir, "tmp.rds"),
                                                  tree = tree,
                                                  id.condition = id_cond,
                                                  id.species = id_species,
                                                  lengths.relmeans = NULL,
                                                  lengths.dispersions = NULL,
                                                  lengths.phylo = FALSE,
                                                  prop.var.tree = runif(n.vars)
  )
  
  
  ## Comparisons
  mean_no_tree <- colMeans(no_tree_sim@count.matrix[1:n.diffexp, ])
  sd_no_tree <- matrixStats::colSds(no_tree_sim@count.matrix[1:n.diffexp, ])
  
  mean_us_tree <- colMeans(us_tree_sim@count.matrix[1:n.diffexp, ])
  sd_us_tree <-  matrixStats::colSds(us_tree_sim@count.matrix[1:n.diffexp, ])
  
  testthat::expect_equal(mean(mean_no_tree[id_cond == 1]), true_mean_1, tol = 1e-2)
  testthat::expect_equal(mean(mean_no_tree[id_cond == 2]), true_mean_2, tol = 1e-2)
  
  testthat::expect_equal(mean(mean_us_tree[id_cond == 1]), true_mean_1, tol = 1e-2)
  testthat::expect_equal(mean(mean_us_tree[id_cond == 2]), true_mean_2, tol = 1e-2)
  
  testthat::expect_equal(mean(sd_no_tree[id_cond == 1]), true_sd_1, tol = 1e-2)
  testthat::expect_equal(mean(sd_us_tree[id_cond == 1]), true_sd_1, tol = 1e-2)
  
  testthat::expect_equal(mean(sd_no_tree[id_cond == 2]),
                         mean(sd_us_tree[id_cond == 2]), tol = 1e-2)
  
})

context("Effective Sample Size")

test_that("Errors", {
  
  ##############################################################################
  ### Errors
  ntips <- 20
  id_cond_3 <- sample(0:2, ntips, replace = TRUE)
  expect_error(nEffPhylolm(NULL, id_cond_3, "BM", 0), "only two conditions")
  
})

test_that("Naive vs phylolm", {
  skip_if_not_installed("phylolm")
  skip_if_not_installed("phytools")
  
  ## Tree
  set.seed(1289)
  ntips <- 20
  tree <- ape::rphylo(ntips, 0.1, 0)
  id_cond <- sample(c(0, 1), ntips, replace = TRUE)
  names(id_cond) <- tree$tip.label
  
  ## Replicates
  r <- 3
  tree_rep <- add_replicates(tree, r)
  id_cond_rep <- rep(id_cond, each = r)
  names(id_cond_rep) <- as.vector(sapply(names(id_cond), function(x) paste(x, 1:3, sep = "_")))
  
  ##############################################################################
  ### BM
  
  expect_equal(nEffNaive(tree, id_cond, "BM", 0),
               nEffPhylolm(tree, id_cond, "BM", 0))
  
  expect_equal(nEffNaive(tree, id_cond, "BM", 0),
               nEffSchur(tree, id_cond, "BM", 0))
  
  # microbenchmark::microbenchmark(nEffNaive(tree, id_cond, "BM", 0),
  #                                nEffPhylolm(tree, id_cond, "BM", 0),
  #                                nEffSchur(tree, id_cond, "BM", 0))
  # The three are equivalent.
  
  expect_equal(tree$edge.length, prune_tree_one_obs(tree_rep)$edge.length)

  expect_warning(expect_equal(nEffNaive(tree_rep, id_cond_rep, "BM", 0),
                              nEffNaive(tree, id_cond, "BM", 0)),
                              "not sorted in the correct order")
  
  ##############################################################################
  ### OU
  
  expect_equal(nEffNaive(tree, id_cond, "OU", 3),
               nEffPhylolm(tree, id_cond, "OU", 3))
  
  expect_equal(nEffNaive(tree, id_cond, "OU", 3),
               nEffSchur(tree, id_cond, "OU", 3))
  
  # microbenchmark::microbenchmark(nEffNaive(tree, id_cond, "OU", 3),
  #                                nEffPhylolm(tree, id_cond, "OU", 3),
  #                                nEffSchur(tree, id_cond, "OU", 3))
  
  expect_equal(tree$edge.length, prune_tree_one_obs(tree_rep)$edge.length)
  
  expect_warning(expect_equal(nEffNaive(tree_rep, id_cond_rep, "OU", 3),
                              nEffNaive(tree, id_cond, "OU", 3)),
                 "not sorted in the correct order")
  
})

test_that("nEff Ratio", {
  skip_if_not_installed("phylolm")
  
  ## Trees
  set.seed(1289)
  ntips <- 2^5
  tree <- ape::stree(ntips, "balanced")
  star_tree <- ape::stree(ntips, "star")
  tree <- ape::compute.brlen(tree)
  star_tree <- ape::compute.brlen(star_tree)
  
  ## Alt cond : nEff greater than 1
  id_cond <- rep(rep(0:1, each = 2), ntips / 4)
  names(id_cond) <- tree$tip.label
  expect_true(nEffRatio(tree, id_cond, "BM", 0) > 1.0)
  expect_equal(nEffRatio(star_tree, id_cond, "BM", 0), 1.0)
  expect_equal(nEffRatio(NULL, id_cond, "BM", 0), 1.0)
  
  ## Bloc cond : nEff smaller than 1
  id_cond <- rep(0:1, each = ntips / 2)
  names(id_cond) <- tree$tip.label
  expect_true(nEffRatio(tree, id_cond, "BM", 0) < 1.0)
  expect_equal(nEffRatio(star_tree, id_cond, "BM", 0), 1.0)
  expect_equal(nEffRatio(NULL, id_cond, "BM", 0), 1.0)
  
})

#' A shiny-based GUI to the main function for running the performance
#' comparison between differential expression methods.
#'
#' This function provides a GUI to the main function for performing comparisons
#' among differential expression methods and generating a report in HTML format
#' (\code{\link{runComparison}}). It is assumed that all differential
#' expression results have been generated in advance (using e.g. the function
#' \code{\link{runDiffExp}}) and that the result \code{compData} object for
#' each data set and each differential expression method is saved separately in
#' files with the extension \code{.rds}. The function opens a graphical user
#' interface where the user can set parameter values and choose the files to be
#' used as the basis of the comparison. It is, however, possible to circumvent
#' the GUI and call the comparison function \code{\link{runComparison}} directly.
#'
#' @param input.directories A list of directories containing the result files
#'     (\code{*.rds}). All results in the provided directories will be available
#'     for inclusion in the comparison, and the selection is performed through
#'     a graphical user interface. All result objects saved in the files should
#'      be of the \code{compData} class, although list objects created by
#'      earlier versions of \code{compcodeR} are supported.
#' @param output.directory The directory where the results should be written.
#'     The subdirectory structure will be created automatically. If the
#'     directory already exists, it will be overwritten.
#' @param recursive A logical parameter indicating whether or not the search
#'     should be extended recursively to subfolders of the
#'     \code{input.directories}.
#' @param out.width The width of the figures in the final report. Will be
#'     passed on to \code{knitr} when the HTML is generated. Can be for
#'     example "800px" (see \code{knitr} documentation for more information).
#' @param upper.limits,lower.limits Lists that can be used to manually set
#'     upper and lower limits for boxplots of fdr, tpr, auc, mcc, fracsign,
#'     nbrtpfp, nbrsign and typeIerror.
#'
#' @returns
#' The function will create a comparison report, named
#' \strong{compcodeR_report<timestamp>.html}, in the \code{output.directory}.
#' It will also create subfolders named \code{compcodeR_code} and
#' \code{compcodeR_figure}, where the code used to perform the differential
#' expression analysis and the figures contained in the report, respectively,
#' will be saved. Note that if these directories already exist they will be
#' overwritten.
#'
#' @export
#' @author Charlotte Soneson
#'
#' @examples
#' if (interactive()) {
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 12500,
#'                                     samples.per.cond = 5, n.diffexp = 1250,
#'                                     output.file = "mydata.rds")
#' runDiffExp(data.file = "mydata.rds", result.extent = "voom.limma",
#'            Rmdfunction = "voom.limma.createRmd", output.directory = ".",
#'            norm.method = "TMM")
#' runDiffExp(data.file = "mydata.rds", result.extent = "ttest",
#'            Rmdfunction = "ttest.createRmd", output.directory = ".",
#'            norm.method = "TMM")
#' runComparisonShiny(input.directories = ".", output.directory = ".", recursive = FALSE)
#' }
#'
#' @importFrom shiny selectInput fluidRow uiOutput numericInput htmlOutput
#'     actionButton reactive renderUI checkboxGroupInput renderText observeEvent
#'     stopApp withProgress incProgress shinyApp
#' @importFrom shinydashboard dashboardPage dashboardHeader dashboardSidebar
#'     dashboardBody box
runComparisonShiny <- function(input.directories, output.directory, recursive,
                               out.width = NULL, upper.limits = NULL,
                               lower.limits = NULL) {
    ## ---------------------------------------------------------------------- ##
    ## Check input arguments
    ## ---------------------------------------------------------------------- ##
    checkClass(input.directories, "input.directories", "character")
    checkClass(output.directory, "output.directory", "character")
    checkClass(recursive, "recursive", "logical")

    if (is.null(input.directories)) {
        stop("You have to provide at least one input directory!")
    } else {
        input.directories <- normalizePath(input.directories, winslash = "/")
    }

    if (is.null(output.directory)) {
        stop("You have to provide an output directory!")
    } else if (length(output.directory) != 1) {
        stop("Please provide precisely one output directory.")
    } else {
        output.directory <- normalizePath(output.directory, winslash = "/")
    }

    ## List all .rds files in the input directories
    input.files.temp <- NULL
    for (input.directory in input.directories) {
        input.files.temp <- union(input.files.temp,
                                  file.path(input.directory,
                                            list.files(input.directory,
                                                       recursive = recursive,
                                                       pattern = "*.rds$")))
    }
    input.files.temp <- normalizePath(input.files.temp, winslash = "/")
    if (length(input.files.temp) == 0) {
        stop("No .rds files in the input directory")
    }

    ## ---------------------------------------------------------------------- ##
    ## Go through the files in the input.directories and see which
    ## datasets are available.
    ## ---------------------------------------------------------------------- ##
    suppressWarnings({
        all.datasets <- NULL
        all.input.files <- NULL
        for (input.file in input.files.temp) {
            temp.input <- readRDS(input.file)
            ## Check if compatible list, then convert to compData object
            if (is.list(temp.input)) {
                temp.input <- convertListTocompData(temp.input)
            }
            ## Keep only the result files (no data files or other things).
            if (is.logical(check_compData_results(temp.input))) {
                all.datasets <- c(all.datasets, info.parameters(temp.input)$dataset)
                all.input.files <- c(all.input.files, input.file)
            }
        }
        avail.datasets <- c('', unique(all.datasets))
    })

    if (length(avail.datasets) == 1) {
        stop("No result .rds files in the input directory")
    }

    ## ---------------------------------------------------------------------- ##
    ## Define shiny app
    ## ---------------------------------------------------------------------- ##
    pLayout <- shinydashboard::dashboardPage(
        skin = "purple",

        shinydashboard::dashboardHeader(
            title = paste0("compcodeR (v",
                           utils::packageVersion("compcodeR"), ")")
        ),

        shinydashboard::dashboardSidebar(
            shiny::selectInput("dataset", label = "Data set",
                               choices = avail.datasets, selected = "",
                               selectize = TRUE)
        ),

        shinydashboard::dashboardBody(
            shiny::fluidRow(
                shinydashboard::box(
                    width = 5,
                    title = "DE methods",
                    shiny::uiOutput("demethods_ui")
                ),
                shinydashboard::box(
                    width = 3,
                    title = "Replicates",
                    shiny::uiOutput("replicates_ui")
                ),
                shinydashboard::box(
                    width = 4,
                    title = "Nbr samples",
                    shiny::uiOutput("nbrsamples_ui")
                )
            ),
            shiny::fluidRow(
                shinydashboard::box(
                    width = 5,
                    title = "Parameters",
                    shiny::numericInput(
                        "adjpFDR",
                        label = "Adjusted p-value threshold for FDR",
                        value = 0.05
                    ),
                    shiny::numericInput(
                        "adjpTPR",
                        label = "Adjusted p-value threshold for TPR",
                        value = 0.05
                    ),
                    shiny::numericInput(
                        "adjpMCC",
                        label = "Adjusted p-value threshold for MCC",
                        value = 0.05
                    ),
                    shiny::numericInput(
                        "nomptypeI",
                        label = "Nominal p-value threshold for type I error",
                        value = 0.05
                    ),
                    shiny::numericInput(
                        "maxtopFDR",
                        label = paste0("Maximal number of top variables ",
                                       "in false discovery curves"),
                        value = 1500
                    ),
                    shiny::numericInput(
                        "adjpOverlap",
                        label = paste0("Adjusted p-value threshold for ",
                                       "overlap analysis"),
                        value = 0.05
                    ),
                    shiny::numericInput(
                        "adjpFracSign",
                        label = paste0("Adjusted p-value threshold for ",
                                       "analysis of fraction significant ",
                                       "variables"),
                        value = 0.05
                    ),
                    shiny::numericInput(
                        "adjpNbr",
                        label = paste0("Adjusted p-value threshold for ",
                                       "analysis of the number of TP, FP, ",
                                       "TN, FN variables"),
                        value = 0.05
                    ),
                    shiny::numericInput(
                        "adjpMA",
                        label = paste0("Adjusted p-value threshold for ",
                                       "coloring of variables in MA plots"),
                        value = 0.05
                    ),
                    shiny::selectInput(
                        "signalMeasure",
                        label = "Signal measure for condition-specific genes",
                        choices = c("mean", "snr"),
                        selected = "mean"
                    )
                ),
                shinydashboard::box(
                    width = 4,
                    title = "Comparisons",
                    shiny::uiOutput("comparisons_ui")
                ),
                shinydashboard::box(
                    width = 3,
                    title = "Run comparison",
                    shiny::htmlOutput("runMessage"),
                    shiny::actionButton("runcomparison", label = "Run comparison",
                                        class = "btn-primary btn-lg")
                )
            )
        )
    )

    server_function <- function(input, output, session) { # nocov start
        availableData <- shiny::reactive({
            if ((input$dataset != "")) {
                keep <- which(all.datasets == input$dataset)
                input.files <- all.input.files[keep]
                datasets <- all.datasets[keep]
                nbr.samples <- NULL
                repl <- NULL
                de.methods <- NULL
                for (input.file in input.files) {
                    temp.input <- readRDS(input.file)
                    if (is.list(temp.input)) {
                        temp.input <- convertListTocompData(temp.input)
                    }
                    ns <- info.parameters(temp.input)$samples.per.cond
                    if (is.null(ns)) {
                        ns <- NA_real_
                    }
                    nbr.samples <- c(nbr.samples, ns)

                    rp <- info.parameters(temp.input)$repl.id
                    if (is.null(rp)) {
                        rp <- NA_real_
                    }
                    repl <- c(repl, rp)

                    dm <- method.names(temp.input)$full.name
                    if (is.null(dm)) {
                        dm <- NA_character_
                    }
                    de.methods <- c(de.methods, dm)
                }
                list(
                    avail.nbr.samples = sort(as.numeric(unique(nbr.samples))),
                    avail.repl = sort(as.numeric(unique(repl))),
                    avail.de.methods = setdiff(unique(de.methods), c(NA_character_)),
                    input.files = input.files,
                    datasets = datasets,
                    nbr.samples = nbr.samples,
                    repl = repl,
                    de.methods = de.methods
                )
            } else {
                NULL
            }
        })

        output$demethods_ui <- shiny::renderUI({
            if (!is.null(availableData())) {
                shiny::checkboxGroupInput(
                    "demethods", label = "",
                    choices = availableData()$avail.de.methods,
                    selected = availableData()$avail.de.methods
                )
            } else {
                NULL
            }
        })

        output$replicates_ui <- shiny::renderUI({
            if (!is.null(availableData())) {
                shiny::checkboxGroupInput(
                    "replicates", label = "",
                    choices = availableData()$avail.repl,
                    selected = availableData()$avail.repl
                )
            } else {
                NULL
            }
        })

        output$nbrsamples_ui <- shiny::renderUI({
            if (!is.null(availableData())) {
                shiny::checkboxGroupInput(
                    "nbrsamples", label = "",
                    choices = availableData()$avail.nbr.samples,
                    selected = availableData()$avail.nbr.samples
                )
            } else {
                NULL
            }
        })

        comps <- c("AUC", "ROC, one replicate", "ROC, all replicates",
                   "Type I error", "FDR",
                   "FDR vs average expression level",
                   "TPR", "MCC", "Number significant",
                   "Number of TP, FP, TN, FN",
                   "False discovery curves, one replicate",
                   "False discovery curves, all replicates",
                   "Fraction significant", "Overlap, one replicate",
                   "MA plot", "Gene score vs average expression level",
                   "Gene score vs signal for condition-specific genes",
                   "Score distribution vs number of outliers",
                   "Spearman correlation between scores",
                   "Sorensen index, one replicate")

        output$comparisons_ui <- shiny::renderUI({
            if (!is.null(availableData())) {
                shiny::checkboxGroupInput("comparisons", label = "",
                                          choices = comps,
                                          selected = comps)
            } else {
                NULL
            }
        })

        output$runMessage <- shiny::renderText("When you are ready to run the analysis, click the button below. <br><br><strong>Important!</strong> Don't close the shiny window while the analysis is running - it will close automatically once it is done.<br><br>")

        shiny::observeEvent(input$runcomparison, {
            if(!is.null(availableData())) {
                shiny::stopApp()
                message("Be patient, your analysis is running...")

                ## Extract all parameters from the panel object
                suppressWarnings({
                    parameters <- list(incl.nbr.samples = input$nbrsamples,
                                       incl.replicates = input$replicates,
                                       incl.dataset = input$dataset,
                                       incl.de.methods = input$demethods,
                                       fdr.threshold = input$adjpFDR,
                                       tpr.threshold = input$adjpTPR,
                                       mcc.threshold = input$adjpMCC,
                                       typeI.threshold = input$nomptypeI,
                                       ma.threshold = input$adjpMA,
                                       fdc.maxvar = input$maxtopFDR,
                                       signal.measure = input$signalMeasure,
                                       overlap.threshold = input$adjpOverlap,
                                       fracsign.threshold = input$adjpFracSign,
                                       nbrtpfp.threshold = input$adjpNbr,
                                       upper.limits = upper.limits,
                                       lower.limits = lower.limits,
                                       comparisons = input$comparisons)
                    nbr.samples <- as.numeric(availableData()$nbr.samples)
                    repl <- as.numeric(availableData()$repl)
                    de.methods <- availableData()$de.methods
                    datasets <- availableData()$datasets
                    input.files <- availableData()$input.files
                })

                ## Check ranges etc for thresholds
                parameters$fdr.threshold <- checkRange(
                    parameters$fdr.threshold, "fdr.treshold", 0, 1
                )
                parameters$tpr.threshold <- checkRange(
                    parameters$tpr.threshold, "tpr.threshold", 0, 1
                )
                parameters$mcc.threshold <- checkRange(
                    parameters$mcc.threshold, "mcc.threshold", 0, 1
                )
                parameters$typeI.threshold <- checkRange(
                    parameters$typeI.threshold, "typeI.threshold", 0, 1
                )
                parameters$ma.threshold <- checkRange(
                    parameters$ma.threshold, "ma.threshold", 0, 1
                )
                parameters$overlap.threshold <- checkRange(
                    parameters$overlap.threshold, "overlap.threshold", 0, 1
                )
                parameters$fracsign.threshold <- checkRange(
                    parameters$fracsign.threshold, "fracsign.threshold", 0, 1
                )
                parameters$nbrtpfp.threshold <- checkRange(
                    parameters$nbrtpfp.threshold, "nbrtpfp.threshold", 0, 1
                )

                ## Transform the names of the comparisons to make
                parameters$comparisons <- shorten.method.names(
                    parameters$comparisons
                )

                ## Run the comparison
                file.table <- data.frame(input.files = input.files,
                                         datasets = datasets,
                                         nbr.samples = nbr.samples,
                                         repl = repl,
                                         de.methods = de.methods,
                                         stringsAsFactors = FALSE)
                shiny::withProgress({
                    runComparison(file.table, parameters,
                                  output.directory, check.table = FALSE,
                                  out.width = out.width)
                    shiny::incProgress(amount = 1)
                }, message = "Running comparison, don't close this window")
            }
        })
    } # nocov end

    shiny::shinyApp(ui = pLayout, server = server_function)
}

checkClass <- function(object, objname, trueclass) {
  if (!(is(object, trueclass))) {
    stop(paste("The object", objname, "should be of class", trueclass))
  }
}

#' The main function to run differential expression analysis
#'
#' The main function for running differential expression analysis (comparing two conditions), using one of the methods interfaced through \code{compcodeR} or a user-defined method. Note that the interface functions are provided for convenience and as templates for other, user-defined workflows, and there is no guarantee that the included differential expression code is kept up-to-date with the latest recommendations and best practices for running each of the interfaced methods, or that the chosen settings are suitable in all situations. The user should make sure that the analysis is performed in the way they intend, and check the code that was run, using e.g. the \code{generateCodeHTMLs()} function.
#'
#' @param data.file The path to a \code{.rds} file containing the data on which the differential expression analysis will be performed, for example a \code{compData} object returned from \code{\link{generateSyntheticData}}.
#' @param result.extent The extension that will be added to the data file name in order to construct the result file name. This can be for example the differential expression method together with a version number.
#' @param Rmdfunction A function that creates an Rmd file containing the code that should be run to perform the differential expression analysis. All functions available through \code{compcodeR} can be listed using the \code{\link{listcreateRmd}} function.
#' @param output.directory The directory in which the result object will be saved.
#' @param norm.path Logical, whether to include the full (absolute) path to the output object in the saved code.
#' @param ... Additional arguments that will be passed to the \code{Rmdfunction}, such as parameter choices for the differential expression method.
#' @export
#'
#' @author Charlotte Soneson
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' listcreateRmd()
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.limma",
#'            Rmdfunction = "voom.limma.createRmd",
#'            output.directory = tmpdir, norm.method = "TMM")
#'
#' if (interactive()) {
#' ## The following list covers the currently available
#' ## differential expression methods:
#' runDiffExp(data.file = "mydata.rds", result.extent = "DESeq2",
#'            Rmdfunction = "DESeq2.createRmd",
#'            output.directory = ".", fit.type = "parametric",
#'            test = "Wald", beta.prior = TRUE,
#'            independent.filtering = TRUE, cooks.cutoff = TRUE,
#'            impute.outliers = TRUE)
#' runDiffExp(data.file = "mydata.rds", result.extent = "DSS",
#'            Rmdfunction = "DSS.createRmd",
#'            output.directory = ".", norm.method = "quantile",
#'            disp.trend = TRUE)
#' runDiffExp(data.file = "mydata.rds", result.extent = "EBSeq",
#'            Rmdfunction = "EBSeq.createRmd",
#'            output.directory = ".", norm.method = "median")
#' runDiffExp(data.file = "mydata.rds", result.extent = "edgeR.exact",
#'            Rmdfunction = "edgeR.exact.createRmd",
#'            output.directory = ".", norm.method = "TMM",
#'            trend.method = "movingave", disp.type = "tagwise")
#' runDiffExp(data.file = "mydata.rds", result.extent = "edgeR.GLM",
#'            Rmdfunction = "edgeR.GLM.createRmd",
#'            output.directory = ".", norm.method = "TMM",
#'            disp.type = "tagwise", disp.method = "CoxReid",
#'            trended = TRUE)
#' runDiffExp(data.file = "mydata.rds", result.extent = "logcpm.limma",
#'            Rmdfunction = "logcpm.limma.createRmd",
#'            output.directory = ".", norm.method = "TMM")
#' runDiffExp(data.file = "mydata.rds", result.extent = "NBPSeq",
#'            Rmdfunction = "NBPSeq.createRmd",
#'            output.directory = ".", norm.method = "TMM",
#'            disp.method = "NBP")
#' runDiffExp(data.file = "mydata.rds", result.extent = "NOISeq",
#'            Rmdfunction = "NOISeq.prenorm.createRmd",
#'            output.directory = ".", norm.method = "TMM")
#' runDiffExp(data.file = "mydata.rds", result.extent = "sqrtcpm.limma",
#'            Rmdfunction = "sqrtcpm.limma.createRmd",
#'            output.directory = ".", norm.method = "TMM")
#' runDiffExp(data.file = "mydata.rds", result.extent = "TCC",
#'            Rmdfunction = "TCC.createRmd",
#'            output.directory = ".", norm.method = "tmm",
#'            test.method = "edger", iteration = 3,
#'            normFDR = 0.1, floorPDEG = 0.05)
#' runDiffExp(data.file = "mydata.rds", result.extent = "ttest",
#'            Rmdfunction = "ttest.createRmd",
#'            output.directory = ".", norm.method = "TMM")
#' runDiffExp(data.file = "mydata.rds", result.extent = "voom.limma",
#'            Rmdfunction = "voom.limma.createRmd",
#'            output.directory = ".", norm.method = "TMM")
#' runDiffExp(data.file = "mydata.rds", result.extent = "voom.ttest",
#'            Rmdfunction = "voom.ttest.createRmd",
#'            output.directory = ".", norm.method = "TMM")
#' }
runDiffExp <- function(data.file, result.extent, Rmdfunction,
                       output.directory = ".", norm.path = TRUE, ...) {
  code.file <- tempfile(pattern = "tempcode", tmpdir = output.directory, fileext = ".Rmd")
  checkClass(data.file, "data.file", "character")
  checkClass(result.extent, "result.extent", "character")
  checkClass(Rmdfunction, "Rmdfunction", "character")
  checkClass(output.directory, "output.directory", "character")

  if (norm.path) {
    output.directory <- normalizePath(output.directory, winslash = "/")
  } else {
    ## Just remove any trailing "/"
    if (substr(output.directory, nchar(output.directory), nchar(output.directory)) == "/") {
      output.directory <- substr(output.directory, 1, nchar(output.directory) - 1)
    }
  }

  ## Extract the file name of the data file (after the last /), and extend it with the
  ## result.extent (before the .rds) to create the result file name.
  data.file.name <- basename(data.file)
  result.file <- file.path(output.directory,
                           gsub(".rds", paste("_", result.extent, ".rds", sep = ""),
                                data.file.name))

  ## Create the .Rmd file with the differential expression code
  eval(parse(text = Rmdfunction))(data.file, result.file, code.file, ...)
  input.Rmd <- code.file

  ## Run the differential expression analysis
  knit(input = input.Rmd, output = str_replace(code.file, ".Rmd", ".md"))

  ## Add the code to the result object
  temp.file <- readRDS(result.file)
  if (is.list(temp.file)) temp.file <- convertListTocompData(temp.file)
  code(temp.file) <- readLines(str_replace(code.file, ".Rmd", ".md"))
  saveRDS(temp.file, file = result.file)

  ## Remove the temporary code file
  file.remove(code.file)
  file.remove(str_replace(code.file, ".Rmd", ".md"))
}

#' Generate synthetic count data sets
#'
#' Generate synthetic count data sets, following the simulation strategy detailed in Soneson and Delorenzi (2013).
#'
#' In the comparison function, only results obtained for data sets with the same value of the \code{dataset} parameter will be compared. Hence, it is important to give the same value of this parameter e.g. to different replicates generated with the same simulation settings.
#'
#' For more detailed information regarding the different types of outliers, see Soneson and Delorenzi (2013).
#'
#' Mean and dispersion parameters (if \code{relmeans} and/or \code{dispersions} is set to \code{"auto"}) are sampled from values estimated from the data sets by Pickrell et al (2010) and Cheung et al (2010). The data sets were downloaded from the ReCount web page (Frazee et al (2011)) and processed as detailed by Soneson and Delorenzi (2013).
#'
#' To get the actual mean value for the Negative Binomial distribution used for the simulation of counts for a given sample, take the column \code{truemeans.S1} (or \code{truemeans.S2}, if the sample is in condition S2) of the \code{variable.annotations} slot, divide by the sum of the same column and multiply with the base sequencing depth (provided in the \code{info.parameters} list) and the depth factor for the sample (given in the \code{sample.annotations} data frame). Thus, if you have a vector of mean values that you want to provide as the \code{relmeans} argument and make sure to use it 'as-is' in the simulation (for condition S1), make sure to set the \code{seqdepth} argument to the sum of the values in the \code{relmeans} vector, and to set \code{minfact} and \code{maxfact} equal to 1.
#'
#' When the \code{tree} argument is provided (not \code{NULL}),
#' then the "phylogenetic Poisson log-Normal" model is used for the simulations,
#' possibly with varying gene lengths across species
#' (both \code{lengths.relmeans} and \code{lengths.dispersions} must be specified
#' or set to \code{"auto"}.)
#' Phylogenetic simulations use the \code{\link[phylolm]{rTrait}} function
#' from package \code{phylolm}.
#'
#' @param dataset A name or identifier for the data set/simulation settings.
#' @param n.vars The initial number of genes in the simulated data set. Based on the filtering conditions (\code{filter.threshold.total} and \code{filter.threshold.mediancpm}), the number of genes in the final data set may be lower than this number.
#' @param samples.per.cond The number of samples in each of the two conditions.
#' @param n.diffexp The number of genes simulated to be differentially expressed between the two conditions.
#' @param repl.id A replicate ID for the specific simulation instance. Useful for example when generating multiple count matrices with the same simulation settings.
#' @param seqdepth The base sequencing depth (total number of mapped reads). This number is multiplied by a value drawn uniformly between \code{minfact} and \code{maxfact} for each sample to generate data with different actual sequencing depths.
#' @param minfact,maxfact The minimum and maximum for the uniform distribution used to generate factors that are multiplied with \code{seqdepth} to generate individual sequencing depths for the simulated samples.
#' @param relmeans A vector of mean values to use in the simulation of data from the Negative Binomial distribution, or \code{"auto"}. Note that these values may be scaled in order to comply with the given sequencing depth. With the default value (\code{"auto"}), the mean values are sampled from values estimated from the Pickrell and Cheung data sets. If \code{relmeans} is a vector, the provided values will be used as mean values in the simulation for the samples in the first condition. The mean values for the samples in the second condition are generated by combining the \code{relmeans} and \code{effect.size} arguments.
#' @param dispersions A vector or matrix of dispersions to use in the simulation of data from the Negative Binomial distribution, or \code{"auto"}. With the default value (\code{"auto"}), the dispersion values are sampled from values estimated from the Pickrell and Cheung data sets. If both \code{relmeans} and \code{dispersions} are set to \code{"auto"}, the means and dispersion values are sampled in pairs from the values in these data sets. If \code{dispersions} is a single vector, the provided dispersions will be used for simulating data from both conditions. If it is a matrix with two columns, the values in the first column are used for condition 1, and the values in the second column are used for condition 2.
#' @param fraction.upregulated The fraction of the differentially expressed genes that is upregulated in condition 2 compared to condition 1.
#' @param between.group.diffdisp Whether or not the dispersion should be allowed to be different between the conditions. Only applicable if \code{dispersions} is \code{"auto"}.
#' @param filter.threshold.total The filter threshold on the total count for a gene across all samples. All genes for which the total count across all samples is less than the threshold will be filtered out.
#' @param filter.threshold.mediancpm The filter threshold on the median count per million (cpm) for a gene across all samples. All genes for which the median cpm across all samples is less than the threshold will be filtered out.
#' @param fraction.non.overdispersed The fraction of the genes that should be simulated according to a Poisson distribution, without overdispersion. The non-overdispersed genes will be divided proportionally between the upregulated, downregulated and non-differentially expressed genes.
#' @param random.outlier.high.prob The fraction of 'random' outliers with unusually high counts.
#' @param random.outlier.low.prob The fraction of 'random' outliers with unusually low counts.
#' @param single.outlier.high.prob The fraction of 'single' outliers with unusually high counts.
#' @param single.outlier.low.prob The fraction of 'single' outliers with unusually low counts.
#' @param effect.size The strength of the differential expression, i.e., the effect size, between the two conditions. If this is a single number, the effect sizes will be obtained by simulating numbers from an exponential distribution (with rate 1) and adding the results to the \code{effect.size}. For genes that are upregulated in the second condition, the mean in the first condition is multiplied by the effect size. For genes that are downregulated in the second condition, the mean in the first condition is divided by the effect size. It is also possible to provide a vector of effect sizes (one for each gene), which will be used as provided. In this case, the \code{fraction.upregulated} and \code{n.diffexp} arguments will be ignored and the values will be derived from the \code{effect.size} vector.
#' @param output.file If not \code{NULL}, the path to the file where the data object should be saved. The extension should be \code{.rds}, if not it will be changed.
#' @param tree a dated phylogenetic tree of class \code{\link[ape]{phylo}} with `samples.per.cond * 2` species.
#' @param prop.var.tree the proportion of the common variance explained by the tree for each gene. It can be a scalar, in which case the same parameter is used for all genes. Otherwise it needs to be a vector with length \code{n.vars}. Default to 1.
#' @param model.process the process to be used for phylogenetic simulations. One of "BM" or "OU", default to "BM".
#' @param selection.strength if the process is "OU", the selection strength parameter.
#' @param id.condition A named vector, indicating which species is in each condition. Default to first `samples.per.cond` species in condition `1` and others in condition `2`.
#' @param id.species A factor giving the species for each sample. If a tree is used, should be a named vector with names matching the taxa of the tree. Default to \code{rep(1, 2*samples.per.cond)}, i.e. all the samples come from the same species.
#' @param check.id.species Should the species vector be checked against the tree lengths (if provided) ? If TRUE, the function checks that all the samples that share a factor value in \code{id.species} that their distance on the tree is zero, i.e. that they are on the same tip of the tree. Default to TRUE.
#' @param lengths.relmeans An optional vector of mean values to use in the simulation of lengths from the Negative Binomial distribution. Should be of length n.vars. Default to \code{NULL}: the lengths are not taken into account for the simulation. If set to \code{"auto"}, the mean length values are sampled from values estimated from the Stern & Crandall (2018) data set.
#' @param lengths.dispersions An optional vector of dispersions to use in the simulation of data from the Negative Binomial distribution. Should be of length n.vars. Default to \code{NULL}: the lengths are not taken into account for the simulation. If set to \code{"auto"}, the dispersion length values are sampled from values estimated from the Stern & Crandall (2018) data set.
#' @param lengths.phylo If TRUE, the lengths are simulated according to a phylogenetic Poisson Log-Normal model on the tree, with a BM process. If FALSE, they are simulated according to an iid negative binomial distribution. In both cases, \code{lengths.relmeans} and \code{lengths.dispersions} are used. Default to TRUE if a tree is provided.
#'
#' @return A \code{\link{compData}} object. If \code{output.file} is not \code{NULL}, the object is saved in the given \code{output.file} (which should have an \code{.rds} extension).
#' @export
#' @author Charlotte Soneson
#' @examples
#' ## RNA-Seq data
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100)
#'
#' ## Inter-species RNA-Seq data
#' library(ape)
#' tree <- read.tree(text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);")
#' id.species <- factor(c("A", "A", "A", "B", "C", "C", "D", "D"))
#' names(id.species) <- tree$tip.label
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 4, n.diffexp = 100,
#'                                     tree = tree,
#'                                     id.species = id.species,
#'                                     lengths.relmeans = "auto",
#'                                     lengths.dispersions = "auto")
#' @references
#' Soneson C and Delorenzi M (2013): A comparison of methods for differential expression analysis of RNA-seq data. BMC Bioinformatics 14:91
#'
#' Cheung VG, Nayak RR, Wang IX, Elwyn S, Cousins SM, Morley M and Spielman RS (2010): Polymorphic cis- and trans-regulation of human gene expression. PLoS Biology 8(9):e1000480
#'
#' Frazee AC, Langmead B and Leek JT (2011): ReCount: a multi-experiment resource of analysis-ready RNA-seq gene count datasets. BMC Bioinformatics 12:449
#'
#' Pickrell JK, Marioni JC, Pai AA, Degner JF, Engelhardt BE, Nkadori E, Veyrieras JB, Stephens M, Gilad Y and Pritchard JK (2010): Understanding mechanisms underlying human gene expression variation with RNA sequencing. Nature 464, 768-772
#'
#' Robles JA, Qureshi SE, Stephen SJ, Wilson SR, Burden CJ and Taylor JM (2012): Efficient experimental design and analysis strategies for the detection of differential expression using RNA-sequencing. BMC Genomics 13:484
#'
#' Stern DB and Crandall KA (2018): The Evolution of Gene Expression Underlying Vision Loss in Cave Animals. Molecular Biology and Evolution. 35:2005–2014.
#' @import sm
#'
generateSyntheticData <- function(dataset, n.vars, samples.per.cond, n.diffexp, repl.id = 1,
                                  seqdepth = 1e7, minfact = 0.7, maxfact = 1.4,
                                  relmeans = "auto", dispersions = "auto",
                                  fraction.upregulated = 1, between.group.diffdisp = FALSE,
                                  filter.threshold.total = 1, filter.threshold.mediancpm = 0,
                                  fraction.non.overdispersed = 0, random.outlier.high.prob = 0,
                                  random.outlier.low.prob = 0, single.outlier.high.prob = 0,
                                  single.outlier.low.prob = 0, effect.size = 1.5,
                                  output.file = NULL,
                                  tree = NULL, prop.var.tree = 1.0,
                                  model.process = c("BM", "OU"), selection.strength = 0,
                                  id.condition = NULL,
                                  id.species = as.factor(rep(1, 2 * samples.per.cond)),
                                  check.id.species = TRUE,
                                  lengths.relmeans = NULL, lengths.dispersions = NULL, lengths.phylo = TRUE) {

  ## Check output file name
  if (!is.null(output.file)) {
    if (!(substr(output.file, nchar(output.file) - 3, nchar(output.file)) == ".rds")) {
      stop("output.file must be an .rds file.")
    }
  }

  ## Generate a unique ID for the data set
  uID <- paste(sample(c(0:9, letters, LETTERS), 10, replace = TRUE), collapse = "")

  ## Checks for phylogenetic tree
  use_tree <- !is.null(tree) # If tree is specified, use it.
  if (lengths.phylo && !use_tree) {
    lengths.phylo <- FALSE
  }


  ## Check id.species
  if (!is.factor(id.species)) warning("Vector 'id.species' must be a factor. Transforming.")
  id.species <- as.factor(id.species)
  levels(id.species) <- 1:length(levels(id.species))

  if (use_tree) {
    ## Check package
    if (!requireNamespace("ape", quietly = TRUE)) {
      stop("Package 'ape' is needed for phylogenetic simulations.", call. = FALSE)
    }
    ## Check Tree
    if (!inherits(tree, "phylo")) {
      stop("The `tree` must be of class `phylo` from package `ape`.")
    }
    ## Check that the tree has the right number of species
    if (length(tree$tip.label) != samples.per.cond * 2) {
      stop("The tree should have as many species as `samples.per.cond` times two.")
    }
    ## Check that the tree is ultrametric
    if (!ape::is.ultrametric(tree)) {
      stop("The tree should be ultrametric.")
    }

    ## Check Conditions
    if (!is.null(id.condition)) {
      id.condition <- checkParamVector(id.condition, "id.condition", tree)
    } else {
      id.condition <- rep(c(1, 2), each = samples.per.cond)
      names(id.condition) <- tree$tip.label
    }

    ## Check id species
    id.species <- checkSpecies(id.species, "id.species", tree, tol = 1e-10, check.id.species)

    ## Check that all genes are over-dispersed
    if (fraction.non.overdispersed != 0) {
      stop("The Phylogenetic Poisson lognormal distribution is always over-dispersed.")
    }

    ## Check Proportion
    if (!is.vector(prop.var.tree)) {
      stop("`prop.var.tree` should be a vector or a scalar.")
    }
    if (length(prop.var.tree) != n.vars) {
      if (length(prop.var.tree) != 1) stop("`prop.var.tree` should be a vector of length the number of genes, or a scalar (in which case it will be recycled).")
    }
    if (any(prop.var.tree > 1.0 | prop.var.tree < 0.0)) {
      stop("All entries of `prop.var.tree` should be between 0 and 1.")
    }

  } else {
    ## Check id.condition (non phylogenetic)
    if (!is.null(id.condition)) {
      if (length(id.condition) != 2 * samples.per.cond) {
        stop("Vector of conditions `id.condition` should have length `2*samples.per.cond`.")
      }
    } else {
      id.condition <- rep(c(1, 2), each = samples.per.cond)
    }
  }

  ## Checks lengths
  if (is.null(lengths.relmeans) != is.null(lengths.dispersions)) {
    stop("For lengths to be used, both the 'lengths.relmeans' and 'lengths.dispersions' vectors must be provided.")
  }
  use_lengths <- !is.null(lengths.relmeans) # If lengths are specified, use them.
  if (use_lengths) {
    if (is.character(lengths.relmeans) || is.character(lengths.dispersions)) {  # if they are 'auto'
      ### Load mu and phi estimates from real data (Stern dataset)
      length.mu.phi.estimates <- system.file("extdata", "Stern2018.Length.Mu.Phi.Estimates.rds",
                                             package = "compcodeR")
      length.mu.phi.estimates <- readRDS(length.mu.phi.estimates)
      length.mu.estimates <- length.mu.phi.estimates$stern2018.length.mu
      length.phi.estimates <- length.mu.phi.estimates$stern2018.length.phi

      ### Sample a mu and a phi for each gene in condition S1
      to.include <- sample(seq_len(length(length.mu.estimates)), n.vars,
                           replace = ifelse(n.vars > length(length.mu.estimates), TRUE, FALSE))
      if (is.character(lengths.dispersions)) lengths.dispersions <- length.phi.estimates[to.include]
      if (is.character(lengths.relmeans)) lengths.relmeans <- length.mu.estimates[to.include]
    }
    if (length(lengths.relmeans) != n.vars) stop("The length of the 'lengths.relmeans' vector must be the same as the number of simulated genes.")
    if (length(lengths.dispersions) != n.vars) stop("The length of the 'lengths.dispersions' vector must be the same as the number of simulated genes.")
  }

	## Define conditions
  condition <- id.condition
  S1 <- which(condition == 1)
  S2 <- which(condition == 2)

	## Define sets of upregulated, downregulated and non-differentially regulated genes
  if (length(effect.size) == 1) {
    n.upregulated <- floor(fraction.upregulated * n.diffexp)
    if (fraction.upregulated != 0 & n.diffexp != 0) {
      genes.upreg <- seq_len(n.upregulated)
    } else {
      genes.upreg <- NULL
    }
    if (fraction.upregulated != 1 & n.diffexp != 0) {
      genes.downreg <- (n.upregulated + 1):n.diffexp
    } else {
      genes.downreg <- NULL
    }
    genes.nonreg <- setdiff(seq_len(n.vars), union(genes.upreg, genes.downreg))
  } else {
    if (length(effect.size) != n.vars) {
      stop("The length of the effect.size vector must be the same as the number of simulated genes.")
    } else {
      genes.upreg <- which(effect.size > 1)
      genes.downreg <- which(effect.size < 1)
      genes.nonreg <- which(effect.size == 1)
      n.upregulated <- length(genes.upreg)
      n.diffexp <- length(genes.upreg) + length(genes.downreg)
      fraction.upregulated <- n.upregulated/n.diffexp
    }
  }

	### Differentially expressed genes
	differential.expression <- rep(0, n.vars)
	differential.expression[genes.upreg] <- 1
	differential.expression[genes.downreg] <- 1
	upregulation <- rep(0, n.vars)
	upregulation[genes.upreg] <- 1
	downregulation <- rep(0, n.vars)
	downregulation[genes.downreg] <- 1

  if (is.character(relmeans) | is.character(dispersions)) {  # if they are 'auto'
    ### Load mu and phi estimates from real data (Pickrell data set and Cheung data set)
    mu.phi.estimates <- system.file("extdata", "Pickrell.Cheung.Mu.Phi.Estimates.rds",
                                    package = "compcodeR")
    mu.phi.estimates <- readRDS(mu.phi.estimates)
    mu.estimates <- mu.phi.estimates$pickrell.cheung.mu
    phi.estimates <- mu.phi.estimates$pickrell.cheung.phi

    ### Sample a mu and a phi for each gene in condition S1
    to.include <- sample(seq_len(length(mu.estimates)), n.vars,
                         replace = ifelse(n.vars > length(mu.estimates), TRUE, FALSE))
    truedispersions.S1 <- phi.estimates[to.include]
    truemeans.S1 <- mu.estimates[to.include]
  }
  if (!is.character(relmeans)) {
    if (length(relmeans) != n.vars) stop("The length of the relmeans vector must be the same as the number of simulated genes.")
    truemeans.S1 <- c(relmeans)
  }
  if (!is.character(dispersions)) {
    if (nrow(cbind(dispersions)) != n.vars) stop("The number of provided dispersions must be the same as the number of simulated genes.")
    truedispersions.S1 <- cbind(dispersions)[, 1]
    if (ncol(cbind(dispersions)) > 1) {
      truedispersions.S2 <- cbind(dispersions)[, 2]
    } else {
      truedispersions.S2 <- truedispersions.S1
    }
  }

	### Generate sequencing depths (nfacts * Nk)
	nfacts <- stats::runif(2 * samples.per.cond, min = minfact, max = maxfact)
	seq.depths <- nfacts * seqdepth

	### If not all genes are overdispersed, let some of them be Poisson distributed (dispersion = 0)
	overdispersed <- rep(1, n.vars)
	if (fraction.non.overdispersed > 0) {
		overdispersed[genes.upreg[seq_len(round(fraction.non.overdispersed * length(genes.upreg)))]] <- 0
		overdispersed[genes.downreg[seq_len(round(fraction.non.overdispersed * length(genes.downreg)))]] <- 0
		overdispersed[genes.nonreg[seq_len(round(fraction.non.overdispersed * length(genes.nonreg)))]] <- 0
	}

	### Find rates of mapping to each gene in each condition
	prob.S1 <- truemeans.S1
	prob.S2 <- rep(0, length(prob.S1))

  if (length(effect.size) == 1) {
    for (i in seq_len(n.vars)) {
      if (i %in% genes.upreg) {
        prob.S2[i] <- (effect.size + stats::rexp(1, rate = 1)) * prob.S1[i]
      } else {
        if (i %in% genes.downreg) {
          prob.S2[i] <- 1/(effect.size + stats::rexp(1, rate = 1)) * prob.S1[i]
        } else {
          prob.S2[i] <- prob.S1[i]
        }
      }
    }
  } else {
    prob.S2 <- c(effect.size) * prob.S1
  }
	true.log2foldchange <- log2(prob.S2/prob.S1)
	sum.S1 <- sum(prob.S1)
	sum.S2 <- sum(prob.S2)

	### Find new dispersions for condition S2, depending on what prob.S2 is.
  ### From the mu/phi estimates, sample a phi value from
	### the pairs where mu is similar to prob.S2.
  if (is.character(dispersions)) {
    truedispersions.S2 <- truedispersions.S1
    if (between.group.diffdisp == TRUE) {
      for (i in seq_len(length(truedispersions.S2))) {
        sample.base <- phi.estimates[abs(log10(mu.estimates) -
                                           log10(prob.S2[i])) < 0.05]
        if (length(sample.base) < 50) {
          sample.base <-
            phi.estimates[order(abs(log10(mu.estimates) -
                                      log10(prob.S2[i])))][seq_len(500)]
        }
        truedispersions.S2[i] <- sample(sample.base, 1)
      }
    }
  }

	truedispersions.S1 <- truedispersions.S1 * overdispersed
	truedispersions.S2 <- truedispersions.S2 * overdispersed

	## Generate lengths and length factors
	nfact_length.S1 <- nfact_length.S2 <- matrix(1, n.vars, length(S1) + length(S2))
	length_matrix <- matrix(NA, 0, 0)
	if (use_lengths) {
	  if (lengths.phylo) {
	    length_matrix <- generateLengthsPhylo(tree, id.species, lengths.relmeans, lengths.dispersions)
	  } else {
	    length_matrix <- generateLengths(id.species, lengths.relmeans, lengths.dispersions)
	  }
	  nfact_length.S1 <- computeFactorLengths(length_matrix, prob.S1, sum.S1)
	  nfact_length.S2 <- computeFactorLengths(length_matrix, prob.S2, sum.S2)
	}

	if (use_tree) {
	  params_simus <- getNegativeBinomialParameters(n.vars = n.vars,
	                                                S1 = S1, prob.S1 = prob.S1, sum.S1 = sum.S1, truedispersions.S1 = truedispersions.S1, nfact_length.S1 = nfact_length.S1,
	                                                S2 = S2, prob.S2 = prob.S2, sum.S2 = sum.S2, truedispersions.S2 = truedispersions.S2, nfact_length.S2 = nfact_length.S2,
	                                                seq.depths = seq.depths)
	  model.process <- match.arg(model.process)
	  Z <- simulateDataPhylo(params_simus$count_means,
	                         params_simus$count_dispersions,
	                         tree = tree, prop.var.tree = prop.var.tree,
	                         model.process = model.process, selection.strength = selection.strength)
	} else {
	  Z <- simulateData(n.vars = n.vars,
	                    S1 = S1, prob.S1 = prob.S1, sum.S1 = sum.S1, truedispersions.S1 = truedispersions.S1, nfact_length.S1 = nfact_length.S1,
	                    S2 = S2, prob.S2 = prob.S2, sum.S2 = sum.S2, truedispersions.S2 = truedispersions.S2, nfact_length.S2 = nfact_length.S2,
	                    seq.depths = seq.depths,
	                    overdispersed = overdispersed)
	}

	### Add 'random' outliers
	random.outliers <- matrix(0, nrow(Z), ncol(Z))
	random.outliers.factor <- matrix(1, nrow(Z), ncol(Z))
	if (random.outlier.high.prob != 0 | random.outlier.low.prob != 0) {
		for (i in seq_len(nrow(Z))) {
			for (j in seq_len(ncol(Z))) {
        tmp <- stats::runif(1)
				if (tmp < random.outlier.high.prob) {
          random.outliers[i, j] <- 1
          random.outliers.factor[i, j] <- stats::runif(1, min = 5, max = 10)
				} else if (tmp < random.outlier.low.prob + random.outlier.high.prob) {
          random.outliers[i, j] <- (-1)
          random.outliers.factor[i, j] <- 1/stats::runif(1, min = 5, max = 10)
				}
			}
		}
    Z <- round(random.outliers.factor * Z)
	}

	### Add 'single' outliers
	has.single.outlier <- rep(0, n.vars)
	single.outliers <- matrix(0, nrow(Z), ncol(Z))
  single.outliers.factor <- matrix(1, nrow(Z), ncol(Z))
	if (single.outlier.high.prob != 0 | single.outlier.low.prob != 0) {
	  has.single.outlier[genes.upreg[seq_len(floor((single.outlier.high.prob +
	                                                  single.outlier.low.prob) *
	                                                 length(genes.upreg)))]] <- 1
	  has.single.outlier[genes.downreg[seq_len(floor((single.outlier.high.prob +
	                                                    single.outlier.low.prob) *
	                                                   length(genes.downreg)))]] <- 1
	  has.single.outlier[genes.nonreg[seq_len(floor((single.outlier.high.prob +
	                                                   single.outlier.low.prob) *
	                                                  length(genes.nonreg)))]] <- 1

		for (i in seq_len(nrow(Z))) {
			if (has.single.outlier[i] == 1) {
				the.sample <- sample(seq_len(ncol(Z)), 1)
        if (stats::runif(1) < (single.outlier.high.prob/(single.outlier.high.prob +
                                                    single.outlier.low.prob))) {
					single.outliers[i, the.sample] <- 1
          single.outliers.factor[i, the.sample] <- stats::runif(1, min = 5, max = 10)
				} else {
					single.outliers[i, the.sample] <- (-1)
          single.outliers.factor[i, the.sample] <- 1/stats::runif(1, min = 5, max = 10)
				}
			}
		}
    Z <- round(single.outliers.factor * Z)
	}

	### Assign variable names to rows
	rownames(Z) <- seq_len(n.vars)

	### Find number of outliers (random, single, up, down) in each group
	n.random.outliers.up.S1 <- apply(random.outliers[, S1] > 0, 1, sum)
	n.random.outliers.up.S2 <- apply(random.outliers[, S2] > 0, 1, sum)
	n.random.outliers.down.S1 <- apply(random.outliers[, S1] < 0, 1, sum)
	n.random.outliers.down.S2 <- apply(random.outliers[, S2] < 0, 1, sum)
	n.single.outliers.up.S1 <- apply(single.outliers[, S1] > 0, 1, sum)
	n.single.outliers.up.S2 <- apply(single.outliers[, S2] > 0, 1, sum)
	n.single.outliers.down.S1 <- apply(single.outliers[, S1] < 0, 1, sum)
	n.single.outliers.down.S2 <- apply(single.outliers[, S2] < 0, 1, sum)

	### Normalize (TMM) and compute A and M values from the pseudocounts
	nf <- calcNormFactors(Z)
	norm.factors <- nf * colSums(Z)
	common.libsize <- exp(mean(log(colSums(Z))))
	pseudocounts <- sweep(Z + 0.5, 2, norm.factors, '/') * common.libsize
	log2.pseudocounts <- log2(pseudocounts)
	M.value <- apply(log2.pseudocounts[, S2], 1, mean) -
    apply(log2.pseudocounts[, S1], 1, mean)
	A.value <- 0.5*(apply(log2.pseudocounts[, S2], 1, mean) +
	                  apply(log2.pseudocounts[, S1], 1, mean))

	### Normalize using lengths
	if (use_lengths) {
	  ## TPM
	  nf.TPM <- calcNormFactors(Z / length_matrix)
	  norm.factors.TPM <- nf.TPM * colSums(Z / length_matrix)
	  common.libsize.TPM <- exp(mean(log(colSums(Z / length_matrix))))
	  pseudocounts.TPM <- sweep((Z + 0.5) / length_matrix, 2, norm.factors.TPM, '/') * common.libsize.TPM
	  log2.pseudocounts.TPM <- log2(pseudocounts.TPM)
	  M.value.TPM <- apply(log2.pseudocounts.TPM[, S2], 1, mean) - apply(log2.pseudocounts.TPM[, S1], 1, mean)
	  A.value.TPM <- 0.5*(apply(log2.pseudocounts.TPM[, S2], 1, mean) + apply(log2.pseudocounts.TPM[, S1], 1, mean))
	}

	### Create an annotation data frame
	variable.annotations <- data.frame(truedispersions.S1 = truedispersions.S1,
	                                   truedispersions.S2 = truedispersions.S2,
	                                   truemeans.S1 = prob.S1,
	                                   truemeans.S2 = prob.S2,
	                                   n.random.outliers.up.S1 = n.random.outliers.up.S1,
	                                   n.random.outliers.up.S2 = n.random.outliers.up.S2,
	                                   n.random.outliers.down.S1 = n.random.outliers.down.S1,
	                                   n.random.outliers.down.S2 = n.random.outliers.down.S2,
	                                   n.single.outliers.up.S1 = n.single.outliers.up.S1,
	                                   n.single.outliers.up.S2 = n.single.outliers.up.S2,
	                                   n.single.outliers.down.S1 = n.single.outliers.down.S1,
	                                   n.single.outliers.down.S2 = n.single.outliers.down.S2,
	                                   M.value = M.value,
	                                   A.value = A.value,
	                                   truelog2foldchanges = true.log2foldchange,
	                                   upregulation = upregulation,
	                                   downregulation = downregulation,
	                                   differential.expression = differential.expression)
	rownames(variable.annotations) <- rownames(Z)

	### Create a sample annotation data frame
	sample.annotations <- data.frame(condition = condition,
	                                 depth.factor = nfacts)
	if (use_tree) sample.annotations$id.species = id.species

	### Include information about the parameters
	info.parameters <- list('n.diffexp' = n.diffexp,
	                        'fraction.upregulated' = fraction.upregulated,
	                        'between.group.diffdisp' = between.group.diffdisp,
	                        'filter.threshold.total' = filter.threshold.total,
	                        'filter.threshold.mediancpm' = filter.threshold.mediancpm,
	                        'fraction.non.overdispersed' = fraction.non.overdispersed,
	                        'random.outlier.high.prob' = random.outlier.high.prob,
	                        'random.outlier.low.prob' = random.outlier.low.prob,
	                        'single.outlier.high.prob' = single.outlier.high.prob,
	                        'single.outlier.low.prob' = single.outlier.low.prob,
	                        'effect.size' = effect.size,
	                        'samples.per.cond' = samples.per.cond,
	                        'repl.id' = repl.id, 'dataset' = dataset,
	                        'uID' = uID, 'seqdepth' = seqdepth,
	                        'minfact' = minfact, 'maxfact' = maxfact,
	                        'nEff' = nEffNaive(tree, id.condition, model.process, selection.strength),
	                        'nEffRatio' = nEffRatio(tree, id.condition, model.process, selection.strength))
	if (use_tree) {
	  variable.annotations$prop.var.tree <- prop.var.tree
	  sample.annotations$id.condition <-  id.condition
	}
	if (use_lengths) {
	  variable.annotations$lengths.relmeans <- lengths.relmeans
	  variable.annotations$lengths.dispersions <- lengths.dispersions
	  variable.annotations$M.value.TPM <- M.value.TPM
	  variable.annotations$A.value.TPM <- A.value.TPM
	}

	### Filter the data with respect to total count
	s <- apply(Z, 1, sum)
	keep.T <- which(s >= filter.threshold.total)
	Z.T <- Z[keep.T, ]
	if (length(length_matrix) != 0) {
	  length_matrix.T <- length_matrix[keep.T, ]
	} else {
	  length_matrix.T <- length_matrix
	}
	variable.annotations.T <- variable.annotations[keep.T, ]
  filtering <- paste('total count >=', filter.threshold.total)

	### Filter the data with respect to median cpm
	cpm <- sweep(Z.T, 2, apply(Z.T, 2, sum), '/') * 1e6
	m <- apply(cpm, 1, stats::median)
	keep.C <- which(m >= filter.threshold.mediancpm)
	Z.TC <- Z.T[keep.C, ]
	if (length(length_matrix) != 0) {
	  length_matrix.TC <- length_matrix.T[keep.C, ]
	} else {
	  length_matrix.TC <- length_matrix.T
	}
	variable.annotations.TC <- variable.annotations.T[keep.C, ]
  filtering <- paste(filtering, "; ", paste('median cpm >=', filter.threshold.mediancpm))

  ### Generate sample and variable names
  rownames(Z.TC) <- paste("g", 1:nrow(Z.TC), sep = "")
  if (!use_tree) colnames(Z.TC) <- paste("sample", seq_len(ncol(Z.TC)), sep = "")
  rownames(sample.annotations) <- colnames(Z.TC)
  rownames(variable.annotations.TC) <- rownames(Z.TC)
  if (length(length_matrix.TC) != 0) {
    colnames(length_matrix.TC) <- colnames(Z.TC)
    rownames(length_matrix.TC) <- rownames(Z.TC)
  }

  data.object <- compData(count.matrix = Z.TC,
                          variable.annotations = variable.annotations.TC,
                          sample.annotations = sample.annotations,
                          filtering = filtering,
                          info.parameters = info.parameters)

  if (use_tree || use_lengths) {
    data.object <- phyloCompDataFromCompData(data.object,
                                             tree = tree,
                                             length.matrix = length_matrix.TC)
  }

  ## Save results
  if (!is.null(output.file)) {
    saveRDS(data.object, file = output.file)
  }

	return(invisible(data.object))
}

computeMval <- function(count.matrix, conditions) {
  if (length(unique(conditions)) != 2) stop("Must have exactly two groups to calculate M-value")
  nf <- calcNormFactors(count.matrix)
  norm.factors <- nf * colSums(count.matrix)
  common.libsize <- exp(mean(log(colSums(count.matrix))))
  pseudocounts <- sweep(count.matrix + 0.5, 2, norm.factors, '/') * common.libsize
  log2.pseudocounts <- log2(pseudocounts)
  M.value <- apply(log2.pseudocounts[, which(conditions == levels(factor(conditions))[2])],
                   1, mean) -
    apply(log2.pseudocounts[, which(conditions == levels(factor(conditions))[1])],
          1, mean)
  return(M.value)
}

computeAval <- function(count.matrix, conditions) {
  if (length(unique(conditions)) != 2) stop("Must have exactly two groups to calculate A-value")
  nf <- calcNormFactors(count.matrix)
  norm.factors <- nf * colSums(count.matrix)
  common.libsize <- exp(mean(log(colSums(count.matrix))))
  pseudocounts <- sweep(count.matrix + 0.5, 2, norm.factors, '/') * common.libsize
  log2.pseudocounts <- log2(pseudocounts)
  A.value <- 0.5*(apply(log2.pseudocounts[, which(conditions == levels(factor(conditions))[2])],
                        1, mean) +
                    apply(log2.pseudocounts[, which(conditions ==
                                                      levels(factor(conditions))[1])],
                          1, mean))
  return(A.value)
}

#' @title Simulate the Data
#'
#' @description
#' Use the Poisson or Negative Binomial model to simulate the data.
#'
#' @inheritParams generateSyntheticData
#' @param S1 Indices in condition 1.
#' @param prob.S1 Vector of means for condition 1.
#' @param sum.S1 Sum of means for condition 1.
#' @param truedispersions.S1 Vector of dispersions for condition 1.
#' @param nfact_length.S1 Matrix of length factors for condition 1.
#' @param S2 Indices in condition 2.
#' @param prob.S2 Vector of means for condition 2.
#' @param sum.S2 Sum of means for condition 2.
#' @param truedispersions.S2 Vector of dispersions for condition 2.
#' @param nfact_length.S2 Matrix of length factors for condition 2.
#' @param overdispersed Indices that are overdispersed.
#'
#' @return Z a n.var times 2*samples.per.cond matrix with the simulated data.
#'
#' @keywords internal
#'
simulateData <- function(n.vars,
                         S1, prob.S1, sum.S1, truedispersions.S1, nfact_length.S1,
                         S2, prob.S2, sum.S2, truedispersions.S2, nfact_length.S2,
                         seq.depths,
                         overdispersed) {
  ### Initialize data matrix
  Z <- matrix(0, n.vars, length(S1) + length(S2))

  ### Generate data
  for (i in seq_len(nrow(Z))) {
    for (j in seq_len(ncol(Z))) {
      if (overdispersed[i] == 1) {
        Z[i, j] <- rnbinom(n = 1, mu = getNegativeBinomialMean(i, j,
                                                               S1, prob.S1, sum.S1, nfact_length.S1,
                                                               S2, prob.S2, sum.S2, nfact_length.S2,
                                                               seq.depths),
                           size = 1 / getNegativeBinomialDispersion(i, j,
                                                                    S1, truedispersions.S1,
                                                                    S2, truedispersions.S2))
      } else {
        Z[i, j] <- rpois(n = 1, lambda = getNegativeBinomialMean(i, j,
                                                                 S1, prob.S1, sum.S1, nfact_length.S1,
                                                                 S2, prob.S2, sum.S2, nfact_length.S2,
                                                                 seq.depths))
      }
    }
  }

  return(Z)
}

#' @title Get all parameters of the NB at once
#'
#' @description
#' Get both the mean and the dispersions of the NB as matrices for all indices.
#'
#' @inheritParams simulateData
#'
#' @return A list of parameters for each entry of the count matrix:
#' \describe{
#' \item{count_means}{a matrix of mean for each gene and sample.}
#' \item{count_dispersions}{a matrix of dispersions for each gene and sample.}
#' }
#'
#' @keywords internal
#'
getNegativeBinomialParameters <- function(n.vars,
                                          S1, prob.S1, sum.S1, truedispersions.S1, nfact_length.S1,
                                          S2, prob.S2, sum.S2, truedispersions.S2, nfact_length.S2,
                                          seq.depths) {
  ### Initialize
  count_means <- matrix(0, n.vars, length(S1) + length(S2))
  count_dispersions <- matrix(0, n.vars, length(S1) + length(S2))

    ### Generate Negative Binomial Parameters
  for (i in seq_len(n.vars)) {
    for (j in seq_len(ncol(count_means))) {
      count_means[i, j] <- getNegativeBinomialMean(i, j,
                                                   S1, prob.S1, sum.S1, nfact_length.S1,
                                                   S2, prob.S2, sum.S2, nfact_length.S2,
                                                   seq.depths)
      count_dispersions[i, j] <- getNegativeBinomialDispersion(i, j,
                                                               S1, truedispersions.S1,
                                                               S2, truedispersions.S2)
    }
  }
  return(list(count_means = count_means,
              count_dispersions = count_dispersions))
}

get_factor <- function(M, i, j) {
  if (length(M) == 0) return(1.0)
  return(M[i, j])
}

#' @title Get NB mean
#'
#' @description
#' Get the NB mean for one gene in one sample
#'
#' @inheritParams simulateData
#' @param i gene index.
#' @param j sample index.
#'
#' @return The mean for gene i in sample j.
#'
#' @keywords internal
#'
getNegativeBinomialMean <- function(i, j,
                                    S1, prob.S1, sum.S1, nfact_length.S1,
                                    S2, prob.S2, sum.S2, nfact_length.S2,
                                    seq.depths) {
  if (j %in% S1) {
    return(prob.S1[i]/sum.S1 * seq.depths[j] * get_factor(nfact_length.S1, i, j))
  } else {
    return(prob.S2[i]/sum.S2 * seq.depths[j] * get_factor(nfact_length.S2, i, j))
  }
}
#' @title Get NB dispersion
#'
#' @description
#' Get the NB dispersion for one gene in one sample
#'
#' @inheritParams simulateData
#' @param i gene index.
#' @param j sample index.
#'
#' @return The dispersion for gene i in sample j.
#'
#' @keywords internal
#'
getNegativeBinomialDispersion <- function(i, j,
                                          S1, truedispersions.S1,
                                          S2, truedispersions.S2) {
  if (j %in% S1) {
    return(truedispersions.S1[i])
  } else {
    return(truedispersions.S2[i])
  }
}

#' @title Simulate a length matrix
#'
#' @description
#' Simulate a length matrix of size n.vars times n.sample, with the length of
#' each gene in each sample.
#'
#' @param id.species An n.sample vector, indicating the species of each sample.
#' @param lengths.relmeans A vector of mean values to use in the simulation of
#' lengths from the Negative Binomial distribution.
#' @param lengths.dispersions A vector or matrix of dispersions to use in the
#' simulation of data from the Negative Binomial distribution.
#'
#' @return A matrix of lengths, with as many columns as the number of species (length of id.species)
#' and as many rows as the number of parameters in lengths.relmeans.
#'
#' @keywords internal
#'
generateLengths <- function(id.species, lengths.relmeans, lengths.dispersions) {
  length_matrix <- matrix(NA, length(lengths.relmeans), length(id.species))
  for(i in 1:length(lengths.relmeans)){
    sims <- rnbinom(length(unique(id.species)),
                    mu = lengths.relmeans[i],
                    size = 1 / lengths.dispersions[i])
    if (any(sims == 0)) {
      ntry <- 1
      while (any(sims == 0) && ntry <= 100) {
        sims <- rnbinom(length(unique(id.species)),
                        mu = lengths.relmeans[i],
                        size = 1 / lengths.dispersions[i])
        ntry <- ntry + 1
      }
      if (any(sims == 0)) {
        warning(paste0("After 100 tries, could not generate non-zero lengths for gene ", i, ". Replacing zeros with the provided mean."))
        sims[sims == 0] <- lengths.relmeans[i]
      }
    }
    length_matrix[i, ] <- sims[id.species]
  }
  return(length_matrix)
}

#' @title Compute Length Normalization Factors
#'
#' @description
#' Compute the factor to be applied for length normalization.
#' Each column of the matrix (samples) is normalized by the weighted average of
#' the column, with weights corresponding to the true probabilities of each gene.
#'
#' @param length_matrix An n.vars times n.sample matrix of lengths of each gene in each sample.
#' @param prob.S1 Vector of means for condition 1.
#' @param sum.S1 Sum of means for condition 1.
#'
#' @return A matrix of the same size as 'length_matrix', with normalization factors
#' to be applied for each sample and each gene.
#'
#' @keywords internal
#'
computeFactorLengths <- function(length_matrix, prob.S1, sum.S1) {
  return(length_matrix %*% diag(1 / colSums(diag(prob.S1 / sum.S1) %*% length_matrix)))
}

#' Summarize a synthetic data set by some diagnostic plots
#'
#' Summarize a synthetic data set (generated by \code{\link{generateSyntheticData}}) by some diagnostic plots.
#'
#' @param data.set A data set, either a \code{\link{compData}} object or a path to an \code{.rds} file where such an object is stored.
#' @param output.filename The filename of the resulting html report (including the path).
#' @export
#' @author Charlotte Soneson
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' if (interactive()) {
#'   summarizeSyntheticDataSet(data.set = file.path(tmpdir, "mydata.rds"),
#'                             output.filename = file.path(tmpdir, "mydata_check.html"))
#' }
summarizeSyntheticDataSet <- function(data.set, output.filename) {

  ## Check that the output.filename ends with .html
  if (!(substr(output.filename, nchar(output.filename) - 4,
               nchar(output.filename)) == ".html")) {
    stop("output.file must be an .html file.")
  }

  ## Generate an .Rmd file
  ##output.filename <- normalizePath(output.filename)
  Rmd.file <- sub(".html", ".Rmd", output.filename)
  md.file <- sub(".html", ".md", output.filename)
  codefile <- file(Rmd.file, open = 'w')
  output.directory <- dirname(output.filename)

  writeLines("### Summary of synthetic data set", codefile)

  opts_chunk$set(fig.path = file.path(output.directory, "compcodeR_check_figure/"))
  opts_chunk$set(fig.width = 9, fig.height = 7)

  if (is.character(data.set) &&
        substr(data.set, nchar(data.set) - 3, nchar(data.set)) == ".rds") {
    dataset.filename <- data.set
    data.set <- readRDS(data.set)
    writeLines(paste("Data set from file:", dataset.filename), codefile)
  }
  if (is(data.set, "compData")) {
    data.set <- data.set
  } else if (is.list(data.set)) {
    data.set <- convertListTocompData(data.set)
  } else {
    stop("Unknown input type")
  }

  ## Print the data parameters
  writeLines(c("```{r settings, echo = FALSE}",
               "print(noquote(lapply(info.parameters(data.set), function(x) {
if (length(x) > 25) x <- noquote(c(x[seq_len(25)], '...'))
               x})), sep = '\n')",
               "```"), codefile)

  writeLines(c("```{r modifications, echo = FALSE}",
               "  variable.annotations(data.set)$differential.expression = as.factor(variable.annotations(data.set)$differential.expression)",
               "variable.annotations(data.set)$total.nbr.outliers = as.factor(variable.annotations(data.set)$n.random.outliers.up.S1 + variable.annotations(data.set)$n.random.outliers.up.S2 + variable.annotations(data.set)$n.random.outliers.down.S1 + variable.annotations(data.set)$n.random.outliers.down.S2 + variable.annotations(data.set)$n.single.outliers.up.S1 + variable.annotations(data.set)$n.single.outliers.up.S2 + variable.annotations(data.set)$n.single.outliers.down.S1 + variable.annotations(data.set)$n.single.outliers.down.S2)",
               "```"), codefile)

  ## MA plots, colored by various annotations
  writeLines(c("```{r calcma, echo = FALSE, dev = 'png', eval = TRUE, include = TRUE}",
               "if (nrow(variable.annotations(data.set)) == 0) {",
               "variable.annotations(data.set) = data.frame(dummy = rep(NA, nrow(count.matrix(data.set))))}",
               "if (is.null(variable.annotations(data.set)$A.value)) {",
               "variable.annotations(data.set)$A.value = computeAval(count.matrix(data.set), sample.annotations(data.set)$condition)}",
               "if (is.null(variable.annotations(data.set)$M.value)) {",
               "variable.annotations(data.set)$M.value = computeMval(count.matrix(data.set), sample.annotations(data.set)$condition)}",
               "if (is.null(variable.annotations(data.set)$differential.expression)) {",
               "variable.annotations(data.set)$differential.expression = factor(rep('NA', nrow(variable.annotations(data.set))))}",
               "if (is.null(variable.annotations(data.set)$total.nbr.outliers)) {",
               "variable.annotations(data.set)$total.nbr.outliers = factor(rep('NA', nrow(variable.annotations(data.set))))}",
               "```"), codefile)

  ## Colored by true differential expression status
  writeLines("### MA plot, colored by true differential expression status", codefile)
  writeLines(c("```{r maplot-trueDEstatus, echo = FALSE, dev = 'png', eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "ggplot(variable.annotations(data.set), aes(x = A.value, y = M.value, color = differential.expression)) + geom_point() + scale_colour_manual(values = c('black', 'red'))",
               "```"), codefile)

  if (length(length.matrix(data.set)) != 0) { # There are lengths
    writeLines("### MA plot, log2 TPM normalized, colored by true differential expression status", codefile)
    writeLines(c("```{r maplot-trueDEstatus-logTPM, echo = FALSE, dev = 'png', eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
                 "ggplot(variable.annotations(data.set), aes(x = A.value.TPM, y = M.value.TPM, color = differential.expression)) + geom_point() + scale_colour_manual(values = c('black', 'red'))",
                 "```"), codefile)
  }

  ## Colored by number of outlier counts
  writeLines("### MA plot, colored by total number of outliers", codefile)
  writeLines(c("```{r maplot-nbroutliers, echo = FALSE, dev = 'png', eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "ggplot(variable.annotations(data.set), aes(x = A.value, y = M.value, color = total.nbr.outliers)) + geom_point()",
               "```"), codefile)

  ## Plots of estimated log2-fold change (M-value) vs true log2-fold change, colored by true differential expression status
  writeLines("### True log2-fold change vs estimated log2-fold change (M-value)", codefile)
  writeLines(c("```{r logfoldchanges, echo = FALSE, dev = 'png', eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "if (!is.null(variable.annotations(data.set)$truelog2foldchanges)) {",
               "ggplot(variable.annotations(data.set), aes(x = truelog2foldchanges, y = M.value, color = differential.expression)) + geom_point() + scale_colour_manual(values = c('black', 'red'))}",
               "```"), codefile)

  if (length(length.matrix(data.set)) != 0) { # There are lengths
    writeLines("### True log2-fold change vs estimated TPM log2-fold change (M-value)", codefile)
    writeLines(c("```{r logfoldchanges-logTPM, echo = FALSE, dev = 'png', eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
                 "if (!is.null(variable.annotations(data.set)$truelog2foldchanges)) {",
                 "ggplot(variable.annotations(data.set), aes(x = truelog2foldchanges, y = M.value.TPM, color = differential.expression)) + geom_point() + scale_colour_manual(values = c('black', 'red'))}",
                 "```"), codefile)
  }

  ## Phylogenetic heatmap
  if (length(phylo.tree(data.set)) != 0 && info.parameters(data.set)$n.diffexp > 0) { # There is a tree, and there are some DE genes
    if (!requireNamespace("ggtree", quietly = TRUE) || !requireNamespace("tidytree", quietly = TRUE)) {
      warning("Packages 'ggtree' and 'tidytree' are needed for phylogenetic heatmap plot. Skipping.", call. = FALSE)
    } else {
      writeLines("### log2 normalized counts heatmap plotted on the phylogeny", codefile)
      writeLines(c("```{r maplot-phyloHeatmap, echo = FALSE, dev = 'png', eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
                   "library(ggtree)",
                   "library(tidytree)",
                   "",
                   "tree <- phylo.tree(data.set)",
                   "conds <- data.frame(label = rownames(sample.annotations(data.set)), condition = as.factor(sample.annotations(data.set)$id.condition))",
                   "gt <- ggtree(tree)",
                   "gt <- gt %<+% conds + geom_tippoint(aes(color = condition))",
                   "",
                   "Z <- count.matrix(data.set)",
                   "nf <- edgeR::calcNormFactors(Z)",
                   "norm.factors <- nf * colSums(Z)",
                   "common.libsize <- exp(mean(log(colSums(Z))))",
                   "pseudocounts <- sweep(Z + 0.5, 2, norm.factors, '/') * common.libsize",
                   "log2.pseudocounts <- log2(pseudocounts)",
                   "",
                   "Z1 <- log2.pseudocounts[which(variable.annotations(data.set)$differential.expression == 1), ]",
                   "Z2 <- log2.pseudocounts[which(variable.annotations(data.set)$differential.expression == 0)[seq_len(nrow(Z1))], ]",
                   "",
                   "gh <- gheatmap(gt, t(Z1), offset = 0.1, width = 5, colnames = FALSE)",
                   "gh <- gheatmap(gh, t(Z2), offset = 5.2, width = 5, colnames = FALSE)",
                   "gh <- gh + scale_fill_viridis_c(option = 'plasma', direction = -1, name = 'log2 norm count')",
                   "gh",
                   "```"), codefile)
      writeLines(c("",
                   "Tips are colored by the true differential expression status.",
                   "Only a subset of `r nrow(Z1) + nrow(Z2)` genes are represented.",
                   "The first block of `r nrow(Z1)` genes are differentially expressed between condition 1 and 2.",
                   "The second block of `r nrow(Z2)` genes are not differentially expressed."),
                 codefile)
    }
  }
  ## Correlation heatmap
  if (length(phylo.tree(data.set)) != 0) { # There is a tree
    writeLines("### log2 normalized counts samples correlation heatmap", codefile)
    writeLines(c("```{r maplot-corHeatmap, echo = FALSE, dev = 'png', eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
                 "Z <- count.matrix(data.set)",
                 "nf <- edgeR::calcNormFactors(Z)",
                 "norm.factors <- nf * colSums(Z)",
                 "common.libsize <- exp(mean(log(colSums(Z))))",
                 "pseudocounts <- sweep(Z + 0.5, 2, norm.factors, '/') * common.libsize",
                 "log2.pseudocounts <- log2(pseudocounts)",
                 "",
                 "sampleDists <- dist( t( log2.pseudocounts ) )",
                 "sampleDistMatrix <- as.matrix(sampleDists)",
                 "heatmap(sampleDistMatrix, col = hcl.colors(256, palette = 'Plasma'))",
                 "```"), codefile)
    writeLines(c("",
                 "Note: the heatmap tree is the correlation tree (the phylogeny is not taken into account in this plot)."),
               codefile)
  }
  ##
  if (length(length.matrix(data.set)) != 0) { # There are lengths
    writeLines("### Lengths: mean versus variance (log2)", codefile)
    writeLines(c(
      "```{r lengths, echo = FALSE, dev = 'png', eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
      "length.matrix_species <- length.matrix(data.set)[, !duplicated(sample.annotations(data.set)$id.species)]",
      "stats_lengths <- data.frame(mean = c(variable.annotations(data.set)$lengths.relmeans,",
      "                                     rowMeans(length.matrix_species)),",
      "                            var = c(variable.annotations(data.set)$lengths.relmeans + variable.annotations(data.set)$lengths.relmeans^2 * variable.annotations(data.set)$lengths.dispersion,",
      "                                    apply(length.matrix_species, 1, var)),",
      "                            simulated = c(rep('true values', nrow(length.matrix_species)),",
      "                                          rep('simulated values', nrow(length.matrix_species))))",
      "ggplot(stats_lengths, aes(x = log2(mean), y = log2(var), color = simulated)) + geom_point() + scale_color_manual(values = c('black', 'blue')) + geom_abline(slope = 1) + coord_fixed(xlim = c(0, NA), ylim = c(0, NA))",
      "```"
    ), codefile)
  }

  close(codefile)

  out <- knitr::knit(input = Rmd.file,
                     output = md.file,
                     envir =  new.env())
  rmarkdown::pandoc_convert(input = out,
                            output = output.filename)
  # markdown::markdownToHTML(file = out,
  #                          output = output.filename,
  #                          encoding = "UTF-8",
  #                          title = "Synthetic data set summary")

  save.rmdfile <- FALSE  ## set to TRUE to save the .Rmd file (debug)
  ## Remove the .Rmd file
  if (!save.rmdfile) file.remove(Rmd.file)

  ## Remove the .md file
  file.remove(md.file)

}

#' Show function for \code{compData} object
#' 
#' Show function for \code{compData} object. 
#' @param object A \code{compData} object
#' 
#' @keywords internal
#' 
show_compData <- function(object) {
  nbr.random.outliers <- 
    sum(object@variable.annotations$n.random.outliers.up.S1 + 
          object@variable.annotations$n.random.outliers.down.S1 + 
          object@variable.annotations$n.random.outliers.up.S2 + 
          object@variable.annotations$n.random.outliers.down.S2)
  nbr.single.outliers <- 
    sum(object@variable.annotations$n.single.outliers.up.S1 + 
          object@variable.annotations$n.single.outliers.down.S1 + 
          object@variable.annotations$n.single.outliers.up.S2 + 
          object@variable.annotations$n.single.outliers.down.S2)
  nbr.diffexp <- sum(object@variable.annotations$differential.expression)
  if (length(object@method.names) == 0) {
    diffexp.statement <- "No differential expression analysis has been performed."
  } else {
    diffexp.statement <- 
      paste("Differential expression analysis was performed by the method", 
            object@method.names$full.name, "on", 
            object@analysis.date, ".")
  }
  cat(paste("An object of class", class(object), "\n"))
  cat(paste("Dataset name:", object@info.parameters$dataset, "\n"))
  cat(paste("Number of samples:", ncol(object@count.matrix), "\n"))
  cat(paste("Number of variables:", nrow(object@count.matrix), "\n"))
  cat(paste("Number of random outliers:", nbr.random.outliers, "\n"))
  cat(paste("Number of single outliers:", nbr.single.outliers, "\n"))
  cat(paste("Number of known truly differentially expressed genes:", nbr.diffexp, "\n"))
  cat(paste(diffexp.statement, "\n\n"))
  cat("count.matrix:\n")
  print(utils::head(object@count.matrix[, seq_len(min(ncol(object@count.matrix), 6))]))
  nbrleftoutrows <- max(c(0, nrow(object@count.matrix) - 6))
  nbrleftoutcols <- max(c(0, ncol(object@count.matrix) - 6))
  if (nbrleftoutrows > 0 & nbrleftoutcols > 0) {
    cat(paste("+", nbrleftoutrows, "rows and", nbrleftoutcols, "cols...\n\n"))
  } else if (nbrleftoutrows > 0) {
    cat(paste("+", nbrleftoutrows, "rows...\n\n"))
  } else if (nbrleftoutcols > 0) {
    cat(paste("+", nbrleftoutrows, "cols...\n\n"))
  }
  cat("sample.annotations:\n")
  print(utils::head(object@sample.annotations))
  nbrleftoutrows <- max(c(0, nrow(object@sample.annotations) - 6))
  if (nbrleftoutrows > 0) {
    cat(paste("+", nbrleftoutrows, "rows...\n\n"))
  } else {
    cat("\n")
  }
  cat("variable.annotations:\n")
  print(utils::head(object@variable.annotations))
  nbrleftoutrows <- max(c(0, nrow(object@variable.annotations) - 6))
  if (nbrleftoutrows > 0) {
    cat(paste("+", nbrleftoutrows, "rows...\n\n"))
  } else {
    cat("\n")
  }
  
  if (length(object@method.names) != 0) {
    cat("Differential expression results:\n\n")
    print(utils::head(object@result.table))
    nbrleftoutrows <- max(c(0, nrow(object@result.table) - 6))
    if (nbrleftoutrows > 0) {
      cat(paste("+", nbrleftoutrows, "rows...\n\n"))
    } else {
      cat("\n")
    }
  }
}

#' Show method for \code{compData} object
#' 
#' Show method for \code{compData} object. 
#' @param object A \code{compData} object
#' @author Charlotte Soneson
#' @examples 
#' mydata <- generateSyntheticData(dataset = "mydata", n.vars = 12500, 
#'                                 samples.per.cond = 5, n.diffexp = 1250)
#' mydata
#' @importFrom utils head
setMethod(
  f = "show",  # name of function
  signature = "compData",  # class of each argument. other ex: signature = c(x = , y = )
  definition = show_compData
)

#' Show method for \code{phyloCompData} object
#' 
#' Show method for \code{phyloCompData} object. 
#' @param object A \code{phyloCompData} object
#' @author Charlotte Soneson, Paul Bastide
#' @examples 
#' mydata <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                 samples.per.cond = 5, n.diffexp = 100,
#'                                 id.species = factor(1:10),
#'                                 tree = ape::rphylo(10, 1, 0),
#'                                 lengths.relmeans = "auto", lengths.dispersions = "auto")
#' mydata
#' @importFrom utils head
setMethod(
  f = "show",  # name of function
  signature = "phyloCompData",  # class of each argument. other ex: signature = c(x = , y = )
  definition = function(object) {
    show_compData(object)

    if (length(object@tree) != 0) {
      cat("Phylogenetic tree:\n")
      print(object@tree)
      cat("\n")
    } else {
      cat("Without phylogenetic tree. \n")
    }
    
    if (length(object@length.matrix) != 0) {
      cat("length.matrix:\n")
      print(head(object@length.matrix[, 1:min(ncol(object@length.matrix), 6)]))
      cat("\n")
    } else {
      cat("No length matrix. \n")
    }
  }
)

#setGeneric("show")

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with DESeq2 with custom model matrix
#' 
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the DESeq2 package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#' 
#' For more information about the methods and the interpretation of the parameters, see the \code{DESeq2} package and the corresponding publications. 
#' 
#' @inheritParams DESeq2.createRmd
#' @param data.path The path to a .rds file containing the \code{phyloCompData} object that will be used for the differential expression analysis.
#' @param extra.design.covariates A vector containing the names of extra control variables to be passed to the design matrix of \code{DESeq2}. All the covariates need to be a column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object, with a matching column name. The covariates can be a numeric vector, or a factor. Note that "condition" factor column is always included, and should not be added here. See Details.
#' 
#' @details 
#' The lengths matrix is used as a normalization factor and applied to the \code{DESeq2}
#' model in the way explained in \code{\link[DESeq2]{normalizationFactors}}
#' (see examples of this function).
#' The provided matrix will be multiplied by the default normalization factor 
#' obtained through the \code{\link[DESeq2]{estimateSizeFactors}} function.
#' 
#' The \code{design} model used in the \code{\link[DESeq2]{DESeqDataSetFromMatrix}}
#' uses the "condition" column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object
#' as well as all the covariates named in \code{extra.design.covariates}.
#' For example, if \code{extra.design.covariates = c("var1", "var2")}, then
#' \code{sample.annotations} must have two columns named "var1" and "var2", and the design formula
#' in the \code{\link[DESeq2]{DESeqDataSetFromMatrix}} function will be:
#' \code{~ condition + var1 + var2}.
#' 
#' @export 
#' @author Charlotte Soneson, Paul Bastide, Mélina Gallopin
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references 
#' Anders S and Huber W (2010): Differential expression analysis for sequence count data. Genome Biology 11:R106
#' 
#' Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of fold change and dispersion for RNA-seq data with DESeq2. Genome Biology, 15:550. 10.1186/s13059-014-0550-8.
#' @examples
#' try(
#' if (require(DESeq2)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' ## Simulate data
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                     samples.per.cond = 5, n.diffexp = 100, 
#'                                     id.species = 1:10,
#'                                     lengths.relmeans = rpois(1000, 1000),
#'                                     lengths.dispersions = rgamma(1000, 1, 1),
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' ## Add covariates
#' ## Model fitted is count.matrix ~ condition + test_factor + test_reg
#' sample.annotations(mydata.obj)$test_factor <- factor(rep(1:2, each = 5))
#' sample.annotations(mydata.obj)$test_reg <- rnorm(10, 0, 1)
#' saveRDS(mydata.obj, file.path(tmpdir, "mydata.rds"))
#' ## Diff Exp
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "DESeq2", 
#'            Rmdfunction = "DESeq2.length.createRmd", 
#'            output.directory = tmpdir, fit.type = "parametric",
#'            test = "Wald",
#'            extra.design.covariates = c("test_factor", "test_reg"))
#' })
DESeq2.length.createRmd <- function(data.path, result.path, codefile, 
                                    fit.type, test, beta.prior = TRUE, 
                                    independent.filtering = TRUE, cooks.cutoff = TRUE, 
                                    impute.outliers = TRUE,
                                    extra.design.covariates = NULL,
                                    nas.as.ones = FALSE) {
  codefile <- file(codefile, open = 'w')
  writeLines("### DESeq2.length", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = TRUE, error = TRUE, warning = TRUE}", 
               "require(DESeq2)", 
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTophyloCompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_phyloCompData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid phyloCompData object.')"),
             codefile)
  writeLines("count_matrix <- count.matrix(cdata)", codefile)
  if (is.null(extra.design.covariates)) {
    writeLines(c(
      paste("DESeq2.length.ds <- DESeq2::DESeqDataSetFromMatrix(countData = count_matrix,",
            "colData = data.frame(condition = factor(sample.annotations(cdata)$condition)),",
            "design = ~ condition)")),
      codefile)
  } else {
    writeLines(c(
      paste0("DESeq2.length.ds <- DESeq2::DESeqDataSetFromMatrix(countData = count_matrix,",
             " colData = cbind(sample.annotations(cdata)[, c('", paste(extra.design.covariates, collapse = "', '"), "'), drop = FALSE], data.frame(condition = factor(sample.annotations(cdata)$condition))),",
             " design = as.formula(paste(' ~ ', paste(c('", paste(extra.design.covariates, collapse = "', '"), "'), collapse= '+'), '+ condition')))")),
      codefile)
  }
  writeLines(c(
    "## Size Factors",
    "DESeq2.length.ds <-  estimateSizeFactors(DESeq2.length.ds)",
    "size_fac <- sizeFactors(DESeq2.length.ds)",
    "mat_size_fac <- matrix(size_fac, ncol = length(size_fac), nrow = nrow(count.matrix(cdata)), byrow = T)",
    "## Extra factors",
    "extraNormFactor <- length.matrix(cdata)",
    "normFactors <- (mat_size_fac * extraNormFactor) / exp(rowMeans(log(mat_size_fac * extraNormFactor)))",
    "normalizationFactors(DESeq2.length.ds) <- as.matrix(normFactors)"),
    codefile)
  writeLines(paste("DESeq2.length.ds <- DESeq2::DESeq(DESeq2.length.ds, fitType = '", fit.type, "', test = '", test, "', betaPrior = ", beta.prior, ")", sep = ""),
             codefile)
  if (impute.outliers == TRUE) {
    writeLines(c("DESeq2.length.ds.clean <- DESeq2::replaceOutliersWithTrimmedMean(DESeq2.length.ds)",
                 paste("DESeq2.length.ds.clean <- DESeq2::DESeq(DESeq2.length.ds.clean, fitType = '", fit.type, "', test = '", test, "', betaPrior = ", beta.prior, ")", sep = ""), 
                 "DESeq2.length.ds <- DESeq2.length.ds.clean"), codefile)
  }
  writeLines(paste("DESeq2.length.results <- DESeq2::results(DESeq2.length.ds, independentFiltering = ", independent.filtering, ", cooksCutoff = ", cooks.cutoff, ")", sep = ""),
             codefile)  
  if (nas.as.ones) {
    # see https://bioconductor.org/packages/release/bioc/vignettes/DESeq2/inst/doc/DESeq2.html#i-want-to-benchmark-deseq2-comparing-to-other-de-tools.
    message("As `nas.as.ones=TRUE`, all NAs in adjusted p values are replaced by 1 to allow for benchmarking with other methods. For more details, see section 'I want to benchmark DESeq2 comparing to other DE tools' from the `DESeq2` vignette (available by running `vignette('DESeq2', package = 'DESeq2')`)")
    writeLines("DESeq2.length.results$padj <- ifelse(is.na(DESeq2.length.results$padj), 1, DESeq2.length.results$padj)", codefile)  
  } else {
    message("As `nas.as.ones=FALSE`, there might be some NAs in the adjusted p values computed by DESeq2. This might bias the comparison of the results with other methods. For more details, see section 'I want to benchmark DESeq2 comparing to other DE tools' from the `DESeq2` vignette (available by running `vignette('DESeq2', package = 'DESeq2')`)")
  }
  writeLines(c("DESeq2.length.pvalues <- DESeq2.length.results$pvalue", 
               "DESeq2.length.adjpvalues <- DESeq2.length.results$padj", 
               "DESeq2.length.logFC <- DESeq2.length.results$log2FoldChange", 
               "DESeq2.length.score <- 1 - DESeq2.length.pvalues", 
               "result.table <- data.frame('pvalue' = DESeq2.length.pvalues, 'adjpvalue' = DESeq2.length.adjpvalues, 'logFC' = DESeq2.length.logFC, 'score' = DESeq2.length.score)", 
               "rownames(result.table) <- rownames(count.matrix(cdata))",
               "result.table(cdata) <- result.table", 
               "package.version(cdata) <- paste('DESeq2,', packageVersion('DESeq2'))",
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'DESeq2.length', 'full.name' = '", paste('DESeq2.length.', utils::packageVersion('DESeq2'), '.', fit.type, '.', test, '.', ifelse(beta.prior == TRUE, 'bp', 'nobp'), '.', ifelse(independent.filtering == TRUE, 'indf', 'noindf'), paste(".cook_", cooks.cutoff, sep = ""), ifelse(impute.outliers, ".imp", ".noimp"), ifelse(!is.null(extra.design.covariates), paste0(".", paste(extra.design.covariates, collapse = ".")), ""), sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid phyloCompData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)  
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with length normalized counts + limma
#' 
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) by applying a length normalizing transformation followed by differential expression analysis with limma. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#' 
#' For more information about the methods and the interpretation of the parameters, see the \code{limma} package and the corresponding publications.
#' 
#' @inheritParams DESeq2.length.createRmd
#' @inheritParams voom.limma.createRmd 
#' @param extra.design.covariates A vector containing the names of extra control variables to be passed to the design matrix of \code{limma}. All the covariates need to be a column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object, with a matching column name. The covariates can be a numeric vector, or a factor. Note that "condition" factor column is always included, and should not be added here. See Details.
#' @param length.normalization one of "none" (no length correction), "TPM", or "RPKM" (default). See details.
#' @param data.transformation one of "log2", "asin(sqrt)" or "sqrt". Data transformation to apply to the normalized data.
#' @param trend should an intensity-trend be allowed for the prior variance? Default to \code{FALSE}.
#' @param block.factor Name of the factor specifying a blocking variable, to be passed to \code{\link[limma]{duplicateCorrelation}} function of the \code{limma} package. All the factors need to be a \code{sample.annotations} from the \code{\link{phyloCompData}} object. Default to null (no block structure).
#' 
#' @details 
#' The \code{length.matrix} field of the \code{phyloCompData} object 
#' is used to normalize the counts, using one of the following formulas:
#' * \code{length.normalization="none"} : \eqn{CPM_{gi} = \frac{N_{gi} + 0.5}{NF_i \times \sum_{g} N_{gi} + 1} \times 10^6}
#' * \code{length.normalization="TPM"} : \eqn{TPM_{gi} = \frac{(N_{gi} + 0.5) / L_{gi}}{NF_i \times \sum_{g} N_{gi}/L_{gi} + 1} \times 10^6}
#' * \code{length.normalization="RPKM"} : \eqn{RPKM_{gi} = \frac{(N_{gi} + 0.5) / L_{gi}}{NF_i \times \sum_{g} N_{gi} + 1} \times 10^9}
#' 
#' where \eqn{N_{gi}} is the count for gene g and sample i,
#' where \eqn{L_{gi}} is the length of gene g in sample i,
#' and \eqn{NF_i} is the normalization for sample i,
#' normalized using \code{calcNormFactors} of the \code{edgeR} package.
#' 
#' The function specified by the \code{data.transformation} is then applied
#' to the normalized count matrix.
#' 
#' The "\eqn{+0.5}" and "\eqn{+1}" are taken from Law et al 2014,
#' and dropped from the normalization 
#' when the transformation is something else than \code{log2}.
#' 
#' The "\eqn{\times 10^6}" and "\eqn{\times 10^9}" factors are omitted when
#' the \code{asin(sqrt)} transformation is taken, as \eqn{asin} can only
#' be applied to real numbers smaller than 1.
#' 
#' The \code{design} model used in the \code{\link[limma]{lmFit}}
#' uses the "condition" column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object
#' as well as all the covariates named in \code{extra.design.covariates}.
#' For example, if \code{extra.design.covariates = c("var1", "var2")}, then
#' \code{sample.annotations} must have two columns named "var1" and "var2", and the design formula
#' in the \code{\link[limma]{lmFit}} function will be:
#' \code{~ condition + var1 + var2}.
#' 
#' @md
#' 
#' @export 
#' @author Charlotte Soneson, Paul Bastide, Mélina Gallopin
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references 
#' Smyth GK (2005): Limma: linear models for microarray data. In: 'Bioinformatics and Computational Biology Solutions using R and Bioconductor'. R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W. Huber (eds), Springer, New York, pages 397-420
#' 
#' Smyth, G. K., Michaud, J., and Scott, H. (2005). The use of within-array replicate spots for assessing differential expression in microarray experiments. Bioinformatics 21(9), 2067-2075.
#' 
#' Law, C.W., Chen, Y., Shi, W. et al. (2014) voom: precision weights unlock linear model analysis tools for RNA-seq read counts. Genome Biol 15, R29.
#'
#' Musser, JM, Wagner, GP. (2015): Character trees from transcriptome data: Origin and individuation of morphological characters and the so‐called “species signal”. J. Exp. Zool. (Mol. Dev. Evol.) 324B: 588– 604. 
#' 
#' @examples
#' try(
#' if (require(limma)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' ## Simulate data
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                     samples.per.cond = 5, n.diffexp = 100, 
#'                                     id.species = factor(1:10),
#'                                     lengths.relmeans = rpois(1000, 1000),
#'                                     lengths.dispersions = rgamma(1000, 1, 1),
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' ## Add covariates
#' ## Model fitted is count.matrix ~ condition + test_factor + test_reg
#' sample.annotations(mydata.obj)$test_factor <- factor(rep(1:2, each = 5))
#' sample.annotations(mydata.obj)$test_reg <- rnorm(10, 0, 1)
#' saveRDS(mydata.obj, file.path(tmpdir, "mydata.rds"))
#' ## Diff Exp
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "length.limma", 
#'            Rmdfunction = "lengthNorm.limma.createRmd", 
#'            output.directory = tmpdir, norm.method = "TMM",
#'            extra.design.covariates = c("test_factor", "test_reg"))
#' })
#' 
lengthNorm.limma.createRmd <- function(data.path, result.path, codefile, norm.method, 
                                       extra.design.covariates = NULL,
                                       length.normalization = "RPKM",
                                       data.transformation = "log2",
                                       trend = FALSE,
                                       block.factor = NULL) {
  if (!is.null(block.factor)) {
    if (!requireNamespace("statmod", quietly = TRUE)) stop("Package `statmod` is required for correlation modeling with `block.factor`.")
  }
  codefile <- file(codefile, open = 'w')
  writeLines("###  limma + length", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(limma)", 
               "require(edgeR)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTophyloCompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_phyloCompData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid phyloCompData object.')"),
             codefile)
  
  writeLines(c("", "# Design"),codefile)
  if (is.null(extra.design.covariates)) {
    writeLines(c(
      "design_formula <- as.formula(~ condition)",
      "design_data <- sample.annotations(cdata)[, 'condition', drop = FALSE]"),
      codefile)
  } else {
    writeLines(c(
      paste0("design_formula <- as.formula(paste(' ~ ', paste(c('", paste(extra.design.covariates, collapse = "', '"), "'), collapse= '+'), '+ condition'))"),
      paste0("design_data <- sample.annotations(cdata)[, c('", paste(extra.design.covariates, collapse = "', '"), "', 'condition'), drop = FALSE]")),
      codefile)
  }
  writeLines(c(
    "design_data$condition <- factor(design_data$condition)",
    "design <- model.matrix(design_formula, design_data)"),
    codefile)
  
  writeNormalization(norm.method, length.normalization, data.transformation, codefile)
  
  if (!is.null(block.factor)) {
    if (length(block.factor) > 1) stop("Only one factor can be taken for block definition.")
    writeLines(c("# Fitting Block correlations",
                 paste0("block <- sample.annotations(cdata)[['", paste(block.factor), "']]"),
                 "corfit <- duplicateCorrelation(data.trans, design = design, block = block, ndups = 1)"),
               codefile)
    writeLines(c("", "# Fit"), codefile)
    writeLines(c("length.fitlimma <- limma::lmFit(data.trans, design = design, correlation = corfit$consensus, block = block)"),
               codefile)
  } else {
    writeLines(c("", "# Fit"), codefile)
    writeLines(c("length.fitlimma <- limma::lmFit(data.trans, design = design)"),
               codefile)
  }
  if (!trend) {
    writeLines("length.fitbayes <- limma::eBayes(length.fitlimma)", codefile)
  } else {
    writeLines("length.fitbayes <- limma::eBayes(length.fitlimma, trend = TRUE)", codefile)
  }
  writeLines(c("length.pvalues <- length.fitbayes$p.value[, ncol(length.fitbayes$p.value)]", 
               "length.adjpvalues <- p.adjust(length.pvalues, method = 'BH')", 
               "length.logFC <- length.fitbayes$coefficients[, ncol(length.fitbayes$coefficients)]", 
               "length.score <- 1 - length.pvalues", 
               "result.table <- data.frame('pvalue' = length.pvalues, 'adjpvalue' = length.adjpvalues, 'logFC' = length.logFC, 'score' = length.score)",
               "rownames(result.table) <- rownames(count.matrix(cdata))", 
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('limma,', packageVersion('limma'), ';', 'edgeR,', packageVersion('edgeR'))", 
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'lengthNorm.limma', 'full.name' = '", 
                     paste('length.', utils::packageVersion('limma'), '.limma.', norm.method,
                           ".lengthNorm.", length.normalization, '.',
                           "dataTrans.", data.transformation,
                           ifelse(trend, '.with_trend', ".no_trend"),
                           ifelse(!is.null(extra.design.covariates), paste0(".", paste(extra.design.covariates, collapse = ".")), ""),
                           ifelse(!is.null(block.factor), paste0(".", paste(block.factor, collapse = ".")), ""),
                           sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid phyloCompData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Generate a \code{.Rmd} file containing code to perform differential expression analysis with length normalized counts + SVA + limma
#' 
#' A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) by applying a length normalizing transformation, followed by a surrogate variable analysis (SVA), and then a differential expression analysis with limma. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
#' 
#' For more information about the methods and the interpretation of the parameters, see the \code{sva} and \code{limma} packages and the corresponding publications.
#' 
#' @inheritParams lengthNorm.limma.createRmd
#' @param n.sv The number of surrogate variables to estimate (see \code{\link[sva]{sva}}). Default to \code{"auto"}: will be estimated with \code{\link[sva]{num.sv}}.
#' 
#' @details 
#' 
#' See the \code{details} section of \code{\link{lengthNorm.limma.createRmd}} for details
#' on the normalization and the extra design covariates.
#' 
#' @md
#' 
#' @export 
#' @author Charlotte Soneson, Paul Bastide, Mélina Gallopin
#' @return The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
#' @references 
#' Smyth GK (2005): Limma: linear models for microarray data. In: 'Bioinformatics and Computational Biology Solutions using R and Bioconductor'. R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W. Huber (eds), Springer, New York, pages 397-420
#' 
#' Smyth, G. K., Michaud, J., and Scott, H. (2005). The use of within-array replicate spots for assessing differential expression in microarray experiments. Bioinformatics 21(9), 2067-2075.
#' 
#' Law, C.W., Chen, Y., Shi, W. et al. (2014) voom: precision weights unlock linear model analysis tools for RNA-seq read counts. Genome Biol 15, R29.
#'
#' Musser, JM, Wagner, GP. (2015): Character trees from transcriptome data: Origin and individuation of morphological characters and the so‐called “species signal”. J. Exp. Zool. (Mol. Dev. Evol.) 324B: 588– 604. 
#' 
#' Leek JT, Johnson WE, Parker HS, Jaffe AE, and Storey JD. (2012) The sva package for removing batch effects and other unwanted variation in high-throughput experiments. Bioinformatics DOI:10.1093/bioinformatics/bts034
#' 
#' @examples
#' try(
#' if (require(limma) && require(sva)) {
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' ## Simulate data
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                     samples.per.cond = 5, n.diffexp = 100, 
#'                                     id.species = factor(1:10),
#'                                     lengths.relmeans = rpois(1000, 1000),
#'                                     lengths.dispersions = rgamma(1000, 1, 1),
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' ## Add covariates
#' ## Model fitted is count.matrix ~ condition + test_factor + test_reg
#' sample.annotations(mydata.obj)$test_factor <- factor(rep(1:2, each = 5))
#' sample.annotations(mydata.obj)$test_reg <- rnorm(10, 0, 1)
#' saveRDS(mydata.obj, file.path(tmpdir, "mydata.rds"))
#' ## Diff Exp
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "lengthNorm.sva.limma", 
#'            Rmdfunction = "lengthNorm.sva.limma.createRmd", 
#'            output.directory = tmpdir, norm.method = "TMM",
#'            extra.design.covariates = c("test_factor", "test_reg"))
#' })
#' 
lengthNorm.sva.limma.createRmd <- function(data.path, result.path, codefile, norm.method, 
                                           extra.design.covariates = NULL,
                                           length.normalization = "RPKM",
                                           data.transformation = "log2",
                                           trend = FALSE,
                                           n.sv = "auto") {
  if (!requireNamespace("sva", quietly = TRUE)) stop("Package `sva` is required for the SVA analysis.")
  codefile <- file(codefile, open = 'w')
  writeLines("###  limma + length + SVA", codefile)
  writeLines(paste("Data file: ", data.path, sep = ''), codefile)
  writeLines(c("```{r, echo = TRUE, eval = TRUE, include = TRUE, message = FALSE, error = TRUE, warning = TRUE}",
               "require(limma)", 
               "require(edgeR)",
               "require(sva)",
               paste("cdata <- readRDS('", data.path, "')", sep = '')), codefile)
  if (is.list(readRDS(data.path))) {
    writeLines("cdata <- convertListTophyloCompData(cdata)", codefile)
  }
  writeLines(c("is.valid <- check_phyloCompData(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid phyloCompData object.')"),
             codefile)
  
  writeLines(c("", "# Design"),codefile)
  if (is.null(extra.design.covariates)) {
    writeLines(c(
      "design_formula <- as.formula(~ condition)",
      "design_formula_0 <- as.formula(~ 1)",
      "design_data <- sample.annotations(cdata)[, 'condition', drop = FALSE]"),
      codefile)
  } else {
    writeLines(c(
      paste0("design_formula <- as.formula(paste(' ~ ', paste(c('", paste(extra.design.covariates, collapse = "', '"), "'), collapse= '+'), '+ condition'))"),
      paste0("design_formula_0 <- as.formula(paste(' ~ ', paste(c('", paste(extra.design.covariates, collapse = "', '"), "'), collapse= '+')))"),
      paste0("design_data <- sample.annotations(cdata)[, c('", paste(extra.design.covariates, collapse = "', '"), "', 'condition'), drop = FALSE]")),
      codefile)
  }
  writeLines(c(
    "design_data$condition <- factor(design_data$condition)",
    "design <- model.matrix(design_formula, design_data)",
    "design_0 <- model.matrix(design_formula_0, design_data)"),
    codefile)
  
  writeNormalization(norm.method, length.normalization, data.transformation, codefile)
  
  writeLines(c("", "# SVA"), codefile)
  if (n.sv == "auto") {
    writeLines("n.sv <- sva::num.sv(data.trans, design, method = 'leek')", codefile)
  } else {
    is.wholenumber <- function(x, tol = .Machine$double.eps^0.5)  abs(x - round(x)) < tol
    if (!is.wholenumber(n.sv)) stop("'n.sv' must be either 'auto' or a whole number.")
    writeLines(paste0("n.sv <- ", paste0(n.sv)), codefile)
  }
  n.sv <- ifelse(is.null(n.sv), "NULL", paste0(n.sv))
  writeLines(c("svobj <- sva::sva(data.trans, design, design_0, n.sv =  n.sv, method = 'irw')",
               "design <- cbind(design, svobj$sv)"),
             codefile)
  writeLines(c("length.fitlimma <- limma::lmFit(data.trans, design = design)"),
             codefile)
  if (!trend) {
    writeLines("length.fitbayes <- limma::eBayes(length.fitlimma)", codefile)
  } else {
    writeLines("length.fitbayes <- limma::eBayes(length.fitlimma, trend = TRUE)", codefile)
  }
  writeLines(c("length.pvalues <- length.fitbayes$p.value[, 'condition2']", 
               "length.adjpvalues <- p.adjust(length.pvalues, method = 'BH')", 
               "length.logFC <- length.fitbayes$coefficients[, 'condition2']", 
               "length.score <- 1 - length.pvalues", 
               "length.n.sv <- svobj$n.sv", 
               "result.table <- data.frame('pvalue' = length.pvalues, 'adjpvalue' = length.adjpvalues, 'logFC' = length.logFC, 'score' = length.score, 'n.sv' = length.n.sv)",
               "rownames(result.table) <- rownames(count.matrix(cdata))", 
               "result.table(cdata) <- result.table",
               "package.version(cdata) <- paste('limma,', packageVersion('limma'), ';', 'edgeR,', packageVersion('edgeR'))", 
               "analysis.date(cdata) <- date()",
               paste("method.names(cdata) <- list('short.name' = 'lengthNorm.sva.limma', 'full.name' = '", 
                     paste('length.',
                           utils::packageVersion('sva'), '.sva.',
                           utils::packageVersion('limma'), '.limma.', norm.method,
                           ".lengthNorm.", length.normalization, '.',
                           "dataTrans.", data.transformation,
                           ifelse(trend, '.with_trend', ".no_trend"),
                           ifelse(!is.null(extra.design.covariates), paste0(".", paste(extra.design.covariates, collapse = ".")), ""),
                           ".n.sv.", n.sv,
                           sep = ''), "')", sep = ''),
               "is.valid <- check_compData_results(cdata)",
               "if (!(is.valid == TRUE)) stop('Not a valid phyloCompData result object.')",
               paste("saveRDS(cdata, '", result.path, "')", sep = "")), codefile)
  writeLines("print(paste('Unique data set ID:', info.parameters(cdata)$uID))", codefile)
  writeLines("sessionInfo()", codefile)
  writeLines("```", codefile)
  close(codefile)
}

#' Check the validity of a \code{compData} object
#' 
#' Check the validity of a \code{compData} object. An object that passes the check can be used as the input for the differential expression analysis methods interfaced by \code{compcodeR}.
#' 
#' @export 
#' @author Charlotte Soneson
#' @param object A \code{compData} object
#' @examples
#' mydata <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                 samples.per.cond = 5, n.diffexp = 100)
#' check_compData(mydata)
check_compData <- function(object) {
  if (!isS4(object)) {
    return("This is not an S4 object.")
  } else {
    if (length(count.matrix(object)) == 0) {
      return("Object must contain a non-empty count matrix.")
    }
    
    if (length(sample.annotations(object)) == 0) {
      return("Object must contain a non-empty sample annotation data frame.")
    }
    
    if (length(sample.annotations(object)$condition) == 0) {
      return("The sample.annotations must contain a column named condition.")
    }
    
    if (length(info.parameters(object)) == 0) {
      return("Object must contain a non-empty list called info.parameters.")
    }
    
    if (length(info.parameters(object)$dataset) == 0) {
      return("info.parameters list must contain an entry named 'dataset'.")
    }
    
    if (length(info.parameters(object)$uID) == 0) {
      return("info.parameters list must contain an entry named 'uID'.")
    }
    
    if (length(count.matrix(object)) != 0 && 
          length(variable.annotations(object)) != 0) {
      if (nrow(count.matrix(object)) != 
            nrow(variable.annotations(object))) {
        return("count.matrix and variable.annotations do not contain the same number of rows.")
      } else {
        if (length(rownames(count.matrix(object))) != 0 && 
            length(rownames(variable.annotations(object))) != 0 && 
            any(rownames(count.matrix(object)) != 
                rownames(variable.annotations(object)))) {
          return("The rownames of count.matrix and variable.annotations are not the same.")
        }
      } 
    } 
    
    if (length(count.matrix(object)) != 0 && 
          length(sample.annotations(object)) != 0) {
      if (ncol(count.matrix(object)) != nrow(sample.annotations(object))) {
        return("The number of columns of count.matrix is different from the number of rows of sample.annotations.")
      } else {
        if (length(colnames(count.matrix(object))) != 0 && 
            length(rownames(sample.annotations(object))) != 0 && 
            any(colnames(count.matrix(object)) != 
                rownames(sample.annotations(object)))) {
          return("The colnames of count.matrix are different from the rownames of sample.annotations.")
        }
      } 
    }
    
    if (length(result.table(object)) != 0 && length(count.matrix(object)) != 0) {
      if (nrow(result.table(object)) != nrow(count.matrix(object))) {
        return("result.table must have the same number of rows as count.matrix.")
      }
    
      if (!is.null(rownames(result.table(object))) && !is.null(rownames(count.matrix(object)))
          && !all(rownames(result.table(object)) == rownames(count.matrix(object)))) {
        return("If present, rownames of result.table must agree with those of count.matrix.")
      }
    }
  }
  return(TRUE)
}

#' Check the validity of a \code{compData} result object
#' 
#' Check the validity of a \code{compData} object containing differential expression results. An object that passes the check can be used as the input for the method comparison functions in \code{compcodeR}.
#' 
#' @export 
#' @author Charlotte Soneson
#' @param object A \code{compData} object
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                 samples.per.cond = 5, n.diffexp = 100,
#'                                 output.file = file.path(tmpdir, "mydata.rds"))
#' ## Check an object without differential expression results
#' check_compData_results(mydata)
#' 
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), 
#'            result.extent = "voom.limma", 
#'            Rmdfunction = "voom.limma.createRmd", 
#'            output.directory = tmpdir, norm.method = "TMM")
#' resdata <- readRDS(file.path(tmpdir, "mydata_voom.limma.rds"))
#' ## Check an object containing differential expression results
#' check_compData_results(resdata)
check_compData_results = function(object) {
  tmp <- check_phyloCompData(object)
  if (is.character(tmp)) {
    return(tmp)
  } else {
    if(check_phyloCompData(object)) {
      if (length(method.names(object)) == 0) {
        return("Object must contain a list named 'method.names' identifying the differential expression method used.")
      }
      
      if (length(result.table(object)) == 0) {
        return("Object must contain a data frame named 'result.table'.")
      }
      
      if (length(result.table(object)$score) == 0) {
        return("result.table must contain a column named 'score'.")
      }
    }
  }
  return(TRUE)
}

#' Class compData
#'
#' The \code{compData} class is used to store information about the experiment, such as the count matrix, sample and variable annotations, information regarding the generation of the data and results from applying a differential expression analysis to the data.
#' 
#' @section Slots:
#' \describe{
#' \item{\code{count.matrix}:}{The read count matrix, with genes as rows and samples as columns.  Class \code{matrix}}
#' \item{\code{sample.annotations}:}{A data frame containing sample annotation information for all samples in the data set. Must contain at least a column named \code{condition}, encoding the division of the samples into two classes. The row names should be the same as the column names of \code{count.matrix}. Class \code{data.frame}}
#' \item{\code{info.parameters}:}{A list of parameters detailing the simulation process used to generate the data. Must contain at least two entries, named \code{dataset} (an informative name for the data set/simulation setting) and \code{uID} (a unique ID for the specific data set instance). Class \code{list}}
#' \item{\code{filtering}:}{A character string detailing the filtering process that has been applied to the data. Class \code{character}}
#' \item{\code{variable.annotations}:}{Contains information regarding the variables, such as the differential expression status, the true mean, dispersion and effect sizes. If present, the row names should be the same as those of \code{count.matrix}. Class \code{data.frame}}
#' \item{\code{analysis.date}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). Gives the date when the differential expression analysis was performed. Class \code{character}}
#' \item{\code{package.version}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). Gives the version numbers of the package(s) used for the differential expression analysis. Class \code{character}}
#' \item{\code{method.names}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). A list, containing the name of the method used for the differential expression analysis. The list should have two entries: \code{full.name} and \code{short.name}, where the \code{full.name} is the full (potentially long) name identifying the method, and \code{short.name} may be an abbreviation. Class \code{list}}
#' \item{\code{code}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). A character string containing the code that was used to run the differential expression analysis. The code should be in R markdown format. Class \code{character}}
#' \item{\code{result.table}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). Contains the results of the differential expression analysis, in the form of a data frame with one row per gene. Must contain at least one column named \code{score}, where a higher value corresponds to 'more strongly differentially expressed genes'. Class \code{data.frame}}
#' }
#' 
#' @section Methods:
#' \describe{
#' \item{count.matrix}{\code{signature(x="compData")}}
#' \item{count.matrix<-}{\code{signature(x="compData",value="matrix")}:
#' Get or set the count matrix in a \code{compData} object. \code{value} should be a numeric matrix.}
#' \item{sample.annotations}{\code{signature(x="compData")}}
#' \item{sample.annotations<-}{\code{signature(x="compData",value="data.frame")}:
#' Get or set the sample annotations data frame in a \code{compData} object. \code{value} should be a data frame with at least a column named 'condition'.}
#' \item{info.parameters}{\code{signature(x="compData")}}
#' \item{info.parameters<-}{\code{signature(x="compData",value="list")}:
#' Get or set the list with info parameters in a \code{compData} object. \code{value} should be a list with at least elements named 'dataset' and 'uID'.}
#' \item{filtering}{\code{signature(x="compData")}}
#' \item{filtering<-}{\code{signature(x="compData",value="character")}:
#' Get or set the information about the filtering in a \code{compData} object. \code{value} should be a character string describing the filtering that has been performed.}
#' \item{variable.annotations}{\code{signature(x="compData")}}
#' \item{variable.annotations<-}{\code{signature(x="compData",value="data.frame")}:
#' Get or set the variable annotations data frame in a \code{compData} object. \code{value} should be a data frame.}
#' \item{analysis.date}{\code{signature(x="compData")}}
#' \item{analysis.date<-}{\code{signature(x="compData",value="character")}:
#' Get or set the analysis date in a \code{compData} object. \code{value} should be a character string describing when the differential expression analysis of the data was performed.}
#' \item{package.version}{\code{signature(x="compData")}}
#' \item{package.version<-}{\code{signature(x="compData",value="character")}:
#' Get or set the information about the package version in a \code{compData} object. \code{value} should be a character string detailing which packages and versions were used to perform the differential expression analysis of the data.}
#' \item{method.names}{\code{signature(x="compData")}}
#' \item{method.names<-}{\code{signature(x="compData",value="list")}:
#' Get or set the method names in a \code{compData} object. \code{value} should be a list with slots \code{full.name} and \code{short.name}, giving the full name and an abbreviation for the method that was used to perform the analysis of the data.}
#' \item{code}{\code{signature(x="compData")}}
#' \item{code<-}{\code{signature(x="compData",value="character")}:
#' Get or set the code slot in a \code{compData} object. \code{value} should be a character string in R markdown format, giving the code that was run to obtain the results from the differential expression analysis.}
#' \item{result.table}{\code{signature(x="compData")}}
#' \item{result.table<-}{\code{signature(x="compData",value="data.frame")}:
#' Get or set the result table in a \code{compData} object. \code{value} should be a data frame with one row per gene, and at least a column named 'score'.}
#' }
#' @section Construction:
#' An object of the class \code{compData} can be constructed using the \code{\link{compData}} function. 
#' @name compData-class
#' @rdname compData-class
#' @exportClass compData
#' @author Charlotte Soneson
setClass(
  Class = "compData", 
  
  representation = representation(count.matrix = "matrix",
                                  sample.annotations = "data.frame",
                                  info.parameters = "list",
                                  filtering = "character",
                                  variable.annotations = "data.frame",
                                  analysis.date = "character",
                                  package.version = "character",
                                  method.names = "list",
                                  code = "character",
                                  result.table = "data.frame"),
  
  validity = check_compData)

setGeneric("count.matrix", function(x) standardGeneric("count.matrix"))
setMethod("count.matrix", "compData", function(x) x@count.matrix)

setGeneric("sample.annotations", function(x, ...) standardGeneric("sample.annotations"))
setMethod("sample.annotations", "compData", function(x) x@sample.annotations)

setGeneric("info.parameters", function(x, ...) standardGeneric("info.parameters"))
setMethod("info.parameters", "compData", function(x) x@info.parameters)

setGeneric("filtering", function(x, ...) standardGeneric("filtering"))
setMethod("filtering", "compData", function(x) x@filtering)

setGeneric("variable.annotations", function(x, ...) standardGeneric("variable.annotations"))
setMethod("variable.annotations", "compData", function(x) x@variable.annotations)

setGeneric("analysis.date", function(x, ...) standardGeneric("analysis.date"))
setMethod("analysis.date", "compData", function(x) x@analysis.date)

setGeneric("package.version", function(x, ...) standardGeneric("package.version"))
setMethod("package.version", "compData", function(x) x@package.version)

setGeneric("method.names", function(x, ...) standardGeneric("method.names"))
setMethod("method.names", "compData", function(x) x@method.names)

setGeneric("code", function(x, ...) standardGeneric("code"))
setMethod("code", "compData", function(x) x@code)

setGeneric("result.table", function(x, ...) standardGeneric("result.table"))
setMethod("result.table", "compData", function(x) x@result.table)

setGeneric("count.matrix<-", function(x, value) standardGeneric("count.matrix<-"))
setReplaceMethod("count.matrix", "compData",
                 function(x, value) {x@count.matrix <- value; check_compData(x); x})

setGeneric("sample.annotations<-", function(x, value) standardGeneric("sample.annotations<-"))
setReplaceMethod("sample.annotations", "compData",
                 function(x, value) {x@sample.annotations <- value; check_compData(x); x})

setGeneric("info.parameters<-", function(x, value) standardGeneric("info.parameters<-"))
setReplaceMethod("info.parameters", "compData",
                 function(x, value) {x@info.parameters <- value; check_compData(x); x})

setGeneric("filtering<-", function(x, value) standardGeneric("filtering<-"))
setReplaceMethod("filtering", "compData",
                 function(x, value) {x@filtering <- value; check_compData(x); x})

setGeneric("variable.annotations<-", 
           function(x, value) standardGeneric("variable.annotations<-"))
setReplaceMethod("variable.annotations", "compData",
                 function(x, value) {x@variable.annotations <- value; check_compData(x); x})

setGeneric("analysis.date<-", function(x, value) standardGeneric("analysis.date<-"))
setReplaceMethod("analysis.date", "compData",
                 function(x, value) {x@analysis.date <- value; check_compData_results(x); x})

setGeneric("package.version<-", function(x, value) standardGeneric("package.version<-"))
setReplaceMethod("package.version", "compData",
                 function(x, value) {x@package.version <- value; check_compData_results(x); x})

setGeneric("method.names<-", function(x, value) standardGeneric("method.names<-"))
setReplaceMethod("method.names", "compData",
                 function(x, value) {x@method.names <- value; check_compData_results(x); x})

setGeneric("code<-", function(x, value) standardGeneric("code<-"))
setReplaceMethod("code", "compData",
                 function(x, value) {x@code <- value; check_compData_results(x); x})

setGeneric("result.table<-", function(x, value) standardGeneric("result.table<-"))
setReplaceMethod("result.table", "compData",
                 function(x, value) {x@result.table <- value; check_compData_results(x); x})

#' Create a \code{compData} object
#' 
#' The \code{compData} class is used to store information about the experiment, such as the count matrix, sample and variable annotations, information regarding the generation of the data and results from applying a differential expression analysis to the data. This constructor function creates a \code{compData} object.
#' 
#' @param count.matrix A count matrix, with genes as rows and observations as columns.
#' @param sample.annotations A data frame, containing at least one column named 'condition', encoding the grouping of the observations into two groups. The row names should be the same as the column names of the \code{count.matrix}.
#' @param info.parameters A list containing information regarding simulation parameters etc. The only mandatory entries are \code{dataset} and \code{uID}, but it may contain entries such as the ones listed below (see \code{generateSyntheticData} for more detailed information about each of these entries).
#' \itemize{
#' \item \code{dataset}: an informative name or identifier of the data set (e.g., summarizing the simulation settings).
#' \item \code{samples.per.cond}
#' \item \code{n.diffexp} 
#' \item \code{repl.id}
#' \item \code{seqdepth}
#' \item \code{minfact}
#' \item \code{maxfact}
#' \item \code{fraction.upregulated}
#' \item \code{between.group.diffdisp}
#' \item \code{filter.threshold.total}
#' \item \code{filter.threshold.mediancpm}
#' \item \code{fraction.non.overdispersed}
#' \item \code{random.outlier.high.prob}
#' \item \code{random.outlier.low.prob}
#' \item \code{single.outlier.high.prob}
#' \item \code{single.outlier.low.prob}
#' \item \code{effect.size}
#' \item \code{uID}: a unique ID for the data set. In contrast to \code{dataset}, the \code{uID} is unique e.g. for each instance of replicated data sets generated with the same simulation settings. 
#' }
#' @param variable.annotations A data frame with variable annotations (with number of rows equal to the number of rows in \code{count.matrix}, that is, the number of variables in the data set). Not mandatory, but may contain columns such as the ones listed below. If present, the row names should be the same as the row names of the \code{count.matrix}.
#' \itemize{
#' \item \code{truedispersions.S1}: the true dispersion for each gene in condition S1.
#' \item \code{truedispersions.S2}: the true dispersion for each gene in condition S2.
#' \item \code{truemeans.S1}: the true mean value for each gene in condition S1.
#' \item \code{truemeans.S2}: the true mean value for each gene in condition S2.
#' \item \code{n.random.outliers.up.S1}: the number of 'random' outliers with extremely high counts for each gene in condition S1.
#' \item \code{n.random.outliers.up.S2}: the number of 'random' outliers with extremely high counts for each gene in condition S2.
#' \item \code{n.random.outliers.down.S1}: the number of 'random' outliers with extremely low counts for each gene in condition S1.
#' \item \code{n.random.outliers.down.S2}: the number of 'random' outliers with extremely low counts for each gene in condition S2.
#' \item \code{n.single.outliers.up.S1}: the number of 'single' outliers with extremely high counts for each gene in condition S1.
#' \item \code{n.single.outliers.up.S2}: the number of 'single' outliers with extremely high counts for each gene in condition S2.
#' \item \code{n.single.outliers.down.S1}: the number of 'single' outliers with extremely low counts for each gene in condition S1.
#' \item \code{n.single.outliers.down.S2}: the number of 'single' outliers with extremely low counts for each gene in condition S2.
#' \item \code{M.value}: the M-value (observed log2 fold change between condition S1 and condition S2) for each gene.
#' \item \code{A.value}: the A-value (observed average expression level across condition S1 and condition S2) for each gene.
#' \item \code{truelog2foldchanges}: the true (simulated) log2 fold changes between condition S1 and condition S2.
#' \item \code{upregulation}: a binary vector indicating which genes are simulated to be upregulated in condition S2 compared to condition S1.
#' \item \code{downregulation}: a binary vector indicating which genes are simulated to be downregulated in condition S2 compared to condition S1.
#' \item \code{differential.expression}: a binary vector indicating which genes are simulated to be differentially expressed in condition S2 compared to condition S1.
#' }
#' @param filtering A character string containing information about the filtering that has been applied to the data set.
#' @param analysis.date If a differential expression analysis has been performed, a character string detailing when it was performed.
#' @param package.version If a differential expression analysis has been performed, a character string giving the version of the differential expression packages that were applied. 
#' @param method.names If a differential expression analysis has been performed, a list with entries \code{full.name} and \code{short.name}, giving the full name of the differential expression method (may including version number and parameter settings) and a short name or abbreviation. 
#' @param code If a differential expression analysis has been performed, a character string containing the code that was run to perform the analysis. The code should be in R markdown format, and can be written to an HTML file using the \code{\link{generateCodeHTMLs}} function.
#' @param result.table If a differential expression analysis has been performed, a data frame containing the results of the analysis. The number of rows should be equal to the number of rows in \code{count.matrix} and if present, the row names should be identical. The only mandatory column is \code{score}, which gives a score for each gene, where a higher score suggests a "more highly differentially expressed" gene. Different comparison functions use different columns of this table, if available. The list below gives the columns that are used by the interfaced methods.
#' \itemize{
#' \item \code{pvalue} nominal p-values
#' \item \code{adjpvalue} p-values adjusted for multiple comparisons
#' \item \code{logFC} estimated log-fold changes between the two conditions
#' \item \code{score} the score that will be used to rank the genes in order of significance. Note that high scores always signify differential expression, that is, a strong association with the predictor. For example, for methods returning a nominal p-value the score can be defined as 1 - pvalue.
#' \item \code{FDR} false discovery rate estimates
#' \item \code{posterior.DE} posterior probabilities of differential expression
#' \item \code{prob.DE} conditional probabilities of differential expression
#' \item \code{lfdr} local false discovery rates
#' \item \code{statistic}  test statistics from the differential expression analysis
#' \item \code{dispersion.S1} dispersion estimates in condition S1
#' \item \code{dispersion.S2} dispersion estimates in condition S2
#' }
#' 
#' @export
#' @author Charlotte Soneson
#' @return A \code{compData} object.
#' @examples
#' count.matrix <- round(matrix(1000*runif(4000), 1000))
#' sample.annotations <- data.frame(condition = c(1, 1, 2, 2))
#' info.parameters <- list(dataset = "mydata", uID = "123456")
#' cpd <- compData(count.matrix, sample.annotations, info.parameters)
compData <- function(count.matrix, sample.annotations, 
                     info.parameters, variable.annotations = data.frame(), 
                     filtering = "no info", analysis.date = "", 
                     package.version = "", method.names = list(), 
                     code = "", result.table = data.frame()) {
  
  count.matrix <- as.matrix(count.matrix)
  mode(count.matrix) <- "numeric"
  
  sample.annotations <- data.frame(sample.annotations, 
                                   stringsAsFactors = FALSE)
  
  cmpd <- new("compData", count.matrix = count.matrix, 
              sample.annotations = sample.annotations, 
              info.parameters = info.parameters, 
              variable.annotations = variable.annotations, 
              filtering = filtering, 
              analysis.date = analysis.date, 
              package.version = package.version, 
              method.names = method.names,
              code = code, 
              result.table = result.table)
  
  validObject(cmpd)
  
  cmpd
}

#' Convert a list with data and results to a \code{compData} object
#' 
#' Given a list with data and results (resulting e.g. from \code{compcodeR} version 0.1.0), convert it to a \code{compData} object.
#' 
#' @export
#' @param inp.list A list with data and results, e.g. generated by \code{compcodeR} version 0.1.0.
#' @author Charlotte Soneson
#' @examples
#' convertListTocompData(list(count.matrix = matrix(round(1000*runif(4000)), 1000),
#'                            sample.annotations = data.frame(condition = c(1,1,2,2)),
#'                            info.parameters = list(dataset = "mydata", 
#'                            uID = "123456")))
convertListTocompData <- function(inp.list) {
  if (is.null(inp.list$count.matrix) || is.null(inp.list$sample.annotations) || 
        is.null(inp.list$info.parameters) || !is.matrix(inp.list$count.matrix) || 
        !is.data.frame(inp.list$sample.annotations) || !is.list(inp.list$info.parameters)) {
    message("Cannot convert list to compData object (not all required slots are available).")
    return(NULL)
  } else {
    compData(count.matrix = inp.list$count.matrix, 
             sample.annotations = inp.list$sample.annotations, 
             info.parameters = inp.list$info.parameters, 
             variable.annotations = as.data.frame(inp.list$variable.annotations,
                                                  stringsAsFactors = FALSE), 
             filtering = as.character(inp.list$filtering), 
             analysis.date = as.character(inp.list$analysis.date), 
             package.version = as.character(inp.list$package.version), 
             method.names = as.list(inp.list$method.names), 
             code = as.character(inp.list$code), 
             result.table = as.data.frame(inp.list$result.table,
                                          stringsAsFactors = FALSE))
  }
}

#' Convert a \code{compData} object to a list
#' 
#' Given a \code{compData} object, convert it to a list.
#' 
#' @export
#' @param cpd A \code{compData} object
#' @author Charlotte Soneson
#' @examples
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 12500,
#'                                     samples.per.cond = 5, n.diffexp = 1250)
#' mydata.list <- convertcompDataToList(mydata.obj)
convertcompDataToList <- function(cpd) {
  list(count.matrix = count.matrix(cpd),
       sample.annotations = sample.annotations(cpd),
       info.parameters = info.parameters(cpd),
       variable.annotations = variable.annotations(cpd),
       filtering = filtering(cpd),
       analysis.data = analysis.date(cpd),
       package.version = package.version(cpd),
       method.names = method.names(cpd),
       code = code(cpd),
       result.table = result.table(cpd))
}

################################################################################
## PhyloCompData
################################################################################

#' Check the validity of a \code{phyloCompData} object
#' 
#' Check the validity of a \code{phyloCompData} object.
#' An object that passes the check can be used as the input for the differential expression analysis methods interfaced by \code{compcodeR}.
#' 
#' @export 
#' @author Charlotte Soneson, Paul Bastide
#' @param object A \code{phyloCompData} object
#' @examples
#' mydata <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                 samples.per.cond = 5, n.diffexp = 100,
#'                                 id.species = factor(1:10),
#'                                 tree = ape::rphylo(10, 1, 0),
#'                                 lengths.relmeans = "auto", lengths.dispersions = "auto")
#' check_phyloCompData(mydata)
#' 
check_phyloCompData <- function(object) {
  cc <- check_compData(object)
  if (!isTRUE(cc)) return(cc)
  
  ## Length matrix
  if (length(count.matrix(object)) != 0 && 
      length(length.matrix(object)) != 0) {
    if (ncol(count.matrix(object)) != ncol(length.matrix(object)) || nrow(count.matrix(object)) != nrow(length.matrix(object))) {
      return("The dimension of count.matrix is different from the dimension of length.matrix.")
    }
    if (length(colnames(count.matrix(object))) != 0 && 
        length(colnames(length.matrix(object))) != 0 && 
        any(colnames(count.matrix(object)) != 
            colnames(length.matrix(object)))) {
      return("The colnames of count.matrix are different from the colnames of length.matrix.")
    }
    if (length(rownames(count.matrix(object))) != 0 && 
        length(rownames(length.matrix(object))) != 0 && 
        any(rownames(count.matrix(object)) != 
            rownames(length.matrix(object)))) {
      return("The rownames of count.matrix are different from the rownames of length.matrix.")
    }
  }
  
  ## Tree
  if (!is.null(phylo.tree(object)) && length(phylo.tree(object)) != 0) {
    if (!inherits(phylo.tree(object), "phylo")) stop("object 'tree' is not of class 'phylo'.")
    if (is.null(phylo.tree(object)$tip.label)) return("The tips of the phylogeny are not named.")
    if (length(count.matrix(object)) != 0) {
      if (!all(phylo.tree(object)$tip.label == colnames(count.matrix(object)))) return("Column names of count.matrix do not match the tip labels.")
    }
    if (length(sample.annotations(object)$id.species) != 0) {
      ids <- sample.annotations(object)$id.species
      names(ids) <- rownames(sample.annotations(object))
      tmp <- try(checkSpecies(ids, "id.species", phylo.tree(object), tol = 1e-10, TRUE),
                 silent = TRUE)
      if (inherits(tmp, 'try-error')) return(geterrmessage())
    }
    
    ## Sample Annotation
    if (length(sample.annotations(object)$id.species) == 0) {
      return("The sample.annotations must contain a column named id.species.")
    }
  }
  
  return(TRUE)
}

#' Class phyloCompData
#'
#' The \code{phyloCompData} class extends the \code{\linkS4class{compData}} class
#' with sequence length and phylogeny related information.
#' 
#' @section Slots:
#' \describe{
#' \item{\code{tree}:}{The phylogenetic tree describing the relationships between samples. The taxa names of the \code{tree} should be the same as the column names of the \code{count.matrix}. Class \code{phylo}.}
#' \item{\code{length.matrix}:}{The length matrix, with genes as rows and samples as columns. The column names of the \code{length.matrix} should be the same as the column names of the \code{count.matrix}. Class \code{matrix}.}
#' \item{\code{sample.annotations}:}{In addition to the columns described in the \code{\linkS4class{compData}} class, if the tree is specified, it should contain an extra column named \code{id.species} of factors giving the species for each sample. The row names should be the same as the column names of count.matrix. Class \code{data.frame}.}
#' }
#' 
#' @section Methods:
#' \describe{
#' \item{phylo.tree}{\code{signature(x="phyloCompData")}}
#' \item{phylo.tree<-}{\code{signature(x="phyloCompData",value="phylo")}:
#' Get or set the tree in a \code{phyloCompData} object. \code{value} should be a phylo object.}
#' \item{length.matrix}{\code{signature(x="phyloCompData")}}
#' \item{length.matrix<-}{\code{signature(x="phyloCompData",value="matrix")}:
#' Get or set the length matrix in a \code{phyloCompData} object. \code{value} should be a numeric matrix.}
#' }
#' @section Construction:
#' An object of the class \code{phyloCompData} can be constructed using the \code{\link{phyloCompData}} function. 
#' @name phyloCompData-class
#' @rdname phyloCompData-class
#' @exportClass phyloCompData
#' @author Charlotte Soneson, Paul Bastide
setClass(
  Class = "phyloCompData", 
  contains = "compData",
  slots = c(tree = "ANY",
            length.matrix = "matrix"),
  validity = check_phyloCompData
)

setGeneric("phylo.tree", function(x) standardGeneric("phylo.tree"))
setMethod("phylo.tree", "compData", function(x) NULL)
setMethod("phylo.tree", "phyloCompData", function(x) x@tree)

setGeneric("phylo.tree<-", function(x, value) standardGeneric("phylo.tree<-"))
setReplaceMethod("phylo.tree", "compData",
                 function(x, value) {stop("There is no 'phylo.tree' slot in a 'compData' object. Please use a 'phyloCompData' object.")})
setReplaceMethod("phylo.tree", "phyloCompData",
                 function(x, value) {x@tree <- value; check_phyloCompData(x); x})

setGeneric("length.matrix", function(x) standardGeneric("length.matrix"))
setMethod("length.matrix", "compData", function(x) NULL)
setMethod("length.matrix", "phyloCompData", function(x) x@length.matrix)

setGeneric("length.matrix<-", function(x, value) standardGeneric("length.matrix<-"))
setReplaceMethod("length.matrix", "compData",
                 function(x, value) {stop("There is no 'lenght.matrix' slot in a 'compData' object. Please use a 'phyloCompData' object.")})
setReplaceMethod("length.matrix", "phyloCompData",
                 function(x, value) {x@length.matrix <- value; check_phyloCompData(x); x})


#' Create a \code{phyloCompData} object
#' 
#' The \code{\linkS4class{phyloCompData}} class extends the \code{\link{compData}} class
#' with sequence length and phylogeny related information.
#' 
#' @inheritParams compData
#' @param tree The phylogenetic tree describing the relationships between samples. The taxa names of the \code{tree} should be the same as the column names of the \code{count.matrix}.
#' @param length.matrix The length matrix, with genes as rows and samples as columns. The column names of the \code{length.matrix} should be the same as the column names of the \code{count.matrix}.
#' @param sample.annotations A data frame, containing at least one column named 'condition', encoding the grouping of the observations into two groups, and one column named \code{id.species} of factors giving the species for each sample if the tree is specified. The row names should be the same as the column names of count.matrix. \code{Class data.frame}.
#' 
#' @export
#' @author Charlotte Soneson, Paul Bastide
#' @return A \code{phyloCompData} object.
#' @examples
#' tree <- ape::read.tree(
#'   text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);"
#'   )
#' count.matrix <- round(matrix(1000*runif(8000), 1000))
#' sample.annotations <- data.frame(condition = c(1, 1, 1, 1, 2, 2, 2, 2),
#'                                  id.species = c("A", "A", "A", "B", "C", "C", "D", "D"))
#' info.parameters <- list(dataset = "mydata", uID = "123456")
#' length.matrix <- round(matrix(1000*runif(8000), 1000))
#' colnames(count.matrix) <- colnames(length.matrix) <- rownames(sample.annotations) <- tree$tip.label
#' cpd <- phyloCompData(count.matrix, sample.annotations, info.parameters,
#'                      tree = tree, length.matrix = length.matrix)
#'
phyloCompData <- function(count.matrix, sample.annotations, 
                          info.parameters, variable.annotations = data.frame(), 
                          filtering = "no info", analysis.date = "", 
                          package.version = "", method.names = list(), 
                          code = "", result.table = data.frame(),
                          tree = list(),
                          length.matrix = matrix(NA_integer_, 0, 0)) {
  
  if (is.null(tree)) tree <- list()
  if (length(tree) == 0) attr(tree, "class") <- "phylo"
  
  cmpd <- new("phyloCompData", 
              compData(count.matrix, sample.annotations, info.parameters,
                       variable.annotations, filtering, analysis.date, 
                       package.version, method.names, code, result.table),
              tree = tree,
              length.matrix = length.matrix)
  
  validObject(cmpd)
  
  cmpd
}

#' Create a \code{phyloCompData} object
#' 
#' The \code{phyloCompData} class extends the \code{\link{compData}} class
#' with sequence length and phylogeny related information.
#' 
#' @param compDataObject An object of class \code{\link{compData}}.
#' @param tree A phylogenetic tree describing the relationships between samples.
#' @param length.matrix A length matrix, with genes as rows and observations as columns.
#' 
#' @keywords internal
#' @author Charlotte Soneson, Paul Bastide
#' @return A \code{phyloCompData} object.
#' 
phyloCompDataFromCompData <- function(compDataObject,
                                      tree = list(),
                                      length.matrix = matrix(NA_integer_, 0, 0)) {
  
  if (is.null(tree)) tree <- list()
  if (length(tree) == 0) attr(tree, "class") <- "phylo"
  
  cmpd <- new("phyloCompData", 
              compDataObject,
              tree = tree,
              length.matrix = length.matrix)
  
  validObject(cmpd)
  
  cmpd
}

#' Convert a list with data and results to a \code{phyloCompData} object
#' 
#' Given a list with data and results (resulting e.g. from \code{compcodeR} version 0.1.0), convert it to a \code{phyloCompData} object.
#' 
#' @export
#' @param inp.list A list with data and results, e.g. generated by \code{compcodeR} version 0.1.0.
#' @author Charlotte Soneson, Paul Bastide
#' @examples
#' tree <- ape::read.tree(
#'   text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);"
#'   )
#' count.matrix <- round(matrix(1000*runif(8000), 1000))
#' sample.annotations <- data.frame(condition = c(1, 1, 1, 1, 2, 2, 2, 2),
#'                                  id.species = c("A", "A", "A", "B", "C", "C", "D", "D"))
#' info.parameters <- list(dataset = "mydata", uID = "123456")
#' length.matrix <- round(matrix(1000*runif(8000), 1000))
#' colnames(count.matrix) <- colnames(length.matrix) <- rownames(sample.annotations) <- tree$tip.label
#' convertListTophyloCompData(list(count.matrix = count.matrix,
#'                                 sample.annotations = sample.annotations,
#'                                 info.parameters = list(dataset = "mydata", 
#'                                                        uID = "123456"),
#'                                 tree = tree,
#'                                 length.matrix = length.matrix))
#'                                  
convertListTophyloCompData <- function(inp.list) {
  compData <- convertListTocompData(inp.list)
  if (is.null(compData)) return(NULL)
  if (is.null(inp.list$tree)) inp.list$tree <- list()
  if (length(inp.list$tree) == 0) attr(inp.list$tree, "class") <- "phylo"
  phyloCompDataFromCompData(compData,
                            tree = inp.list$tree,
                            length.matrix = if (is.null(inp.list$length.matrix)) matrix(NA, 0, 0) else inp.list$length.matrix)
}

#' Convert a \code{phyloCompData} object to a list
#' 
#' Given a \code{phyloCompData} object, convert it to a list.
#' 
#' @export
#' @param cpd A \code{phyloCompData} object
#' @author Charlotte Soneson, Paul Bastide
#' @examples
#' tree <- ape::read.tree(
#'   text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);"
#'   )
#' id.species <- factor(c("A", "A", "A", "B", "C", "C", "D", "D"))
#' names(id.species) <- tree$tip.label
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                     samples.per.cond = 4, n.diffexp = 100,
#'                                     tree = tree,
#'                                     id.species = id.species)
#' mydata.list <- convertcompDataToList(mydata.obj)
#' 
convertphyloCompDataToList <- function(cpd) {
  list(count.matrix = count.matrix(cpd),
       sample.annotations = sample.annotations(cpd),
       info.parameters = info.parameters(cpd),
       variable.annotations = variable.annotations(cpd),
       filtering = filtering(cpd),
       analysis.data = analysis.date(cpd),
       package.version = package.version(cpd),
       method.names = method.names(cpd),
       code = code(cpd),
       result.table = result.table(cpd),
       tree = phylo.tree(cpd),
       length.matrix = length.matrix(cpd))
}

test_that("generateSyntheticData fails with wrong inputs", {
  tdir <- tempdir()

  expect_error(generateSyntheticData(
    dataset = "B_625_625", n.vars = 500,
    samples.per.cond = 5, n.diffexp = 50,
    output.file = file.path(tdir, "tmp.txt")
  ), "output.file must be an .rds file.")

  expect_error(generateSyntheticData(
    dataset = "B_625_625", n.vars = 500,
    samples.per.cond = 5, n.diffexp = 50,
    effect.size = 1:3,
    output.file = file.path(tdir, "tmp.rds")
  ), "The length of the effect.size vector must be the same as the number of simulated genes.")

  expect_error(generateSyntheticData(
    dataset = "B_625_625", n.vars = 500,
    samples.per.cond = 5, n.diffexp = 50,
    relmeans = 1:3,
    output.file = file.path(tdir, "tmp.rds")
  ), "The length of the relmeans vector must be the same as the number of simulated genes.")

  expect_error(generateSyntheticData(
    dataset = "B_625_625", n.vars = 500,
    samples.per.cond = 5, n.diffexp = 50,
    dispersions = 1:3,
    output.file = file.path(tdir, "tmp.rds")
  ), "The number of provided dispersions must be the same as the number of simulated genes.")
})

test_that("compData object checks work", {
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 5, n.diffexp = 0,
    output.file = NULL
  )

  expect_equal(checkDataObject(tmp), "Data object looks ok.")

  l <- convertcompDataToList(tmp)
  expect_is(l, "list")
  cpd <- convertListTocompData(l)
  expect_is(cpd, "compData")
  expect_equal(checkDataObject(cpd), "Data object looks ok.")
  l$count.matrix <- NULL
  expect_message({cpd2 <- convertListTocompData(l)},
                 "Cannot convert list to compData object")
  expect_equal(cpd2, NULL)

  tmp2 <- tmp; expect_error({count.matrix(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({sample.annotations(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({filtering(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({analysis.date(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({package.version(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({info.parameters(tmp2) <- 1:3})

  expect_equal(check_compData(tmp), TRUE)
  expect_equal(check_compData(count.matrix(tmp)), "This is not an S4 object.")
  tmp2 <- tmp; count.matrix(tmp2) <- as.matrix(numeric(0)); expect_equal(check_compData(tmp2), "Object must contain a non-empty count matrix.")
  tmp2 <- tmp; sample.annotations(tmp2) <- as.data.frame(NULL); expect_equal(check_compData(tmp2), "Object must contain a non-empty sample annotation data frame.")
  tmp2 <- tmp; sample.annotations(tmp2) <- data.frame(condition = numeric(0)); expect_equal(check_compData(tmp2), "The sample.annotations must contain a column named condition.")
  tmp2 <- tmp; info.parameters(tmp2) <- list(); expect_equal(check_compData(tmp2), "Object must contain a non-empty list called info.parameters.")
  tmp2 <- tmp; info.parameters(tmp2) <- list(tmp = 1); expect_equal(check_compData(tmp2), "info.parameters list must contain an entry named 'dataset'.")
  tmp2 <- tmp; info.parameters(tmp2) <- list(dataset = ""); expect_equal(check_compData(tmp2), "info.parameters list must contain an entry named 'uID'.")
  tmp2 <- tmp; count.matrix(tmp2) <- count.matrix(tmp2)[1:10, ]; expect_equal(check_compData(tmp2), "count.matrix and variable.annotations do not contain the same number of rows.")
  tmp2 <- tmp; rownames(count.matrix(tmp2)) <- paste0("r", rownames(count.matrix(tmp2))); expect_equal(check_compData(tmp2), "The rownames of count.matrix and variable.annotations are not the same.")
  tmp2 <- tmp; count.matrix(tmp2) <- count.matrix(tmp2)[, 1:2]; expect_equal(check_compData(tmp2), "The number of columns of count.matrix is different from the number of rows of sample.annotations.")
  tmp2 <- tmp; colnames(count.matrix(tmp2)) <- paste0("r", colnames(count.matrix(tmp2))); expect_equal(check_compData(tmp2), "The colnames of count.matrix are different from the rownames of sample.annotations.")

  expect_equal(check_compData_results(tmp), "Object must contain a list named 'method.names' identifying the differential expression method used.")
})

test_that("phyloCompData object checks work", {
  tree <- ape::read.tree(text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);")
  idsp <- as.factor(c("A", "A", "A", "B", "C", "C", "D", "D"))
  names(idsp) <- tree$tip.label
  idcond <- c(1, 1, 1, 1, 2, 2, 2, 2)
  names(idcond) <- tree$tip.label

  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 4, n.diffexp = 10,
    tree = tree,
    id.species =  idsp,
    id.condition = idcond,
    lengths.relmeans = "auto",
    lengths.dispersions = "auto",
    output.file = NULL
  )

  expect_equal(checkDataObject(tmp), "Data object looks ok.")

  l <- convertphyloCompDataToList(tmp)
  expect_is(l, "list")

  cpd <- convertListTocompData(l)
  expect_is(cpd, "compData")
  expect_equal(checkDataObject(cpd), "Data object looks ok.")
  expect_null(length.matrix(cpd))
  expect_null(phylo.tree(cpd))
  expect_error(phylo.tree(cpd) <- l$tree, "There is no 'phylo.tree' slot in a 'compData' object. Please use a 'phyloCompData' object.")
  expect_error(length.matrix(cpd) <- l$length.matrix, "There is no 'lenght.matrix' slot in a 'compData' object. Please use a 'phyloCompData' object.")


  cpd <- convertListTophyloCompData(l)
  expect_is(cpd, "phyloCompData")
  expect_equal(checkDataObject(cpd), "Data object looks ok.")

  cpdbis <- phyloCompData(l$count.matrix, l$sample.annotations,
                          l$info.parameters, l$variable.annotations,
                          l$filtering, character(0),
                          l$package.version, l$method.names,
                          l$code, l$result.table,
                          l$tree,
                          l$length.matrix)
  expect_equal(cpd, cpdbis)

  l$count.matrix <- NULL
  expect_message({cpd2 <- convertListTocompData(l)},
                 "Cannot convert list to compData object")
  expect_message({cpd2 <- convertListTophyloCompData(l)},
                 "Cannot convert list to compData object")
  expect_equal(cpd2, NULL)

  tmp2 <- tmp; expect_error({count.matrix(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({sample.annotations(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({filtering(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({analysis.date(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({package.version(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({info.parameters(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({length.matrix(tmp2) <- 1:3})
  tmp2 <- tmp; expect_error({phylo.tree(tmp2) <- 1:3})

  expect_equal(check_compData(tmp), TRUE)
  expect_equal(check_compData(count.matrix(tmp)), "This is not an S4 object.")
  tmp2 <- tmp; count.matrix(tmp2) <- as.matrix(numeric(0)); expect_equal(check_phyloCompData(tmp2), "Object must contain a non-empty count matrix.")
  tmp2 <- tmp; sample.annotations(tmp2) <- as.data.frame(NULL); expect_equal(check_phyloCompData(tmp2), "Object must contain a non-empty sample annotation data frame.")
  tmp2 <- tmp; sample.annotations(tmp2) <- data.frame(condition = numeric(0)); expect_equal(check_phyloCompData(tmp2), "The sample.annotations must contain a column named condition.")
  tmp2 <- tmp; info.parameters(tmp2) <- list(); expect_equal(check_phyloCompData(tmp2), "Object must contain a non-empty list called info.parameters.")
  tmp2 <- tmp; info.parameters(tmp2) <- list(tmp = 1); expect_equal(check_phyloCompData(tmp2), "info.parameters list must contain an entry named 'dataset'.")
  tmp2 <- tmp; info.parameters(tmp2) <- list(dataset = ""); expect_equal(check_phyloCompData(tmp2), "info.parameters list must contain an entry named 'uID'.")
  tmp2 <- tmp; count.matrix(tmp2) <- count.matrix(tmp2)[1:10, ]; expect_equal(check_phyloCompData(tmp2), "count.matrix and variable.annotations do not contain the same number of rows.")
  tmp2 <- tmp; rownames(count.matrix(tmp2)) <- paste0("r", rownames(count.matrix(tmp2))); expect_equal(check_phyloCompData(tmp2), "The rownames of count.matrix and variable.annotations are not the same.")
  tmp2 <- tmp; count.matrix(tmp2) <- count.matrix(tmp2)[, 1:2]; expect_equal(check_phyloCompData(tmp2), "The number of columns of count.matrix is different from the number of rows of sample.annotations.")
  tmp2 <- tmp; colnames(count.matrix(tmp2)) <- paste0("r", colnames(count.matrix(tmp2))); expect_equal(check_phyloCompData(tmp2), "The colnames of count.matrix are different from the rownames of sample.annotations.")

  tmp2 <- tmp; length.matrix(tmp2) <- length.matrix(tmp2)[1:10, ]; expect_equal(check_phyloCompData(tmp2), "The dimension of count.matrix is different from the dimension of length.matrix.")
  tmp2 <- tmp; rownames(length.matrix(tmp2)) <- paste0("r", rownames(length.matrix(tmp2))); expect_equal(check_phyloCompData(tmp2), "The rownames of count.matrix are different from the rownames of length.matrix.")
  tmp2 <- tmp; length.matrix(tmp2) <- length.matrix(tmp2)[, 1:2]; expect_equal(check_phyloCompData(tmp2), "The dimension of count.matrix is different from the dimension of length.matrix.")
  tmp2 <- tmp; colnames(length.matrix(tmp2)) <- paste0("r", colnames(length.matrix(tmp2))); expect_equal(check_phyloCompData(tmp2), "The colnames of count.matrix are different from the colnames of length.matrix.")

  tmp2 <- tmp; phylo.tree(tmp2)$tip.label <- NULL; expect_equal(check_phyloCompData(tmp2), "The tips of the phylogeny are not named.")
  tmp2 <- tmp; phylo.tree(tmp2)$tip.label <- paste0("r", phylo.tree(tmp2)$tip.label); expect_equal(check_phyloCompData(tmp2), "Column names of count.matrix do not match the tip labels.")
  tmp2 <- tmp; phylo.tree(tmp2)$tip.label <- phylo.tree(tmp2)$tip.label[c(2, 1, 3:8)]; expect_equal(check_phyloCompData(tmp2), "Column names of count.matrix do not match the tip labels.")
  tmp2 <- tmp; colnames(count.matrix(tmp2)) <- colnames(count.matrix(tmp2))[c(2, 1, 3:8)]; expect_equal(check_phyloCompData(tmp2), "The colnames of count.matrix are different from the rownames of sample.annotations.")
  tmp2 <- tmp; colnames(length.matrix(tmp2)) <- colnames(length.matrix(tmp2))[c(2, 1, 3:8)]; expect_equal(check_phyloCompData(tmp2), "The colnames of count.matrix are different from the colnames of length.matrix.")
  tmp2 <- tmp; rownames(sample.annotations(tmp2)) <- rownames(sample.annotations(tmp2))[c(2, 1, 3:8)]; expect_equal(check_phyloCompData(tmp2), "The colnames of count.matrix are different from the rownames of sample.annotations.")
  tmp2 <- tmp; sample.annotations(tmp2)$id.species <- rep(1, 8); expect_equal(check_phyloCompData(tmp2), "Error in checkSpecies(ids, \"id.species\", phylo.tree(object), tol = 1e-10,  : \n  The provided species do not match with the tree branch lengths. Please check the 'id.species' vector.\n")
  tmp2 <- tmp; sample.annotations(tmp2)$id.species <- NULL; expect_equal(check_phyloCompData(tmp2), "The sample.annotations must contain a column named id.species.")

  expect_equal(check_compData_results(tmp), "Object must contain a list named 'method.names' identifying the differential expression method used.")
})

test_that("generateSyntheticData works", {
  tdir <- tempdir()

  ## No DEGs
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 5, n.diffexp = 0,
    output.file = NULL
  )
  expect_is(tmp, "compData")
  expect_equal(variable.annotations(tmp)$truedispersions.S1,
               variable.annotations(tmp)$truedispersions.S2)
  expect_equal(variable.annotations(tmp)$truemeans.S1,
               variable.annotations(tmp)$truemeans.S2)
  expect_equal(sum(variable.annotations(tmp)$n.random.outliers.up.S1 +
                     variable.annotations(tmp)$n.random.outliers.up.S2 +
                     variable.annotations(tmp)$n.random.outliers.down.S1 +
                     variable.annotations(tmp)$n.random.outliers.down.S2 +
                     variable.annotations(tmp)$n.single.outliers.up.S1 +
                     variable.annotations(tmp)$n.single.outliers.up.S2 +
                     variable.annotations(tmp)$n.single.outliers.down.S1 +
                     variable.annotations(tmp)$n.single.outliers.down.S2), 0)
  expect_equal(sum(abs(variable.annotations(tmp)$truelog2foldchanges)), 0)
  expect_equal(sum(variable.annotations(tmp)$upregulation +
                     variable.annotations(tmp)$downregulation +
                     variable.annotations(tmp)$differential.expression), 0)

  ## Specify effect sizes individually
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 5, n.diffexp = 10,
    effect.size = c(exp(abs(rnorm(5))), exp(-abs(rnorm(5))), rep(1, 40)),
    output.file = NULL
  )
  expect_is(tmp, "compData")
  expect_equal(variable.annotations(tmp)$truedispersions.S1,
               variable.annotations(tmp)$truedispersions.S2)
  expect_equal(variable.annotations(tmp)$truemeans.S1[-(1:10)],
               variable.annotations(tmp)$truemeans.S2[-(1:10)])
  expect_equal(sum(variable.annotations(tmp)$n.random.outliers.up.S1 +
                     variable.annotations(tmp)$n.random.outliers.up.S2 +
                     variable.annotations(tmp)$n.random.outliers.down.S1 +
                     variable.annotations(tmp)$n.random.outliers.down.S2 +
                     variable.annotations(tmp)$n.single.outliers.up.S1 +
                     variable.annotations(tmp)$n.single.outliers.up.S2 +
                     variable.annotations(tmp)$n.single.outliers.down.S1 +
                     variable.annotations(tmp)$n.single.outliers.down.S2), 0)
  expect_equal(sum(abs(variable.annotations(tmp)$truelog2foldchanges[-(1:10)])), 0)
  expect_equal(sign(variable.annotations(tmp)$truelog2foldchanges),
               c(rep(1, 5), rep(-1, 5), rep(0, 40)))
  expect_equal(variable.annotations(tmp)$upregulation,
               c(rep(1, 5), rep(0, 45)))
  expect_equal(variable.annotations(tmp)$downregulation,
               c(rep(0, 5), rep(1, 5), rep(0, 40)))
  expect_equal(sum(variable.annotations(tmp)$upregulation +
                     variable.annotations(tmp)$downregulation), 10)

  ## Different dispersions between groups
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 5, n.diffexp = 10,
    between.group.diffdisp = TRUE,
    output.file = NULL
  )
  expect_is(tmp, "compData")
  expect_equal(any(variable.annotations(tmp)$truedispersions.S1 !=
                     variable.annotations(tmp)$truedispersions.S2),
               TRUE)
  expect_equal(variable.annotations(tmp)$upregulation,
               c(rep(1, 10), rep(0, 40)))
  expect_equal(variable.annotations(tmp)$downregulation,
               rep(0, 50))
  expect_equal(sum(variable.annotations(tmp)$upregulation +
                     variable.annotations(tmp)$downregulation), 10)

  ## Not overdispersed
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 5, n.diffexp = 10,
    between.group.diffdisp = FALSE,
    fraction.non.overdispersed = 0.5,
    output.file = NULL
  )
  expect_is(tmp, "compData")
  expect_equal(variable.annotations(tmp)$truedispersions.S1,
               variable.annotations(tmp)$truedispersions.S2)
  expect_equal(any(variable.annotations(tmp)$truedispersions.S1 == 0), TRUE)
  expect_equal(info.parameters(tmp)$fraction.non.overdispersed, 0.5)

  ## Outliers
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 5, n.diffexp = 10,
    random.outlier.high.prob = 0.1,
    random.outlier.low.prob = 0.1,
    single.outlier.high.prob = 0.1,
    single.outlier.low.prob = 0.1,
    output.file = NULL
  )
  expect_equal(any(variable.annotations(tmp)$n.random.outliers.up.S1 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.random.outliers.up.S2 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.random.outliers.down.S1 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.random.outliers.down.S2 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.single.outliers.up.S1 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.single.outliers.up.S2 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.single.outliers.down.S1 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.single.outliers.down.S2 > 0), TRUE)

  ## Summary report
  expect_error(summarizeSyntheticDataSet(tmp, file.path(tdir, "tmp.rds")),
               "output.file must be an .html file.")
  summarizeSyntheticDataSet(tmp, file.path(tdir, "tmp_summaryrep.html"))
  expect_equal(file.exists(normalizePath(file.path(tdir, "tmp_summaryrep.html"),
                                         winslash = "/")), TRUE)
})

test_that("generateSyntheticData works - with lengths and phylo", {
  tdir <- tempdir()

  ## Errors with lengths
  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 50,
      samples.per.cond = 4, n.diffexp = 5,
      repl.id = 1,
      lengths.relmeans = rpois(40, 1e4),
      lengths.dispersions = rgamma(50, 1, 1),
      output.file = NULL
    ),
    "The length of the 'lengths.relmeans' vector must be the same as the number of simulated genes.")
  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 50,
      samples.per.cond = 4, n.diffexp = 5,
      repl.id = 1,
      lengths.relmeans = rpois(50, 1e4),
      lengths.dispersions = rgamma(40, 1, 1),
      output.file = NULL
    ),
    "The length of the 'lengths.dispersions' vector must be the same as the number of simulated genes.")
  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 500,
      samples.per.cond = 4, n.diffexp = 50,
      repl.id = 1,
      lengths.relmeans = rpois(50, 1e4),
      output.file = NULL
    ),
    "For lengths to be used, both the 'lengths.relmeans' and 'lengths.dispersions' vectors must be provided.")

  ## Errors and warnings with tree
  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 500,
      samples.per.cond = 4, n.diffexp = 50,
      repl.id = 1,
      tree = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);",
      output.file = NULL
    ),
    "The `tree` must be of class `phylo` from package `ape`.")

  tree <- ape::read.tree(text = "(((A1:0,A2:0,A3:0):0.5,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);")

  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 500,
      samples.per.cond = 4, n.diffexp = 50,
      repl.id = 1,
      tree = tree,
      output.file = NULL
    ),
    "The tree should be ultrametric.")

  tree <- ape::read.tree(text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);")

  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 500,
      samples.per.cond = 5, n.diffexp = 50,
      repl.id = 1,
      tree = tree,
      output.file = NULL
    ),
    "The tree should have as many species as `samples.per.cond` times two")
  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 500,
      samples.per.cond = 4, n.diffexp = 50,
      repl.id = 1,
      tree = tree,
      id.species =  as.factor(c("A", "A", "A", "B", "C", "C", "D")),
      output.file = NULL
    ),
    "`id.species` should have the same length as the number of taxa in the tree.")
  expect_warning(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 500,
      samples.per.cond = 4, n.diffexp = 50,
      repl.id = 1,
      tree = tree,
      id.species =  c("A", "A", "A", "B", "C", "C", "D", "D"),
      output.file = NULL
    ),
    "Vector 'id.species' must be a factor.")
  expect_warning(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 500,
      samples.per.cond = 4, n.diffexp = 50,
      repl.id = 1,
      tree = tree,
      id.species =  as.factor(c("A", "A", "A", "B", "C", "C", "D", "D")),
      output.file = NULL
    ),
    "`id.species` is not named. I'm naming them, assuming they are in the same order as the tree.")

  idsp <- as.factor(c("A", "A", "A", "B", "C", "C", "D", "D"))
  names(idsp) <- c("F", tree$tip.label[-1])

  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 500,
      samples.per.cond = 4, n.diffexp = 50,
      repl.id = 1,
      tree = tree,
      id.species =  idsp,
      output.file = NULL
    ),
    "`id.species` names do not match the tip labels.")

  idsp <- as.factor(c("A", "A", "A", "B", "C", "C", "D", "D"))
  names(idsp) <- tree$tip.label

  expect_warning(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 500,
      samples.per.cond = 4, n.diffexp = 50,
      repl.id = 1,
      tree = tree,
      id.condition = c(1, 1, 1, 1, 2, 2, 2, 2),
      id.species =  idsp,
      output.file = NULL
    ),
    "`id.condition` is not named. I'm naming them, assuming they are in the same order as the tree.")

  idcond <- c(1, 1, 1, 1, 2, 2, 2, 2)
  names(idcond) <- tree$tip.label

  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 50,
      samples.per.cond = 4, n.diffexp = 0,
      tree = tree,
      id.species =  idsp,
      id.condition = idcond,
      output.file = NULL,
      prop.var.tree = c(0.1, 0.1)
    ),
    "should be a vector of length the number of genes"
  )

  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 50,
      samples.per.cond = 4, n.diffexp = 0,
      tree = tree,
      id.species =  idsp,
      id.condition = idcond,
      output.file = NULL,
      prop.var.tree = c(1.1, rep(0.1, 48), 2)
    ),
    "All entries of `prop.var.tree` should be between 0 and 1"
  )

  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 50,
      samples.per.cond = 4, n.diffexp = 0,
      tree = tree,
      id.species =  idsp,
      id.condition = idcond,
      output.file = NULL,
      prop.var.tree = 1.1
    ),
    "All entries of `prop.var.tree` should be between 0 and 1"
  )

  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 50,
      samples.per.cond = 4, n.diffexp = 0,
      tree = tree,
      id.species =  idsp,
      id.condition = idcond,
      output.file = NULL,
      prop.var.tree = matrix(0.1, 10, 5)
    ),
    "should be a vector"
  )

  ## No DEGs
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 4, n.diffexp = 0,
    tree = tree,
    id.species =  idsp,
    id.condition = idcond,
    output.file = NULL
  )
  expect_is(tmp, "phyloCompData")
  expect_equal(variable.annotations(tmp)$truedispersions.S1,
               variable.annotations(tmp)$truedispersions.S2)
  expect_equal(variable.annotations(tmp)$truemeans.S1,
               variable.annotations(tmp)$truemeans.S2)
  expect_equal(sum(variable.annotations(tmp)$n.random.outliers.up.S1 +
                     variable.annotations(tmp)$n.random.outliers.up.S2 +
                     variable.annotations(tmp)$n.random.outliers.down.S1 +
                     variable.annotations(tmp)$n.random.outliers.down.S2 +
                     variable.annotations(tmp)$n.single.outliers.up.S1 +
                     variable.annotations(tmp)$n.single.outliers.up.S2 +
                     variable.annotations(tmp)$n.single.outliers.down.S1 +
                     variable.annotations(tmp)$n.single.outliers.down.S2), 0)
  expect_equal(sum(abs(variable.annotations(tmp)$truelog2foldchanges)), 0)
  expect_equal(sum(variable.annotations(tmp)$upregulation +
                     variable.annotations(tmp)$downregulation +
                     variable.annotations(tmp)$differential.expression), 0)

  ## Specify effect sizes individually
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 4, n.diffexp = 10,
    tree = tree,
    id.species =  idsp,
    id.condition = idcond,
    effect.size = c(exp(abs(rnorm(5))), exp(-abs(rnorm(5))), rep(1, 40)),
    output.file = NULL
  )
  expect_is(tmp, "phyloCompData")
  expect_equal(variable.annotations(tmp)$truedispersions.S1,
               variable.annotations(tmp)$truedispersions.S2)
  expect_equal(variable.annotations(tmp)$truemeans.S1[-(1:10)],
               variable.annotations(tmp)$truemeans.S2[-(1:10)])
  expect_equal(sum(variable.annotations(tmp)$n.random.outliers.up.S1 +
                     variable.annotations(tmp)$n.random.outliers.up.S2 +
                     variable.annotations(tmp)$n.random.outliers.down.S1 +
                     variable.annotations(tmp)$n.random.outliers.down.S2 +
                     variable.annotations(tmp)$n.single.outliers.up.S1 +
                     variable.annotations(tmp)$n.single.outliers.up.S2 +
                     variable.annotations(tmp)$n.single.outliers.down.S1 +
                     variable.annotations(tmp)$n.single.outliers.down.S2), 0)
  expect_equal(sum(abs(variable.annotations(tmp)$truelog2foldchanges[-(1:10)])), 0)
  expect_equal(sign(variable.annotations(tmp)$truelog2foldchanges),
               c(rep(1, 5), rep(-1, 5), rep(0, 40)))
  expect_equal(variable.annotations(tmp)$upregulation,
               c(rep(1, 5), rep(0, 45)))
  expect_equal(variable.annotations(tmp)$downregulation,
               c(rep(0, 5), rep(1, 5), rep(0, 40)))
  expect_equal(sum(variable.annotations(tmp)$upregulation +
                     variable.annotations(tmp)$downregulation), 10)

  ## Different dispersions between groups
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 4, n.diffexp = 10,
    between.group.diffdisp = TRUE,
    tree = tree,
    id.species =  idsp,
    id.condition = idcond,
    output.file = NULL
  )
  expect_is(tmp, "phyloCompData")
  expect_equal(any(variable.annotations(tmp)$truedispersions.S1 !=
                     variable.annotations(tmp)$truedispersions.S2),
               TRUE)
  expect_equal(variable.annotations(tmp)$upregulation,
               c(rep(1, 10), rep(0, 40)))
  expect_equal(variable.annotations(tmp)$downregulation,
               rep(0, 50))
  expect_equal(sum(variable.annotations(tmp)$upregulation +
                     variable.annotations(tmp)$downregulation), 10)

  ## Not overdispersed
  expect_error(
    generateSyntheticData(
      dataset = "B_625_625", n.vars = 50,
      samples.per.cond = 4, n.diffexp = 10,
      between.group.diffdisp = FALSE,
      fraction.non.overdispersed = 0.5,
      tree = tree,
      id.species =  idsp,
      id.condition = idcond,
      output.file = NULL
    ),
    "The Phylogenetic Poisson lognormal distribution is always over-dispersed.")

  ## Outliers
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 4, n.diffexp = 10,
    tree = tree,
    id.species =  idsp,
    random.outlier.high.prob = 0.1,
    random.outlier.low.prob = 0.1,
    single.outlier.high.prob = 0.1,
    single.outlier.low.prob = 0.1,
    output.file = NULL
  )
  expect_equal(any(variable.annotations(tmp)$n.random.outliers.up.S1 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.random.outliers.up.S2 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.random.outliers.down.S1 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.random.outliers.down.S2 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.single.outliers.up.S1 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.single.outliers.up.S2 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.single.outliers.down.S1 > 0), TRUE)
  expect_equal(any(variable.annotations(tmp)$n.single.outliers.down.S2 > 0), TRUE)

  ## Summary report
  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 4, n.diffexp = 10,
    tree = tree,
    id.species =  idsp,
    id.condition = idcond,
    lengths.relmeans = "auto",
    lengths.dispersions = "auto",
    output.file = NULL
  )

  expect_error(summarizeSyntheticDataSet(tmp, file.path(tdir, "tmp.rds")),
               "output.file must be an .html file.")
  summarizeSyntheticDataSet(tmp, file.path(tdir, "tmp_summaryrep.html"))
  expect_equal(file.exists(normalizePath(file.path(tdir, "tmp_summaryrep.html"),
                                         winslash = "/")), TRUE)
})

test_that("help functions work", {
  listcreateRmd()

  expect_warning(expect_error(checkRange("hello", "name", 0, 1), "Illegal value"), "NAs introduced by coercion")
  expect_equal(checkRange(-1, "name", 0, 1), 0)
  expect_equal(checkRange(2, "name", 0, 1), 1)
  expect_equal(checkRange("-1", "name", 0, 1), 0)

  expect_equal(shorten.method.names(c("AUC", "ROC, all replicates")),
               c("auc", "rocall"))

  set.seed(1)
  tmp <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 50,
    samples.per.cond = 5, n.diffexp = 10,
    output.file = NULL
  )

  expect_error(
    computeMval(count.matrix(tmp), c(3, sample.annotations(tmp)$condition[-1])),
    "Must have exactly two groups to calculate M-value"
  )
  expect_error(
    computeAval(count.matrix(tmp), c(3, sample.annotations(tmp)$condition[-1])),
    "Must have exactly two groups to calculate A-value"
  )

  mval <- computeMval(count.matrix(tmp), sample.annotations(tmp)$condition)
  aval <- computeAval(count.matrix(tmp), sample.annotations(tmp)$condition)

  expect_is(mval, "numeric")
  expect_is(aval, "numeric")
  expect_equal(length(mval), nrow(count.matrix(tmp)))
  expect_equal(length(aval), nrow(count.matrix(tmp)))
})

test_that("runDiffExp works", {

  tdir <- tempdir()
  set.seed(1)  ## note that with other seeds, the number of genes
  ## passing the filtering threshold could be different

  testdat <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 500,
    samples.per.cond = 5, n.diffexp = 50,
    repl.id = 1, seqdepth = 1e5,
    fraction.upregulated = 0.5,
    between.group.diffdisp = FALSE,
    filter.threshold.total = 1,
    filter.threshold.mediancpm = 0,
    fraction.non.overdispersed = 0,
    output.file = file.path(tdir, "B_625_625_5spc_repl1.rds")
  )

  expect_equal(checkDataObject(testdat), "Data object looks ok.")

  tmp <- readRDS(normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"))
  expect_is(tmp, "compData")
  expect_is(count.matrix(tmp), "matrix")
  expect_equal(nrow(count.matrix(tmp)), 500)
  expect_equal(ncol(count.matrix(tmp)), 10)
  expect_is(sample.annotations(tmp), "data.frame")
  expect_equal(nrow(sample.annotations(tmp)), 10)
  expect_equal(ncol(sample.annotations(tmp)), 2)
  expect_is(variable.annotations(tmp), "data.frame")
  expect_equal(nrow(variable.annotations(tmp)), 500)
  expect_equal(ncol(variable.annotations(tmp)), 18)
  expect_is(info.parameters(tmp), "list")
  expect_equal(info.parameters(tmp)$n.diffexp, 50)
  expect_equal(info.parameters(tmp)$dataset, "B_625_625")
  expect_equal(info.parameters(tmp)$fraction.upregulated, 0.5)
  expect_equal(info.parameters(tmp)$between.group.diffdisp, FALSE)
  expect_equal(info.parameters(tmp)$filter.threshold.total, 1)
  expect_equal(info.parameters(tmp)$filter.threshold.mediancpm, 0)
  expect_equal(info.parameters(tmp)$fraction.non.overdispersed, 0)
  expect_equal(info.parameters(tmp)$random.outlier.high.prob, 0)
  expect_equal(info.parameters(tmp)$random.outlier.low.prob, 0)
  expect_equal(info.parameters(tmp)$single.outlier.high.prob, 0)
  expect_equal(info.parameters(tmp)$single.outlier.low.prob, 0)
  expect_equal(info.parameters(tmp)$effect.size, 1.5)
  expect_equal(info.parameters(tmp)$samples.per.cond, 5)
  expect_equal(info.parameters(tmp)$repl.id, 1)
  expect_equal(info.parameters(tmp)$seqdepth, 1e5)
  expect_equal(info.parameters(tmp)$minfact, 0.7)
  expect_equal(info.parameters(tmp)$maxfact, 1.4)
  expect_equal(filtering(tmp), "total count >= 1 ;  median cpm >= 0")
  expect_is(analysis.date(tmp), "character")
  expect_equal(analysis.date(tmp), "")
  expect_is(package.version(tmp), "character")
  expect_equal(package.version(tmp), "")
  expect_is(method.names(tmp), "list")
  expect_equal(method.names(tmp), list())

  # if (requireNamespace("baySeq", quietly = TRUE)) {
  #   runDiffExp(
  #     data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
  #     result.extent = "baySeq",
  #     Rmdfunction = "baySeq.createRmd",
  #     output.directory = tdir, norm.method = "edgeR",
  #     equaldisp = TRUE
  #   )
  # }
  if (requireNamespace("DESeq2", quietly = TRUE)) {
    expect_message(
      runDiffExp(
        data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
        result.extent = "DESeq2",
        Rmdfunction = "DESeq2.createRmd",
        output.directory = tdir, fit.type = "parametric",
        test = "Wald", beta.prior = TRUE,
        independent.filtering = TRUE, cooks.cutoff = TRUE,
        impute.outliers = TRUE,
        nas.as.ones = FALSE
      ),
      "there might be some NAs in the adjusted p values computed by DESeq2"
    )
    expect_message(
      runDiffExp(
        data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
        result.extent = "DESeq2_nona",
        Rmdfunction = "DESeq2.createRmd",
        output.directory = tdir, fit.type = "parametric",
        test = "Wald", beta.prior = TRUE,
        independent.filtering = TRUE, cooks.cutoff = TRUE,
        impute.outliers = TRUE,
        nas.as.ones = TRUE
      ),
      "all NAs in adjusted p values are replaced by 1 to allow for benchmarking with other methods"
    )
  }
  if (requireNamespace("DSS", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "DSS",
      Rmdfunction = "DSS.createRmd",
      output.directory = tdir, norm.method = "quantile",
      disp.trend = FALSE
    )
  }
  if (requireNamespace("EBSeq", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "EBSeq",
      Rmdfunction = "EBSeq.createRmd",
      output.directory = tdir, norm.method = "median"
    )
  }
  # edgeR is in Imports -> always installed
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "edgeR.exact",
    Rmdfunction = "edgeR.exact.createRmd",
    output.directory = tdir, norm.method = "TMM",
    trend.method = "movingave", disp.type = "tagwise"
  )
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "edgeR.GLM",
    Rmdfunction = "edgeR.GLM.createRmd",
    output.directory = tdir, norm.method = "TMM",
    disp.type = "tagwise", disp.method = "CoxReid",
    trended = TRUE
  )
  # limma is in Imports -> always installed
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "logcpm.limma",
    Rmdfunction = "logcpm.limma.createRmd",
    output.directory = tdir, norm.method = "TMM"
  )
  if (requireNamespace("NBPSeq", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "NBPSeq",
      Rmdfunction = "NBPSeq.createRmd",
      output.directory = tdir, norm.method = "TMM",
      disp.method = "NBP"
    )
  }
  if (requireNamespace("NOISeq", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "NOISeq",
      Rmdfunction = "NOISeq.prenorm.createRmd",
      output.directory = tdir, norm.method = "TMM"
    )
  }
  # limma is in Imports -> always installed
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "sqrtcpm.limma",
    Rmdfunction = "sqrtcpm.limma.createRmd",
    output.directory = tdir, norm.method = "TMM"
  )
  if (requireNamespace("TCC", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "TCC",
      Rmdfunction = "TCC.createRmd",
      output.directory = tdir, norm.method = "tmm",
      test.method = "edger", iteration = 3,
      normFDR = 0.1, floorPDEG = 0.05
    )
  }
  if (requireNamespace("genefilter", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "ttest",
      Rmdfunction = "ttest.createRmd",
      output.directory = tdir, norm.method = "TMM"
    )
  }
  # limma is in Imports -> always installed
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "voom.limma",
    Rmdfunction = "voom.limma.createRmd",
    output.directory = tdir, norm.method = "TMM"
  )
  if (requireNamespace("genefilter", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "voom.ttest",
      Rmdfunction = "voom.ttest.createRmd",
      output.directory = tdir, norm.method = "TMM"
    )
  }

  methods <- c("DESeq2", "DESeq2_nona", "DSS", "EBSeq", "edgeR.exact",
               "edgeR.GLM", "logcpm.limma", "NBPSeq", "NOISeq",
               "sqrtcpm.limma", "TCC", "ttest", "voom.limma",
               "voom.ttest")
  pkgs <- c("DESeq2", "DESeq2", "DSS", "EBSeq", "edgeR",
            "edgeR", "limma", "NBPSeq", "NOISeq",
            "limma", "TCC", "genefilter", "limma",
            "genefilter")

  ## Test show() method
  m <- "edgeR.exact" # edgeR always installed
  tmp <- readRDS(normalizePath(file.path(tdir, paste0("B_625_625_5spc_repl1_", m, ".rds")),
                               winslash = "/"))
  show(tmp)
  count.matrix(tmp) <- count.matrix(tmp)[, 1:4]
  show(tmp)

  for (i in seq_len(length(methods))) {
    m <- methods[i]
    pkg <- pkgs[i]
    if (requireNamespace(pkg, quietly = TRUE)) {
      tmp <- readRDS(normalizePath(file.path(tdir, paste0("B_625_625_5spc_repl1_", m, ".rds")), winslash = "/"))

      expect_is(tmp, "compData")
      expect_is(result.table(tmp), "data.frame")
      expect_equal(nrow(result.table(tmp)), 500)
      expect_is(code(tmp), "character")
      expect_is(analysis.date(tmp), "character")
      expect_is(compcodeR:::package.version(tmp), "character")
      expect_is(method.names(tmp), "list")
      expect_named(method.names(tmp), c("short.name", "full.name"))

      tmp2 <- tmp; result.table(tmp2) <- result.table(tmp2)[1:10, ]; expect_equal(check_compData_results(tmp2), "result.table must have the same number of rows as count.matrix.")
      tmp2 <- tmp; result.table(tmp2) <- data.frame(); expect_equal(check_compData_results(tmp2), "Object must contain a data frame named 'result.table'.")
      tmp2 <- tmp; result.table(tmp2)$score <- NULL; expect_equal(check_compData_results(tmp2), "result.table must contain a column named 'score'.")
    }
  }

  for (i in seq_len(length(methods))) {
    m <- methods[i]
    pkg <- pkgs[i]
    if (requireNamespace(pkg, quietly = TRUE)) {
      generateCodeHTMLs(
        normalizePath(file.path(tdir, paste0("B_625_625_5spc_repl1_", m, ".rds")),
                      winslash = "/"), normalizePath(tdir)
      )
      expect_true(file.exists(normalizePath(file.path(
        tdir, paste0("B_625_625_5spc_repl1_",
                     m, "_code.html")), winslash = "/")))
    }
  }

  ## Comparison report
  file.table <- data.frame(input.files = normalizePath(file.path(
    tdir, paste0("B_625_625_5spc_repl1_",
                 c("voom.limma", "sqrtcpm.limma", "edgeR.exact", "edgeR.GLM"), ## Only packages in import
                 ".rds")), winslash = "/"))
  parameters <- NULL
  comp <- runComparison(file.table = file.table, output.directory = tdir,
                        parameters = parameters)

  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = parameters, save.result.table = FALSE, knit.results = FALSE),
               "At least on of 'save.result.table' or 'knit.results' must be set to TRUE, otherwise the function does not produce anything.")
  comp2 <- runComparison(file.table = file.table, output.directory = tdir,
                         parameters = parameters, save.result.table = TRUE, knit.results = FALSE)
  ff <- list.files(path = tdir, pattern = "compcodeR_result_table_.*.rds", full.names = TRUE)
  resTable <- readRDS(ff[length(ff)])
  expect_equal(resTable$fp + resTable$tp + resTable$fn + resTable$tn, rep(500, nrow(resTable)))
  expect_equal(ncol(resTable), 14)
  expect_equal(nrow(resTable), 4)

  parameters <- list()
  par2 <- parameters; par2$incl.dataset <- "missing"
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with datasets")
  par2 <- parameters; par2$incl.nbr.samples <- 10
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with nbr.samples")
  par2 <- parameters; par2$incl.replicates <- 10
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with replicates")
  par2 <- parameters; par2$incl.de.methods <- "missing"
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with DE methods")

})

test_that("runDiffExp works - with lengths", {

  tdir <- tempdir()
  set.seed(1)  ## note that with other seeds, the number of genes
  ## passing the filtering threshold could be different

  testdat <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 500,
    samples.per.cond = 5, n.diffexp = 50,
    repl.id = 1, seqdepth = 1e5,
    fraction.upregulated = 0.5,
    between.group.diffdisp = FALSE,
    filter.threshold.total = 1,
    filter.threshold.mediancpm = 0,
    fraction.non.overdispersed = 0,
    id.species = factor(1:10),
    lengths.relmeans = rpois(500, 1e4),
    lengths.dispersions = rgamma(500, 1, 1),
    output.file = file.path(tdir, "B_625_625_5spc_repl1.rds")
  )

  expect_equal(checkDataObject(testdat), "Data object looks ok.")

  tmp <- readRDS(normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"))
  expect_is(tmp, "compData")
  expect_is(count.matrix(tmp), "matrix")
  expect_equal(nrow(count.matrix(tmp)), 498) # some are filtered
  expect_equal(ncol(count.matrix(tmp)), 10)
  expect_is(sample.annotations(tmp), "data.frame")
  expect_equal(nrow(sample.annotations(tmp)), 10)
  expect_equal(ncol(sample.annotations(tmp)), 2)
  expect_is(variable.annotations(tmp), "data.frame")
  expect_equal(nrow(variable.annotations(tmp)), 498)
  expect_equal(ncol(variable.annotations(tmp)), 22)
  expect_is(info.parameters(tmp), "list")
  expect_equal(info.parameters(tmp)$n.diffexp, 50)
  expect_equal(info.parameters(tmp)$dataset, "B_625_625")
  expect_equal(info.parameters(tmp)$fraction.upregulated, 0.5)
  expect_equal(info.parameters(tmp)$between.group.diffdisp, FALSE)
  expect_equal(info.parameters(tmp)$filter.threshold.total, 1)
  expect_equal(info.parameters(tmp)$filter.threshold.mediancpm, 0)
  expect_equal(info.parameters(tmp)$fraction.non.overdispersed, 0)
  expect_equal(info.parameters(tmp)$random.outlier.high.prob, 0)
  expect_equal(info.parameters(tmp)$random.outlier.low.prob, 0)
  expect_equal(info.parameters(tmp)$single.outlier.high.prob, 0)
  expect_equal(info.parameters(tmp)$single.outlier.low.prob, 0)
  expect_equal(info.parameters(tmp)$effect.size, 1.5)
  expect_equal(info.parameters(tmp)$samples.per.cond, 5)
  expect_equal(info.parameters(tmp)$repl.id, 1)
  expect_equal(info.parameters(tmp)$seqdepth, 1e5)
  expect_equal(info.parameters(tmp)$minfact, 0.7)
  expect_equal(info.parameters(tmp)$maxfact, 1.4)
  expect_equal(info.parameters(tmp)$nEff, 2.5)
  expect_equal(info.parameters(tmp)$nEffRatio, 1.0)
  expect_equal(filtering(tmp), "total count >= 1 ;  median cpm >= 0")
  expect_is(analysis.date(tmp), "character")
  expect_equal(analysis.date(tmp), "")
  expect_is(package.version(tmp), "character")
  expect_equal(package.version(tmp), "")
  expect_is(method.names(tmp), "list")
  expect_equal(method.names(tmp), list())

  if (requireNamespace("DESeq2", quietly = TRUE)) {
    expect_message(
      runDiffExp(
        data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
        result.extent = "DESeq2.length",
        Rmdfunction = "DESeq2.length.createRmd",
        output.directory = tdir, fit.type = "parametric",
        test = "Wald", beta.prior = TRUE,
        independent.filtering = TRUE, cooks.cutoff = TRUE,
        impute.outliers = TRUE,
        extra.design.covariates = NULL,
        nas.as.ones = FALSE
      ),
      "there might be some NAs in the adjusted p values computed by DESeq2"
    )
  }
  # limma is in Imports
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "lengthNorm.limma",
    Rmdfunction = "lengthNorm.limma.createRmd",
    output.directory = tdir, norm.method = "TMM",
    extra.design.covariates = NULL,
    length.normalization = "RPKM",
    data.transformation = "log2",
    block.factor = NULL
  )
  # phylolm is in Imports
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "phylolm",
    Rmdfunction = "phylolm.createRmd",
    output.directory = tdir, norm.method = "TMM",
    model = "BM", measurement_error = TRUE,
    extra.design.covariates = NULL,
    length.normalization = "RPKM",
    data.transformation = "log2"
  )

  methods <- c("DESeq2.length", "lengthNorm.limma", "phylolm")

  ## Test show() method
  m <- "lengthNorm.limma"
  tmp <- readRDS(normalizePath(file.path(tdir, paste0("B_625_625_5spc_repl1_", m, ".rds")),
                               winslash = "/"))
  show(tmp)
  count.matrix(tmp) <- count.matrix(tmp)[, 1:4]
  show(tmp)

  for (m in methods) {
    if (m != "DESeq2.length" || requireNamespace("DESeq2", quietly = TRUE)) {
      tmp <- readRDS(normalizePath(file.path(tdir, paste0("B_625_625_5spc_repl1_", m, ".rds")), winslash = "/"))

      expect_is(tmp, "phyloCompData")
      expect_is(result.table(tmp), "data.frame")
      expect_equal(nrow(result.table(tmp)), 498)
      expect_is(code(tmp), "character")
      expect_is(analysis.date(tmp), "character")
      expect_is(compcodeR:::package.version(tmp), "character")
      expect_is(method.names(tmp), "list")
      expect_named(method.names(tmp), c("short.name", "full.name"))

      tmp2 <- tmp; result.table(tmp2) <- result.table(tmp2)[1:10, ]; expect_equal(check_compData_results(tmp2), "result.table must have the same number of rows as count.matrix.")
      tmp2 <- tmp; result.table(tmp2) <- data.frame(); expect_equal(check_compData_results(tmp2), "Object must contain a data frame named 'result.table'.")
      tmp2 <- tmp; result.table(tmp2)$score <- NULL; expect_equal(check_compData_results(tmp2), "result.table must contain a column named 'score'.")
    }
  }

  for (m in methods) {
    if (m != "DESeq2.length" || requireNamespace("DESeq2", quietly = TRUE)) {
      generateCodeHTMLs(
        normalizePath(file.path(tdir, paste0("B_625_625_5spc_repl1_", m, ".rds")),
                      winslash = "/"), normalizePath(tdir)
      )
      expect_true(file.exists(normalizePath(file.path(
        tdir, paste0("B_625_625_5spc_repl1_",
                     m, "_code.html")), winslash = "/")))
    }
  }

  ## Comparison report
  file.table <- data.frame(input.files = normalizePath(file.path(
    tdir, paste0("B_625_625_5spc_repl1_",
                 methods[-1],
                 ".rds")), winslash = "/"))
  parameters <- NULL
  comp <- runComparison(file.table = file.table, output.directory = tdir,
                        parameters = parameters)

  comp2 <- runComparison(file.table = file.table, output.directory = tdir,
                         parameters = parameters, save.result.table = TRUE, knit.results = FALSE)
  ff <- list.files(path = tdir, pattern = "compcodeR_result_table_.*.rds", full.names = TRUE)
  resTable <- readRDS(ff[length(ff)])
  expect_equal(resTable$fp + resTable$tp + resTable$fn + resTable$tn, rep(498, nrow(resTable)))
  expect_equal(ncol(resTable), 14)
  expect_equal(nrow(resTable), length(methods) - 1)

  parameters <- list()
  par2 <- parameters; par2$incl.dataset <- "missing"
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with datasets")
  par2 <- parameters; par2$incl.nbr.samples <- 10
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with nbr.samples")
  par2 <- parameters; par2$incl.replicates <- 10
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with replicates")
  par2 <- parameters; par2$incl.de.methods <- "missing"
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with DE methods")
})

test_that("runDiffExp works - phylo", {

  tdir <- tempdir()

  tree <- ape::read.tree(text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);")

  idsp <- as.factor(c("A", "A", "A", "B", "C", "C", "D", "D"))
  names(idsp) <- tree$tip.label

  idcond <- c(1, 1, 1, 1, 2, 2, 2, 2)
  names(idcond) <- tree$tip.label

  set.seed(1)  ## note that with other seeds, the number of genes
  ## passing the filtering threshold could be different

  testdat <- generateSyntheticData(
    dataset = "B_625_625", n.vars = 500,
    samples.per.cond = 4, n.diffexp = 50,
    repl.id = 1, seqdepth = 1e5,
    fraction.upregulated = 0.5,
    between.group.diffdisp = FALSE,
    filter.threshold.total = 1,
    filter.threshold.mediancpm = 0,
    fraction.non.overdispersed = 0,
    tree = tree,
    id.condition = idcond,
    id.species =  idsp,
    lengths.relmeans = "auto",
    lengths.dispersions = "auto",
    output.file = file.path(tdir, "B_625_625_5spc_repl1.rds")
  )

  expect_equal(checkDataObject(testdat), "Data object looks ok.")

  tmp <- readRDS(normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"))
  expect_is(tmp, "phyloCompData")
  expect_is(count.matrix(tmp), "matrix")
  expect_equal(nrow(count.matrix(tmp)), 489) # some are filtered
  expect_equal(ncol(count.matrix(tmp)), 8)
  expect_equal(nrow(length.matrix(tmp)), 489) # some are filtered
  expect_equal(ncol(length.matrix(tmp)), 8)
  expect_is(sample.annotations(tmp), "data.frame")
  expect_equal(nrow(sample.annotations(tmp)), 8)
  expect_equal(ncol(sample.annotations(tmp)), 4)
  expect_is(variable.annotations(tmp), "data.frame")
  expect_equal(nrow(variable.annotations(tmp)), 489)
  expect_equal(ncol(variable.annotations(tmp)), 23)
  expect_is(info.parameters(tmp), "list")
  expect_equal(info.parameters(tmp)$n.diffexp, 50)
  expect_equal(info.parameters(tmp)$dataset, "B_625_625")
  expect_equal(info.parameters(tmp)$fraction.upregulated, 0.5)
  expect_equal(info.parameters(tmp)$between.group.diffdisp, FALSE)
  expect_equal(info.parameters(tmp)$filter.threshold.total, 1)
  expect_equal(info.parameters(tmp)$filter.threshold.mediancpm, 0)
  expect_equal(info.parameters(tmp)$fraction.non.overdispersed, 0)
  expect_equal(info.parameters(tmp)$random.outlier.high.prob, 0)
  expect_equal(info.parameters(tmp)$random.outlier.low.prob, 0)
  expect_equal(info.parameters(tmp)$single.outlier.high.prob, 0)
  expect_equal(info.parameters(tmp)$single.outlier.low.prob, 0)
  expect_equal(info.parameters(tmp)$effect.size, 1.5)
  expect_equal(info.parameters(tmp)$samples.per.cond, 4)
  expect_equal(info.parameters(tmp)$repl.id, 1)
  expect_equal(info.parameters(tmp)$seqdepth, 1e5)
  expect_equal(info.parameters(tmp)$minfact, 0.7)
  expect_equal(info.parameters(tmp)$maxfact, 1.4)
  expect_equal(info.parameters(tmp)$nEff, 0.3636364, tolerance = 1e-7)
  expect_equal(info.parameters(tmp)$nEffRatio, info.parameters(tmp)$nEff) # n/4 = 1
  expect_equal(unique(variable.annotations(tmp)$prop.var.tree), 1.0)
  expect_equal(filtering(tmp), "total count >= 1 ;  median cpm >= 0")
  expect_is(analysis.date(tmp), "character")
  expect_equal(analysis.date(tmp), "")
  expect_is(package.version(tmp), "character")
  expect_equal(package.version(tmp), "")
  expect_is(method.names(tmp), "list")
  expect_equal(method.names(tmp), list())

  if (requireNamespace("DESeq2", quietly = TRUE)) {
    expect_message(
      runDiffExp(
        data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
        result.extent = "DESeq2.length",
        Rmdfunction = "DESeq2.length.createRmd",
        output.directory = tdir, fit.type = "parametric",
        test = "Wald", beta.prior = TRUE,
        independent.filtering = TRUE, cooks.cutoff = TRUE,
        impute.outliers = TRUE,
        extra.design.covariates = NULL,
        nas.as.ones = TRUE
      ),
      "all NAs in adjusted p values are replaced by 1"
    )
  }
  # limma is in Imports
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "lengthNorm.limma",
    Rmdfunction = "lengthNorm.limma.createRmd",
    output.directory = tdir, norm.method = "TMM",
    extra.design.covariates = NULL,
    length.normalization = "TPM",
    data.transformation = "log2",
    block.factor = NULL
  )
  if (requireNamespace("statmod", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "lengthNorm.limma.cor",
      Rmdfunction = "lengthNorm.limma.createRmd",
      output.directory = tdir, norm.method = "TMM",
      extra.design.covariates = NULL,
      length.normalization = "TPM",
      data.transformation = "log2",
      block.factor = "id.species"
    )
  }
  if (requireNamespace("sva", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "lengthNorm.sva.limma",
      Rmdfunction = "lengthNorm.sva.limma.createRmd",
      output.directory = tdir, norm.method = "TMM",
      extra.design.covariates = NULL,
      length.normalization = "TPM",
      data.transformation = "log2"
    )
  }
  # phylolm is in Imports
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "phylolm_cpm",
    Rmdfunction = "phylolm.createRmd",
    output.directory = tdir, norm.method = "TMM",
    model = "OUfixedRoot", measurement_error = TRUE,
    extra.design.covariates = NULL,
    length.normalization = "none",
    data.transformation = "sqrt"
  )
  # phylolm is in Imports
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "phylolm",
    Rmdfunction = "phylolm.createRmd",
    output.directory = tdir, norm.method = "TMM",
    model = "BM", measurement_error = TRUE,
    extra.design.covariates = NULL,
    length.normalization = "TPM",
    data.transformation = "log2"
  )

  # with extra factor
  tmp <- readRDS(normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"))
  sample.annotations(tmp)$test_reg <- rnorm(nrow(sample.annotations(tmp)))
  sample.annotations(tmp)$test_fac <- factor(sample(c(0, 1)))
  saveRDS(tmp, normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"))

  if (requireNamespace("DESeq2", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "DESeq2.length.factor",
      Rmdfunction = "DESeq2.length.createRmd",
      output.directory = tdir, fit.type = "parametric",
      test = "Wald", beta.prior = TRUE,
      independent.filtering = TRUE, cooks.cutoff = TRUE,
      impute.outliers = FALSE,
      extra.design.covariates = c("test_reg", "test_fac")
    )
  }
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "lengthNorm.limma.factor",
    Rmdfunction = "lengthNorm.limma.createRmd",
    output.directory = tdir, norm.method = "TMM",
    extra.design.covariates = c("test_reg", "test_fac"),
    trend = TRUE,
    length.normalization = "TPM",
    data.transformation = "log2",
    block.factor = NULL
  )
  if (requireNamespace("sva", quietly = TRUE)) {
    runDiffExp(
      data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
      result.extent = "lengthNorm.sva.limma.factor",
      Rmdfunction = "lengthNorm.sva.limma.createRmd",
      output.directory = tdir, norm.method = "TMM",
      length.normalization = "TPM",
      data.transformation = "log2",
      extra.design.covariates = c("test_reg", "test_fac"),
      n.sv = 1
    )
  }
  runDiffExp(
    data.file = normalizePath(file.path(tdir, "B_625_625_5spc_repl1.rds"), winslash = "/"),
    result.extent = "phylolm.factor",
    Rmdfunction = "phylolm.createRmd",
    output.directory = tdir, norm.method = "TMM",
    model = "BM", measurement_error = TRUE,
    extra.design.covariates = c("test_reg", "test_fac"),
    length.normalization = "TPM",
    data.transformation = "log2"
  )

  methods <- c("DESeq2.length", "DESeq2.length.factor", "lengthNorm.limma", "lengthNorm.limma.cor", "lengthNorm.limma.factor", "lengthNorm.sva.limma", "lengthNorm.sva.limma.factor", "phylolm.factor", "phylolm_cpm", "phylolm")

  ## Test show() method
  m <- "lengthNorm.limma"
  tmp <- readRDS(normalizePath(file.path(tdir, paste0("B_625_625_5spc_repl1_", m, ".rds")),
                               winslash = "/"))
  show(tmp)
  count.matrix(tmp) <- count.matrix(tmp)[, 1:4]
  show(tmp)

  for (m in methods) {
    if (!(m %in% c("DESeq2.length", "DESeq2.length.factor")) || requireNamespace("DESeq2", quietly = TRUE)) {
      if (!(m %in% c("lengthNorm.limma.cor")) || requireNamespace("statmod", quietly = TRUE)) {
        if (!(m %in% c("lengthNorm.sva.limma", "lengthNorm.sva.limma.factor")) || requireNamespace("sva", quietly = TRUE)) {
          tmp <- readRDS(normalizePath(file.path(tdir, paste0("B_625_625_5spc_repl1_", m, ".rds")), winslash = "/"))

          expect_is(tmp, "phyloCompData")
          expect_is(result.table(tmp), "data.frame")
          expect_equal(nrow(result.table(tmp)), 489)
          expect_is(code(tmp), "character")
          expect_is(analysis.date(tmp), "character")
          expect_is(compcodeR:::package.version(tmp), "character")
          expect_is(method.names(tmp), "list")
          expect_named(method.names(tmp), c("short.name", "full.name"))

          tmp2 <- tmp; result.table(tmp2) <- result.table(tmp2)[1:10, ]; expect_equal(check_compData_results(tmp2), "result.table must have the same number of rows as count.matrix.")
          tmp2 <- tmp; result.table(tmp2) <- data.frame(); expect_equal(check_compData_results(tmp2), "Object must contain a data frame named 'result.table'.")
          tmp2 <- tmp; result.table(tmp2)$score <- NULL; expect_equal(check_compData_results(tmp2), "result.table must contain a column named 'score'.")
        }
      }
    }
  }

  for (m in methods) {
    if (!(m %in% c("DESeq2.length", "DESeq2.length.factor")) || requireNamespace("DESeq2", quietly = TRUE)) {
      if (!(m %in% c("lengthNorm.limma.cor")) || requireNamespace("statmod", quietly = TRUE)) {
        if (!(m %in% c("lengthNorm.sva.limma", "lengthNorm.sva.limma.factor")) || requireNamespace("sva", quietly = TRUE)) {
          generateCodeHTMLs(
            normalizePath(file.path(tdir, paste0("B_625_625_5spc_repl1_", m, ".rds")),
                          winslash = "/"), normalizePath(tdir)
          )
          expect_true(file.exists(normalizePath(file.path(
            tdir, paste0("B_625_625_5spc_repl1_",
                         m, "_code.html")), winslash = "/")))
        }
      }
    }
  }

  ## Comparison report
  file.table <- data.frame(input.files = normalizePath(file.path(
    tdir, paste0("B_625_625_5spc_repl1_",
                 methods[!(methods %in% c("DESeq2.length", "DESeq2.length.factor", "lengthNorm.limma.cor", "lengthNorm.sva.limma", "lengthNorm.sva.limma.factor"))],
                 ".rds")), winslash = "/"))
  parameters <- NULL

  comp <- runComparison(file.table = file.table, output.directory = tdir,
                        parameters = parameters, save.result.table = TRUE, knit.results = FALSE)
  ff <- list.files(path = tdir, pattern = "compcodeR_result_table_.*.rds", full.names = TRUE)
  resTable <- readRDS(ff[length(ff)])
  expect_equal(resTable$fp + resTable$tp + resTable$fn + resTable$tn, rep(489, nrow(resTable)))
  expect_equal(ncol(resTable), 14)
  expect_equal(nrow(resTable), length(methods) - 5)

  parameters <- list()
  par2 <- parameters; par2$incl.dataset <- "missing"
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with datasets")
  par2 <- parameters; par2$incl.nbr.samples <- 10
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with nbr.samples")
  par2 <- parameters; par2$incl.replicates <- 10
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with replicates")
  par2 <- parameters; par2$incl.de.methods <- "missing"
  expect_error(runComparison(file.table = file.table, output.directory = tdir,
                             parameters = par2),
               "No methods left to compare after matching with DE methods")
})

#' RNAseq data simulation, differential expression analysis and
#' performance comparison of differential expression methods
#'
#' This package provides extensive functionality for comparing
#' results obtained by different methods for differential expression analysis
#' of RNAseq data. It also contains functions for simulating count data and
#' interfaces to several packages for performing the differential expression analysis.
#' @name compcodeR-package
#' @aliases compcodeR
#' @docType package
#' @import knitr markdown ROCR lattice gplots gtools caTools grid KernSmooth MASS ggplot2 stringr modeest limma edgeR vioplot methods rmarkdown sm
#' @title RNAseq data simulation, differential expression analysis and
#' performance comparison of differential expression methods
#' @author Charlotte Soneson
#' @keywords package
NULL

# Generate a .Rmd file containing code to perform a comparison of differential
# expression methods
#
# A function to generate code that can be run to perform a comparison of the
# performance of several differential expression methods. The code is written to
# a .Rmd file. This function is generally not called by the user, the main
# interface for comparing differential expression methods is the
# \code{\link{runComparisonGUI}} function.
#
# @param setup.parameters List of parameters (internal).
# @param output.file The path to the file where the code will be written.
# @author Charlotte Soneson
createResultsRmdFile <- function(setup.parameters.file, output.file) {
  ## Check that the output file ends with .Rmd
  if (!(substr(output.file, nchar(output.file) - 3,
               nchar(output.file)) == ".Rmd")) {
    output.file <- sub(strsplit(output.file,
                                "\\.")[[1]][length(strsplit(output.file,
                                                            "\\.")[[1]])],
                       "Rmd",
                       output.file)
  }

  ## Open the output file
  resultfile <- file(output.file, open = "w")

  ## Load the setup parameters
  setup.parameters <- readRDS(setup.parameters.file)
  setup.parameters$incl.nbr.samples <-
    as.numeric(setup.parameters$incl.nbr.samples)
  setup.parameters$incl.replicates <-
    as.numeric(setup.parameters$incl.replicates)

  if (all(!is.na(setup.parameters$incl.nbr.samples))) {
    setup.parameters$incl.nbr.samples <-
      sort(setup.parameters$incl.nbr.samples)
  }
  if (all(!is.na(setup.parameters$incl.replicates))) {
    setup.parameters$incl.replicates <-
      sort(setup.parameters$incl.replicates)
  }

  ## Write the text that goes in the top of of the report (detailing which
  ## parameter values were used etc.)
  writeLines(c("```{r setup, echo = FALSE}",
               "options(width = 80)",
               "```"), resultfile)
  writeLines("# Comparison report, differential expression of RNAseq data", resultfile)
  writeLines(c(paste("Created by the compcodeR package, version",
                     packageVersion("compcodeR")),
               paste("Date:", date())
               ##               paste("Parameter file:", setup.parameters.file),
               ##               "```{r loadparam, echo = FALSE}",
               ##               paste("setup.parameters = readRDS('", setup.parameters.file, "')", sep = ""),
               ##               "```",
               ##paste("Data set:", setup.parameters$incl.dataset)
  ), resultfile, sep = "\n\n")
  writeLines("Data set:", resultfile)
  writeLines(c("```{r dataset, echo = FALSE}",
               "cat(setup.parameters$incl.dataset)",
               "```"), resultfile, sep = '\n')

  if (any(!is.na(setup.parameters$incl.nbr.samples))) {
    writeLines("Number of samples per condition:", resultfile)
    writeLines(c("```{r nsamples, echo = FALSE}",
                 "cat(sort(setup.parameters$incl.nbr.samples), sep = ', ')",
                 "```"), resultfile, sep = '\n')
  }
  if (any(!is.na(setup.parameters$incl.replicates))) {
    writeLines("Included replicates (for repeated simulated data sets):",
               resultfile)
    writeLines(c("```{r replicates, echo = FALSE}",
                 "cat(sort(setup.parameters$incl.replicates), sep = ', ')",
                 "```"), resultfile, sep = '\n')
  }
  writeLines("Differential expression methods included in the comparison:",
             resultfile)
  writeLines(c("```{r demethods, echo = FALSE}",
               "cat(setup.parameters$incl.de.methods, sep = '\n')",
               "```"), resultfile)

  writeLines("Parameter values:", resultfile)
  writeLines(c("```{r parametervalues, echo = FALSE}",
               "print(data.frame(value = unlist(setup.parameters[c('fdr.threshold', 'tpr.threshold', 'typeI.threshold', 'mcc.threshold', 'ma.threshold', 'fdc.maxvar', 'overlap.threshold', 'fracsign.threshold', 'nbrtpfp.threshold', 'signal.measure')])))",
               "```"), resultfile)

  writeLines(" ", resultfile, sep = "\n\n")

  ## Set some parameters for the plotting
  nbr.cols <- 3#min(3, length(setup.parameters$incl.replicates) + 1)
  nbr.rows <- ceiling((length(setup.parameters$incl.replicates) + 1)/nbr.cols)
  nbr.cols2 <- 3#min(3, length(setup.parameters$incl.de.methods))
  nbr.rows2 <- ceiling(length(setup.parameters$incl.de.methods)/nbr.cols2)
  kk1 <- length(setup.parameters$incl.de.methods) *
    length(setup.parameters$incl.nbr.samples)

  writeLines("## Contents", resultfile)
  if ('rocall' %in% setup.parameters$comparisons)
    writeLines("- [ROC curves, all replicates](#rocall)\n", resultfile)
  if ('rocone' %in% setup.parameters$comparisons)
    writeLines("- [ROC curves, single replicate](#rocone)\n", resultfile)
  if ('auc' %in% setup.parameters$comparisons)
    writeLines("- [Area under the ROC curve](#auc)\n", resultfile)
  if ('mcc' %in% setup.parameters$comparisons)
    writeLines("- [Matthew's correlation coefficient](#mcc)\n", resultfile)
  if ('fdcurvesall' %in% setup.parameters$comparisons)
    writeLines("- [False discovery curves, all replicates](#fdcurvesall)\n",
               resultfile)
  if ('fdcurvesone' %in% setup.parameters$comparisons)
    writeLines("- [False discovery curves, single replicate](#fdcurvesone)\n",
               resultfile)
  if ('maplot' %in% setup.parameters$comparisons)
    writeLines("- [MA plots, single replicate](#maplot)\n", resultfile)
  if ('scorevsexpr' %in% setup.parameters$comparisons)
    writeLines("- [Gene score vs average expression level, single replicate](#scorevsexpr)\n", resultfile)
  if ('scorevssignal' %in% setup.parameters$comparisons)
    writeLines("- [Gene score vs 'signal' for genes expressed in only one condition, all replicates](#scorevssignal)\n", resultfile)
  if ('scorevsoutlier' %in% setup.parameters$comparisons)
    writeLines("- [Score distribution vs number of outliers, single replicate](#scorevsoutlier)\n", resultfile)
  if ('fracsign' %in% setup.parameters$comparisons)
    writeLines("- [Fraction significant genes](#fracsign)\n", resultfile)
  if ('nbrsign' %in% setup.parameters$comparisons)
    writeLines("- [Number of significant genes](#nbrsign)\n", resultfile)
  if ('nbrtpfp' %in% setup.parameters$comparisons)
    writeLines("- [Number of TP, FP, TN, FN](#nbrtpfp)\n", resultfile)
  if ('typeIerror' %in% setup.parameters$comparisons)
    writeLines("- [Type I error](#typeIerror)\n", resultfile)
  if ('fdr' %in% setup.parameters$comparisons)
    writeLines("- [False discovery rate](#fdr)\n", resultfile)
  if ('fdrvsexpr' %in% setup.parameters$comparisons)
    writeLines("- [False discovery rate vs average expression level](#fdrvsexpr)\n", resultfile)
  if ('tpr' %in% setup.parameters$comparisons)
    writeLines("- [True positive rate](#tpr)\n", resultfile)
  if ('overlap' %in% setup.parameters$comparisons)
    writeLines("- [Overlap between sets of differentially expressed genes, single replicate](#overlap)\n", resultfile)
  if ('sorensen' %in% setup.parameters$comparisons)
    writeLines("- [Sorensen index between sets of differentially expressed genes, single replicate](#sorensen)\n", resultfile)
  if ('correlation' %in% setup.parameters$comparisons)
    writeLines("- [Spearman correlation between scores, single replicate](#correlation)\n", resultfile)
  writeLines(" ", resultfile)

  ## Include the actual results
  if ('rocall' %in% setup.parameters$comparisons) {
    writeLines("## ROC (receiver operating characteristic) curves [(Contents)](#contents)", resultfile)
    writeLines("A receiver operating characteristic (ROC) curve is a way to summarize the ability of a test or ranking procedure to rank truly positive (i.e., truly differentially expressed) genes ahead of truly negative (i.e., truly non-differentially expressed). To create the ROC curve for a given differential expression method, the genes are ranked in decreasing order by the score, which is assigned to them during the differential expression analysis and quantifies the degree of statistical significance or association with the predictor (the condition). For a given threshold, all genes with scores above the threshold are classified as 'positive' and all genes with scores below the threshold are classified as 'negative'. Comparing these assignments to the true differential expression status, a true positive rate and a false positive rate can be computed and marked in a plot. As the threshold is changed, these pairs of values trace out the ROC curve. A good test procedure gives a ROC curve which passes close to the upper left corner of the plot, while a poor test corresponds to a ROC curve close to the diagonal. \n", resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i],
                         " samples/condition [(Contents)](#contents)"), resultfile)
      }
      writeLines(c(paste("```{r rocall-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = ",
                         6*nbr.cols, ", fig.height = ",
                         6*nbr.rows, ", fig.align = 'center'}", sep = ""),
                   paste("makeROCcurves(setup.parameters, sel.nbrsamples = ",
                   setup.parameters$incl.nbr.samples[i], ", sel.repl =  c(", paste(intersect(setup.parameters$incl.replicates, setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)]), collapse = ", "), "))", sep = ""),
                   "```", " "), resultfile)
    }
  }

  if ('rocone' %in% setup.parameters$comparisons) {
    writeLines("## ROC curves, single replicate [(Contents)](#contents)", resultfile)
    writeLines("A receiver operating characteristic (ROC) curve is a way to summarize the ability of a test or ranking procedure to rank truly positive (i.e., truly differentially expressed) genes ahead of truly negative (i.e., truly non-differentially expressed). To create the ROC curve for a given differential expression method, the genes are ranked in decreasing order by the score, which is assigned to them during the differential expression analysis and quantifies the degree of statistical significance or association with the predictor (the condition). For a given threshold, all genes with scores above the threshold are classified as 'positive' and all genes with scores below the threshold are classified as 'negative'. Comparing these assignments to the true differential expression status, a true positive rate and a false positive rate can be computed and marked in a plot. As the threshold is changed, these pairs of values trace out the ROC curve. A good test procedure gives a ROC curve which passes close to the upper left corner of the plot, while a poor test corresponds to a ROC curve close to the diagonal. \n", resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i],
                         " samples/condition [(Contents)](#contents)"), resultfile)
      }
      writeLines(c(paste("```{r rocone-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 18, fig.height = 6, fig.align = 'left'}", sep = ""),
                   paste("makeROCcurves(setup.parameters, sel.nbrsamples = ",
                         setup.parameters$incl.nbr.samples[i], ", sel.repl = ",
                         mfv(setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)])[1], ")", sep = ""),
                   "```", " "), resultfile)
    }
  }

  if (any(c('auc', 'fdr', 'tpr', 'typeIerror', 'fracsign', 'nbrtpfp', 'nbrsign', 'mcc') %in% setup.parameters$comparisons)) {
    writeLines(c(paste("```{r tabl, eval = TRUE, include = TRUE}"),
                 "res.table = createResultTable(setup.parameters)"), resultfile)
    if (any(!is.na(setup.parameters$incl.nbr.samples))) {
      writeLines("res.table = padResultTable(res.table)", resultfile)
    }
    writeLines(c("```", " "), resultfile)
  }

  if ('auc' %in% setup.parameters$comparisons) {
    writeLines("## AUC [(Contents)](#contents)", resultfile)
    writeLines("A receiver operating characteristic (ROC) curve is a way to summarize the ability of a test or ranking procedure to rank truly positive (i.e., truly differentially expressed) genes ahead of truly negative (i.e., truly non-differentially expressed). To create the ROC curve for a given differential expression method, the genes are ranked in decreasing order by the score, which is assigned to them during the differential expression analysis and quantifies the degree of statistical significance or association with the predictor (the condition). For a given threshold, all genes with scores above the threshold are classified as 'positive' and all genes with scores below the threshold are classified as 'negative'. Comparing these assignments to the true differential expression status, a true positive rate and a false positive rate can be computed and marked in a plot. As the threshold is changed, these pairs of values trace out the ROC curve. A good test procedure gives a ROC curve which passes close to the upper left corner of the plot, while a poor test corresponds to a ROC curve close to the diagonal. The area under the ROC curve (AUC) summarizes the performance of the ranking procedure. A good method gives an AUC close to 1, while a poor method gives an AUC closer to 0.5. Each boxplot below summarizes the AUCs across all data set replicates included in the comparison. \n", resultfile)
    writeLines(c(paste("```{r auc, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height = ",
                       length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'auc')",
                 "```", " "), resultfile)
  }

  if ('mcc' %in% setup.parameters$comparisons) {
    writeLines("## Matthew's correlation coefficient [(Contents)](#contents)", resultfile)
    writeLines(paste0("Matthew's correlation coefficient is a measure summarizing the performance of a binary classifier, by combining the number of observed true positives, true negatives, false positives and false negatives into a single value. The correlation coefficient takes values between -1 and 1, where 1 corresponds to perfect classification and -1 corresponds to complete disagreement between the classification and the true labels. A value of 0 corresponds to random assignment. The figures below indicate the MCC obtained at an adjusted p-value threshold of ", setup.parameters$mcc.threshold, ". Only differential expression methods returning corrected p-values or FDR estimates are included in the figure. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n"), resultfile)
    writeLines(c(paste("```{r mcc, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height = ",
                       length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'mcc')",
                 "```", " "), resultfile)
  }

  if ('fdcurvesall' %in% setup.parameters$comparisons) {
    writeLines("## False discovery curves, all replicates [(Contents)](#contents)", resultfile)
    writeLines("A false discovery curve depicts the number of false positives encountered while stepping through a list of genes ranked by a score representing their statistical significance or the degree of association with a predictor. The truly differentially expressed genes are considered the 'true positives', and the truly non-differentially expressed genes the 'true negatives'. Hence, at a given position in the ranked list (shown on the x-axis) the value on the y-axis represents the number of truly non-differentially expressed genes that are ranked above that position. A good ranking method puts few true negatives among the top-ranked genes, and hence the false discovery curve rises slowly. A poor ranking method is recognized by a steeply increasing false discovery curve.\n", resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"),
                   resultfile)
      }
      writeLines(c(paste("```{r fdcall-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = ",
                         6*nbr.cols, ", fig.height = ", 6*nbr.rows, ", fig.align = 'left'}", sep = ""),
                   paste("makeFalseDiscoveryCurves(setup.parameters, sel.nbrsamples = ",
                         setup.parameters$incl.nbr.samples[i], ", sel.repl =  c(", paste(intersect(setup.parameters$incl.replicates, setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)]), collapse = ", "), "))", sep = ""),
                   "```", " "), resultfile)
    }
  }

  if ('fdcurvesone' %in% setup.parameters$comparisons) {
    writeLines("## False discovery curves, single replicate [(Contents)](#contents)", resultfile)
    writeLines("A false discovery curve depicts the number of false positives encountered while stepping through a list of genes ranked by a score representing their statistical significance or the degree of association with a predictor. The truly differentially expressed genes are considered the 'true positives', and the truly non-differentially expressed genes the 'true negatives'. Hence, at a given position in the ranked list (shown on the x-axis) the value on the y-axis represents the number of truly non-differentially expressed genes that are ranked above that position. A good ranking method puts few true negatives among the top-ranked genes, and hence the false discovery curve rises slowly. A poor ranking method is recognized by a steeply increasing false discovery curve.\n", resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"),
                   resultfile)
      }
      writeLines(c(paste("```{r fdcone-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 18, fig.height = 6, fig.align = 'left'}", sep = ""),
                   paste("makeFalseDiscoveryCurves(setup.parameters, sel.nbrsamples = ",
                         setup.parameters$incl.nbr.samples[i], ", sel.repl = ",
                         mfv(setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)])[1], ")"),
                   "```", " "), resultfile)
    }
  }

  if ('maplot' %in% setup.parameters$comparisons) {
    writeLines("## MA plots, single replicate [(Contents)](#contents)", resultfile)
    writeLines(paste("An MA plot depicts the average expression level of the genes ('A', shown on the x-axis) and their log-fold change between two conditions ('M', shown on the y-axis). The genes called differentially expressed at an adjusted p-value threshold of", setup.parameters$ma.threshold, "are marked in color.\n"), resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"),
                   resultfile)
      }
      writeLines(c(paste("```{r maplot-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = ",
                         6*nbr.cols2, ", fig.height = ", 6*nbr.rows2, ", fig.align = 'left'}", sep = ""),
                   paste("plotMASignificant(setup.parameters, sel.nbrsamples = ",
                         setup.parameters$incl.nbr.samples[i], ", sel.repl = ",
                         mfv(setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)])[1], ")"),
                   "```", " "), resultfile)
    }
  }

  if ('scorevsexpr' %in% setup.parameters$comparisons) {
    writeLines("## Gene score vs average expression level, single replicate [(Contents)](#contents)", resultfile)
    writeLines(paste("In the figures below the gene score, which is computed in the differential expression analysis (and stored in the 'score' field of the result object), is plotted against the average expression level of the genes ('A', shown on the x-axis). A high value of the score signifies a 'more significant' gene. The colored line represents a loess fit to the data.\n"), resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"),
                   resultfile)
      }
      writeLines(c(paste("```{r scorevsexpr-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = ",
                         6*nbr.cols2, ", fig.height = ", 6*nbr.rows2, ", fig.align = 'left'}", sep = ""),
                   paste("plotScoreVsExpr(setup.parameters, sel.nbrsamples = ",
                         setup.parameters$incl.nbr.samples[i], ", sel.repl = ",
                         mfv(setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)])[1], ")"),
                   "```", " "), resultfile)
    }
  }

  if ('scorevssignal' %in% setup.parameters$comparisons) {
    writeLines("## Gene score vs 'signal' for genes expressed in only one condition, all replicates [(Contents)](#contents)", resultfile)
    writeLines(paste("In the figures below the gene score, which is computed in the differential expression analysis (and stored in the 'score' field of the result object), is plotted against the 'signal', for genes that are expressed in only one of the two conditions. The signal (shown on the x-axis) is defined by computing the ", c("logarithm (base 2) of the normalized pseudo-counts for all samples in the condition where the gene is expressed, and averaging these values", "signal-to-noise ratio in the condition where the gene is expressed, i.e., first computing the logarithm (base 2) of the normalized pseudo-counts for all samples in this condition, and then computing the ratio between the mean and the standard deviation of these values")[match(setup.parameters$signal.measure, c("mean", "snr"))], ". A high value of the score (shown on the y-axis) signifies a gene that is more strongly associated with the predictor (the sample condition). We expect the methods to give higher scores to genes with stronger signal. The results from all dataset replicates included in the comparison are shown in the same plot, and the points are colored according to the data set replicate they originate from.\n"), resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"),
                   resultfile)
      }
      writeLines(c(paste("```{r scorevssignal-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = ",
                         6*nbr.cols2, ", fig.height = ", 6*nbr.rows2, ", fig.align = 'left'}", sep = ""),
                   paste("plotSignalForZeroCounts(setup.parameters, sel.nbrsamples = ",
                         setup.parameters$incl.nbr.samples[i], ", sel.repl =  c(", paste(intersect(setup.parameters$incl.replicates, setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)]), collapse = ", "), "))", sep = ""),
                   "```", " "), resultfile)
    }
  }

  if ('scorevsoutlier' %in% setup.parameters$comparisons) {
    writeLines("## Score distribution vs number of outliers, single replicate [(Contents)](#contents)", resultfile)
    writeLines("The violin plots below show the distribution of the score assigned to the genes by the differential expression methods, as a function of the number of 'outlier counts' (that is, extremely high or low counts introduced artificially in the data and not generated by the underlying statistical distribution) for the genes. All types of outliers are summed. This allows an investigation of the sensitivity of a differential expression method to outlier counts (deviations from the underlying statistical model). A method that is sensitive to outliers shows a different score distribution for genes with outlier counts than for genes without outlier counts. When interpreting the figures below, be observant on the number of genes generating each distribution (indicated below the figure), since an empirical distribution based on only a few values many not be completely representative of the true distribution.\n", resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"),
                   resultfile)
      }
      writeLines(c(paste("```{r scorevsoutlier-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = ",
                         6*nbr.cols2, ", fig.height = ", 6*nbr.rows2, ", fig.align = 'left'}", sep = ""),
                   paste("plotScoreVsOutliers(setup.parameters, sel.nbrsamples = ",
                         setup.parameters$incl.nbr.samples[i], ", sel.repl = ",
                         mfv(setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)])[1], ")"),
                   "```", " "), resultfile)
    }
  }


  if ('fracsign' %in% setup.parameters$comparisons) {
    writeLines("## Fraction significant [(Contents)](#contents)", resultfile)
    writeLines(paste("The figures below indicate the fraction of genes in the data set that are called significant at an adjusted p-value threshold of ", setup.parameters$fracsign.threshold,". Only differential expression methods returning corrected p-values or FDR estimates are included in the figure. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n",
                     sep = ''), resultfile)
    writeLines(c(paste("```{r fracsign, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height =", length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'fracsign')",
                 "```", " "), resultfile)
  }

  if ('nbrsign' %in% setup.parameters$comparisons) {
    writeLines("## Number of significant genes [(Contents)](#contents)", resultfile)
    writeLines(paste("The figures below indicate the number of genes in the data set that are called significant at an adjusted p-value threshold of ", setup.parameters$fracsign.threshold,". Only differential expression methods returning corrected p-values or FDR estimates are included in the figure. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n",
                     sep = ''), resultfile)
    writeLines(c(paste("```{r nbrsign, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height =", length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'nbrsign')",
                 "```", " "), resultfile)
  }

  if ('nbrtpfp' %in% setup.parameters$comparisons) {
    writeLines("## Number of true positives [(Contents)](#contents)", resultfile)
    writeLines(paste("The figures below indicate the number of true positive genes found at an adjusted p-value threshold of ", setup.parameters$nbrtpfp.threshold,". Only differential expression methods returning corrected p-values or FDR estimates are included in the figure. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n",
                     sep = ''), resultfile)
    writeLines(c(paste("```{r nbrtp, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height =", length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'tp')",
                 "```", " "), resultfile)

    writeLines("## Number of false positives [(Contents)](#contents)", resultfile)
    writeLines(paste("The figures below indicate the number of false positive genes found at an adjusted p-value threshold of ", setup.parameters$nbrtpfp.threshold,". Only differential expression methods returning corrected p-values or FDR estimates are included in the figure. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n",
                     sep = ''), resultfile)
    writeLines(c(paste("```{r nbrfp, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height =", length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'fp')",
                 "```", " "), resultfile)

    writeLines("## Number of true negatives [(Contents)](#contents)", resultfile)
    writeLines(paste("The figures below indicate the number of true negative genes found at an adjusted p-value threshold of ", setup.parameters$nbrtpfp.threshold,". Only differential expression methods returning corrected p-values or FDR estimates are included in the figure. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n",
                     sep = ''), resultfile)
    writeLines(c(paste("```{r nbrtn, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height =", length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'tn')",
                 "```", " "), resultfile)

    writeLines("## Number of false negatives [(Contents)](#contents)", resultfile)
    writeLines(paste("The figures below indicate the number of false negative genes found at an adjusted p-value threshold of ", setup.parameters$nbrtpfp.threshold,". Only differential expression methods returning corrected p-values or FDR estimates are included in the figure. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n",
                     sep = ''), resultfile)
    writeLines(c(paste("```{r nbrfn, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height =", length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'fn')",
                 "```", " "), resultfile)
  }

  if ('typeIerror' %in% setup.parameters$comparisons) {
    writeLines("## Type I error [(Contents)](#contents)", resultfile)
    writeLines(paste("The nominal p-value returned by a statistical test indicate the probability of obtaining a value of the test statistic which is at least as extreme as the one observed, given that the null hypothesis is true, e.g., that the gene is not differentially expressed between the compared conditions. Classifying a gene as statistically significantly differentially expressed although it is not truly differentially expressed is referred to as a type I error. For a good statistical test, we expect that the observed type I error rate at a given nominal p-value threshold (that is, the fraction of truly non-differentially expressed genes with a nominal p-value below this threshold) does not exceed the threshold. The figures below show the observed type I error rate at a nominal p-value threshold of ", setup.parameters$typeI.threshold, ". Only differential expression methods returning nominal p-values are included in the comparison. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n", sep = ''), resultfile)
    writeLines(c(paste("```{r typeIerror, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height =", length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'typeIerror')",
                 "```", " "), resultfile)
  }

  if ('fdr' %in% setup.parameters$comparisons) {
    writeLines("## FDR [(Contents)](#contents)", resultfile)
    writeLines(paste("The false discovery rate (FDR) indicates the fraction of truly non-differentially expressed genes that we expect to find among the genes that we consider to be differentially expressed. For high-dimensional problems, where many statistical tests are performed simultaneously (such as gene expression studies) it is more relevant to attempt to control the FDR than to control the gene-wise type I error rate, since it is almost certain that at least one gene will show a low nominal p-value even if the null hypothesis is true. To control the FDR, typically, the nominal p-values are adjusted for the large number of tests that are performed. The figures below indicate the observed rate of false discoveries (i.e., the fraction of truly non-differentially expressed genes among the genes that are considered significant) at an adjusted p-value threshold of ", setup.parameters$fdr.threshold,". Only methods returning corrected p-values or FDR estimates are included. Each boxplot summarizes the values obtained across all data set replicates that are included in the comparison. For a good method, the observed FDR should not be too high above the imposed adjusted p-value threshold (indicated by a dashed vertical line). If the observed FDR is much larger than the imposed adjusted p-value threshold, the fraction of false discoveries is not controlled at the claimed level. \n", sep = ''), resultfile)
    writeLines(c(paste("```{r fdr, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height =", length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'fdr')",
                 "```", " "), resultfile)
  }

  if ('fdrvsexpr' %in% setup.parameters$comparisons) {
    writeLines("## FDR vs average expression level [(Contents)](#contents)", resultfile)
    writeLines(paste("The figures below show the observed false discovery rate as a function of the the average expression level of the genes ('A', shown on the x-axis). The average expression levels in a given data set are binned into 10 quantiles (each containing 1/10 of the values) and the false discovery rate at an imposed adjusted p-value cutoff of ", setup.parameters$fdr.threshold, "is estimated for each bin. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n"), resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"),
                   resultfile)
      }
      writeLines(c(paste("```{r fdrvsexpr-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = ",
                         6*nbr.cols2, ", fig.height = ", 6*nbr.rows2, ", fig.align = 'left'}", sep = ""),
                   paste("plotFDRVsExpr(setup.parameters, sel.nbrsamples = ",
                         setup.parameters$incl.nbr.samples[i], ", sel.repl =  c(", paste(intersect(setup.parameters$incl.replicates, setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)]), collapse = ", "), "))", sep = ""),
                   "```", " "), resultfile)
    }
  }

  if ('tpr' %in% setup.parameters$comparisons) {
    writeLines("## TPR [(Contents)](#contents)", resultfile)
    writeLines(paste("The true positive rate (TPR) indicates the fraction of truly non-differentially expressed genes that are indeed considered significant by a method at a given significance threshold. A good method gives a high true positive rate, while at the same time keeping the false discovery rate under control. The figures below show the observed rate of true positives at an adjusted p-value threshold of ", setup.parameters$tpr.threshold,". Only methods returning corrected p-values or FDR estimates are included. Each boxplot summarizes the values obtained across all data set replicates included in the comparison.\n", sep = ''), resultfile)
    writeLines(c(paste("```{r tpr, dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 14, fig.height =", length(setup.parameters$incl.nbr.samples) + 0.65*kk1, ", fig.align = 'left'}"),
                 "plotResultTable(setup.parameters, res.table, 'tpr')",
                 "```", " "), resultfile)
  }

  if ('overlap' %in% setup.parameters$comparisons) {
    writeLines("## Overlap, single replicate [(Contents)](#contents)", resultfile)
    writeLines(paste("The table below shows, for each pair of differential expression methods, the number of genes that are considered statistically significant by both of them at an adjusted p-value threshold of ",setup.parameters$overlap.threshold,". Only methods returning corrected p-values or FDR estimates are included in the comparison. Note that the size of the overlap between two sets naturally depends on the number of genes in each of the sets (indicated along the diagonal of the table).\n", sep = ''), resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        idx <- which(setup.parameters$file.info$nbr.samples == setup.parameters$incl.nbr.samples[i])
      } else {
        idx <- which(is.na(setup.parameters$file.info$nbr.samples))
      }
      if (length(unique(setup.parameters$file.info$de.methods[idx])) > 1) {
        if (any(!is.na(setup.parameters$incl.nbr.samples))) {
          writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"), resultfile)
        }
        writeLines(c(paste("```{r overlap-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = 10, fig.height = 10, fig.align = 'left'}", sep = ""),
##                     "options(width = 200)",
                     paste("computeOverlap(setup.parameters, sel.nbrsamples = ", setup.parameters$incl.nbr.samples[i], ", sel.repl = ", mfv(setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)])[1], ", plot.type = 'Overlap')"),
                     "```", " "), resultfile)
      }
    }
  }

  if ('sorensen' %in% setup.parameters$comparisons) {
    writeLines("## Sorensen index, single replicate [(Contents)](#contents)", resultfile)
    writeLines(paste("The table below shows, for each pair of differential expression methods, the Sorensen index, which is a way of quantifying the overlap between the collections of differentially expressed genes found by the two methods at an adjusted p-value threshold of ", setup.parameters$overlap.threshold,".Only methods returning corrected p-values or FDR estimates are included. The Sorensen index is defined as the ratio between the number of genes shared by the two sets and the average number of genes in the two sets. Hence, it always attains values between 0 and 1. A larger Sorensen index implies better overlap between the two sets, and hence that the two compared methods give similar differential expression results. The values of the Sorensen index for all pairs of compared methods are also visualized in a 'heatmap', where the color corresponds to Sorensen index.\n", sep = ''), resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        idx <- which(setup.parameters$file.info$nbr.samples == setup.parameters$incl.nbr.samples[i])
      } else {
        idx <- which(is.na(setup.parameters$file.info$nbr.samples))
      }
      if (length(unique(setup.parameters$file.info$de.methods[idx])) > 1) {
        if (any(!is.na(setup.parameters$incl.nbr.samples))) {
          writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"), resultfile)
        }
        writeLines(c(paste("```{r sorensen-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = ", length(setup.parameters$incl.de.methods) + 3, ", fig.height = ", length(setup.parameters$incl.de.methods) + 3, ", fig.align = 'left'}", sep = ""),
                     paste("computeOverlap(setup.parameters, sel.nbrsamples = ", setup.parameters$incl.nbr.samples[i], ", sel.repl = ", mfv(setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, y = setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)])[1], ", plot.type = 'Sorensen')"),
                     "```", " "), resultfile)
      }
    }
  }

  if ('correlation' %in% setup.parameters$comparisons) {
    writeLines("## Spearman correlation between scores [(Contents)](#contents)", resultfile)
    writeLines("The table below shows, for each pair of compared differential expression methods, the Spearman correlation between the scores that they assign to the genes. The value of the correlation is always between -1 and 1, and a high positive value of the Spearman correlation indicates that the compared methods rank the genes in a similar fashion. The results are also shown in a 'heatmap', where the color indicates the Spearman correlation. Finally, the methods are clustered using hierarchical clustering, with a dissimilarity measure defined as 1 - Spearman correlation. This visualizes the relationships among the compared differential expression methods, and groups together methods that rank the genes similarly.\n", resultfile)
    for (i in seq_len(length(setup.parameters$incl.nbr.samples))) {
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        idx <- which(setup.parameters$file.info$nbr.samples == setup.parameters$incl.nbr.samples[i])
      } else {
        idx <- which(is.na(setup.parameters$file.info$nbr.samples))
      }
      if (any(!is.na(setup.parameters$incl.nbr.samples))) {
        writeLines(paste("####", setup.parameters$incl.nbr.samples[i], " samples/condition [(Contents)](#contents)"), resultfile)
      }
      writeLines(c(paste("```{r correlation-", i, ", dev = c('png', 'pdf'), eval = TRUE, include = TRUE, fig.width = ", length(setup.parameters$incl.de.methods) + 3, ", fig.height = ", length(setup.parameters$incl.de.methods) + 3, ", fig.align = 'left'}", sep = ""),
                   paste("computeCorrelation(setup.parameters, sel.nbrsamples = ", setup.parameters$incl.nbr.samples[i], ", sel.repl = ", mfv(setup.parameters$file.info$repl[vapply(setup.parameters$file.info$nbr.samples, identical, setup.parameters$incl.nbr.samples[i], FUN.VALUE = FALSE)])[1], ")"),
                   "```", " "), resultfile)
    }
  }

  close(resultfile)
}

checkClass <- function(object, objname, trueclass) {
  if (!(is(object, trueclass))) {
    stop(paste("The object", objname, "should be of class", trueclass))
  }
}

#' A GUI to the main function for running the performance comparison between differential expression methods.
#'
#' This function provides a GUI to the main function for performing comparisons among differential expression methods and generating a report in HTML format (\code{\link{runComparison}}). It is assumed that all differential expression results have been generated in advance (using e.g. the function \code{\link{runDiffExp}}) and that the result \code{compData} object for each data set and each differential expression method is saved separately in files with the extension \code{.rds}. The function opens a graphical user interface where the user can set parameter values and choose the files to be used as the basis of the comparison. It is, however, possible to circumvent the GUI and call the comparison function \code{\link{runComparison}} directly.
#'
#' This function requires that the \code{rpanel} package is installed. If this package can not be installed, please use the \code{\link{runComparison}} function directly.
#'
#' @param input.directories A list of directories containing the result files (\code{*.rds}). All results in the provided directories will be available for inclusion in the comparison, and the selection is performed through a graphical user interface. All result objects saved in the files should be of the \code{compData} class, although list objects created by earlier versions of \code{compcodeR} are supported.
#' @param output.directory The directory where the results should be written. The subdirectory structure will be created automatically. If the directory already exists, it will be overwritten.
#' @param recursive A logical parameter indicating whether or not the search should be extended recursively to subfolders of the \code{input.directories}.
#' @param out.width The width of the figures in the final report. Will be passed on to \code{knitr} when the HTML is generated. Can be for example "800px" (see \code{knitr} documentation for more information)
#' @param upper.limits,lower.limits Lists that can be used to manually set upper and lower limits for boxplots of fdr, tpr, auc, mcc, fracsign, nbrtpfp, nbrsign and typeIerror.
#' @return
#' The function will create a comparison report, named \strong{compcodeR_report<timestamp>.html}, in the \code{output.directory}. It will also create subfolders named \code{compcodeR_code} and \code{compcodeR_figure}, where the code used to perform the differential expression analysis and the figures contained in the report, respectively, will be saved. Note that if these directories already exist they will be overwritten.
#' @export
#' @author Charlotte Soneson
#' @examples
#' if (interactive()) {
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 12500,
#'                                     samples.per.cond = 5, n.diffexp = 1250,
#'                                     output.file = "mydata.rds")
#' runDiffExp(data.file = "mydata.rds", result.extent = "voom.limma",
#'            Rmdfunction = "voom.limma.createRmd", output.directory = ".",
#'            norm.method = "TMM")
#' runDiffExp(data.file = "mydata.rds", result.extent = "ttest",
#'            Rmdfunction = "ttest.createRmd", output.directory = ".",
#'            norm.method = "TMM")
#' runComparisonGUI(input.directories = ".", output.directory = ".", recursive = FALSE)
#' }
#nocov start
runComparisonGUI <- function(input.directories, output.directory, recursive,
                             out.width = NULL, upper.limits = NULL, lower.limits = NULL) {
  if (!requireNamespace("rpanel")) stop("To use the GUI you must install the rpanel package. If it is not possible to install the package on your system, please use the runComparison() function instead.")
  checkClass(input.directories, "input.directories", "character")
  checkClass(output.directory, "output.directory", "character")
  checkClass(recursive, "recursive", "logical")

  ## Get the absolute path of the input directories
  if (is.null(input.directories)) {
    stop("You have to provide at least one input directory!")
  } else {
    input.directories <- normalizePath(input.directories, winslash = "/")
  }

  if (is.null(output.directory)) {
    stop("You have to provide an output directory!")
  } else if (length(output.directory) != 1) {
    stop("Please provide precisely one output directory.")
  } else {
    output.directory <- normalizePath(output.directory, winslash = "/")
  }

  ## List all rds files in the input directories
  input.files.temp <- NULL
  for (input.directory in input.directories) {
    input.files.temp <- union(input.files.temp, file.path(input.directory,
                                                          list.files(input.directory,
                                                                     recursive = recursive,
                                                                     pattern = "*.rds$")))
  }
  input.files.temp <- normalizePath(input.files.temp, winslash = "/")
  if (length(input.files.temp) == 0) {
    stop("No .rds files in the input directory")
  }

  ## Go through the files in the input.directories and see which
  ## datasets are available.
  suppressWarnings({
    datasets <- NULL
    input.files <- NULL
    for (input.file in input.files.temp) {
      temp.input <- readRDS(input.file)
      ## Check if compatible list, then convert to compData object
      if (is.list(temp.input)) {
        temp.input <- convertListTocompData(temp.input)
      }
      ## Keep only the result files (no data files or other things).
      if (is.logical(check_compData_results(temp.input))) {
        datasets <- c(datasets, info.parameters(temp.input)$dataset)
        input.files <- c(input.files, input.file)
      }
    }
    avail.datasets <- c('', unique(datasets))
  })

  if (length(avail.datasets) == 1) {
    stop("No result .rds files in the input directory")
  }

  ## Create the GUI for selecting the data set
  dataset.panel <- rpanel::rp.control(title = "Select data set",
                                      panelname = "dataset.panel",
                                      incl.dataset = avail.datasets[1],
                                      fdr.threshold = 0.05,
                                      tpr.threshold = 0.05,
                                      mcc.threshold = 0.05,
                                      typeI.threshold = 0.05,
                                      fdc.maxvar = 1500,
                                      overlap.threshold = 0.05,
                                      fracsign.threshold = 0.05,
                                      nbrtpfp.threshold = 0.05,
                                      ma.threshold = 0.05,
                                      signal.measure = "mean",
                                      input.files = input.files,
                                      datasets = datasets,
                                      avail.datasets = avail.datasets,
                                      output.directory = output.directory,
                                      out.width = out.width,
                                      upper.limits = upper.limits,
                                      lower.limits = lower.limits)

  ## Create the radiobutton for selecting a data set
  combo.dataset <- rpanel::rp.combo(dataset.panel,
                                    variable = "incl.dataset",
                                    action = I,
                                    vals = avail.datasets,
                                    initval = avail.datasets[1],
                                    prompt = "Data set",
                                    pos = list("row" = 1, "column" = 1))

  go.button <- rpanel::rp.button(dataset.panel, action = function(panel) {
    ## Go through all input files corresponding to the chosen data set, and record the
    ## available nbrsamples/repl/de methods
    panel$input.files <- panel$input.files[panel$datasets == panel$incl.dataset]
    panel$datasets <- panel$datasets[panel$datasets == panel$incl.dataset]
    suppressWarnings({
      nbr.samples <- NULL
      repl <- NULL
      de.methods <- NULL
      for (input.file in panel$input.files) {
        temp.input <- readRDS(input.file)
        if (is.list(temp.input)) temp.input <- convertListTocompData(temp.input)
        nbr.samples <- c(nbr.samples, ifelse(is.null(info.parameters(temp.input)$samples.per.cond),
                                             NA_real_, info.parameters(temp.input)$samples.per.cond))
        repl <- c(repl, ifelse(is.null(info.parameters(temp.input)$repl.id),
                               NA_real_, info.parameters(temp.input)$repl.id))
        de.methods <- c(de.methods, ifelse(is.null(method.names(temp.input)$full.name),
                                           NA_character_, method.names(temp.input)$full.name))
      }
      avail.nbr.samples <- sort(as.numeric(unique(nbr.samples)))  # numeric(0) if all are NA
      avail.repl <- sort(as.numeric(unique(repl)))  # numeric(0) if all are NA
      avail.de.methods <- setdiff(unique(de.methods), c(NA_character_))
    })
    panel$avail.nbr.samples <- avail.nbr.samples
    panel$avail.repl <- avail.repl
    panel$avail.de.methods <- avail.de.methods
    panel$nbr.samples <- nbr.samples
    panel$repl <- repl
    panel$de.methods <- de.methods
    createSelectionPanel(panel)
    return(panel)
  }, quitbutton = TRUE, title = "Continue", pos = list("row" = 2, "column" = 2))
}
#nocov end

# Create the user interface for selecting parameters for the method comparison
#
# Launch the user interface for selecting the parameters that govern the comparison of differential expression methods. This function will be called when pressing the "Continue" button in the interface for selecting the data set. This function will not be called directly by the user.
#
# @param panel An rpanel
# @author Charlotte Soneson
#nocov start
createSelectionPanel = function(panel) {
  ###########################################
  ## Create the GUI for setting parameters ##
  ###########################################

  ## Define the set of possible comparison methods
  comparisons <- c("AUC", "ROC, one replicate", "ROC, all replicates",
                   "Type I error", "FDR",
                   "FDR vs average expression level",
                   "TPR", "MCC", "Number significant",
                   "Number of TP, FP, TN, FN",
                   "False discovery curves, one replicate",
                   "False discovery curves, all replicates",
                   "Fraction significant", "Overlap, one replicate",
                   "MA plot", "Gene score vs average expression level",
                   "Gene score vs signal for condition-specific genes",
                   "Score distribution vs number of outliers",
                   "Spearman correlation between scores",
                   "Sorensen index, one replicate")

  ## Create the main panel window
  if (length(panel$avail.nbr.samples) != 0) {
    incl.nbr.samples <- rep(TRUE, length(panel$avail.nbr.samples))
  } else {
    incl.nbr.samples <- NULL
  }
  if (length(panel$avail.repl) != 0) {
    incl.repl <- rep(TRUE, length(panel$avail.repl))
  } else {
    incl.repl <- NULL
  }
  main.panel <- rpanel::rp.control(title = "Set parameters",
                                   panelname = "main.panel",
                                   incl.nbr.samples = incl.nbr.samples,
                                   incl.replicates = incl.repl,
                                   incl.de.methods = rep(TRUE, length(panel$avail.de.methods)),
                                   incl.dataset = panel$incl.dataset,
                                   fdr.threshold = panel$fdr.threshold,
                                   tpr.threshold = panel$tpr.threshold,
                                   mcc.threshold = panel$mcc.threshold,
                                   typeI.threshold = panel$typeI.threshold,
                                   fdc.maxvar = panel$fdc.maxvar,
                                   ma.threshold = panel$ma.threshold,
                                   signal.measure = panel$signal.measure,
                                   overlap.threshold = panel$overlap.threshold,
                                   fracsign.threshold = panel$fracsign.threshold,
                                   nbrtpfp.threshold = panel$nbrtpfp.threshold,
                                   comparisons = rep(TRUE, length(comparisons)),
                                   input.files = panel$input.files,
                                   nbr.samples = panel$nbr.samples,
                                   repl = panel$repl,
                                   de.methods = panel$de.methods,
                                   datasets = panel$datasets,
                                   output.directory = panel$output.directory,
                                   out.width = panel$out.width,
                                   upper.limits = panel$upper.limits,
                                   lower.limits = panel$lower.limits)

  ## Create the checkboxes for selecting the number of samples
  if (length(panel$avail.nbr.samples) != 0) {
    checkbox.incl.nbr.samples <-
      rpanel::rp.checkbox(main.panel,
                          variable = "incl.nbr.samples",
                          action = I,
                          labels = panel$avail.nbr.samples,
                          initval = labels %in% main.panel$incl.nbr.samples,
                          title = "Number of samples",
                          pos = list("row" = 3, "column" = 2,
                                     "rowspan" = length(panel$avail.nbr.samples)))
  }

  ## Create the checkboxes for selecting the replicates to include
  if (length(panel$avail.repl) != 0) {
    checkbox.repl <-
      rpanel::rp.checkbox(main.panel,
                          variable = "incl.replicates",
                          action = I,
                          labels = panel$avail.repl,
                          initval = labels %in% main.panel$incl.replicates,
                          title = "Replicates",
                          pos = list("row" = 2, "column" = 2))
  }

  ## Create a checkbox for selecting the DE methods to include
  checkbox.de.methods <-
    rpanel::rp.checkbox(main.panel,
                        variable = "incl.de.methods",
                        action = I,
                        labels = panel$avail.de.methods,
                        initval = labels %in% main.panel$incl.de.methods,
                        title = "DE methods",
                        pos = list("row" = 2, "column" = 1))

  ## Create a checkbox for selecting the comparison methods to include
  checkbox.comparisons <-
    rpanel::rp.checkbox(main.panel,
                        variable = "comparisons",
                        action = I,
                        labels = comparisons,
                        initval = labels %in% main.panel$comparisons,
                        title = "Comparisons",
                        pos = list("row" = 2, "column" = 3))

  ## Create a text field for entering the adjusted p-value threshold
  ## used for the FDR analysis
  text.fdr.threshold <-
    rpanel::rp.textentry(main.panel,
                         variable = "fdr.threshold",
                         action = I,
                         labels = "Adjusted p-value threshold for FDR",
                         initval = main.panel$fdr.threshold,
                         title = "",
                         pos = list("row" = 3, "column" = 1))

  ## Create a text field for entering the adjusted p-value threshold
  ## used for the TPR analysis
  text.tpr.threshold <-
    rpanel::rp.textentry(main.panel,
                         variable = "tpr.threshold",
                         action = I,
                         labels = "Adjusted p-value threshold for TPR",
                         initval = main.panel$tpr.threshold,
                         title = "",
                         pos = list("row" = 4, "column" = 1))

  ## Create a text field for entering the adjusted p-value threshold
  ## used for the MCC analysis
  text.mcc.threshold <-
    rpanel::rp.textentry(main.panel,
                         variable = "mcc.threshold",
                         action = I,
                         labels = "Adjusted p-value threshold for MCC",
                         initval = main.panel$mcc.threshold,
                         title = "",
                         pos = list("row" = 4, "column" = 1))

  ## Create a text field for entering the nominal p-value threshold
  ## used for the type I error analysis
  text.typeI.threshold <-
    rpanel::rp.textentry(main.panel,
                         variable = "typeI.threshold",
                         action = I,
                         labels = "Nominal p-value threshold for type I error",
                         initval = main.panel$typeI.threshold,
                         title = "",
                         pos = list("row" = 5, "column" = 1))

  ## Create a text field for entering the maximal number of variables
  ## to use in the false discovery curves
  text.fdc.maxvar <-
    rpanel::rp.textentry(main.panel,
                         variable = "fdc.maxvar",
                         action = I,
                         labels = "Maximal number of top variables in false discovery curves",
                         initval = main.panel$fdc.maxvar,
                         title = "",
                         pos = list("row" = 6, "column" = 1))

  ## Create a text field for entering the adjusted p-value threshold
  ## for overlap analysis
  text.overlap.threshold <-
    rpanel::rp.textentry(main.panel,
                         variable = "overlap.threshold",
                         action = I,
                         labels = "Adjusted p-value threshold for overlap analysis",
                         initval = main.panel$overlap.threshold,
                         title = "",
                         pos = list("row" = 7, "column" = 1))

  ## Create a text field for entering the adjusted p-value threshold
  ## for analysis of the fraction of significant variables
  text.fracsign.threshold <-
    rpanel::rp.textentry(main.panel,
                         variable = "fracsign.threshold",
                         action = I,
                         labels = "Adjusted p-value threshold for analysis of fraction significant variables",
                         initval = main.panel$fracsign.threshold,
                         title = "",
                         pos = list("row" = 8, "column" = 1))

  ## Create a text field for entering the adjusted p-value threshold
  ## for analysis of the number of TP, FP, TN, FN
  text.nbrtpfp.threshold <-
    rpanel::rp.textentry(main.panel,
                         variable = "nbrtpfp.threshold",
                         action = I,
                         labels = "Adjusted p-value threshold for analysis of the number of TP, FP, TN, FN variables",
                         initval = main.panel$nbrtpfp.threshold,
                         title = "",
                         pos = list("row" = 9, "column" = 1))

  ## Create a text field for entering the adjusted p-value threshold
  ## for coloring MA plots
  text.ma.threshold <-
    rpanel::rp.textentry(main.panel,
                         variable = "ma.threshold",
                         action = I,
                         labels = "Adjusted p-value threshold for coloring of genes in MA plots",
                         initval = main.panel$ma.threshold,
                         title = "",
                         pos = list("row" = 10, "column" = 1))

  ## Create a radiobutton to select the signal measure
  combo.signal.measure <- rpanel::rp.combo(main.panel,
                                           variable = "signal.measure",
                                           action = I,
                                           vals = c("mean", "snr"),
                                           initval = main.panel$signal.measure,
                                           prompt = "Signal measure for condition-specific genes",
                                           pos = list("row" = 11, "column" = 1))

  ## Create the "OK" button that runs the comparison
  ok.button <-
    rpanel::rp.button(main.panel, action = performComparison,
                      title = "Run comparison",
                      quitbutton = TRUE,
                      pos = list("row" = 3, "column" = 3, "rowspan" = 1))

  ## Create the "Close" button
  close.button <-
    rpanel::rp.button(main.panel, action = function(panel){return(panel)},
                      title = "Cancel", quitbutton = TRUE,
                      pos = list("row" = 4, "column" = 3, "rowspan" = 1))

  #rp.block(main.panel)
}
#nocov end

checkRange <- function(value, parname, minvalue, maxvalue) {
  if (is.na(as.numeric(value))) {
    stop(paste("Illegal value for parameter", parname))
  } else {
    newvalue <- as.numeric(value)
    if (newvalue < minvalue) newvalue <- minvalue
    if (newvalue > maxvalue) newvalue <- maxvalue
  }
  return(newvalue)
}

# Run the comparison of differential expression methods
#
# This function will be launched when pressing the "Run comparison" button in the parameter selection user interface. It will not be called directly by the user.
#
# @param panel An rpanel
# @author Charlotte Soneson
#nocov start
performComparison <- function(panel) {
  message("Be patient, your analysis is running...")

  ## Extract all parameters from the panel object
  suppressWarnings({
    if (length(panel$incl.nbr.samples) == 1) {
      names(panel$incl.nbr.samples) <-
        unique(panel$nbr.samples[!is.na(panel$nbr.samples)])
    }
    if (length(panel$incl.replicates) == 1) {
      names(panel$incl.replicates) <- unique(panel$repl[!is.na(panel$repl)])
    }
    if (length(panel$incl.de.methods) == 1) {
      names(panel$incl.de.methods) <- unique(panel$de.methods)
    }
    parameters <- list(incl.nbr.samples = as.numeric(names(which(panel$incl.nbr.samples == TRUE))),
                       incl.replicates = as.numeric(names(which(panel$incl.replicates == TRUE))),
                       incl.dataset = panel$incl.dataset,
                       incl.de.methods = names(which(panel$incl.de.methods == TRUE)),
                       fdr.threshold = as.numeric(panel$fdr.threshold),
                       tpr.threshold = as.numeric(panel$tpr.threshold),
                       mcc.threshold = as.numeric(panel$mcc.threshold),
                       typeI.threshold = as.numeric(panel$typeI.threshold),
                       ma.threshold = as.numeric(panel$ma.threshold),
                       fdc.maxvar = as.numeric(panel$fdc.maxvar),
                       signal.measure = as.character(panel$signal.measure),
                       overlap.threshold = as.numeric(panel$overlap.threshold),
                       fracsign.threshold = as.numeric(panel$fracsign.threshold),
                       nbrtpfp.threshold = as.numeric(panel$nbrtpfp.threshold),
                       upper.limits = panel$upper.limits,
                       lower.limits = panel$lower.limits,
                       comparisons = names(which(panel$comparisons == TRUE)))
    nbr.samples <- as.numeric(panel$nbr.samples)
    repl <- as.numeric(panel$repl)
    de.methods <- panel$de.methods
    datasets <- panel$datasets
    input.files <- panel$input.files
    output.directory <- panel$output.directory
    out.width <- panel$out.width
  })

  ## Check ranges etc for thresholds
  parameters$fdr.threshold <- checkRange(parameters$fdr.threshold, "fdr.treshold", 0, 1)
  parameters$tpr.threshold <- checkRange(parameters$tpr.threshold, "tpr.threshold", 0, 1)
  parameters$mcc.threshold <- checkRange(parameters$mcc.threshold, "mcc.threshold", 0, 1)
  parameters$typeI.threshold <- checkRange(parameters$typeI.threshold, "typeI.threshold", 0, 1)
  parameters$ma.threshold <- checkRange(parameters$ma.threshold, "ma.threshold", 0, 1)
  parameters$overlap.threshold <- checkRange(parameters$overlap.threshold, "overlap.threshold", 0, 1)
  parameters$fracsign.threshold <- checkRange(parameters$fracsign.threshold, "fracsign.threshold", 0, 1)
  parameters$nbrtpfp.threshold <- checkRange(parameters$nbrtpfp.threshold, "nbrtpfp.threshold", 0, 1)

  ## Transform the names of the comparisons to make
  parameters$comparisons <- shorten.method.names(parameters$comparisons)

  ## Run the comparison
  file.table <- data.frame(input.files = input.files,
                           datasets = datasets,
                           nbr.samples = nbr.samples,
                           repl = repl,
                           de.methods = de.methods,
                           stringsAsFactors = FALSE)
  runComparison(file.table, parameters,
                output.directory, check.table = FALSE,
                out.width = out.width)

  return(panel)
}
#nocov end

#' Run the performance comparison between differential expression methods.
#'
#' The main function for performing comparisons among differential expression methods and generating a report in HTML format. It is assumed that all differential expression results have been generated in advance (using e.g. the function \code{\link{runDiffExp}}) and that the result \code{compData} object for each data set and each differential expression method is saved separately in files with the extension \code{.rds}. Note that the function can also be called via the \code{\link{runComparisonGUI}} function, which lets the user set parameters and select input files using a graphical user interface.
#'
#' The input to \code{\link{runComparison}} is a data frame with at least a column named \code{input.files}, containing paths to \code{.rds} files containing result objects (of the class \code{compData}), such as those generated by \code{\link{runDiffExp}}. Other columns that can be included in the data frame are \code{datasets}, \code{nbr.samples}, \code{repl} and \code{de.methods}. They have to match the information contained in the corresponding result objects. If these columns are not present, they will be added to the data frame automatically.
#'
#' @param file.table A data frame with at least a column \code{input.files}, potentially also columns named \code{datasets}, \code{nbr.samples}, \code{repl} and \code{de.methods}.
#' @param parameters A list containing parameters for the comparison study. The following entries are supported, and used by different comparison methods:
#' \itemize{
#' \item \code{incl.nbr.samples} An array with sample sizes (number of samples per condition) to consider in the comparison. If set to \code{NULL}, all sample sizes will be included.
#' \item \code{incl.dataset} A dataset name (corresponding to the \code{dataset} slot of the results or data objects), indicating the dataset that will be used for the comparison. Only one dataset can be chosen.
#' \item \code{incl.replicates} An array with replicate numbers to consider in the comparison. If set to \code{NULL}, all replicates will be included.
#' \item \code{incl.de.methods} An array with differential expression methods to be compared. If set to \code{NULL}, all differential expression methods will be included.
#' \item \code{fdr.threshold} The adjusted p-value threshold for FDR calculations. Default 0.05.
#' \item \code{tpr.threshold} The adjusted p-value threshold for TPR calculations. Default 0.05.
#' \item \code{mcc.threshold} The adjusted p-value threshold for MCC calculations. Default 0.05.
#' \item \code{typeI.threshold} The nominal p-value threshold for type I error calculations. Default 0.05.
#' \item \code{fdc.maxvar} The maximal number of variables to include in false discovery curve plots. Default 1500.
#' \item \code{overlap.threshold} The adjusted p-value for overlap analysis. Default 0.05.
#' \item \code{fracsign.threshold} The adjusted p-value for calculation of the fraction/number of genes called significant. Default 0.05.
#' \item \code{nbrtpfp.threshold} The adjusted p-value for calculation of the number of TP, FP, TN, FN genes. Default 0.05.
#' \item \code{ma.threshold} The adjusted p-value threshold for coloring genes in MA plots. Default 0.05.
#' \item \code{signal.measure} Either \code{'mean'} or \code{'snr'}, determining how to define the signal strength for a gene which is expressed in only one condition.
#' \item \code{upper.limits,lower.limits} Lists that can be used to manually set the upper and lower plot limits for boxplots of fdr, tpr, auc, mcc, fracsign, nbrtpfp and typeIerror.
#' \item \code{comparisons} Array containing the comparison methods to be applied. The entries must be chosen among the following abbreviations:
#' \itemize{
#' \item \code{"auc"} - Compute the area under the ROC curve
#' \item \code{"mcc"} - Compute Matthew's correlation coefficient
#' \item \code{"tpr"} - Compute the true positive rate at a given adjusted p-value threshold (\code{tpr.threshold})
#' \item \code{"fdr"} - Compute the false discovery rate at a given adjusted p-value threshold (\code{fdr.threshold})
#' \item \code{"fdrvsexpr"} - Compute the false discovery rate as a function of the expression level.
#' \item \code{"typeIerror"} - Compute the type I error rate at a given nominal p-value threshold (\code{typeI.threshold})
#' \item \code{"fracsign"} - Compute the fraction of genes called significant at a given adjusted p-value threshold (\code{fracsign.threshold}).
#' \item \code{"nbrsign"} - Compute the number of genes called significant at a given adjusted p-value threshold (\code{fracsign.threshold}).
#' \item \code{"nbrtpfp"} - Compute the number of true positives, false positives, true negatives and false negatives at a given adjusted p-value threshold (\code{nbrtpfp.threshold}).
#' \item \code{"maplot"} - Construct MA plots, depicting the average expression level and the log fold change for the genes and indicating the genes called differential expressed at a given adjusted p-value threshold (\code{ma.threshold}).
#' \item \code{"fdcurvesall"} - Construct false discovery curves for each of the included replicates.
#' \item \code{"fdcurvesone"} - Construct false discovery curves for a single replicate only
#' \item \code{"rocall"} - Construct ROC curves for each of the included replicates
#' \item \code{"rocone"} - Construct ROC curves for a single replicate only
#' \item \code{"overlap"} - Compute the overlap between collections of genes called differentially expressed by the different methods at a given adjusted p-value threshold (\code{overlap.threshold})
#' \item \code{"sorensen"} - Compute the Sorensen index, quantifying the overlap between collections of genes called differentially expressed by the different methods, at a given adjusted p-value threshold (\code{overlap.threshold})
#' \item \code{"correlation"} - Compute the Spearman correlation between gene scores assigned by different methods
#' \item \code{"scorevsoutlier"} - Visualize the distribution of the gene scores as a function of the number of outlier counts introduced for the genes
#' \item \code{"scorevsexpr"} - Visualize the gene scores as a function of the average expression level of the genes
#' \item \code{"scorevssignal"} - Visualize the gene score as a function of the 'signal strength' (see the \code{signal.measure} parameter above) for genes that are expressed in only one condition
#' }
#' }
#' @param output.directory The directory where the results should be written. The subdirectory structure will be created automatically. If the directory already exists, it will be overwritten.
#' @param check.table Logical, should the input table be checked for consistency. Default \code{TRUE}.
#' @param out.width The width of the figures in the final report. Will be passed on to \code{knitr} when the HTML is generated.
#' @param save.result.table Logical, should the intermediate result table be saved for future use ? Default to \code{FALSE}.
#' @param knit.results Logical, should the Rmd be generated and knitted ? Default to \code{TRUE}. If \code{FALSE}, no comparison report is generated, and only the intermediate result table is saved (if \code{save.result.table=TRUE}).
#' @return
#' If \code{knit.results=TRUE}, the function will create a comparison report, named \strong{compcodeR_report<timestamp>.html}, in the \code{output.directory}. It will also create subfolders named \code{compcodeR_code} and \code{compcodeR_figure}, where the code used to perform the differential expression analysis and the figures contained in the report, respectively, will be stored. Note that if these directories already exists, they will be overwritten.
#' If \code{save.result.table=TRUE}, the function will also create a comparison report, named \strong{compcodeR_result_table_<timestamp>.rds} in the \code{output.directory}, containing the result table.
#' @export
#' @author Charlotte Soneson
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.limma",
#'            Rmdfunction = "voom.limma.createRmd", output.directory = tmpdir,
#'            norm.method = "TMM")
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "edgeR.exact",
#'            Rmdfunction = "edgeR.exact.createRmd", output.directory = tmpdir,
#'            norm.method = "TMM",
#'            trend.method = "movingave", disp.type = "tagwise")
#' file.table <- data.frame(input.files = file.path(tmpdir,
#'                          c("mydata_voom.limma.rds", "mydata_edgeR.exact.rds")),
#'                          stringsAsFactors = FALSE)
#' parameters <- list(incl.nbr.samples = 5, incl.replicates = 1, incl.dataset = "mydata",
#'                    incl.de.methods = NULL,
#'                    fdr.threshold = 0.05, tpr.threshold = 0.05, typeI.threshold = 0.05,
#'                    ma.threshold = 0.05, fdc.maxvar = 1500, overlap.threshold = 0.05,
#'                    fracsign.threshold = 0.05, mcc.threshold = 0.05,
#'                    nbrtpfp.threshold = 0.05,
#'                    comparisons = c("auc", "fdr", "tpr", "ma", "correlation"))
#' if (interactive()) {
#'   runComparison(file.table = file.table, parameters = parameters, output.directory = tmpdir)
#' }
#' @importFrom grDevices heat.colors
#' @importFrom graphics axis legend lines par title
#' @importFrom stats as.dist cor hclust loess median na.omit predict rexp rnbinom
#'   rpois runif sd
#' @importFrom utils packageVersion
runComparison <- function(file.table,
                          parameters,
                          output.directory,
                          check.table = TRUE,
                          out.width = NULL,
                          save.result.table = FALSE,
                          knit.results = TRUE) {

  ## Check arguments
  if (!save.result.table && !knit.results) {
    stop("At least on of 'save.result.table' or 'knit.results' must be set to TRUE, otherwise the function does not produce anything.")
  }

  checkClass(file.table, "file.table", "data.frame")
  checkClass(output.directory, "output.directory", "character")

  if (is.null(parameters)) {
    parameters <- list()
  }
  checkClass(parameters, "parameters", "list")

  ## Set default values if not given
  if (is.null(parameters$fdr.threshold)) parameters$fdr.threshold <- 0.05
  if (is.null(parameters$tpr.threshold)) parameters$tpr.threshold <- 0.05
  if (is.null(parameters$mcc.threshold)) parameters$mcc.threshold <- 0.05
  if (is.null(parameters$typeI.threshold)) parameters$typeI.threshold <- 0.05
  if (is.null(parameters$ma.threshold)) parameters$ma.threshold <- 0.05
  if (is.null(parameters$fdc.maxvar)) parameters$fdc.maxvar <- 1500
  if (is.null(parameters$signal.measure)) parameters$signal.measure <- "mean"
  if (is.null(parameters$overlap.threshold)) parameters$overlap.threshold <- 0.05
  if (is.null(parameters$fracsign.threshold)) parameters$fracsign.threshold <- 0.05
  if (is.null(parameters$nbrtpfp.threshold)) parameters$nbrtpfp.threshold <- 0.05
  if (is.null(parameters$comparisons)) parameters$comparisons <-
    c("auc", "fdr", "tpr", "mcc",
      "maplot", "correlation", "nbrtpfp",
      "typeIerror", "fracsign", "nbrsign",
      "fdcurvesall", "fdcurvesone",
      "rocall", "rocone", "overlap",
      "scorevsexpr", "sorensen",
      "correlation", "scorevsoutlier",
      "fdrvsexpr", "scorevssignal")

  ## Some options, useful for debugging
  save.rmdfile <- FALSE  ## set to TRUE to save the .Rmd file

  file.table <- data.frame(file.table, stringsAsFactors = FALSE)

  file.table$input.files <- normalizePath(as.character(file.table$input.files),
                                          winslash = "/")

  ## Check the input table/parameters
  ## First, make the table consistent (go through all input files, check the number of samples,
  ## the replicate ID and the de.method. If it doesn't agree with table, change the table and
  ## print a message.)
  ## This is not needed if we call runComparison from runComparisonGUI
  if (check.table) {
    file.table <- checkTableConsistency(file.table)
  }
  if (nrow(file.table) == 0) {
    stop("No methods left to compare after checking object validity!")
  }
  if (is.null(parameters$incl.dataset)) {
    parameters$incl.dataset <- unique(file.table$datasets)
  }

  ## Get the whole path to the output.directory
  output.directory <- normalizePath(output.directory, winslash = "/")

  ## If the output.directory does not exist, create it and some subfolders
  dir.create(output.directory, showWarnings = FALSE)
  dir.create(file.path(output.directory, "compcodeR_code"), showWarnings = FALSE)
  dir.create(file.path(output.directory, "compcodeR_figure"), showWarnings = FALSE)

  ## Set options for knitr
  opts_knit$set(progress = FALSE, verbose = FALSE)
  opts_chunk$set(warning = FALSE, error = FALSE, message = FALSE, comment = '',
                 fig.path = file.path(output.directory, "compcodeR_figure/"),
                 echo = FALSE, out.width = out.width)

  ## Go through the input files and keep only the ones that are compatible
  ## with the selected parameters.
  ## First select the ones from the right dataset (this is a required parameter)
  idx.keep <- which(file.table$datasets %in% parameters$incl.dataset)
  file.table <- file.table[idx.keep, ]
  if (nrow(file.table) == 0) {
    stop("No methods left to compare after matching with datasets to include!")
  }

  ## If any of the files have information about nbr.samples, keep only the files
  ## with nbr.samples in accordance with the selected nbr.samples. Otherwise,
  ## keep all files
  if (is.null(parameters$incl.nbr.samples) || all(is.na(parameters$incl.nbr.samples))) {
    ## If no selection of nbr.samples, keep all
    idx.keep <- seq_len(nrow(file.table))
  } else {
    if (any(!is.na(file.table$nbr.samples))) {
      idx.keep <- which(file.table$nbr.samples %in% parameters$incl.nbr.samples)
    } else {
      idx.keep <- seq_len(nrow(file.table))
    }
  }
  file.table <- file.table[idx.keep, ]
  if (nrow(file.table) == 0) {
    stop("No methods left to compare after matching with nbr.samples to include!")
  }

  ## If any of the files have information about replicate, keep only the files
  ## with replicate in accordance with the selected replicate. Otherwise,
  ## keep all files
  if (is.null(parameters$incl.replicates) || all(is.na(parameters$incl.replicates))) {
    ## If no selection of replicates, keep all
    idx.keep <- seq_len(nrow(file.table))
  } else {
    if (any(!is.na(file.table$repl))) {
      idx.keep <- which(file.table$repl %in% parameters$incl.replicates)
    } else {
      idx.keep <- seq_len(nrow(file.table))
    }
  }
  file.table <- file.table[idx.keep, ]
  if (nrow(file.table) == 0) {
    stop("No methods left to compare after matching with replicates to include!")
  }

  if (is.null(parameters$incl.de.methods) || all(is.na(parameters$incl.de.methods))) {
    ## If no selection of de.methods, keep all
    idx.keep <- seq_len(nrow(file.table))
  } else {
    idx.keep <- which(file.table$de.methods %in% parameters$incl.de.methods)
  }
  file.table <- file.table[idx.keep, ]
  if (nrow(file.table) == 0) {
    stop("No methods left to compare after matching with DE methods to include!")
  }

  parameters$file.info <- file.table
  parameters$file.info[is.na(parameters$file.info)] <- NA_real_

  parameters$incl.nbr.samples <- unique(file.table$nbr.samples)
  parameters$incl.nbr.samples[is.na(parameters$incl.nbr.samples)] <- NA_real_
  parameters$incl.replicates <- unique(file.table$repl)
  parameters$incl.replicates[is.na(parameters$incl.replicates)] <- NA_real_
  parameters$incl.de.methods <- unique(file.table$de.methods)

  ## Check that the input files actually correspond to the same simulation settings
  ## (data sets with the same name can only differ in the number of samples and
  ## the replicate number)
  checkCompatibility(parameters$file.info)

  parameters$specified.colors <- definePlotColors(parameters$incl.de.methods)

  setup.parameters <- parameters
  ##saveRDS(setup.parameters, "/Users/charlotte/Desktop/setup.parameters.ex.rds")

  ## Generate the Rmd file containing the results
  timestamp <- format(Sys.time(), "%Y-%m-%d-%H-%M-%S")

  ## Save the setup.parameters
  setup.parameters.file <- file.path(output.directory,
                                     paste("compcodeR_parameters_",
                                           timestamp,
                                           ".rds", sep = ""))
  saveRDS(setup.parameters, setup.parameters.file)

  if (save.result.table) {
    doSaveResultsTable(setup.parameters.file,
                       output.file = file.path(output.directory,
                                               paste("compcodeR_result_table_",
                                                     timestamp,
                                                     ".rds", sep = "")))
  }

  if (knit.results) {
    createResultsRmdFile(setup.parameters.file,
                         output.file = file.path(output.directory,
                                                 paste("compcodeR_report_",
                                                       timestamp,
                                                       ".Rmd", sep = "")))

    ## Generate the HTML file
    out <- knitr::knit(input = file.path(output.directory, paste("compcodeR_report_",
                                                                 timestamp,
                                                                 ".Rmd", sep = "")),
                       output = file.path(output.directory, paste("compcodeR_report_",
                                                                  timestamp,
                                                                  ".md", sep = "")),
                       envir =  new.env())
    rmarkdown::pandoc_convert(input = out,
                              output = file.path(output.directory, paste("compcodeR_report_",
                                                                         timestamp,
                                                                         ".html", sep = "")))
    # markdown::markdownToHTML(file = out,
    #                          output = file.path(output.directory, paste("compcodeR_report_",
    #                                                                     timestamp,
    #                                                                     ".html", sep = "")),
    #                          encoding = "UTF-8",
    #                          title = "compcodeR results")

    ## Remove the .Rmd file
    if (!save.rmdfile) {
      file.remove(file.path(output.directory, paste("compcodeR_report_",
                                                    timestamp,
                                                    ".Rmd", sep = "")))
      file.remove(file.path(output.directory, paste("compcodeR_report_",
                                                    timestamp,
                                                    ".md", sep = "")))
    }

    ## Generate the HTML files containing the code for all compared instances
    generateCodeHTMLs(setup.parameters$file.info$input.files,
                      file.path(output.directory, "compcodeR_code"))
  }
  message("Done!")
}

# Save the result table for further plotting
#
# This function is generally not called by the user.
#
# @author Charlotte Soneson, Paul Bastide
doSaveResultsTable <- function(setup.parameters.file, output.file) {
  ## Check that the output file ends with .rds
  if (!(substr(output.file, nchar(output.file) - 3, nchar(output.file)) == ".rds")) {
    output.file <- sub(strsplit(output.file, "\\.")[[1]][length(strsplit(output.file, "\\.")[[1]])], "rds", output.file)
  }

  ## Load the setup parameters
  setup.parameters <- readRDS(setup.parameters.file)
  setup.parameters$incl.nbr.samples <- as.numeric(setup.parameters$incl.nbr.samples)
  setup.parameters$incl.replicates <- as.numeric(setup.parameters$incl.replicates)
  if (all(!is.na(setup.parameters$incl.nbr.samples))) {
    setup.parameters$incl.nbr.samples <- sort(setup.parameters$incl.nbr.samples)
  }
  if (all(!is.na(setup.parameters$incl.replicates))) {
    setup.parameters$incl.replicates <- sort(setup.parameters$incl.replicates)
  }

  ## Create the result table
  if (any(c('auc', 'fdr', 'tpr', 'typeIerror', 'fracsign', 'nbrtpfp', 'nbrsign', 'mcc') %in% setup.parameters$comparisons)) {
    res.table <- createResultTable(setup.parameters)
    if (any(!is.na(setup.parameters$incl.nbr.samples))) {
      res.table <- padResultTable(res.table)
    }
  }

  ## Create the result table
  saveRDS(res.table, file = output.file)
}

# Check the compatibility of data sets used for method comparison
#
# Check that there are no contradictions or inconsistencies among the data sets used for comparing different methods for differential expression analysis. Please note that data sets that are given the same name (the 'dataset' entry) can only differ in the number of samples per condition and the replicate ID (and the unique data set ID). All other simulation parameters must be identical. This function is generally not called by the user.
#
# @param file.info.table Table containing the files that are intended for use in the comparison.
# @author Charlotte Soneson
checkCompatibility <- function(file.info.table){
  ## First check that all files have the same data set name
  if (length(unique(file.info.table$datasets[!is.na(file.info.table$datasets)])) != 1) {
    stop("All data sets must have the same name (the 'dataset' entry).")
  }

  ## Then check that all input files with the same nbr samples and repl.id are
  ## identical (that they have the same unique ID)
  all.combinations <- interaction(file.info.table$nbr.samples,
                                  file.info.table$repl)
  for (tmp in levels(all.combinations)) {
    tmp.nbr.samples <- strsplit(tmp, "\\.")[[1]][1]
    tmp.repl <- strsplit(tmp, "\\.")[[1]][2]
    tmp.uID <- NULL
    tmp.lines <- which(all.combinations == tmp)
    if (length(tmp.lines) != 0) {
      for (i in seq_len(length(tmp.lines))) {
        w <- readRDS(as.character(file.info.table$input.files[tmp.lines[i]]))
        if (is.list(w)) w <- convertListTocompData(w)
        if (!is.null(w)) tmp.uID <- c(tmp.uID, info.parameters(w)$uID)
      }
    }
    if (length(unique(tmp.uID)) > 1) {
      stop("Different unique identifiers for data sets with the same name, number of
           samples and replicate ID.")
    }
  }

  ## Then check that all input files with the same dataset name (i.e., all input files)
  ## only differ in the nbr samples and repl.id
  nex.files <- NULL
  ii <- 1
  while (!file.exists(as.character(file.info.table$input.files[ii]))) {
    nex.files <- c(nex.files, ii)
    ii <- ii + 1
  }
  w <- readRDS(as.character(file.info.table$input.files[ii]))
  if (is.list(w)) w <- convertListTocompData(w)
  tmp.ref <- info.parameters(w)
  tmp.ref[c("uID", "samples.per.cond", "repl.id")] <- NULL

  if (ii != length(file.info.table$input.files)) {
    for (i in (ii + 1):length(file.info.table$input.files)) {
      if (file.exists(as.character(file.info.table$input.files[i]))) {
        w <- readRDS(as.character(file.info.table$input.files[i]))
        if (is.list(w)) w <- convertListTocompData(w)
        tmp.comp <- info.parameters(w)
        tmp.comp[c("uID", "samples.per.cond", "repl.id")] <- NULL
        if (!(all(tmp.ref %in% tmp.comp) & all(tmp.comp %in% tmp.ref))) {
          print(tmp.ref[!(tmp.ref %in% tmp.comp)])
          print(tmp.comp[!(tmp.comp %in% tmp.ref)])
          stop("The same data set name is used to refer to data sets with different
           simulation parameters")
        }
      } else {
        nex.files <- c(nex.files, i)
      }
    }
  }
}

## Comparison functions
# Assign plot colors to a collection of differential expression methods
#
# Assign a plot color to each differential expression method present in the input vector. This color will be used for all graphical representations in the method comparison. The colors are taken from a pre-defined collection. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparison}} function.
#
# @param methods Vector of methods that will be assigned plot colors.
# @return List with the assigned plot colors for all methods present in \code{methods}.
# @author Charlotte Soneson
definePlotColors <- function(methods) {
  available.plot.colors = c('red', 'cyan', 'blue', 'green', 'orange', 'violet', 'brown',
                            'deeppink', 'forestgreen', 'aquamarine4', 'cadetblue3', 'grey',
                            'bisque', 'darkkhaki', 'darkgoldenrod3', 'pink', 'plum',
                            'tomato', 'wheat', 'azure4', 'blue4', 'blueviolet', 'brown4',
                            'burlywood3', 'burlywood4', 'chartreuse', 'chocolate',
                            'cornflowerblue', 'cornsilk3', 'darkolivegreen2', 'darkorange2',
                            'darksalmon', 'darkseagreen', 'dodgerblue', 'firebrick1',
                            'lavender', 'lemonchiffon2', 'hotpink', 'lightskyblue2',
                            'mediumaquamarine', 'olivedrab2', 'palegreen')
  plot.colors <- list()
  for (i in seq_len(length(methods))) {
    plot.colors[sort(methods)[i]] <- available.plot.colors[i]
  }
  return(plot.colors)
}

# Plot ROC curves
#
# Plot receiver operating characteristic (ROC) curves, depicting the relationship between the false positive rate (x-axis) and the true positive rate (y-axis) as the significance threshold for differential expression is changed. The genes are ordered by the \code{score} column of the \code{result.table} data frame available in the result objects returned by \code{\link{runDiffExp}}. A well-performing differential expression method has a sharply increasing ROC curve, with a large area under the curve (AUC). This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparison}} function.
#
# @param setup.parameters List of parameters (internal).
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which ROC curves will be constructed
# @param sel.repl The replicate numbers (instances of a given simulation setting) for which ROC curves will be constructed
# @author Charlotte Soneson
makeROCcurves = function(setup.parameters, sel.nbrsamples, sel.repl) {
  ## Compute and plot ROC curves for the selected data set(s).
  ## One figure for each sel.nbrsamples, one panel for each sel.repl
  nbr.cols <- 3
  nbr.rows <- ceiling((length(sel.repl) + 1)/nbr.cols)

  for (i in seq_len(length(sel.nbrsamples))) {
    incl.legend <- FALSE
    graphics::par(mfrow = c(nbr.rows, nbr.cols), cex.lab = 2,
                  cex.axis = 1.5, las = 1, cex.main = 1.75, mar = c(5, 5, 4, 2))
    all.plot.methods <- NULL
    all.plot.colors <- NULL
    for (j in seq_len(length(sel.repl))) {
      plot.colors <- NULL
      plot.methods <- NULL
      tmp.k <- 1
      for (k in seq_len(length(setup.parameters$incl.de.methods))) {
        ## Extract results from selected DE method, nbr samples and replicate
        idx1 <- findFileIdx(setup.parameters$file.info, "de.methods",
                            setup.parameters$incl.de.methods[k])
        idx2 <- findFileIdx(setup.parameters$file.info, "nbr.samples",
                            sel.nbrsamples[i])
        idx3 <- findFileIdx(setup.parameters$file.info, "repl",
                            sel.repl[j])
        idx <- intersect(intersect(idx1, idx2), idx3)
        if (length(idx) != 0) {
          ## Read data
          X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
          if (is.list(X)) X <- convertListTocompData(X)
          the.scores <- result.table(X)$score
          if (!all(variable.annotations(X)$differential.expression == 0)) {
            incl.legend <- TRUE
            idx_not_na <- which(!is.na(the.scores))
            the.prediction <- prediction(the.scores[idx_not_na],
                                         variable.annotations(X)$differential.expression[idx_not_na])
            the.performance <- performance(the.prediction,
                                           measure = 'tpr',
                                           x.measure = 'fpr')
            fpr <- unlist(the.performance@x.values)
            tpr <- unlist(the.performance@y.values)

            plot.colors <- c(plot.colors,
                            setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]])
            plot.methods <- c(plot.methods, setup.parameters$incl.de.methods[k])

            ## Create vectors for legend (combine info across all replicates)
            if (length(which(all.plot.methods == setup.parameters$incl.de.methods[k])) == 0) {
              all.plot.methods <- c(all.plot.methods, setup.parameters$incl.de.methods[k])
              all.plot.colors <- c(all.plot.colors, setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]])
            }

            if (tmp.k == 1) {
              if (is.na(sel.repl[j])) {
                if (is.na(sel.nbrsamples[i])) {
                  maintext <- ""
                } else {
                  maintext <- paste(sel.nbrsamples[i], "samples/condition")
                }
              } else {
                if (is.na(sel.nbrsamples[i])) {
                  maintext <- paste("Replicate", sel.repl[j])
                } else {
                  maintext <- paste("Replicate", sel.repl[j], ", ", sel.nbrsamples[i],
                                    "samples/condition")
                }
              }
              plot(fpr, tpr, type = 'l', xlim = c(0, 1), ylim = c(0, 1),
                   col = setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]],
                   main = maintext,
                   lwd = 1.5,
                   xlab = 'False positive rate',
                   ylab = 'True positive rate')
            } else {
              graphics::lines(
                fpr, tpr,
                col = setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]],
                lwd = 1.5)
            }
          }
          tmp.k <- tmp.k + 1
        }
      }
    }
    if (incl.legend) {
      plot(0:1, 0:1, type = 'n', axes = FALSE, xlab = '', ylab = '')
      graphics::legend('topleft', legend = all.plot.methods,
                       col = all.plot.colors, lty = 1, lwd = 2,
                       cex = ifelse(length(all.plot.methods) < 24, 1.5,
                                    1.3/length(all.plot.methods)*24))
    } else {
      cat("No truly differentially expressed genes found. ")
    }
  }
}

# Plot false discovery curves
#
# Plot false discovery curves, depicting the number of false discoveries encountered as the significance threshold for differential expression is changed. The genes are ordered by the \code{score} column of the \code{result.table} data frame available in the result objects returned by \code{\link{runDiffExp}}. A well-performing differential expression method has a slowly increasing false discovery curve, meaning that as more and more genes are considered differentially expressed, only few of them are false discoveries. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparison}} function.
#
# @param setup.parameters List of parameters (internal).
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which the false discovery curves will be constructed.
# @param sel.repl The replicate numbers (the instances of a given simulation setting) for which the false discovery curves will be constructed.
# @author Charlotte Soneson
makeFalseDiscoveryCurves <- function(setup.parameters, sel.nbrsamples, sel.repl, legend.outside = TRUE) {
  nbr.cols <- 3
  nbr.rows <- ceiling((length(sel.repl) + 1)/nbr.cols)

  ##sel.repl <- sort(sel.repl)

  for (i in seq_len(length(sel.nbrsamples))) {
    incl.legend <- FALSE
    graphics::par(mfrow = c(nbr.rows, nbr.cols), cex.lab = 2,
                  cex.axis = 1.5, las = 1, cex.main = 1.75, mar = c(5, 5, 4, 2),
                  mgp = c(3.5, 1, 0))
    all.plot.colors <- NULL
    all.plot.methods <- NULL
    for (j in seq_len(length(sel.repl))) {
      plot.colors <- NULL
      plot.methods <- NULL
      tmp.k <- 1
      for (k in seq_len(length(setup.parameters$incl.de.methods))) {
        idx1 <- findFileIdx(setup.parameters$file.info, "de.methods",
                            setup.parameters$incl.de.methods[k])
        idx2 <- findFileIdx(setup.parameters$file.info, "nbr.samples",
                            sel.nbrsamples[i])
        idx3 <- findFileIdx(setup.parameters$file.info, "repl", sel.repl[j])
        idx <- intersect(intersect(idx1, idx2), idx3)
        if (length(idx) != 0) {
          X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
          if (is.list(X)) X <- convertListTocompData(X)
          the.scores <- result.table(X)$score
          if (!all(variable.annotations(X)$differential.expression == 0)) {
            incl.legend <- TRUE
            the.scores.ordered <- the.scores[order(the.scores,
                                                  decreasing = TRUE)]
            trulyDE.ordered <- variable.annotations(X)$differential.expression[order(the.scores,
                                                                                   decreasing = TRUE)]
            the.scores.unique <- sort(unique(the.scores), decreasing = TRUE)
            xcoord <- cumsum(as.vector(table(-the.scores.ordered)))
            ycoord <- cumsum(1 - trulyDE.ordered)[cumsum(as.vector(table(-the.scores.ordered)))]

            plot.colors <- c(plot.colors,
                             setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]])
            plot.methods <- c(plot.methods, setup.parameters$incl.de.methods[k])

            ## Create vectors for legend (combine info across all replicates)
            if (length(which(all.plot.methods == setup.parameters$incl.de.methods[k])) == 0) {
              all.plot.methods <- c(all.plot.methods, setup.parameters$incl.de.methods[k])
              all.plot.colors <- c(all.plot.colors, setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]])
            }

            if (all(xcoord < setup.parameters$fdc.maxvar)) {
              tmp.fdc.maxvar <- max(xcoord)
            } else {
              tmp.fdc.maxvar <- setup.parameters$fdc.maxvar
            }

            if (tmp.k == 1) {
              if (is.na(sel.repl[j])) {
                if (is.na(sel.nbrsamples[i])) {
                  maintext <- ""
                } else {
                  maintext <- paste(sel.nbrsamples[i], "samples/condition")
                }
              } else {
                if (is.na(sel.nbrsamples[i])) {
                  maintext <- paste("Replicate", sel.repl[j])
                } else {
                  maintext <- paste("Replicate", sel.repl[j], ", ", sel.nbrsamples[i],
                                    "samples/condition")
                }
              }

              suppressWarnings({plot(xcoord[seq_len(min(which(xcoord >= tmp.fdc.maxvar)))],
                                     ycoord[seq_len(min(which(xcoord >= tmp.fdc.maxvar)))],
                                     type = 'l', xlim = c(0, tmp.fdc.maxvar), log = 'y', las = 1,
                                     lwd = 1.5,  #1.5
                                     ylim = c(1, tmp.fdc.maxvar),
                                     col = setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]],
                                     xlab = 'Number of selected genes',
                                     ylab = 'Number of false discoveries',
                                     main = maintext)})
            } else {
              suppressWarnings({
                graphics::lines(xcoord[seq_len(min(which(xcoord >= tmp.fdc.maxvar)))],
                                ycoord[seq_len(min(which(xcoord >= tmp.fdc.maxvar)))],
                                col = setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]],
                                lwd = 1.5)})   #1.5
            }
          }
          tmp.k <- tmp.k + 1
        }
      }
    }
    if (incl.legend) {
      if (legend.outside) {
        plot(0:1, 0:1, type = 'n', axes = FALSE, xlab = '', ylab = '')
        graphics::legend('topleft', legend = all.plot.methods,
                         col = all.plot.colors, lty = 1, lwd = 2,
                         cex = ifelse(length(all.plot.methods) < 24, 1.5,
                                      1.3/length(all.plot.methods)*24))
      } else {
        graphics::legend('bottomright', legend = all.plot.methods,
                         col = all.plot.colors, lty = 1, lwd = 2,
                         cex = ifelse(length(all.plot.methods) < 24, 1.5,
                                      1.3/length(all.plot.methods)*24))
      }
    } else {
      cat("No truly differentially expressed genes found.")
    }
  }
}

# Construct MA plots
#
# Construct MA plots, depicting the log-fold change (M) vs the average expression level (A) for all genes and indicating the genes that are determined to be differentially expressed. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# @param setup.parameters List of parameters (internal).
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which the MA plots will be constructed
# @param sel.repl The replicate numbers (instances of a given simulation setting) for which the MA plots will be constructed
# @author Charlotte Soneson
plotMASignificant <- function(setup.parameters, sel.nbrsamples, sel.repl) {
  nbr.cols <- 3
  nbr.rows <- ceiling(length(setup.parameters$incl.de.methods)/nbr.cols)
  for (i in seq_len(length(sel.nbrsamples))) {
    graphics::par(mfrow = c(nbr.rows, nbr.cols), cex.lab = 2,
                  cex.axis = 1.5, las = 1, cex.main = 1.2,
                  cex.main = 1.75, mar = c(5, 5, 4, 2))
    for (k in seq_len(length(setup.parameters$incl.de.methods))) {
      idx1 <- findFileIdx(setup.parameters$file.info, "de.methods",
                          setup.parameters$incl.de.methods[k])
      idx2 <- findFileIdx(setup.parameters$file.info, "nbr.samples",
                          sel.nbrsamples[i])
      idx3 <- findFileIdx(setup.parameters$file.info, "repl", sel.repl)
      idx <- intersect(intersect(idx1, idx2), idx3)
      if (length(idx) != 0) {
        X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
        if (is.list(X)) X <- convertListTocompData(X)
        if (is.null(variable.annotations(X)$A.value) | is.null(variable.annotations(X)$M.value)) {
          A.value <- computeAval(count.matrix(X), sample.annotations(X)$condition)
          M.value <- computeMval(count.matrix(X), sample.annotations(X)$condition)
        } else {
          A.value <- variable.annotations(X)$A.value
          M.value <- variable.annotations(X)$M.value
        }
        if ('adjpvalue' %in% colnames(result.table(X))) {
          significant <- which(result.table(X)$adjpvalue < setup.parameters$ma.threshold)
        } else if ('FDR' %in% colnames(result.table(X))) {
            significant <- which(result.table(X)$FDR < setup.parameters$ma.threshold)
        } else {
          significant <- NULL
        }
        maplotcols <- rep('black', length(A.value))
        maplotcols[significant] <- setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]]
        if (!is.null(significant)) {
          plot(A.value, M.value, cex = 1, pch = 20, main = setup.parameters$incl.de.methods[k],
               xlab = "Average expression",
               ylab = "Log fold change",
               col = maplotcols)
        } else {
          plot(1, type = "n", xlab = "Average expression",
               ylab = "Log fold change",
               main = setup.parameters$incl.de.methods[k],
               xaxt = "n", yaxt = "n")
        }
      }
    }
  }
}

# Plot the gene score vs the average expression level of the gene
#
# Plot the gene score vs the average expression level (A) for all genes. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# @param setup.parameters List of parameters (internal).
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which the MA plots will be constructed
# @param sel.repl The replicate numbers (instances of a given simulation setting) for which the plots will be constructed
# @author Charlotte Soneson
plotScoreVsExpr <- function(setup.parameters, sel.nbrsamples, sel.repl) {
  nbr.cols <- 3
  nbr.rows <- ceiling(length(setup.parameters$incl.de.methods)/nbr.cols)
  for (i in seq_len(length(sel.nbrsamples))) {
    graphics::par(mfrow = c(nbr.rows, nbr.cols), cex.lab = 2,
                  cex.axis = 1.5, las = 1, cex.main = 1.2,
                  cex.main = 1.75, mar = c(5, 5, 4, 2))
    for (k in seq_len(length(setup.parameters$incl.de.methods))) {
      idx1 <- findFileIdx(setup.parameters$file.info, "de.methods",
                          setup.parameters$incl.de.methods[k])
      idx2 <- findFileIdx(setup.parameters$file.info, "nbr.samples",
                          sel.nbrsamples[i])
      idx3 <- findFileIdx(setup.parameters$file.info, "repl", sel.repl)
      idx <- intersect(intersect(idx1, idx2), idx3)
      if (length(idx) != 0) {
        X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
        if (is.list(X)) X <- convertListTocompData(X)
        if (is.null(variable.annotations(X)$A.value)) {
          A.value <- computeAval(count.matrix(X), sample.annotations(X)$condition)
        } else {
          A.value <- variable.annotations(X)$A.value
        }
        score <- result.table(X)$score
        linecol <- setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]]
        plot(A.value, score, cex = 0.75, pch = 20, main = setup.parameters$incl.de.methods[k],
             xlab = "Average expression",
             ylab = "Score")
        loessline <- stats::loess(score ~ A.value)
        xval <- seq(min(A.value), max(A.value), length.out = 500)
        graphics::lines(xval, stats::predict(loessline, xval), col = linecol, lwd = 5)
      }
    }
  }
}

# Plot the gene score vs an 'outlier score'
#
# Plot the gene score vs an outlier score, defined as the ratio between A and B, where A is the difference between the highest and the second highest normalized count, and B is the difference between the highest and the lowest normalized count. The outlier score is averaged across all samples. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# @param setup.parameters List of parameters (internal).
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which the MA plots will be constructed
# @param sel.repl The replicate numbers (instances of a given simulation setting) for which the MA plots will be constructed
# @author Charlotte Soneson
# plotScoreVsOutlierEvidence <- function(setup.parameters, sel.nbrsamples, sel.repl) {
#   nbr.cols <- 3
#   nbr.rows <- ceiling(length(setup.parameters$incl.de.methods)/nbr.cols)
#   for (i in seq_len(length(sel.nbrsamples))) {
#     par(mfrow = c(nbr.rows, nbr.cols), cex.lab = 2,
#         cex.axis = 1.5, las = 1, cex.main = 1.2, cex.main = 1.75, mar = c(5, 5, 4, 2))
#     for (k in seq_len(length(setup.parameters$incl.de.methods))) {
#       idx1 <- findFileIdx(setup.parameters$file.info, "de.methods",
#                           setup.parameters$incl.de.methods[k])
#       idx2 <- findFileIdx(setup.parameters$file.info, "nbr.samples",
#                           sel.nbrsamples[i])
#       idx3 <- findFileIdx(setup.parameters$file.info, "repl", sel.repl)
#       idx <- intersect(intersect(idx1, idx2), idx3)
#       if (length(idx) != 0) {
#         X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
#         if (is.list(X)) X <- convertListTocompData(X)
#         ## Normalize counts (compute pseudocounts)
#         nf <- calcNormFactors(count.matrix(X))
#         norm.factors <- nf * colSums(count.matrix(X))
#         common.libsize <- exp(mean(log(colSums(count.matrix(X)))))
#         pseudocounts <- sweep(count.matrix(X) + 0.5, 2, norm.factors, '/') * common.libsize
#         ## Compute the outlier score
#         tmp <- t(apply(count.matrix(X)[, sample.annotations(X)$condition ==
#                                          levels(factor(sample.annotations(X)$condition))[1]],
#                        1, sort))
#         outlier.score.1.1 <- (tmp[, ncol(tmp)] - tmp[, (ncol(tmp) - 1)])/(tmp[, ncol(tmp)] -
#                                                                             tmp[, 1])
#         outlier.score.1.2 <- (tmp[, 2] - tmp[, 1])/(tmp[, ncol(tmp)] - tmp[, 1])
#         outlier.score.1 <- sqrt(outlier.score.1.1*outlier.score.1.2)
#         outlier.score.1[is.na(outlier.score.1)] <- 0
#
#         tmp <- t(apply(count.matrix(X)[, sample.annotations(X)$condition ==
#                                          levels(factor(sample.annotations(X)$condition))[2]],
#                        1, sort))
#         outlier.score.2.1 <- (tmp[, ncol(tmp)] - tmp[, (ncol(tmp) - 1)])/(tmp[, ncol(tmp)] -
#                                                                           tmp[, 1])
#         outlier.score.2.2 <- (tmp[, 2] - tmp[, 1])/(tmp[, ncol(tmp)] - tmp[, 1])
#         outlier.score.2 <- sqrt(outlier.score.2.1*outlier.score.2.2)
#         outlier.score.2[is.na(outlier.score.2)] <- 0
#         outlier.score <- 0.5*(outlier.score.1 + outlier.score.2)
#
#         ## Count number of outliers
#         if (length(variable.annotations(X)) != 0) {
#           total.outliers <- apply(variable.annotations(X)[match(rownames(result.table(X)),
#                                                                 rownames(variable.annotations(X))),
#                                                           which(colnames(variable.annotations(X)) %in%
#                                                                   c("n.random.outliers.up.S1",
#                                                                     "n.random.outliers.up.S2",
#                                                                     "n.random.outliers.down.S1",
#                                                                     "n.random.outliers.down.S2",
#                                                                     "n.single.outliers.up.S1",
#                                                                     "n.single.outliers.up.S2",
#                                                                     "n.single.outliers.down.S1",
#                                                                     "n.single.outliers.down.S2"))], 1, sum)
#         } else {
#           total.outliers <- rep(0, length(score))
#         }
#
# #        boxplot(outlier.score ~ total.outliers)
#         score <- result.table(X)$score
#         linecol <- setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]]
#         plot(outlier.score, score, cex = 0.75, pch = 20,
#              main = setup.parameters$incl.de.methods[k],
#              xlab = "Outlier score",
#              ylab = "Score")
#         loessline <- loess(score ~ outlier.score)
#         xval <- seq(min(outlier.score), max(outlier.score), length.out = 500)
#         lines(xval, predict(loessline, xval), col = linecol, lwd = 5)
#       }
#     }
#   }
# }

findGenesAllZero <- function(count.matrix, conditions) {
  ## Find genes that are zero for all samples in one condition
  cm1 <- count.matrix[, which(conditions == levels(factor(conditions))[1])]
  cm2 <- count.matrix[, which(conditions == levels(factor(conditions))[2])]
  zero1 <- which(apply(cm1, 1, sum) == 0)
  zero2 <- which(apply(cm2, 1, sum) == 0)
  return(list(zero1 = zero1, zero2 = zero2))
}

computeSignal <- function(count.matrix, conditions, signal.measure) {
  ## Normalize counts (compute pseudocounts) and log-transform
  nf <- calcNormFactors(count.matrix)
  norm.factors <- nf * colSums(count.matrix)
  common.libsize <- exp(mean(log(colSums(count.matrix))))
  pseudocounts <- sweep(count.matrix + 0.5, 2, norm.factors, '/') * common.libsize
  log2.pseudocounts <- log2(pseudocounts)

  ## If the second line below is uncommented, compute the "log2 pseudocounts" for
  ## a matrix with all zeros (the same normalization factors as above) and
  ## subtract from the actual log2 pseudocounts
  tmpmat <- matrix(0, nrow(count.matrix), ncol(count.matrix))
  ##tmpmat <- log2(sweep(tmpmat + 0.5, 2, norm.factors, "/") * common.libsize)

  ## Compute difference between the values
  log2.pseudocounts.diff <- log2.pseudocounts - tmpmat

  if (signal.measure == "snr") {
    ## Split into two matrices depending on condition. Average within each condition for each gene
    signal1 <-
      apply(log2.pseudocounts.diff[, which(conditions ==
                                             levels(factor(conditions))[1])],
            1, mean)/apply(log2.pseudocounts.diff[, which(conditions ==
                                                            levels(factor(conditions))[1])],
                           1, stats::sd)
    signal2 <-
      apply(log2.pseudocounts.diff[, which(conditions ==
                                             levels(factor(conditions))[2])],
            1, mean)/apply(log2.pseudocounts.diff[, which(conditions ==
                                                            levels(factor(conditions))[2])],
                           1, stats::sd)
  } else if (signal.measure == "mean") {
    signal1 <- apply(log2.pseudocounts.diff[, which(conditions ==
                                                      levels(factor(conditions))[1])],
                  1, mean)
    signal2 <- apply(log2.pseudocounts.diff[, which(conditions ==
                                                      levels(factor(conditions))[2])],
                  1, mean)
  }

  return(list(signal1 = signal1, signal2 = signal2))
}

# Plot the gene score vs the "signal", for genes expressed in only one condition
#
# For genes expressed in only one condition, plot the gene score vs the average expression level in that condition. All replicates are merged in one plot. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# @param setup.parameters List of parameters (internal).
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which the plots will be constructed
# @param sel.repl The replicate numbers (instances of a given simulation setting) for which the plots will be constructed
# @author Charlotte Soneson
plotSignalForZeroCounts <- function(setup.parameters, sel.nbrsamples, sel.repl) {
  theplotcols <- c("black", "red", "green", "blue", "grey", "cyan", "forestgreen",
                   "orange", "brown", "violet", "deeppink", "aquamarine4",
                   "cadetblue3", "bisque", "darkkhaki", "darkgoldenrod3", "pink",
                   "plum", "tomato", "yellow", "azure4", "blue4", "blueviolet",
                   "chartreuse", "chocolate", "cornflowerblue", "darkorange2",
                   "darksalmon", "lemonchiffon2", "palegreen", "lightskyblue2")

  nbr.cols <- 3
  nbr.rows <- ceiling(length(setup.parameters$incl.de.methods)/nbr.cols)
  for (i in seq_len(length(sel.nbrsamples))) {
    graphics::par(mfrow = c(nbr.rows, nbr.cols), cex.lab = 2,
                  cex.axis = 1.5, las = 1, cex.main = 1.2,
                  cex.main = 1.75, mar = c(5, 5, 4, 2))
    for (k in seq_len(length(setup.parameters$incl.de.methods))) {
      idx1 <- findFileIdx(setup.parameters$file.info, "de.methods",
                          setup.parameters$incl.de.methods[k])
      idx2 <- findFileIdx(setup.parameters$file.info, "nbr.samples",
                          sel.nbrsamples[i])
      tmpx <- c()
      tmpy <- c()
      plotcol <- c()
      for (j in seq_len(length(sel.repl))) {
        idx3 <- findFileIdx(setup.parameters$file.info, "repl", sel.repl[j])
        idx <- intersect(intersect(idx1, idx2), idx3)
        if (length(idx) != 0) {
          X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
          if (is.list(X)) X <- convertListTocompData(X)
          zerocounts <- findGenesAllZero(count.matrix(X), sample.annotations(X)$condition)
          signals <- computeSignal(count.matrix(X), sample.annotations(X)$condition,
                                   signal.measure = setup.parameters$signal.measure)
          tmpx <- c(tmpx, signals$signal1[zerocounts$zero2], signals$signal2[zerocounts$zero1])
          tmpy <- c(tmpy, result.table(X)$score[zerocounts$zero2],
                    result.table(X)$score[zerocounts$zero1])
          plotcol <- c(plotcol, rep(theplotcols[j],
                                    length(zerocounts$zero1) + length(zerocounts$zero2)))
        }
      }
      if ((length(tmpx) != 0) && (!(all(is.na(tmpy))))) {
        plot(tmpx, tmpy, xlab = setup.parameters$signal.measure,
             ylab = "Score", cex = 1, pch = 20, col = plotcol,
             main = setup.parameters$incl.de.methods[k])
        ##linecol <- setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]]
        ##loessline <- loess(tmpy ~ tmpx, span = 0.25)
        ##xval <- seq(min(tmpx), max(tmpx), length.out = 500)
        ##lines(xval, predict(loessline, xval), col = linecol, lwd = 5)
      } else {
        plot(1, type = "n", axes = FALSE, xlab = "", ylab = "",
             main = setup.parameters$incl.de.methods[k])
      }
    }
  }
}

# computeM <- function(count.matrix, conditions) {
#   nf <- calcNormFactors(count.matrix)
#   norm.factors <- nf * colSums(count.matrix)
#   common.libsize <- exp(mean(log(colSums(count.matrix))))
#   pseudocounts <- sweep(count.matrix + 0.5, 2, norm.factors, '/') * common.libsize
#   log2.pseudocounts <- log2(pseudocounts)
#   M.value <- apply(log2.pseudocounts[, which(conditions == levels(factor(conditions))[2])],
#                    1, mean) -
#     apply(log2.pseudocounts[, which(conditions == levels(factor(conditions))[1])],
#           1, mean)
#   return(M.value)
# }

# computeA <- function(count.matrix, conditions) {
#   nf <- calcNormFactors(count.matrix)
#   norm.factors <- nf * colSums(count.matrix)
#   common.libsize <- exp(mean(log(colSums(count.matrix))))
#   pseudocounts <- sweep(count.matrix + 0.5, 2, norm.factors, '/') * common.libsize
#   log2.pseudocounts <- log2(pseudocounts)
#   A.value <- 0.5*(apply(log2.pseudocounts[, which(conditions == levels(factor(conditions))[2])],
#                         1, mean) +
#                     apply(log2.pseudocounts[, which(conditions ==
#                                                       levels(factor(conditions))[1])],
#                           1, mean))
#   return(A.value)
# }

computeFDR <- function(adjpvalues, trueDElabels, signthreshold) {
  length(intersect(which(adjpvalues < signthreshold),
                   which(trueDElabels == 0)))/length(which(adjpvalues < signthreshold))
}

computeTPR <- function(adjpvalues, trueDElabels, signthreshold) {
  length(intersect(which(adjpvalues < signthreshold),
                   which(trueDElabels == 1)))/length(which(trueDElabels == 1))
}

computeTP <- function(adjpvalues, trueDElabels, signthreshold) {
  length(intersect(which(adjpvalues < signthreshold),
                   which(trueDElabels == 1)))
}

computeFP <- function(adjpvalues, trueDElabels, signthreshold) {
  length(intersect(which(adjpvalues < signthreshold),
                   which(trueDElabels == 0)))
}

computeTN <- function(adjpvalues, trueDElabels, signthreshold) {
  length(intersect(which(adjpvalues >= signthreshold),
                   which(trueDElabels == 0)))
}

computeFN <- function(adjpvalues, trueDElabels, signthreshold) {
  length(intersect(which(adjpvalues >= signthreshold),
                   which(trueDElabels == 1)))
}

computeMCC <- function(adjpvalues, trueDElabels, signthreshold) {
  tp <- length(intersect(which(adjpvalues < signthreshold),
                          which(trueDElabels == 1)))
  fp <- length(intersect(which(adjpvalues < signthreshold),
                          which(trueDElabels == 0)))
  tn <- length(intersect(which(adjpvalues >= signthreshold),
                          which(trueDElabels == 0)))
  fn <- length(intersect(which(adjpvalues >= signthreshold),
                          which(trueDElabels == 1)))
  n <- tp + fp + tn + fn
  s <- (tp + fn)/n
  p <- (tp + fp)/n
  (tp/n - s*p)/sqrt(p*s*(1 - s)*(1 - p))
}

computeTypeIerror <- function(pvalues, trueDElabels, signthreshold) {
  length(intersect(which(pvalues < signthreshold),
                   which(trueDElabels == 0)))/length(which(trueDElabels == 0))

}

findFileIdx <- function(file.table, column, value) {
  if (is.na(value)) {
    return(which(is.na(file.table[, column])))
  } else {
    return(which(file.table[, column] == value))
  }
}

# Plot the observed FDR vs the average expression level of the gene
#
# Plot the observed FDR vs the average expression level (A) for all genes. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# @param setup.parameters List of parameters (internal).
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which the MA plots will be constructed
# @param sel.repl The replicate numbers (instances of a given simulation setting) for which the MA plots will be constructed
# @author Charlotte Soneson
plotFDRVsExpr <- function(setup.parameters, sel.nbrsamples, sel.repl) {
  for (i in seq_len(length(sel.nbrsamples))) {
    all.methods <- NULL
    obs.fdr.total <- NULL
    doplot <- FALSE
    idx1 <- findFileIdx(setup.parameters$file.info, "nbr.samples", sel.nbrsamples[i])
    for (k in seq_len(length(setup.parameters$incl.de.methods))) {
      obs.fdr.method <- NULL
      idx2 <- intersect(idx1, findFileIdx(setup.parameters$file.info, "de.methods",
                                          setup.parameters$incl.de.methods[k]))
      for (j in seq_len(length(sel.repl))) {
        idx <- intersect(idx2, findFileIdx(setup.parameters$file.info, "repl",
                                           sel.repl[j]))
        if (length(idx) != 0) {
          X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
          if (is.list(X)) X <- convertListTocompData(X)
          if (!all(variable.annotations(X)$differential.expression == 0)) {
            if (is.null(variable.annotations(X)$A.value)) {
              A.value <- computeAval(count.matrix(X), sample.annotations(X)$condition)
            } else {
              A.value <- variable.annotations(X)$A.value
            }
            if ('adjpvalue' %in% colnames(result.table(X))) {
              adjp <- result.table(X)$adjpvalue
            } else if ('FDR' %in% colnames(result.table(X))) {
              adjp <- result.table(X)$FDR
            } else {
              adjp <- NULL
            }
            if (!is.null(adjp)) {
              if (!(setup.parameters$incl.de.methods[k] %in% all.methods)) {
                all.methods <- c(all.methods, setup.parameters$incl.de.methods[k])
              }
              doplot <- TRUE
              tmp <- data.frame(status = variable.annotations(X)$differential.expression,
                                adjp = adjp)
              ## Split the genes by expression level
              r <- range(A.value)
              expr.bin <- cut(A.value, seq(r[1], r[2], length.out = 11),
                              include.lowest = TRUE)
              levels(expr.bin) <- c("(0,10]", "(10,20]", "(20,30]", "(30,40]",
                                    "(40,50]", "(50,60]", "(60,70]", "(70,80]",
                                    "(80,90]", "(90,100]")
              ## Split the fdr vector and compute the observed FDR
              split.tmp <- split(tmp, expr.bin)
              obs.fdr <- vapply(split.tmp, function(x, thr = setup.parameters$fdr.threshold) {
                computeFDR(x$adjp, x$status, thr)
              }, FUN.VALUE = NA_real_)
              obs.fdr.method <- rbind(obs.fdr.method, data.frame(bin = names(obs.fdr),
                                                                 fdr = obs.fdr,
                                                                 method = rep(setup.parameters$incl.de.methods[k], length(obs.fdr))))
            }
          }
        }
      }
      if ((!is.null(obs.fdr.method)) && (!all(is.na(obs.fdr.method$fdr)))) {
        obs.fdr.total <- rbind(obs.fdr.total, obs.fdr.method)
      }
    }
    #}
    if (doplot && is.data.frame(obs.fdr.total)) {
      obs.fdr.total$method <- factor(obs.fdr.total$method,
                                     levels = setup.parameters$incl.de.methods)

      suppressWarnings({
        print(ggplot(obs.fdr.total, aes_string(x = "bin", y = "fdr", fill = "method")) +
                geom_boxplot(outlier.size = 0) +
                scale_fill_manual(values = unlist(setup.parameters$specified.colors),
                                  name = "", guide = FALSE) +
                facet_wrap(~ method, ncol = 3, drop = FALSE, scales = "free_x") +
                geom_jitter(position = position_jitter(width = 0.1, height = 0), size = 1.5) +
                xlab("Bin") +
                ylab("FDR") +
                theme_bw() +
                scale_y_continuous(limits = c(-0, 1)) +
                theme(strip.text.x = element_text(size = 15),
                      axis.text.y = element_text(size = 15),
                      axis.text.x = element_text(angle = 90, hjust = 1, vjust = 0.5, size = 15),
                      axis.title.x = element_text(size = 15),
                      axis.title.y = element_text(size = 15)))
      })

    } else {
      cat ("No truly differentially expressed genes found, or no differentially expressed genes found by any method. ")
    }
  }
}

# Plot distribution of gene scores as a function of the number of outliers
#
# Plot the distribution of the scores assigned to the genes, grouped by the total number of outlier counts introduced for the genes.
#
# @param setup.parameters List of parameters (internal).
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which the enrichment plots will be constructed
# @param sel.repl The replicate numbers (instances of a given simulation setting) for which the enrichment plots will be constructed
# @author Charlotte Soneson
plotScoreVsOutliers <- function(setup.parameters, sel.nbrsamples, sel.repl) {
  nbr.cols <- 3
  nbr.rows <- ceiling(length(setup.parameters$incl.de.methods)/nbr.cols)
  for (i in seq_len(length(sel.nbrsamples))) {
    graphics::par(mfrow = c(nbr.rows, nbr.cols), mar = c(9, 6, 4, 2), mgp = c(4, 1, 0),
                  cex.axis = 1.5, las = 1, cex.main = 1.75, cex.lab = 2)
    for (k in seq_len(length(setup.parameters$incl.de.methods))) {
      idx1 <- findFileIdx(setup.parameters$file.info, "de.methods",
                          setup.parameters$incl.de.methods[k])
      idx2 <- findFileIdx(setup.parameters$file.info, "nbr.samples",
                          sel.nbrsamples[i])
      idx3 <- findFileIdx(setup.parameters$file.info, "repl", sel.repl)
      idx <- intersect(intersect(idx1, idx2), idx3)
      if (length(idx) != 0) {
        X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
        if (is.list(X)) X <- convertListTocompData(X)
        score <- result.table(X)$score
        if (length(variable.annotations(X)) != 0) {
          total.outliers <- apply(variable.annotations(X)[match(rownames(result.table(X)),
                                                                rownames(variable.annotations(X))),
                                                          which(colnames(variable.annotations(X)) %in%
                                                                  c("n.random.outliers.up.S1",
                                                                    "n.random.outliers.up.S2",
                                                                    "n.random.outliers.down.S1",
                                                                    "n.random.outliers.down.S2",
                                                                    "n.single.outliers.up.S1",
                                                                    "n.single.outliers.up.S2",
                                                                    "n.single.outliers.down.S1",
                                                                    "n.single.outliers.down.S2"))], 1, sum)
        } else {
          total.outliers <- rep(0, length(score))
        }

        ## Violin plots
        keep <- which(total.outliers %in%
                        names(table(total.outliers))[which(table(total.outliers) > 3)])
        total.outliers <- total.outliers[keep]
        score <- score[keep]

        w <- split(score, total.outliers)
        names(w)[1] <- "x"

        do.call(vioplot, c(lapply(w, stats::na.omit),
                           list(horizontal = FALSE, names = names(table(total.outliers))),
                           col = setup.parameters$specified.colors[[setup.parameters$incl.de.methods[k]]]))
        graphics::title(main = setup.parameters$incl.de.methods[k],
                        xlab = "Total number of outliers",
                        ylab = "Score")

        graphics::axis(1, at = seq_len(length(unique(total.outliers))),
                       labels = paste("n =", table(total.outliers)[match(levels(factor(total.outliers)),
                                                                         names(table(total.outliers)))]),
                       tick = FALSE, line = 1, lwd = 0)

      }
    }
  }
}

# Construct a result table with selected performance measures for later plotting
#
# Construct a result table containing one or several of the type I error, the fraction of significant genes, the false discovery rate (FDR), the true positive rate (TPR), Matthew's correlation coefficient (MCC), and the area under the ROC curve (AUC). This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# The result table returned from this function may contain "missing" lines, for example, there may be some differential expression methods that have not been applied to all data sets. This can be fixed by passing the result table through the \code{\link{padResultTable}} function, which will fill in all such missing lines with NA values.
#
# @param setup.parameters List of parameters (internal). The \code{comparisons} entry defines the performance measures that will be included in the result table.
# @return A result table, containing the selected performance measures for each differential expression method and for each of the included data sets (the collection of data sets to include is defined by the \code{setup.parameters} list).
# @author Charlotte Soneson
createResultTable <- function(setup.parameters) {
  if ('typeIerror' %in% setup.parameters$comparisons) {tIe.vec <- rep(NA, nrow(setup.parameters$file.info))}
  if ('fracsign' %in% setup.parameters$comparisons) {fsn.vec <- rep(NA, nrow(setup.parameters$file.info))}
  if ('nbrsign' %in% setup.parameters$comparisons) {nsn.vec <- rep(NA, nrow(setup.parameters$file.info))}
  if ('nbrtpfp' %in% setup.parameters$comparisons) {
    tp.vec <- rep(NA, nrow(setup.parameters$file.info))
    fp.vec <- rep(NA, nrow(setup.parameters$file.info))
    tn.vec <- rep(NA, nrow(setup.parameters$file.info))
    fn.vec <- rep(NA, nrow(setup.parameters$file.info))
  }
  if ('fdr' %in% setup.parameters$comparisons) {fdr.vec <- rep(NA, nrow(setup.parameters$file.info))}
  if ('tpr' %in% setup.parameters$comparisons) {tpr.vec <- rep(NA, nrow(setup.parameters$file.info))}
  if ('auc' %in% setup.parameters$comparisons) {auc.vec <- rep(NA, nrow(setup.parameters$file.info))}
  if ('mcc' %in% setup.parameters$comparisons) {mcc.vec <- rep(NA, nrow(setup.parameters$file.info))}

  for (i in seq_len(nrow(setup.parameters$file.info))) {
    X <- readRDS(as.character(setup.parameters$file.info$input.files[i]))
    if (is.list(X)) X <- convertListTocompData(X)
    if ('typeIerror' %in% setup.parameters$comparisons && 'pvalue' %in% colnames(result.table(X))) {
      tIe.vec[i] <- computeTypeIerror(result.table(X)$pvalue,
                                      variable.annotations(X)$differential.expression,
                                      setup.parameters$typeI.threshold)
    }
    if (!all(variable.annotations(X)$differential.expression == 0)) {
      if ('auc' %in% setup.parameters$comparisons) {
        the.scores <- result.table(X)$score
        idx_not_na <- which(!is.na(the.scores))
        the.prediction <- prediction(the.scores[idx_not_na],
                                     variable.annotations(X)$differential.expression[idx_not_na])
        auc.vec[i] <- unlist(performance(the.prediction, measure = 'auc')@y.values)
      }

      if ('mcc' %in% setup.parameters$comparisons) {
        if ('FDR' %in% colnames(result.table(X))) {
          mcc.vec[i] <- computeMCC(result.table(X)$FDR,
                                   variable.annotations(X)$differential.expression,
                                   setup.parameters$mcc.threshold)
        } else {
          if ('adjpvalue' %in% colnames(result.table(X))) {
            mcc.vec[i] <- computeMCC(result.table(X)$adjpvalue,
                                     variable.annotations(X)$differential.expression,
                                     setup.parameters$mcc.threshold)
          }
        }
      }

      if ('fdr' %in% setup.parameters$comparisons) {
        if ('FDR' %in% colnames(result.table(X))) {
          fdr.vec[i] <- computeFDR(result.table(X)$FDR,
                                   variable.annotations(X)$differential.expression,
                                   setup.parameters$fdr.threshold)
        } else {
          if ('adjpvalue' %in% colnames(result.table(X))) {
            fdr.vec[i] <- computeFDR(result.table(X)$adjpvalue,
                                     variable.annotations(X)$differential.expression,
                                     setup.parameters$fdr.threshold)
          }
        }
      }

      if ('tpr' %in% setup.parameters$comparisons) {
        if ('FDR' %in% colnames(result.table(X))) {
          tpr.vec[i] <- computeTPR(result.table(X)$FDR,
                                   variable.annotations(X)$differential.expression,
                                   setup.parameters$tpr.threshold)
        } else {
          if ('adjpvalue' %in% colnames(result.table(X))) {
            tpr.vec[i] <- computeTPR(result.table(X)$adjpvalue,
                                     variable.annotations(X)$differential.expression,
                                     setup.parameters$tpr.threshold)
          }
        }
      }

      if ('nbrtpfp' %in% setup.parameters$comparisons) {
        if ('FDR' %in% colnames(result.table(X))) {
          tp.vec[i] <- computeTP(result.table(X)$FDR,
                                 variable.annotations(X)$differential.expression,
                                 setup.parameters$nbrtpfp.threshold)
          tn.vec[i] <- computeTN(result.table(X)$FDR,
                                 variable.annotations(X)$differential.expression,
                                 setup.parameters$nbrtpfp.threshold)
          fp.vec[i] <- computeFP(result.table(X)$FDR,
                                 variable.annotations(X)$differential.expression,
                                 setup.parameters$nbrtpfp.threshold)
          fn.vec[i] <- computeFN(result.table(X)$FDR,
                                 variable.annotations(X)$differential.expression,
                                 setup.parameters$nbrtpfp.threshold)
        } else {
          if ('adjpvalue' %in% colnames(result.table(X))) {
            tp.vec[i] <- computeTP(result.table(X)$adjpvalue,
                                   variable.annotations(X)$differential.expression,
                                   setup.parameters$nbrtpfp.threshold)
            tn.vec[i] <- computeTN(result.table(X)$adjpvalue,
                                   variable.annotations(X)$differential.expression,
                                   setup.parameters$nbrtpfp.threshold)
            fp.vec[i] <- computeFP(result.table(X)$adjpvalue,
                                   variable.annotations(X)$differential.expression,
                                   setup.parameters$nbrtpfp.threshold)
            fn.vec[i] <- computeFN(result.table(X)$adjpvalue,
                                   variable.annotations(X)$differential.expression,
                                   setup.parameters$nbrtpfp.threshold)
          }
        }
      }

    }

    if ('fracsign' %in% setup.parameters$comparisons) {
      if ('FDR' %in% colnames(result.table(X))) {
        fsn.vec[i] <- length(which(result.table(X)$FDR <
                                     setup.parameters$fracsign.threshold))/nrow(result.table(X))
      } else {
        if ('adjpvalue' %in% colnames(result.table(X))) {
          fsn.vec[i] <- length(which(result.table(X)$adjpvalue <
                                       setup.parameters$fracsign.threshold))/nrow(result.table(X))
        }
      }
    }

    if ('nbrsign' %in% setup.parameters$comparisons) {
      if ('FDR' %in% colnames(result.table(X))) {
        nsn.vec[i] <- length(which(result.table(X)$FDR <
                                     setup.parameters$fracsign.threshold))
      } else {
        if ('adjpvalue' %in% colnames(result.table(X))) {
          nsn.vec[i] <- length(which(result.table(X)$adjpvalue <
                                       setup.parameters$fracsign.threshold))
        }
      }
    }
  }
  temp.results <- NULL
  if ('typeIerror' %in% setup.parameters$comparisons) {temp.results <- cbind(temp.results, 'typeIerror' = tIe.vec)}
  if ('fracsign' %in% setup.parameters$comparisons) {temp.results <- cbind(temp.results, 'fracsign' = fsn.vec)}
  if ('nbrsign' %in% setup.parameters$comparisons) {temp.results <- cbind(temp.results, 'nbrsign' = nsn.vec)}
  if ('fdr' %in% setup.parameters$comparisons) {temp.results <- cbind(temp.results, 'fdr' = fdr.vec)}
  if ('tpr' %in% setup.parameters$comparisons) {temp.results <- cbind(temp.results, 'tpr' = tpr.vec)}
  if ('auc' %in% setup.parameters$comparisons) {temp.results <- cbind(temp.results, 'auc' = auc.vec)}
  if ('mcc' %in% setup.parameters$comparisons) {temp.results <- cbind(temp.results, 'mcc' = mcc.vec)}
  if ('nbrtpfp' %in% setup.parameters$comparisons) {
    temp.results <- cbind(temp.results, 'fp' = fp.vec)
    temp.results <- cbind(temp.results, 'tp' = tp.vec)
    temp.results <- cbind(temp.results, 'fn' = fn.vec)
    temp.results <- cbind(temp.results, 'tn' = tn.vec)
  }
  result.table <- data.frame(cbind(setup.parameters$file.info[, c('nbr.samples',
                                                                  'repl',
                                                                  'de.methods')],
                                   temp.results))
  result.table
}

# Generates the missing lines of a result table
#
# Pads a result table generated by \code{\link{createResultTable}} by extending it with lines containing NA to replace "missing lines". This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# @seealso \code{\link{createResultTable}}
# @param result.table A result table generated by \code{\link{createResultTable}}.
# @return An extended result table. This can be sent to \code{\link{plotResultTable}} to create a graphical representation in the form of a boxplot.
# @author Charlotte Soneson
padResultTable <- function(result.table) {
  unique.spc <- unique(result.table$nbr.samples)
  unique.repl <- unique(result.table$repl)
  unique.method <- unique(result.table$de.methods)
  rt.temp.1 <- NULL
  rt.temp.2 <- NULL
  rt.temp.3 <- NULL
  for (i in seq_len(length(unique.spc))) {
    for (j in seq_len(length(unique.repl))) {
      for (k in seq_len(length(unique.method))) {
        if (length(intersect(intersect(which(result.table$nbr.samples == unique.spc[i]),
                                       which(result.table$repl == unique.repl[j])),
                             which(result.table$de.methods == unique.method[k]))) == 0) {
          rt.temp.1 <- rbind(rt.temp.1, c(unique.spc[i], unique.repl[j]))
          rt.temp.2 <- c(rt.temp.2, unique.method[k])
          rt.temp.3 <- rbind(rt.temp.3, rep(NaN, ncol(result.table) - 3))
        }
      }
    }
  }
  rt.temp <- data.frame(rt.temp.1, rt.temp.2, rt.temp.3)
  if (nrow(rt.temp) != 0) {
    colnames(rt.temp) <- colnames(result.table)
    result.table <- rbind(result.table, rt.temp)
  }
  ## Replace NAs with NaNs
  result.table[is.na(result.table)] <- NaN
  for (i in seq_len(length(unique.spc))) {
    for (j in seq_len(length(unique.method))) {
      a <- intersect(which(result.table$nbr.samples == unique.spc[i]),
                    which(result.table$de.methods == unique.method[j]))
      for (w in 4:ncol(result.table)) {
        if (all(is.na(result.table[a, w]) | result.table[a, w] == 'NaN')) {
          result.table[a, w] <- (-1000)
        }
      }
    }
  }
  result.table
}

# Plot the content of a result table in a boxplot
#
# A function to construct a boxplot to represent a result table, obtained by \code{\link{createResultTable}} and potentially subsequently padded via \code{\link{padResultTable}}. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# @param setup.parameters List of parameters (internal).
# @param result.table R result table
# @param the.asp The measure that should be plotted. Possible values are \code{"auc"} (the area under the ROC curve), \code{"fdr"} (the false discovery rate), \code{"tpr"} (the true positive rate), \code{"typeIerror"}, \code{"mcc"} (Matthew's correlation coefficient), \code{"nbrtpfp"} (the number of TP, FP, TN, FN), \code{"nbrsign"} (the number of genes considered significant) and \code{"fracsign"} (the fraction of genes considered significant).
# @author Charlotte Soneson
plotResultTable <- function(setup.parameters, result.table, the.asp) {
  the.result <- result.table[[the.asp]]
  the.methods <- unique(result.table$de.methods)
  plot.colors <- NULL
  for (i in seq_len(length(the.methods))) {
    plot.colors <- c(plot.colors, setup.parameters$specified.colors[[the.methods[i]]])
  }
  names(plot.colors) <- the.methods
  xmax.def <- max(the.result, na.rm = TRUE)
  xmin.def <- 0

  if (the.asp == 'typeIerror') {
    the.xlab <- 'Type I error'
    the.threshold <- setup.parameters$typeI.threshold
    the.xmin <- setup.parameters$lower.limits$typeIerror
    the.xmax <- setup.parameters$upper.limits$typeIerror
  }
  if (the.asp == 'fdr') {
    the.xlab <- 'False discovery rate'
    the.threshold <- setup.parameters$fdr.threshold
    the.xmin <- setup.parameters$lower.limits$fdr
    the.xmax <- setup.parameters$upper.limits$fdr
  }
  if (the.asp == 'tpr') {
    the.xlab <- 'True positive rate'
    the.threshold <- NA
    the.xmin <- setup.parameters$lower.limits$tpr
    the.xmax <- setup.parameters$upper.limits$tpr
  }
  if (the.asp == 'mcc') {
    the.xlab <- 'MCC'
    the.threshold <- NA
    the.xmin <- setup.parameters$lower.limits$mcc
    the.xmax <- setup.parameters$upper.limits$mcc
  }
  if (the.asp == 'auc') {
    the.xlab <- 'AUC'
    the.threshold <- NA
    the.xmin <- setup.parameters$lower.limits$auc
    the.xmax <- setup.parameters$upper.limits$auc
  }
  if (the.asp == 'fracsign') {
    the.xlab <- 'Fraction significant'
    the.threshold <- NA
    the.xmin <- setup.parameters$lower.limits$fracsign
    the.xmax <- setup.parameters$upper.limits$fracsign
  }
  if (the.asp == "nbrsign") {
    the.xlab = "Number significant"
    the.threshold <- NA
    the.xmin <- setup.parameters$lower.limits$nbrsign
    the.xmax <- setup.parameters$upper.limits$nbrsign
  }
  if (the.asp == "tp") {
    the.xlab <- "Number of true positives"
    the.threshold <- NA
    the.xmin <- setup.parameters$lower.limits$tp
    the.xmax <- setup.parameters$upper.limits$tp
  }
  if (the.asp == "tn") {
    the.xlab = "Number of true negatives"
    the.threshold <- NA
    the.xmin <- setup.parameters$lower.limits$tn
    the.xmax <- setup.parameters$upper.limits$tn
  }
  if (the.asp == "fp") {
    the.xlab <- "Number of false positives"
    the.threshold <- NA
    the.xmin <- setup.parameters$lower.limits$fp
    the.xmax <- setup.parameters$upper.limits$fp
  }
  if (the.asp == "fn") {
    the.xlab <- "Number of false negatives"
    the.threshold <- NA
    the.xmin <- setup.parameters$lower.limits$fn
    the.xmax <- setup.parameters$upper.limits$fn
  }
  xmax <- ifelse(is.null(the.xmax), xmax.def, the.xmax)
  xmin <- ifelse(is.null(the.xmin), xmin.def, the.xmin)

  if (any(!is.na(the.result)) && !all(the.result == -1000)) {
    graphics::par(mar = c(5, max(nchar(the.methods)), 4, 2))
    if (any(!is.na(result.table$nbr.samples))) {
      f2.temp <- factor(paste(result.table$nbr.samples, "samples per condition"),
                        levels = paste(sort(as.numeric(unique(result.table$nbr.samples)),
                                            decreasing = FALSE), "samples per condition"))
      result.table$nbr.samples.2 <- f2.temp
      ## The ggplot command below will throw an error:
      ## Error in `$<-.data.frame`(`*tmp*`, "weight", value = 1) :
      ## replacement has 1 row, data has 0
      ## if one facet is completely empty (all methods). It arises since all points of
      ## the facet are outside of the plotting range. It can be ignored.
      suppressWarnings({
        print(ggplot(result.table, aes_string(x = "de.methods", y = the.asp,
                                              fill = "de.methods")) +
                geom_hline(yintercept = ifelse(is.na(the.threshold), xmin - 3, the.threshold),
                           linetype = 2) +
                geom_boxplot(outlier.size = 0) +
                scale_fill_manual(values = plot.colors, name = "", guide = FALSE) +
                facet_wrap(~ nbr.samples.2, ncol = 1) +
                geom_jitter(position = position_jitter(width = 0.1, height = 0), size = 2) +
                xlab("") +
                ylab(the.xlab) +
                theme_bw() +
                scale_y_continuous(limits = c(xmin, xmax)) +
                coord_flip() +
                theme(strip.text.x = element_text(size = 15),
                      axis.text.y = element_text(size = 15),  #20
                      axis.text.x = element_text(size = 15),
                      axis.title.x = element_text(size = 15)))  #20
      })
    } else {
      suppressWarnings({
        print(ggplot(result.table, aes_string(x = "de.methods", y = the.asp,
                                              fill = "de.methods")) +
                geom_hline(yintercept = ifelse(is.na(the.threshold), xmin - 3, the.threshold),
                           linetype = 2) +
                geom_boxplot(outlier.size = 0) +
                scale_fill_manual(values = plot.colors, name = "", guide = FALSE) +
                geom_jitter(position = position_jitter(width = 0.1, height = 0), size = 2) +
                xlab("") +
                ylab(the.xlab) +
                theme_bw() +
                scale_y_continuous(limits = c(xmin, xmax)) +
                coord_flip() +
                theme(strip.text.x = element_text(size = 15),
                      axis.text.y = element_text(size = 15),
                      axis.text.x = element_text(size = 15),
                      axis.title.x = element_text(size = 15)))
      })
    }
  } else {
    cat("No results available. No truly differentially expressed genes provided?")
  }
}

# Compute Spearman correlations among scores
#
# Computes pairwise Spearman correlations among scores obtained from different differential expression methods applied to the same data set. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# @param setup.parameters List of parameters (internal). Needs to contain at least the following entries:
# \itemize{
# \item \code{incl.de.methods}
# \item \code{file.info}
# \item \code{result.table}
# }
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which the correlations should be computed. The correlations are computed separately for each sample size.
# @param sel.repl The replicate number (the instance of a given simulation setting) for which the correlations should be computed.
# @author Charlotte Soneson
computeCorrelation <- function(setup.parameters, sel.nbrsamples, sel.repl) {
  all.scores <- list()
  for (i in seq_len(length(sel.nbrsamples))) {
    if (any(!is.na(sel.nbrsamples))) {
      all.scores[[sel.nbrsamples[i]]] <- list()
    } else {
      all.scores <- list()
    }
    for (j in seq_len(length(setup.parameters$incl.de.methods))) {
      idx1 <- findFileIdx(setup.parameters$file.info, "de.methods",
                          setup.parameters$incl.de.methods[j])
      idx2 <- findFileIdx(setup.parameters$file.info, "nbr.samples",
                          sel.nbrsamples[i])
      idx3 <- findFileIdx(setup.parameters$file.info, "repl", sel.repl)
      idx <- intersect(intersect(idx1, idx2), idx3)
      if (length(idx) != 0) {
        X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
        if (is.list(X)) X <- convertListTocompData(X)
        if (any(!is.na(sel.nbrsamples))) {
          all.scores[[sel.nbrsamples[i]]][[setup.parameters$incl.de.methods[j]]] <-
            result.table(X)$score
        } else {
          all.scores[[setup.parameters$incl.de.methods[j]]] <- result.table(X)$score
        }
      }
    }
  }
  for (i in seq_len(length(sel.nbrsamples))) {
    if (any(!is.na(sel.nbrsamples))) {
      curr.methods <- names(all.scores[[sel.nbrsamples[i]]])
    } else {
      curr.methods <- names(all.scores)
    }
    Spearman.correlation <- matrix(0, length(curr.methods), length(curr.methods))
    for (j in seq_len(length(curr.methods))) {
      for (k in seq_len(length(curr.methods))) {
        if (any(!is.na(sel.nbrsamples))) {
          Spearman.correlation[j, k] <-
            stats::cor(all.scores[[sel.nbrsamples[i]]][[curr.methods[j]]],
                       all.scores[[sel.nbrsamples[i]]][[curr.methods[k]]],
                       method = 'spearman', use = 'na.or.complete')
        } else {
          Spearman.correlation[j, k] <-
            stats::cor(all.scores[[curr.methods[j]]],
                       all.scores[[curr.methods[k]]],
                       method = 'spearman', use = 'na.or.complete')
        }
      }
    }
    rownames(Spearman.correlation) <- colnames(Spearman.correlation) <- curr.methods
    print(Spearman.correlation)

    if (nrow(Spearman.correlation) > 2) {
      hc <- stats::hclust(stats::as.dist(1 - Spearman.correlation), method = 'average')
      print(levelplot(Spearman.correlation[hc$order, hc$order], xlab = '', ylab = '',
                      column.values = nrow(Spearman.correlation):1,
                      at = seq(-1, 1, length = 200),
                      scales = list(y = list(labels = curr.methods[hc$order],
                                             at = nrow(Spearman.correlation):1),
                                    x = list(rot = 90)),
                      col.regions = grDevices::heat.colors(200),
                      panel = function(...) {
                        arg <- list(...)
                        panel.levelplot(...)
                        panel.text(arg$x, arg$y, round(arg$z, 2))}))
      plot(hc)
    } else {
      print(levelplot(Spearman.correlation, xlab = '', ylab = '',
                      column.values = nrow(Spearman.correlation):1,
                      at = seq(-1, 1, length = 200),
                      scales = list(y = list(labels = curr.methods,
                                             at = nrow(Spearman.correlation):1),
                                    x = list(rot = 90)),
                      col.regions = grDevices::heat.colors(200),
                      panel = function(...) {
                        arg <- list(...)
                        panel.levelplot(...)
                        panel.text(arg$x, arg$y, round(arg$z, 2))}))
    }
  }
}

# Compute the overlap among sets of genes called differentially expressed by different methods
#
# Computes the overlap among sets of genes called differentially expressed by different methods applied to the same data set. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# The regular overlap analysis (i.e., with \code{plot.type = "overlap"}) computes the overlap (the number of shared genes) between the collection of genes called differentially expressed for each pair of differential expression methods. In other words, if \eqn{A} and \eqn{B} denote the collections of differentially expressed genes obtained by two methods, the overlap is defined as \deqn{O(A,B)=|A\cap B|,}where \eqn{|\cdot|} denotes the cardinality of a set. Since the expected overlap increases with the number of genes called differentially expressed, it is also possible to perform a normalized overlap analysis, which calculates instead the Sorensen index for each pair of gene collections. The Sorensen index for the two sets \eqn{A} and \eqn{B} is defined by \deqn{S(A,B)=\frac{2|A\cap B|}{|A|+|B|}.}
#
# @param setup.parameters List of parameters. Needs to contain at least the following entries:
# \itemize{
# \item \code{incl.de.methods}
# \item \code{file.info}
# \item \code{result.table}
# }
# @param sel.nbrsamples The sample sizes (number of samples per condition) for which the correlations should be computed. The correlations are computed separately for each sample size.
# @param sel.repl The replicate number (the instance of a given simulation setting) for which the correlations should be computed.
# @param plot.type The type of comparison that will be performed. Possible values are \code{"overlap"} and \code{"sorensen"}.
# @author Charlotte Soneson
computeOverlap <- function(setup.parameters, sel.nbrsamples, sel.repl, plot.type) {
  sign.genes <- list()
  for (i in seq_len(length(sel.nbrsamples))) {
    if (any(!is.na(sel.nbrsamples))) {
      sign.genes[[sel.nbrsamples[i]]] <- list()
    } else {
      sign.genes <- list()
    }
    for (j in seq_len(length(setup.parameters$incl.de.methods))) {
      idx1 <- findFileIdx(setup.parameters$file.info, "de.methods",
                          setup.parameters$incl.de.methods[j])
      idx2 <- findFileIdx(setup.parameters$file.info, "nbr.samples",
                          sel.nbrsamples[i])
      idx3 <- findFileIdx(setup.parameters$file.info, "repl", sel.repl)
      idx <- intersect(intersect(idx1, idx2), idx3)
      if (length(idx) != 0) {
        X <- readRDS(as.character(setup.parameters$file.info$input.files[idx]))
        if (is.list(X)) X <- convertListTocompData(X)
        if ('adjpvalue' %in% colnames(result.table(X))) {
          if (any(!is.na(sel.nbrsamples))) {
            sign.genes[[sel.nbrsamples[i]]][[setup.parameters$incl.de.methods[j]]] <-
              rownames(result.table(X))[which(result.table(X)$adjpvalue <
                                                setup.parameters$overlap.threshold)]
          } else {
            sign.genes[[setup.parameters$incl.de.methods[j]]] <-
              rownames(result.table(X))[which(result.table(X)$adjpvalue <
                                                setup.parameters$overlap.threshold)]
          }
        } else {
          if ('FDR' %in% colnames(result.table(X))) {
            if (any(!is.na(sel.nbrsamples))) {
              sign.genes[[sel.nbrsamples[i]]][[setup.parameters$incl.de.methods[j]]] <-
                rownames(result.table(X))[which(result.table(X)$FDR <
                                                  setup.parameters$overlap.threshold)]
            } else {
              sign.genes[[setup.parameters$incl.de.methods[j]]] <-
                rownames(result.table(X))[which(result.table(X)$FDR <
                                                  setup.parameters$overlap.threshold)]
            }
          }
        }
      }
    }
  }
  for (i in seq_len(length(sel.nbrsamples))) {
    if (any(!is.na(sel.nbrsamples))) {
      curr.methods <- names(sign.genes[[sel.nbrsamples[i]]])
    } else {
      curr.methods <- names(sign.genes)
    }
    Sorensen.index <- matrix(0, length(curr.methods), length(curr.methods))
    Overlap <- matrix(0, length(curr.methods), length(curr.methods))
    for (j in seq_len(length(curr.methods))) {
      for (k in seq_len(length(curr.methods))) {
        if (any(!is.na(sel.nbrsamples))) {
          Sorensen.index[j, k] <-
            computeSorensen(sign.genes[[sel.nbrsamples[i]]][[curr.methods[j]]],
                            sign.genes[[sel.nbrsamples[i]]][[curr.methods[k]]])
          Overlap[j, k] <- length(intersect(sign.genes[[sel.nbrsamples[i]]][[curr.methods[j]]],
                                            sign.genes[[sel.nbrsamples[i]]][[curr.methods[k]]]))
        } else {
          Sorensen.index[j, k] <- computeSorensen(sign.genes[[curr.methods[j]]],
                                                  sign.genes[[curr.methods[k]]])
          Overlap[j, k] <- length(intersect(sign.genes[[curr.methods[j]]],
                                            sign.genes[[curr.methods[k]]]))
        }
      }
    }
    rownames(Sorensen.index) <- colnames(Sorensen.index) <- curr.methods
    rownames(Overlap) <- colnames(Overlap) <- curr.methods
    if (plot.type == 'Sorensen') {
      print(Sorensen.index)
      Sorensen.noNA <- Sorensen.index
      Sorensen.noNA[is.na(Sorensen.index)] <- 0
      hc <- stats::hclust(stats::as.dist(1 - Sorensen.noNA))
      print(levelplot(Sorensen.index[hc$order, hc$order], xlab = '', ylab = '',
                      column.values = nrow(Sorensen.index):1, at = seq(0, 1, length = 100),
                      scales = list(y = list(labels=curr.methods[hc$order],
                                             at=nrow(Sorensen.index):1),
                                    x = list(rot = 90)),
                      col.regions = grDevices::heat.colors(100),
                      panel = function(...) {
                        arg <- list(...)
                        panel.levelplot(...)
                        panel.text(arg$x, arg$y, round(arg$z, 2))}))
    }
    if (plot.type == 'Overlap') {
      print(Overlap)
    }
  }
}

computeSorensen <- function(x, y) {
  2 * length(intersect(x, y))/(length(x) + length(y))
}

# Shorten the names of comparison methods
#
# A function to transform the names of comparison methods from those entered in the GUI to those used within the program. This function is generally not called by the user, the main interface for comparing differential expression methods is the \code{\link{runComparisonGUI}} function.
#
# @param input.methods A list of comparison method identifiers, as entered in the graphical user interface.
# @return A list of transformed comparison method identifiers, as used within the package (less human readable).
# @author Charlotte Soneson
shorten.method.names <- function(input.methods) {
  transform.table <- list('AUC' = 'auc', 'TPR' = 'tpr', 'FDR' = 'fdr',
                          'Type I error' = 'typeIerror', 'MCC' = 'mcc',
                          'Number significant' = 'nbrsign',
                          'Number of TP, FP, TN, FN' = 'nbrtpfp',
                          'Fraction significant' = 'fracsign', 'MA plot' = 'maplot',
                          'False discovery curves, all replicates' = 'fdcurvesall',
                          'False discovery curves, one replicate' = 'fdcurvesone',
                          'ROC, all replicates' = 'rocall', 'ROC, one replicate' = 'rocone',
                          'Overlap, one replicate' = 'overlap',
                          'Gene score vs average expression level' = 'scorevsexpr',
                          'Sorensen index, one replicate' = 'sorensen',
                          'Spearman correlation between scores' = 'correlation',
                          'Score distribution vs number of outliers' = 'scorevsoutlier',
                          'FDR vs average expression level' = 'fdrvsexpr',
                          'Gene score vs signal for condition-specific genes' = 'scorevssignal')
  output.methods <- rep('', length(input.methods))
  for (i in seq_len(length(input.methods))) {
    output.methods[i] <- transform.table[[input.methods[i]]]
  }
  output.methods
}

#' Check consistency of input table to \code{\link{runComparison}}
#'
#' Check that the \code{dataset}, \code{nbr.samples}, \code{repl} and \code{de.methods} columns of a data frame are consistent with the information provided in the input files (given in the \code{input.files} column of the data frame). If there are inconsistencies or missing information in any of the columns, replace the given information with the information in the input files.
#'
#' @param file.table A data frame with columns named \code{input.files} and (optionally) \code{datasets}, \code{nbr.samples}, \code{repl}, \code{de.methods}.
#' @return Returns a consistent file table defining the result files that will be used as the basis for a method comparison.
#' @author Charlotte Soneson
#' @export
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.limma",
#'            Rmdfunction = "voom.limma.createRmd", output.directory = tmpdir,
#'            norm.method = "TMM")
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "edgeR.exact",
#'            Rmdfunction = "edgeR.exact.createRmd", output.directory = tmpdir,
#'            norm.method = "TMM",
#'            trend.method = "movingave", disp.type = "tagwise")
#'
#' ## A correct table
#' file.table <- data.frame(input.files = file.path(tmpdir,
#'                          c("mydata_voom.limma.rds", "mydata_edgeR.exact.rds")),
#'                          datasets = c("mydata", "mydata"),
#'                          nbr.samples = c(5, 5),
#'                          repl = c(1, 1),
#'                          stringsAsFactors = FALSE)
#' new.table <- checkTableConsistency(file.table)
#' new.table
#'
#' ## An incorrect table
#' file.table <- data.frame(input.files = file.path(tmpdir,
#'                          c("mydata_voom.limma.rds", "mydata_edgeR.exact.rds")),
#'                          datasets = c("mydata", "mydata"),
#'                          nbr.samples = c(5, 3),
#'                          repl = c(2, 1),
#'                          stringsAsFactors = FALSE)
#' new.table <- checkTableConsistency(file.table)
#' new.table
#'
#' ## A table with missing information
#' file.table <- data.frame(input.files = file.path(tmpdir,
#'                          c("mydata_voom.limma.rds", "mydata_edgeR.exact.rds")),
#'                          stringsAsFactors = FALSE)
#' new.table <- checkTableConsistency(file.table)
#' new.table
checkTableConsistency <- function(file.table) {

  if (is.null(file.table$input.files)) {
    stop("Table must have a column named input.files!")
  }

  datasets <- rep(NA, length(file.table$input.files))
  nbr.samples <- rep(NA, length(file.table$input.files))
  repl <- rep(NA, length(file.table$input.files))
  de.methods <- rep(NA, length(file.table$input.files))
  keep <- c()

  file.table <- lapply(file.table, function(x) {
    if (is.factor(x)) {
      as.character(x)
    } else {
      x
    }
  })

  for (i in seq_len(length(file.table$input.files))) {
    if (is.character(file.table$input.files[i]) &&
          str_detect(file.table$input.files[i], "\\.rds$")) {
      X <- readRDS(file.table$input.files[i])
      if (is.list(X)) X <- convertListTocompData(X)

      if (!is.logical(check_compData_results(X))) {
        message(paste("File", file.table$input.files[i], "is not a valid result object and will be removed from the table."))
      } else {
        keep <- c(keep, i)

        ## Check dataset (must be present in the data file)
        if (is.null(info.parameters(X)$dataset)) {
          stop(paste("'dataset' information missing in the file", file.table$input.files[i]))
        }
        if (!is.null(file.table$datasets)) {
          if (file.table$datasets[i] != info.parameters(X)$dataset) {
            message(paste("Inconsistency between provided dataset and information in file",
                          file.table$input.files[i], ". Replacing the given information with
                      the one given in the saved file."))
          }
        }
        datasets[i] <- info.parameters(X)$dataset

        ## Check nbr.samples
        if (is.null(info.parameters(X)$samples.per.cond)) {
          nbr.samples[i] <- NA
        } else {
          nbr.samples[i] <- info.parameters(X)$samples.per.cond
        }
        if (!is.null(file.table$nbr.samples)) {
          if (file.table$nbr.samples[i] != nbr.samples[i]) {
            message(paste("Inconsistency between provided nbr.samples and information in file",
                          file.table$input.files[i], ". Replacing the given information with
                      the one given in the saved file."))
          }
        }

        ## Check repl
        if (is.null(info.parameters(X)$repl.id)) {
          repl[i] <- NA
        } else {
          repl[i] <- info.parameters(X)$repl.id
        }
        if (!is.null(file.table$repl)) {
          if (file.table$repl[i] != repl[i]) {
            message(paste("Inconsistency between provided repl and information in file",
                          file.table$input.files[i], ". Replacing the given information with
                      the one given in the saved file."))
          }
        }

        ## Check nbr.samples
        if (is.null(method.names(X)$full.name)) {
          stop(paste("No (or misformatted) information about DE method in the file",
                     file.table$input.files[i]))
        }
        de.methods[i] <- method.names(X)$full.name
        if (!is.null(file.table$de.methods)) {
          if (file.table$de.methods[i] != de.methods[i]) {
            message(paste("Inconsistency between provided de.method and information in file",
                          file.table$input.files[i], ". Replacing the given information with
                      the one given in the saved file."))
          }
        }
      }
    } else {
      message(paste(file.table$input.files[i], "is not an rds file and will be removed from the table."))
    }
  }
  ## If everything ok, add the missing info to the file.table
  file.table$datasets <- datasets
  file.table$nbr.samples <- nbr.samples
  file.table$repl <- repl
  file.table$de.methods <- de.methods

  file.table <- data.frame(file.table, stringsAsFactors = FALSE)
  file.table[keep, ]
}

#' Check a list or a \code{compData} object for compatibility with the differential expression functions interfaced by \code{compcodeR}
#' 
#' Check if a list or a \code{compData} object contains the necessary slots for applying the differential expression functions interfaced by the \code{compcodeR} package. This function is provided for backward compatibility, see also \code{\link{check_compData}} and \code{\link{check_compData_results}}.
#' 
#' @param data.obj A list containing data and condition information, or a \code{compData} object.
#' @author Charlotte Soneson
#' @export
#' @examples
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
#'                                     samples.per.cond = 5, n.diffexp = 100)
#' checkDataObject(mydata.obj)
checkDataObject <- function(data.obj) {
  if (is.list(data.obj)) data.obj <- convertListTocompData(data.obj)
  if (check_compData(data.obj) == TRUE) {
    "Data object looks ok."
  }
}

#' Generate HTML file(s) containing code used to run differential expression analysis.
#'
#' A function to extract the code used to generate differential expression results from saved \code{compData} result objects (typically obtained by \code{\link{runDiffExp}}), and to write the code to HTML files. This requires that the code was saved as a character string in R markdown format in the \code{code} slot of the result object, which is done automatically by \code{\link{runDiffExp}}. If the differential expression analysis was performed with functions outside \code{compcodeR}, the code has to be added manually to the result object.
#'
#' @param input.files A vector with paths to one or several \code{.rds} files containing \code{compData} objects with the results from differential expression analysis. One code HTML file is generated for each file in the vector.
#' @param output.directory The path to the directory where the code HTML files will be saved.
#' @export
#' @author Charlotte Soneson
#' @examples
#' tmpdir <- normalizePath(tempdir(), winslash = "/")
#' mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
#'                                     samples.per.cond = 5, n.diffexp = 100,
#'                                     output.file = file.path(tmpdir, "mydata.rds"))
#' runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.limma",
#'            Rmdfunction = "voom.limma.createRmd", output.directory = tmpdir,
#'            norm.method = "TMM")
#' generateCodeHTMLs(file.path(tmpdir, "mydata_voom.limma.rds"), tmpdir)
generateCodeHTMLs <- function(input.files, output.directory) {
  input.files <- normalizePath(input.files, winslash = "/")
  output.directory <- normalizePath(output.directory, winslash = "/")

  for (i in seq_len(length(input.files))) {
    temp <- as.character(input.files[i])
    if (!(substr(basename(temp), nchar(basename(temp)) - 3, nchar(basename(temp))) == ".rds")) {
      message(paste(temp, "is not an .rds file, no code file will be generated."))
    } else {
      ## Extract only the filename (that will be used to name the code file)
      filename <- sub(".rds", "", basename(temp))
      rdsobj <- readRDS(temp)
      ## If it is a list, convert to a compData object
      if (is.list(rdsobj)) {
        rdsobj <- convertListTocompData(rdsobj)
      }
      if (!is.logical(check_compData(rdsobj))) {
        message(paste(temp, "is not a valid compData object, no code file will be generated."))
      } else {
        if (length(code(rdsobj)) == 0) {
          message(paste("Code not available in", input.files[i]))
        } else {
          ## Create the code file
          codefile <- file.path(output.directory, paste(filename,  "_code.md", sep = ""))
          fileConn <- file(codefile)

          ## Write the code to the file
          writeLines(text = code(rdsobj), con = fileConn)
          close(fileConn)

          ## Generate HTML file
          rmarkdown::pandoc_convert(input = codefile,
                                    output = str_replace(codefile, pattern = ".md", replacement = ".html"))
          # markdownToHTML(file = codefile,
          #                output = str_replace(codefile, pattern = ".md", replacement = ".html"),
          #                title = 'Code')

          ## Remove the temporary markdown file
          file.remove(codefile)
        }
      }
    }
  }
}

---
title: "Comparing methods for differential expression analysis of RNAseq data with the compcodeR package"
author: "Charlotte Soneson"
date: "`r Sys.Date()`"
package: compcodeR
output: 
  BiocStyle::html_document:
      toc: true
vignette: >
  %\VignetteIndexEntry{compcodeR}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography: compcodeR.bib
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
options(width = 55)
```

```{r setup}
library(compcodeR)
```

# Introduction

`r Biocpkg("compcodeR")` is an R package that provides an interface to several popular methods for differential expression analysis of RNAseq data and contains functionality for comparing the outcomes and performances of several differential expression methods applied to the same data set. The package also contains a function for generating synthetic RNAseq counts, using the simulation framework described in more detail in @Soneson2013.

This vignette provides a tutorial on how to use the different functionalities of the `r Biocpkg("compcodeR")` package. 

Currently, the differential expression interfaces provided in the package are restricted to comparisons between two conditions. However, many of the comparison functions are more general and can also be applied to test results from other contrast types, as well as to test results from other data types than RNAseq.

**Important!** Since `r Biocpkg("compcodeR")` provides interfaces to differential expression analysis methods implemented in other R packages, take care to cite the appropriate references if you use any of the interface functions (see the reference manual for more information). Also be sure to always check the code that was used to run the differential expression analysis, using e.g. the `generateCodeHTMLs()` function (see [below](#performing-differential-expression-analysis) for more information) to make sure that parameters etc. agree with your intentions and that there were no errors or serious warnings. These interface functions are provided for convenience and as templates for other, user-defined workflows, and there is no guarantee that the included differential expression code is kept up-to-date with the latest recommendations and best practices for running each of the interfaced methods, or that the chosen settings are suitable in all situations, and the user should make sure that the analysis is performed in the way they intend. For instructions on how to add your own DE method, see [below](#providing-your-own-differential-expression-code).


# The `compData` class

Within the `r Biocpkg("compcodeR")` package (version >= 0.2.0), data sets and results are represented as objects of the `compData` class. The functions in the package are still compatible with the list-based representation used in version 0.1.0, but we strongly encourage users to use the `compData` class, and all results generated by the package will be given in this format. If you have a data or result object generated with `r Biocpkg("compcodeR")` version 0.1.0, you can convert it to a `compData` object using the `convertListTocompData` function. 

A `compData` object has at least three slots, containing the count matrix, sample annotations and a list containing at least an identifying name and a unique ID for the data set. It can also contain variable annotations, such as information regarding genes that are known to be differentially expressed. After performing a differential expression analysis, the `compData` object contains additional information, such as which method was used to perform the analysis, which settings were used and the gene-wise results from the analysis. More detailed information about the `compData` class are available in the sections on [the data object](#the-data-object) and [the result object](#the-result-object).

# A sample workflow
This section contains a sample workflow showing the main functionalities of the `r Biocpkg("compcodeR")` package. We start by [generating a synthetic count data set](#simulating-data), to which we then [apply three different differential expression methods](#performing-differential-expression-analysis). Finally, we [compare the outcome](#comparing-results-from-several-differential-expression-methods) of the three methods and generate a report summarizing the results.

## Simulating data
The simulations are performed following the description by @Soneson2013. As an example, we use the `generateSyntheticData` function to generate a synthetic count data set containing 12,500 genes and two groups of 5 samples each, where 10% of the genes are simulated to be differentially expressed between the two groups (equally distributed between up- and downregulated in group 2 compared to group 1). Furthermore, the counts for all genes are simulated from a Negative Binomial distribution with the same dispersion in the two sample groups, and no outlier counts are introduced. We filter the data set by excluding only the genes with zero counts in all samples (i.e., those for which the total count is 0). This simulation setting corresponds to the one denoted $B_{625}^{625}$ in @Soneson2013. The following code creates a `compData` object containing the simulated data set and saves it to a file named `"B_625_625_5spc_repl1.rds"`.

```{r, eval=FALSE}
B_625_625 <- generateSyntheticData(dataset = "B_625_625", n.vars = 12500, 
                                   samples.per.cond = 5, n.diffexp = 1250, 
                                   repl.id = 1, seqdepth = 1e7, 
                                   fraction.upregulated = 0.5, 
                                   between.group.diffdisp = FALSE, 
                                   filter.threshold.total = 1, 
                                   filter.threshold.mediancpm = 0, 
                                   fraction.non.overdispersed = 0, 
                                   output.file = "B_625_625_5spc_repl1.rds")
```

The `summarizeSyntheticDataSet` function provides functionality to check some aspects of the simulated data by generating a report summarizing the parameters that were used for the simulation, as well as including some diagnostic plots. The report contains two MA-plots, showing the estimated average expression level and the log-fold change for all genes, indicating either the truly differentially expressed genes or the total number of outliers introduced for each gene. It also shows the log-fold changes estimated from the simulated data versus those underlying the simulation. The input to the `summarizeSyntheticDataSet` function can be either a `compData` object or the path to a file containing such an object. 

```{r reportsimulated, eval = FALSE}
summarizeSyntheticDataSet(data.set = "B_625_625_5spc_repl1.rds", 
                          output.filename = "B_625_625_5spc_repl1_datacheck.html")
```

Figure 1 shows two of the figures generated by this function. The top panel shows an MA plot with the genes colored by the true differential expression status. The bottom panel shows the relationship between the true log-fold changes between the two sample groups underlying the simulation, and the estimated log-fold changes based on the simulated counts. 

```{r, echo = FALSE, fig.cap = "Example figures from the summarization report generated for a simulated data set. The top panel shows an MA plot, with the genes colored by the true differential expression status. The bottom panel shows the relationship between the true log-fold changes between the two sample groups underlying the simulation, and the estimated log-fold changes based on the simulated counts. Also here, the genes are colored by the true differential expression status.", fig.show='hold',fig.align='center'}
knitr::include_graphics(c("compcodeR_check_figure/maplot-trueDEstatus.png", "compcodeR_check_figure/logfoldchanges.png"))
```

## Performing differential expression analysis 
We will now apply some of the interfaced differential expression methods to find genes that are differentially expressed between the two conditions in the simulated data set. This is done through the `runDiffExp` function, which is the main interface for performing differential expression analyses in `r Biocpkg("compcodeR")`. The code below applies three differential expression methods to the data set generated above: the `voom` transformation from the `r Biocpkg("limma")` package (combined with `limma` for differential expression), the exact test from the `r Biocpkg("edgeR")` package, and a regular t-test applied directly on the count level data. 

```{r rundiffexp1, eval = FALSE}
runDiffExp(data.file = "B_625_625_5spc_repl1.rds", 
           result.extent = "voom.limma", Rmdfunction = "voom.limma.createRmd", 
           output.directory = ".", norm.method = "TMM")
runDiffExp(data.file = "B_625_625_5spc_repl1.rds", 
           result.extent = "edgeR.exact", Rmdfunction = "edgeR.exact.createRmd", 
           output.directory = ".", norm.method = "TMM", 
           trend.method = "movingave", disp.type = "tagwise")
runDiffExp(data.file = "B_625_625_5spc_repl1.rds", result.extent = "ttest", 
           Rmdfunction = "ttest.createRmd", 
           output.directory = ".", norm.method = "TMM")
```

The code needed to perform each of the analyses is provided in the `*.createRmd` functions. To obtain a list of all available `*.createRmd` functions (and hence of the available differential expression methods), we can use the `listcreateRmd()` function. Example calls are also provided in the reference manual (see the help pages for the `runDiffExp` function).

```{r listcreatermd}
listcreateRmd()
```

You can also [apply your own differential expression method](#providing-your-own-differential-expression-code) to the simulated data.

## Comparing results from several differential expression methods

Once we have obtained the results of the differential expression analyses (either by the methods interfaced by `r Biocpkg("compcodeR")` or in other ways), we can compare the results and generate an HTML report summarizing the results from the different methods from many different aspects (see below for an [overview of the comparison metrics](#the-evaluation-metrics)). In `r Biocpkg("compcodeR")`, there are two ways of invoking the comparison functionality; either directly from the command line or via a graphical user interface (GUI). The GUI is mainly included to avoid long function calls and provide a clear overview of the available methods and parameter choices. To use the GUI the R package `r CRANpkg("rpanel")` must be installed (which assumes that BWidget is available). Moreover, the GUI may have rendering problems on certain platforms, particularly on small screens and if many methods are to be compared. Below, we will show how to perform the comparison using both approaches.

### The graphical user interface

First, we consider the `runComparisonGUI` function, to which we provide a list of directories containing our result files, and the directory where the final report will be generated. Since the three result files above were saved in the current working directory, we can run the following code to perform the comparison:

```{r runcomparison, eval = FALSE}
runComparisonGUI(input.directories = ".", 
                 output.directory = ".", recursive = FALSE)
```

This opens a graphical user interface (Figure 2) where we can select which of the data files available in the input directories that should be included as a basis for the comparison, and which comparisons to perform. Through this interface, we can also set p-value cutoffs for significance and other parameters that will govern the behaviour of the comparison. 

**Important!** When you have modified a value in one of the textboxes (p-value cutoffs etc.), press Return on your keyboard to confirm the assignment of the new value to the parameter. Always check in the resulting comparison report that the correct values were recognized and used for the comparisons.

```{r, echo = FALSE, fig.cap = "Screenshot of the graphical user interface used to select data set (left) and set parameters (right) for the comparison of differential expression methods. The available choices for the Data set, DE methods, Number of samples and Replicates are automatically generated from the compData objects available in the designated input directories. Only one data set can be used for the comparison. In the lower part of the window we can set (adjusted) p-value thresholds for each comparison method separately. For example, we can evaluate the true FDR at one adjusted p-value threshold, and estimate the TPR for another adjusted p-value threshold. We can also set the maximal number of top-ranked variables that will be considered for the false discovery curves.", fig.show='hold',fig.align='center'}
knitr::include_graphics(c("screenshot-gui-1.png", "screenshot-gui-2.png"))
```

After the selections have been made, the function will perform the comparisons and generate an HTML report, which is saved in the designated output directory and automatically named `compcodeR_report_<timestamp>.html`. Please note that depending on the number of compared methods and the number of included data sets, this step may take several minutes. `r Biocpkg("compcodeR")` will notify you when the report is ready (with a message **Done!** in the console). 

**Note!** Depending on the platform you use to run R, you may see a prompt ($">"$) in the console before the analysis is done. However, `r Biocpkg("compcodeR")` will always notify you when it is finished, by typing **Done!** in the console.

The comparison function will also generate a subdirectory called `compcodeR_code`, where the R code used to perform each of the comparisons is detailed in HTML reports, and another subdirectory called `compcodeR_figure`, where the plots generated in the comparison are saved. The code HTML reports can also be generated manually for a given result file (given that the `code` component is present in the `compData` object), using the function `generateCodeHTMLs`. For example, to generate a report containing the code that was run to perform the t-test above, as well as the output from the R console, we can write:

```{r generatecode, eval = FALSE}
generateCodeHTMLs("B_625_625_5spc_repl1_ttest.rds", ".")
```

These reports are useful to check that there were no errors or warnings when running the differential expression analyses. 

### Direct command-line call

Next, we show how to run the comparison by calling the function `runComparison` directly. In this case, we need to supply the function with a list of result files to use as a basis for the comparison. We can also provide a list of parameters (p-value thresholds, the differential expression methods to include in the comparison, etc.). The default values of these parameters are outlined in the reference manual. The following code provides an example, given the data generated above.

```{r nogui-comparison, eval = FALSE}
file.table <- data.frame(input.files = c("B_625_625_5spc_repl1_voom.limma.rds", 
                                         "B_625_625_5spc_repl1_ttest.rds", 
                                         "B_625_625_5spc_repl1_edgeR.exact.rds"), 
                         stringsAsFactors = FALSE)
parameters <- list(incl.nbr.samples = NULL, incl.replicates = NULL, 
                   incl.dataset = "B_625_625", incl.de.methods = NULL, 
                   fdr.threshold = 0.05, tpr.threshold = 0.05, 
                   typeI.threshold = 0.05, ma.threshold = 0.05, 
                   fdc.maxvar = 1500, overlap.threshold = 0.05, 
                   fracsign.threshold = 0.05, 
                   comparisons = c("auc", "fdr", "tpr", "ma", "correlation"))
runComparison(file.table = file.table, parameters = parameters, output.directory = ".")
```

By setting `incl.nbr.samples`, `incl.replicates` and `incl.de.methods` to `NULL`, we ask `r Biocpkg("compcodeR")` to include all results provided in the `file.table`. By providing a vector of values for each of these variables, it is possible to limit the selection to a subset of the provided files. Please note that the values given to `incl.replicates` and `incl.nbr.samples` are matched with values of the `info.parameters$repl.id` and `info.parameters$samples.per.cond` slots in the data/result objects, and that the values given to `incl.de.methods` are matched with values stored in the `method.names$full.name` slot of the result objects. If the values do not match, the corresponding result object will not be considered in the comparison. Consult the package manual for the full list of comparison methods available for use with the `runComparison` function. Setting `parameters = NULL` implies that all results provided in the `file.table` are used, and that all parameter values are set to their defaults (see the reference manual). Note that only one dataset identifier can be provided to the comparison (that is, `parameters$incl.dataset` must be a single string).


# Using your own data

The `r Biocpkg("compcodeR")` package provides a straightforward function for simulating count data (`generateSyntheticData`). However, it is easy to apply the interfaced differential expression methods to your own data, given that it is provided in a `compData` object (see [below](#the-data-object) for a description of the data format). You can use the function `check_compData` to check that your object satisfies the necessary criteria to be fed into the differential expression methods. 

To create a `compData` object from a count matrix and a data frame with sample annotations, you can use the function `compData`. The following code provides a minimal example. Note that you need to provide a `dataset` name (a 'description' of the simulation settings) as well as a unique data set identifier `uID`, which has to be unique for each `compData` object (e.g., for each simulation instance, even if the same simulation parameters are used).

```{r create-compData, eval=TRUE}
count.matrix <- matrix(round(1000*runif(4000)), 1000, 4)
sample.annot <- data.frame(condition = c(1, 1, 2, 2))
info.parameters <- list(dataset = "mytestdata", uID = "123456")
cpd <- compData(count.matrix = count.matrix, 
                sample.annotations = sample.annot, 
                info.parameters = info.parameters)
check_compData(cpd)
```


# Providing your own differential expression code

The `r Biocpkg("compcodeR")` package provides an interface for calling some of the most commonly used differential expression methods developed for RNAseq data. However, it is easy to incorporate your own favorite method. In principle, this can be done in one of two ways:

* Write a `XXX.createRmd` function (where `XXX` corresponds to your method), similar to the ones provided in the package, which creates a `.Rmd` file containing the code that is run to perform the differential expression analysis. Then call this function through the `runDiffExp` function. When implementing your function, make sure that the output is a `compData` object, structured as described [below](#the-result-object). The `*.createRmd` functions provided in the package take the following input arguments:

  * `data.path` -- the path to the `.rds` file containing the `compData` object to which the differential expression will be applied.
  * `result.path` -- the path to the `.rds` file where the resulting `compData` object will be stored.
  * `codefile` -- the name of the code (with extension .Rmd) where the code will be stored.
  * any arguments for setting parameters of the differential expression analysis.

* Run the differential expression analysis completely outside the `r Biocpkg("compcodeR")` package, and save the result in a `compData` object with the slots described [below](#the-result-object). 

You can use the `check_compData_results` function to check if your object satisfies the necessary conditions for being used as the output of a differential expression analysis and compared to results obtained by other methods with `r Biocpkg("compcodeR")`.

# The format of the data and result objects

This section details the format of the data and result objects generated and used by the `r Biocpkg("compcodeR")` package. Both objects are of the `compData` class. The format guidelines below must be be followed if you apply the functions in the package to a data set of your own, or to differential expression results generated outside the package. Note that for most of the functionality of the package, the objects should be saved separately to files with a `.rds` extension, and the path of this object is provided to the functions.

## The data object

The `compData` data object used by `r Biocpkg("compcodeR")` is an S4 object with the following slots:

* `count.matrix` [`class matrix`] (**mandatory**) -- the count matrix, with rows representing genes and columns representing samples.
* `sample.annotations` [`class data.frame`] (**mandatory**) -- sample annotations. Each row corresponds to one sample, and each column to one annotation. The data objects generated by the `generateSyntheticData` function have two annotations:

  * `condition` [`class character` or `numeric`] (**mandatory**) -- the class for each sample. Currently the differential expression implementations in the package supports only two-group comparisons, hence the `condition` should have exactly two unique values.
  * `depth.factor` [`class numeric`] -- the depth factor for each sample. This factor, multiplied by the `sequencing depth`, corresponds to the target library size of the sample when simulating the counts.

* `info.parameters` [`class list`] -- a list detailing the parameter values that have been used for the simulation.

  * `dataset` [`class character`] (**mandatory**) -- the name of the data set.
  * `samples.per.cond` [`class numeric`] -- the number of samples in each of the two conditions.
  * `n.diffexp` [`class numeric`] -- the number of genes that are simulated to be differentially expressed between the two conditions.
  * `repl.id` [`class numeric`] -- a replicate number, which can be set to differentiate between different instances generated with the exact same simulation settings.
  * `seqdepth` [`class numeric`] -- the "base" sequencing depth that was used for the simulations. For each sample, it is modified by multiplication with a value sampled uniformly between `minfact` and `maxfact` to generate the actual sequencing depth for the sample.
  * `minfact` [`class numeric`] -- the lower bound on the values used to multiply the `seqdepth` to generate the actual sequencing depth for the individual samples.
  * `maxfact` [`class numeric`] -- the upper bound on the values used to multiply the `seqdepth` to generate the actual sequencing depth for the individual samples.
  * `fraction.upregulated` [`class numeric`] -- the fraction of the differentially expressed genes that were simulated to be upregulated in condition 2 compared to condition 1. Must be in the interval [0, 1]. The remaining differentially expressed genes are simulated to be downregulated in condition 2.
  * `between.group.diffdisp` [`class logical`] -- whether the counts from the two conditions were simulated with different dispersion parameters.
  * `filter.threshold.total` [`class numeric`] -- the filter threshold that is applied to the total count across all samples. All genes for which the total count is below this number have been excluded from the data set in the simulation process.
  * `filter.threshold.mediancpm` [`class numeric`] -- the filter threshold that is applied to the median count per million (cpm) across all samples. All genes for which the median cpm is below this number have been excluded from the data set in the simulation process.
  * `fraction.non.overdispersed` [`class numeric`] -- the fraction of the genes in the data set that are simulated according to a model without overdispersion (i.e., a Poisson model).
  * `random.outlier.high.prob` [`class numeric`] -- the fraction of extremely high random outlier counts introduced in the simulated data sets. Please consult @Soneson2013 for a detailed description of the different types of outliers.
  * `random.outlier.low.prob` [`class numeric`] -- the fraction of extremely low random outlier counts introduced in the simulated data sets. Please consult @Soneson2013 for a detailed description of the different types of outliers.
  * `single.outlier.high.prob` [`class numeric`] -- the fraction of extremely high single outlier counts introduced in the simulated data sets. Please consult @Soneson2013 for a detailed description of the different types of outliers.
  * `single.outlier.low.prob` [`class numeric`] -- the fraction of extremely low single outlier counts introduced in the simulated data sets. Please consult @Soneson2013 for a detailed description of the different types of outliers.
  * `effect.size` [`class numeric`] -- the degree of differential expression, i.e., a measure of the minimal effect size. Alternatively, a vector of provided effect sizes for each of the variables.
  * `uID` [`class character`] (**mandatory**) -- a unique identification number given to each data set. For the data sets simulated with `r Biocpkg("compcodeR")`, it consists of a sequence of 10 randomly generated alpha-numeric characters.

* `filtering` [`class character`] -- a summary of the filtering that has been applied to the data.
* `variable.annotations` [`class data.frame`] -- annotations for each of the variables in the data set. Each row corresponds to one variable, and each column to one annotation. No annotation is mandatory, however some of them are necessary if the differential expression results for the data are going to be used for certain comparison tasks. The data sets simulated within `r Biocpkg("compcodeR")` have the following named variable annotations:

  * `truedispersions.S1` [`class numeric`] -- the true dispersions used in the simulations of the counts for the samples in condition 1.
  * `truedispersions.S2` [`class numeric`] -- the true dispersions used in the simulations of the counts for the samples in condition 2.
  * `truemeans.S1` [`class numeric`] -- the true mean values used in the simulations of the counts for the samples in condition 1.
  * `truemeans.S2` [`class numeric`] -- the true mean values used in the simulations of the counts for the samples in condition 2.
  * `n.random.outliers.up.S1` [`class numeric`] -- the number of extremely high random outliers introduced for each gene in condition 1.
  * `n.random.outliers.up.S2` [`class numeric`] -- the number of extremely high random outliers introduced for each gene in condition 2.
  * `n.random.outliers.down.S1` [`class numeric`] -- the number of extremely low random outliers introduced for each gene in condition 1.
  * `n.random.outliers.down.S2` [`class numeric`] -- the number of extremely low random outliers introduced for each gene in condition 2.
  * `n.single.outliers.up.S1` [`class numeric`] -- the number of extremely high single outliers introduced for each gene in condition 1.
  * `n.single.outliers.up.S2` [`class numeric`] -- the number of extremely high single outliers introduced for each gene in condition 2.
  * `n.single.outliers.down.S1` [`class numeric`] -- the number of extremely low single outliers introduced for each gene in condition 1.
  * `n.single.outliers.down.S2` [`class numeric`] -- the number of extremely low single outliers introduced for each gene in condition 2.
  * `M.value` [`class numeric`] -- the estimated log2-fold change between conditions 1 and 2 for each gene. These values were estimated using the `r Biocpkg("edgeR")` package.
  * `A.value` [`class numeric`] -- the estimated average expression in conditions 1 and 2 for each gene. These values were estimated using the `r Biocpkg("edgeR")` package.
  * `truelog2foldchanges` [`class numeric`] -- the "true" log2-fold changes between conditions 1 and 2 for each gene, based on the parameters used for simulation.
  * `upregulation` [`class numeric`] -- a binary annotation (0/1) indicating which genes are simulated to be upregulated in condition 2 compared to condition 1. (Upregulated genes are indicated with a 1.)
  * `downregulation` [`class numeric`] -- a binary annotation (0/1) indicating which genes are simulated to be downregulated in condition 2 compared to condition 1. (Downregulated genes are indicated with a 1.)
  * `differential.expression` [`class numeric`] (mandatory for many comparisons, such as the computation of false discovery rates, true positive rates, ROC curves, false discovery curves etc.)-- a binary annotation (0/1) indicating which genes are simulated to be differentially expressed in condition 2 compared to condition 1. In other words, the sum of `upregulation` and `downregulation`.

To apply the functions of the package to a `compData` object of the type detailed above, it needs to be saved to a file with extension `.rds`. To save the object `cpd` to the file `saveddata.rds`, simply type

```{r savedata, eval = FALSE}
saveRDS(cpd, "saveddata.rds")
```


## The result object

When applying one of the differential expression methods interfaced through `r Biocpkg("compcodeR")`, the `compData` object is extended with some additional slots. These are described below.

* `analysis.date` [`class character`] -- the date and time when the differential expression analysis was performed.
* `package.version` [`class character`] -- the version of the packages used in the differential expression analysis.
* `method.names` [`class list`] (**mandatory**) -- a list containing the names of the differential expression method, which should be used to identify the results in the comparison. Contains two components:

  * `short.name` [`class character`] -- a short name, used for convenience.
  * `full.name` [`class character`] -- a fully identifying name of the differential expression method, including e.g. version numbers and parameter values. In the method comparisons, the results will be grouped based on the `full.name`.

* `code` [`class character`] -- the code that was used to run the differential expression analysis, in R markdown (.Rmd) format.
* `result.table` [`class data.frame`] (**mandatory**) -- a data frame containing the results of the differential expression analysis. Each row corresponds to one gene, and each column to a value generated by the analysis. The precise columns will depend on the method applied. The following columns are used by at least one of the methods interfaced by `r Biocpkg("compcodeR")`:

  * `pvalue` [`class numeric`] -- the nominal p-values.
  * `adjpvalue` [`class numeric`] -- p-values adjusted for multiple comparisons.
  * `logFC` [`class numeric`] -- estimated log-fold changes between the two conditions.
  * `score` [`class numeric`] (**mandatory**) -- the score that will be used to rank the genes in order of significance. Note that **high scores always signify differential expression, that is, a strong association with the predictor**. For example, for methods returning a nominal p-value the score is generally obtained as `1 - pvalue`.
  * `FDR` [`class numeric`] -- the false discovery rate estimate.
  * `posterior.DE` [`class numeric`] -- the posterior probability of differential expression.
  * `prob.DE` [`class numeric`] -- The conditional probability of differential expression.
  * `lfdr` [`class numeric`] -- the local false discovery rate.
  * `statistic` [`class numeric`] -- a test statistic from the differential expression analysis.
  * `dispersion.S1` [`class numeric`] -- dispersion estimate in condition 1.
  * `dispersion.S2` [`class numeric`] -- dispersion estimate in condition 2.

For many of the comparison methods, the naming of the result columns is important. For example, the p-value column must be named `pvalue` in order to be recognized by the comparison method computing type I error. Similarly, either an `adjpvalue` or an `FDR` column must be present in order to apply the comparison methods requiring adjusted p-value/FDR cutoffs. If both are present, the `adjpvalue` column takes precedence over the `FDR` column.

To be used in the comparison function, the result `compData` object must be saved to a `.rds` file.

# The evaluation metrics

This section provides an overview of the methods that are implemented in `r Biocpkg("compcodeR")` for comparing differential expression results obtained by different methods. The selection of which methods to apply is made through a graphical user interface that is opened when the `runComparisonGUI` function is called (see Figure 2). Alternatively, the selection of methods can be supplied to the `runComparison` function directly, to circumvent the GUI.

## ROC (one replicate/all replicates)

This method computes a ROC curve for either a single representative among the replicates of a given data set, or for all replicates (in separate plots). The ROC curves are generated by plotting the true positive rate (TPR, on the y-axis) versus the false positive rate (FPR, on the x-axis) when varying the cutoff on the `score` (see the description of the result object above). A good ranking method gives a ROC curve which passes close to the upper left corner of the plot, while a bad method gives a ROC curve closer to the diagonal. Calculation of the ROC curves requires that the differential expression status of each gene is provided. 

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/rocone-1.png")
```

## AUC

This comparison method computes the area under the ROC curve and represents the result in boxplots, where each box summarizes the results for one method across all replicates of a data set. A good ranking method gives to a large value of the AUC. This requires that the differential expression status of each gene is provided.

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/auc.png")
```

## Type I error

This approach computes the type I error (the fraction of the genes that are truly non-differentially expressed that are called significant at a given nominal p-value threshold) for each method and sample size separately, and represent it in boxplots, where each box summarizes the results for one method across all replicates of a data set. This requires that the differential expression status of each gene is provided (see the description of the data object above) and that the `pvalue` column is present in the `result.table` of the included result objects. The dashed vertical line represents the imposed nominal p-value threshold, and we wish that the observed type I error is lower than this threshold.

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/typeIerror.png")
```

## FDR

Here, we compute the observed false discovery rate (the fraction of the genes called significant that are truly non-differentially expressed at a given adjusted p-value/FDR threshold) for each method and sample size separately, and represent the estimates in boxplots, where each box summarizes the results for one method across all replicates of a data set. This requires that the differential expression status of each gene is provided (see the description of the data object above) and that the `adjpvalue` or `FDR` column is present in the `result.table` of the included result objects. The dashed vertical line represents the imposed adjusted p-value threshold (that is, the level at which we wish to control the false discovery rate).

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/fdr.png")
```

## FDR as a function of expression level
Instead of looking at the overall false discovery rate, this method allows us to study the FDR as a function of the average expression level of the genes. For each data set, the average expression levels are binned into 10 bins of equal size (i.e., each containing 10% of the genes), and the FDR is computed for each of them. The results are shown by means of boxplots, summarizing the results across all replicates of a data set.

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/fdrvsexpr-1.png")
```

## TPR
With this approach, we compute the observed true positive rate (the fraction of the truly differentially expressed genes that are called significant at a given adjusted p-value/FDR threshold) for each method and sample size separately, and represent the estimates in boxplots, where each box summarizes the results for one method across all replicates of a data set. This requires that the differential expression status of each gene is provided (see the description of the data object above) and that the `adjpvalue` or `FDR` column is present in the `result.table` of the included result objects. There is often a trade-off between achieving a high TPR (which is desirable) and controlling the number of false positives, and hence the TPR plots should typically be interpreted together with the type I error and/or FDR plots.

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/tpr.png")
```

## False discovery curves (one replicate/all replicates)

This choice plots the false discovery curves, depicting the number of false discoveries (i.e., truly non-differentially expressed genes) that are encountered when traversing the ranked list of genes ordered in decreasing order by the `score` column of the `result.table`. As for the ROC curves, the plots can be made for a single replicate or for all replicates (each in a separate figure). A well-performing method is represented by a slowly rising false discovery curve (in other words, few false positives among the top-ranked genes).

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/fdcone-1.png")
```

## Fraction/number of significant genes

We can also compute the fraction and/or number of the genes that are called significant at a given adjusted p-value/FDR threshold for each method and sample size separately, and represent the estimates in boxplots, where each box summarizes the results for one method across all replicates of a data set. This requires that the `adjpvalue` or `FDR` column is present in the `result.table` of the included result objects. Since this plot does not incorporate information about the number of the identity of the truly differentially expressed genes, we can not conclude whether a large or small fraction of significant genes is preferable. Thus, the plot is merely an indication of which methods are more liberal (giving more significantly differentially expressed genes) and which are more conservative.

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/fracsign.png")
```

## Overlap, one replicate

For each pair of methods, this approach computes the overlap between the sets of genes called differentially expressed by each of them at a given adjusted p-value/FDR threshold. Only one representative of the replicates of a data set is used. This requires that the `adjpvalue` or `FDR` column is present in the `result.table` of the included result objects. Since the overlap depends on the number of genes called differentially expressed by the different methods, a normalized overlap measure (the Sorensen index) is also provided (see below). The results are represented as a table of the sizes of the overlaps between each pair of methods.

## Sorensen index, one replicate
For each pair of methods, this approach computes a normalized pairwise overlap value between the sets of genes called differentially expressed by each of them at a given adjusted p-value/FDR threshold. Only one representative of the replicates of a data set is used. This requires that the `adjpvalue` or `FDR` column is present in the `result.table` of the included result objects. The Sorensen index (also called the Dice coefficient) for two sets $A$ and $B$ is given by $$S(A,B)=\frac{2|A\cap B|}{|A|+|B|},$$where $|\cdot|$ denotes the cardinality of a set (the number of elements in the set). The results are represented in the form of a table, and also as a colored heatmap, where the color represents the degree of overlap between the sets of differentially expressed genes found by different methods. 

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/sorensen-1.png")
```

## MA plot
With this approach we can construct MA-plots (one for each differential expression method) for one replicate of a data set, depicting the estimated log-fold change (on the y-axis) versus the estimated average expression (on the x-axis). The genes that are called differentially expressed are marked with color.

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/maplot-1.png")
```

## Spearman correlation
This approach computes the pairwise Spearman correlation between the gene scores obtained by different differential expression methods (the `score` component of the `result.table`). The correlations are visualized by means of a color-coded table and used to construct a dissimilarity measure for hierarchical clustering of the differential expression methods.

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics(c("compcodeR_figure/correlation-11.png",
                          "compcodeR_figure/correlation-12.png"))
```

## Score distribution vs number of outliers

This method plots the distribution of the gene scores obtained by different differential expression methods (the `score` component of the `result.table`, see the description of the result object above) as a function of the number of outliers imposed for the genes. The distributions are visualized by means of violin plots. In the example below, there are no outliers introduced. Recall that a high score corresponds to more significant genes. In the presence of outliers, the score distribution plots can be used to examine whether the presence of an outlier count for a gene shifts the score distribution towards higher or lower values.

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/scorevsoutlier-1.png")
```

## Score distribution vs average expression level
This method plots the gene scores (the `score` component of the `result.table`, see the description of the result object above) as a function of the average expression level of the gene. Recall that high scores correspond to more significant genes. The colored line shows the trend in the relationship between the two variables by means of a loess fit. These plots can be used to examine whether highly expressed genes tend to have (e.g.) higher scores than lowly expressed genes, and more generally to provide a useful characteristic of the methods. However, it is not clear what would be the "optimal" behavior.

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/scorevsexpr-1.png")
```

## Score vs 'signal' for genes expressed in only one condition

This method plots the gene scores (the `score` component of the `result.table`, see the description of the result object above) as a function of the 'signal strength' for genes that are detected in only one of the two conditions. The signal strength can be defined either as the average (log-transformed) normalized pseudo-count in the condition where the gene is expressed, or as the signal-to-noise ratio in this condition, that is, as the average log-transformed normalized pseudo-count divided by the standard deviation of the log-transformed normalized pseudo-count. Typically, we would expect that the score increases with the signal strength. 

```{r, echo = FALSE, fig.show='hold',fig.align='center'}
knitr::include_graphics("compcodeR_figure/scorevssignal-1.png")
```

## Matthew's correlation coefficient

Matthew's correlation coefficient summarizes the result of a classification task in a single number, incorporating the number of false positives, true positives, false negatives and true negatives. A correlation coefficient of +1 indicates perfect classification, while a correlation coefficient of -1 indicates perfect "anti-classification", i.e., that all objects are misclassified.

# Session info

```{r session-info}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExpPhylo.R
\name{DESeq2.length.createRmd}
\alias{DESeq2.length.createRmd}
\title{Generate a \code{.Rmd} file containing code to perform differential expression analysis with DESeq2 with custom model matrix}
\usage{
DESeq2.length.createRmd(
  data.path,
  result.path,
  codefile,
  fit.type,
  test,
  beta.prior = TRUE,
  independent.filtering = TRUE,
  cooks.cutoff = TRUE,
  impute.outliers = TRUE,
  extra.design.covariates = NULL,
  nas.as.ones = FALSE
)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{phyloCompData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{fit.type}{The fitting method used to get the dispersion-mean relationship. Possible values are \code{"parametric"}, \code{"local"} and \code{"mean"}.}

\item{test}{The test to use. Possible values are \code{"Wald"} and \code{"LRT"}.}

\item{beta.prior}{Whether or not to put a zero-mean normal prior on the non-intercept coefficients. Default is \code{TRUE}.}

\item{independent.filtering}{Whether or not to perform independent filtering of the data. With independent filtering=TRUE, the adjusted p-values for genes not passing the filter threshold are set to NA.}

\item{cooks.cutoff}{The cutoff value for the Cook's distance to consider a value to be an outlier. Set to Inf or FALSE to disable outlier detection. For genes with detected outliers, the p-value and adjusted p-value will be set to NA.}

\item{impute.outliers}{Whether or not the outliers should be replaced by a trimmed mean and the analysis rerun.}

\item{extra.design.covariates}{A vector containing the names of extra control variables to be passed to the design matrix of \code{DESeq2}. All the covariates need to be a column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object, with a matching column name. The covariates can be a numeric vector, or a factor. Note that "condition" factor column is always included, and should not be added here. See Details.}

\item{nas.as.ones}{Whether or not adjusted p values that are returned as \code{NA} by \code{DESeq2} should be set to \code{1}. This option is useful for comparisons with other methods. For more details, see section "I want to benchmark DESeq2 comparing to other DE tools" from the \code{DESeq2} vignette (available by running \code{vignette("DESeq2", package = "DESeq2")}). Default to \code{FALSE}.}
}
\value{
The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the DESeq2 package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the interpretation of the parameters, see the \code{DESeq2} package and the corresponding publications.


The lengths matrix is used as a normalization factor and applied to the \code{DESeq2}
model in the way explained in \code{\link[DESeq2]{normalizationFactors}}
(see examples of this function).
The provided matrix will be multiplied by the default normalization factor 
obtained through the \code{\link[DESeq2]{estimateSizeFactors}} function.

The \code{design} model used in the \code{\link[DESeq2]{DESeqDataSetFromMatrix}}
uses the "condition" column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object
as well as all the covariates named in \code{extra.design.covariates}.
For example, if \code{extra.design.covariates = c("var1", "var2")}, then
\code{sample.annotations} must have two columns named "var1" and "var2", and the design formula
in the \code{\link[DESeq2]{DESeqDataSetFromMatrix}} function will be:
\code{~ condition + var1 + var2}.
}
\examples{
try(
if (require(DESeq2)) {
tmpdir <- normalizePath(tempdir(), winslash = "/")
## Simulate data
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
                                    samples.per.cond = 5, n.diffexp = 100, 
                                    id.species = 1:10,
                                    lengths.relmeans = rpois(1000, 1000),
                                    lengths.dispersions = rgamma(1000, 1, 1),
                                    output.file = file.path(tmpdir, "mydata.rds"))
## Add covariates
## Model fitted is count.matrix ~ condition + test_factor + test_reg
sample.annotations(mydata.obj)$test_factor <- factor(rep(1:2, each = 5))
sample.annotations(mydata.obj)$test_reg <- rnorm(10, 0, 1)
saveRDS(mydata.obj, file.path(tmpdir, "mydata.rds"))
## Diff Exp
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "DESeq2", 
           Rmdfunction = "DESeq2.length.createRmd", 
           output.directory = tmpdir, fit.type = "parametric",
           test = "Wald",
           extra.design.covariates = c("test_factor", "test_reg"))
})
}
\references{
Anders S and Huber W (2010): Differential expression analysis for sequence count data. Genome Biology 11:R106

Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of fold change and dispersion for RNA-seq data with DESeq2. Genome Biology, 15:550. 10.1186/s13059-014-0550-8.
}
\author{
Charlotte Soneson, Paul Bastide, Mélina Gallopin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{simulateDataPhylo}
\alias{simulateDataPhylo}
\title{Simulate the Data using the tree}
\usage{
simulateDataPhylo(
  count_means,
  count_dispersions,
  tree,
  prop.var.tree,
  model.process = "BM",
  selection.strength = 0
)
}
\arguments{
\item{tree}{a dated phylogenetic tree of class \code{\link[ape]{phylo}} with `samples.per.cond * 2` species.}

\item{prop.var.tree}{the proportion of the common variance explained by the tree for each gene. It can be a scalar, in which case the same parameter is used for all genes. Otherwise it needs to be a vector with length \code{n.vars}. Default to 1.}

\item{model.process}{the process to be used for phylogenetic simulations. One of "BM" or "OU", default to "BM".}

\item{selection.strength}{if the process is "OU", the selection strength parameter.}
}
\value{
Z a matrix with the data
}
\description{
Use the Phylogenetic Poisson Log Normal model to simulate the data.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateSyntheticData.R
\name{getNegativeBinomialMean}
\alias{getNegativeBinomialMean}
\title{Get NB mean}
\usage{
getNegativeBinomialMean(
  i,
  j,
  S1,
  prob.S1,
  sum.S1,
  nfact_length.S1,
  S2,
  prob.S2,
  sum.S2,
  nfact_length.S2,
  seq.depths
)
}
\arguments{
\item{i}{gene index.}

\item{j}{sample index.}

\item{S1}{Indices in condition 1.}

\item{prob.S1}{Vector of means for condition 1.}

\item{sum.S1}{Sum of means for condition 1.}

\item{nfact_length.S1}{Matrix of length factors for condition 1.}

\item{S2}{Indices in condition 2.}

\item{prob.S2}{Vector of means for condition 2.}

\item{sum.S2}{Sum of means for condition 2.}

\item{nfact_length.S2}{Matrix of length factors for condition 2.}
}
\value{
The mean for gene i in sample j.
}
\description{
Get the NB mean for one gene in one sample
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{add_replicates}
\alias{add_replicates}
\title{Add replicates to a tree}
\usage{
add_replicates(tree, r)
}
\arguments{
\item{tree}{A phylogenetic tree with n tips.}

\item{r}{the number of replicates too add at each species.}
}
\value{
A phylogenetic tree with n * r tips, and clusters of tips with zero branch lengths.
}
\description{
Utility function to add replicates to a tree, as tips with zero length branches.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateSyntheticData.R
\name{getNegativeBinomialDispersion}
\alias{getNegativeBinomialDispersion}
\title{Get NB dispersion}
\usage{
getNegativeBinomialDispersion(
  i,
  j,
  S1,
  truedispersions.S1,
  S2,
  truedispersions.S2
)
}
\arguments{
\item{i}{gene index.}

\item{j}{sample index.}

\item{S1}{Indices in condition 1.}

\item{truedispersions.S1}{Vector of dispersions for condition 1.}

\item{S2}{Indices in condition 2.}

\item{truedispersions.S2}{Vector of dispersions for condition 2.}
}
\value{
The dispersion for gene i in sample j.
}
\description{
Get the NB dispersion for one gene in one sample
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runDiffExp.R
\name{runDiffExp}
\alias{runDiffExp}
\title{The main function to run differential expression analysis}
\usage{
runDiffExp(
  data.file,
  result.extent,
  Rmdfunction,
  output.directory = ".",
  norm.path = TRUE,
  ...
)
}
\arguments{
\item{data.file}{The path to a \code{.rds} file containing the data on which the differential expression analysis will be performed, for example a \code{compData} object returned from \code{\link{generateSyntheticData}}.}

\item{result.extent}{The extension that will be added to the data file name in order to construct the result file name. This can be for example the differential expression method together with a version number.}

\item{Rmdfunction}{A function that creates an Rmd file containing the code that should be run to perform the differential expression analysis. All functions available through \code{compcodeR} can be listed using the \code{\link{listcreateRmd}} function.}

\item{output.directory}{The directory in which the result object will be saved.}

\item{norm.path}{Logical, whether to include the full (absolute) path to the output object in the saved code.}

\item{...}{Additional arguments that will be passed to the \code{Rmdfunction}, such as parameter choices for the differential expression method.}
}
\description{
The main function for running differential expression analysis (comparing two conditions), using one of the methods interfaced through \code{compcodeR} or a user-defined method. Note that the interface functions are provided for convenience and as templates for other, user-defined workflows, and there is no guarantee that the included differential expression code is kept up-to-date with the latest recommendations and best practices for running each of the interfaced methods, or that the chosen settings are suitable in all situations. The user should make sure that the analysis is performed in the way they intend, and check the code that was run, using e.g. the \code{generateCodeHTMLs()} function.
}
\examples{
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
listcreateRmd()
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.limma",
           Rmdfunction = "voom.limma.createRmd",
           output.directory = tmpdir, norm.method = "TMM")

if (interactive()) {
## The following list covers the currently available
## differential expression methods:
runDiffExp(data.file = "mydata.rds", result.extent = "DESeq2",
           Rmdfunction = "DESeq2.createRmd",
           output.directory = ".", fit.type = "parametric",
           test = "Wald", beta.prior = TRUE,
           independent.filtering = TRUE, cooks.cutoff = TRUE,
           impute.outliers = TRUE)
runDiffExp(data.file = "mydata.rds", result.extent = "DSS",
           Rmdfunction = "DSS.createRmd",
           output.directory = ".", norm.method = "quantile",
           disp.trend = TRUE)
runDiffExp(data.file = "mydata.rds", result.extent = "EBSeq",
           Rmdfunction = "EBSeq.createRmd",
           output.directory = ".", norm.method = "median")
runDiffExp(data.file = "mydata.rds", result.extent = "edgeR.exact",
           Rmdfunction = "edgeR.exact.createRmd",
           output.directory = ".", norm.method = "TMM",
           trend.method = "movingave", disp.type = "tagwise")
runDiffExp(data.file = "mydata.rds", result.extent = "edgeR.GLM",
           Rmdfunction = "edgeR.GLM.createRmd",
           output.directory = ".", norm.method = "TMM",
           disp.type = "tagwise", disp.method = "CoxReid",
           trended = TRUE)
runDiffExp(data.file = "mydata.rds", result.extent = "logcpm.limma",
           Rmdfunction = "logcpm.limma.createRmd",
           output.directory = ".", norm.method = "TMM")
runDiffExp(data.file = "mydata.rds", result.extent = "NBPSeq",
           Rmdfunction = "NBPSeq.createRmd",
           output.directory = ".", norm.method = "TMM",
           disp.method = "NBP")
runDiffExp(data.file = "mydata.rds", result.extent = "NOISeq",
           Rmdfunction = "NOISeq.prenorm.createRmd",
           output.directory = ".", norm.method = "TMM")
runDiffExp(data.file = "mydata.rds", result.extent = "sqrtcpm.limma",
           Rmdfunction = "sqrtcpm.limma.createRmd",
           output.directory = ".", norm.method = "TMM")
runDiffExp(data.file = "mydata.rds", result.extent = "TCC",
           Rmdfunction = "TCC.createRmd",
           output.directory = ".", norm.method = "tmm",
           test.method = "edger", iteration = 3,
           normFDR = 0.1, floorPDEG = 0.05)
runDiffExp(data.file = "mydata.rds", result.extent = "ttest",
           Rmdfunction = "ttest.createRmd",
           output.directory = ".", norm.method = "TMM")
runDiffExp(data.file = "mydata.rds", result.extent = "voom.limma",
           Rmdfunction = "voom.limma.createRmd",
           output.directory = ".", norm.method = "TMM")
runDiffExp(data.file = "mydata.rds", result.extent = "voom.ttest",
           Rmdfunction = "voom.ttest.createRmd",
           output.directory = ".", norm.method = "TMM")
}
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExp.R
\name{sqrtcpm.limma.createRmd}
\alias{sqrtcpm.limma.createRmd}
\title{Generate a \code{.Rmd} file containing code to perform differential expression analysis with limma after square root-transforming the counts per million (cpm)}
\usage{
sqrtcpm.limma.createRmd(data.path, result.path, codefile, norm.method)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{norm.method}{The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} function from the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}.}
}
\value{
The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using limma, after preprocessing the counts by computing the counts per million (cpm) and applying a square-root transformation. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the interpretation of the parameters, see the \code{edgeR} and \code{limma} packages and the corresponding publications.
}
\examples{
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "sqrtcpm.limma",
           Rmdfunction = "sqrtcpm.limma.createRmd",
           output.directory = tmpdir, norm.method = "TMM")
}
\references{
Smyth GK (2005): Limma: linear models for microarray data. In: 'Bioinformatics and Computational Biology Solutions using R and Bioconductor'. R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W. Huber (eds), Springer, New York, pages 397-420

Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140

Robinson MD and Oshlack A (2010): A scaling normalization method for differential expression analysis of RNA-seq data. Genome Biology 11:R25
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{phyloCompData}
\alias{phyloCompData}
\title{Create a \code{phyloCompData} object}
\usage{
phyloCompData(
  count.matrix,
  sample.annotations,
  info.parameters,
  variable.annotations = data.frame(),
  filtering = "no info",
  analysis.date = "",
  package.version = "",
  method.names = list(),
  code = "",
  result.table = data.frame(),
  tree = list(),
  length.matrix = matrix(NA_integer_, 0, 0)
)
}
\arguments{
\item{count.matrix}{A count matrix, with genes as rows and observations as columns.}

\item{sample.annotations}{A data frame, containing at least one column named 'condition', encoding the grouping of the observations into two groups, and one column named \code{id.species} of factors giving the species for each sample if the tree is specified. The row names should be the same as the column names of count.matrix. \code{Class data.frame}.}

\item{info.parameters}{A list containing information regarding simulation parameters etc. The only mandatory entries are \code{dataset} and \code{uID}, but it may contain entries such as the ones listed below (see \code{generateSyntheticData} for more detailed information about each of these entries).
\itemize{
\item \code{dataset}: an informative name or identifier of the data set (e.g., summarizing the simulation settings).
\item \code{samples.per.cond}
\item \code{n.diffexp} 
\item \code{repl.id}
\item \code{seqdepth}
\item \code{minfact}
\item \code{maxfact}
\item \code{fraction.upregulated}
\item \code{between.group.diffdisp}
\item \code{filter.threshold.total}
\item \code{filter.threshold.mediancpm}
\item \code{fraction.non.overdispersed}
\item \code{random.outlier.high.prob}
\item \code{random.outlier.low.prob}
\item \code{single.outlier.high.prob}
\item \code{single.outlier.low.prob}
\item \code{effect.size}
\item \code{uID}: a unique ID for the data set. In contrast to \code{dataset}, the \code{uID} is unique e.g. for each instance of replicated data sets generated with the same simulation settings. 
}}

\item{variable.annotations}{A data frame with variable annotations (with number of rows equal to the number of rows in \code{count.matrix}, that is, the number of variables in the data set). Not mandatory, but may contain columns such as the ones listed below. If present, the row names should be the same as the row names of the \code{count.matrix}.
\itemize{
\item \code{truedispersions.S1}: the true dispersion for each gene in condition S1.
\item \code{truedispersions.S2}: the true dispersion for each gene in condition S2.
\item \code{truemeans.S1}: the true mean value for each gene in condition S1.
\item \code{truemeans.S2}: the true mean value for each gene in condition S2.
\item \code{n.random.outliers.up.S1}: the number of 'random' outliers with extremely high counts for each gene in condition S1.
\item \code{n.random.outliers.up.S2}: the number of 'random' outliers with extremely high counts for each gene in condition S2.
\item \code{n.random.outliers.down.S1}: the number of 'random' outliers with extremely low counts for each gene in condition S1.
\item \code{n.random.outliers.down.S2}: the number of 'random' outliers with extremely low counts for each gene in condition S2.
\item \code{n.single.outliers.up.S1}: the number of 'single' outliers with extremely high counts for each gene in condition S1.
\item \code{n.single.outliers.up.S2}: the number of 'single' outliers with extremely high counts for each gene in condition S2.
\item \code{n.single.outliers.down.S1}: the number of 'single' outliers with extremely low counts for each gene in condition S1.
\item \code{n.single.outliers.down.S2}: the number of 'single' outliers with extremely low counts for each gene in condition S2.
\item \code{M.value}: the M-value (observed log2 fold change between condition S1 and condition S2) for each gene.
\item \code{A.value}: the A-value (observed average expression level across condition S1 and condition S2) for each gene.
\item \code{truelog2foldchanges}: the true (simulated) log2 fold changes between condition S1 and condition S2.
\item \code{upregulation}: a binary vector indicating which genes are simulated to be upregulated in condition S2 compared to condition S1.
\item \code{downregulation}: a binary vector indicating which genes are simulated to be downregulated in condition S2 compared to condition S1.
\item \code{differential.expression}: a binary vector indicating which genes are simulated to be differentially expressed in condition S2 compared to condition S1.
}}

\item{filtering}{A character string containing information about the filtering that has been applied to the data set.}

\item{analysis.date}{If a differential expression analysis has been performed, a character string detailing when it was performed.}

\item{package.version}{If a differential expression analysis has been performed, a character string giving the version of the differential expression packages that were applied.}

\item{method.names}{If a differential expression analysis has been performed, a list with entries \code{full.name} and \code{short.name}, giving the full name of the differential expression method (may including version number and parameter settings) and a short name or abbreviation.}

\item{code}{If a differential expression analysis has been performed, a character string containing the code that was run to perform the analysis. The code should be in R markdown format, and can be written to an HTML file using the \code{\link{generateCodeHTMLs}} function.}

\item{result.table}{If a differential expression analysis has been performed, a data frame containing the results of the analysis. The number of rows should be equal to the number of rows in \code{count.matrix} and if present, the row names should be identical. The only mandatory column is \code{score}, which gives a score for each gene, where a higher score suggests a "more highly differentially expressed" gene. Different comparison functions use different columns of this table, if available. The list below gives the columns that are used by the interfaced methods.
\itemize{
\item \code{pvalue} nominal p-values
\item \code{adjpvalue} p-values adjusted for multiple comparisons
\item \code{logFC} estimated log-fold changes between the two conditions
\item \code{score} the score that will be used to rank the genes in order of significance. Note that high scores always signify differential expression, that is, a strong association with the predictor. For example, for methods returning a nominal p-value the score can be defined as 1 - pvalue.
\item \code{FDR} false discovery rate estimates
\item \code{posterior.DE} posterior probabilities of differential expression
\item \code{prob.DE} conditional probabilities of differential expression
\item \code{lfdr} local false discovery rates
\item \code{statistic}  test statistics from the differential expression analysis
\item \code{dispersion.S1} dispersion estimates in condition S1
\item \code{dispersion.S2} dispersion estimates in condition S2
}}

\item{tree}{The phylogenetic tree describing the relationships between samples. The taxa names of the \code{tree} should be the same as the column names of the \code{count.matrix}.}

\item{length.matrix}{The length matrix, with genes as rows and samples as columns. The column names of the \code{length.matrix} should be the same as the column names of the \code{count.matrix}.}
}
\value{
A \code{phyloCompData} object.
}
\description{
The \code{\linkS4class{phyloCompData}} class extends the \code{\link{compData}} class
with sequence length and phylogeny related information.
}
\examples{
tree <- ape::read.tree(
  text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);"
  )
count.matrix <- round(matrix(1000*runif(8000), 1000))
sample.annotations <- data.frame(condition = c(1, 1, 1, 1, 2, 2, 2, 2),
                                 id.species = c("A", "A", "A", "B", "C", "C", "D", "D"))
info.parameters <- list(dataset = "mydata", uID = "123456")
length.matrix <- round(matrix(1000*runif(8000), 1000))
colnames(count.matrix) <- colnames(length.matrix) <- rownames(sample.annotations) <- tree$tip.label
cpd <- phyloCompData(count.matrix, sample.annotations, info.parameters,
                     tree = tree, length.matrix = length.matrix)

}
\author{
Charlotte Soneson, Paul Bastide
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runComparison.R
\name{checkTableConsistency}
\alias{checkTableConsistency}
\title{Check consistency of input table to \code{\link{runComparison}}}
\usage{
checkTableConsistency(file.table)
}
\arguments{
\item{file.table}{A data frame with columns named \code{input.files} and (optionally) \code{datasets}, \code{nbr.samples}, \code{repl}, \code{de.methods}.}
}
\value{
Returns a consistent file table defining the result files that will be used as the basis for a method comparison.
}
\description{
Check that the \code{dataset}, \code{nbr.samples}, \code{repl} and \code{de.methods} columns of a data frame are consistent with the information provided in the input files (given in the \code{input.files} column of the data frame). If there are inconsistencies or missing information in any of the columns, replace the given information with the information in the input files.
}
\examples{
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.limma",
           Rmdfunction = "voom.limma.createRmd", output.directory = tmpdir,
           norm.method = "TMM")
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "edgeR.exact",
           Rmdfunction = "edgeR.exact.createRmd", output.directory = tmpdir,
           norm.method = "TMM",
           trend.method = "movingave", disp.type = "tagwise")

## A correct table
file.table <- data.frame(input.files = file.path(tmpdir,
                         c("mydata_voom.limma.rds", "mydata_edgeR.exact.rds")),
                         datasets = c("mydata", "mydata"),
                         nbr.samples = c(5, 5),
                         repl = c(1, 1),
                         stringsAsFactors = FALSE)
new.table <- checkTableConsistency(file.table)
new.table

## An incorrect table
file.table <- data.frame(input.files = file.path(tmpdir,
                         c("mydata_voom.limma.rds", "mydata_edgeR.exact.rds")),
                         datasets = c("mydata", "mydata"),
                         nbr.samples = c(5, 3),
                         repl = c(2, 1),
                         stringsAsFactors = FALSE)
new.table <- checkTableConsistency(file.table)
new.table

## A table with missing information
file.table <- data.frame(input.files = file.path(tmpdir,
                         c("mydata_voom.limma.rds", "mydata_edgeR.exact.rds")),
                         stringsAsFactors = FALSE)
new.table <- checkTableConsistency(file.table)
new.table
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runComparison.R
\name{runComparisonGUI}
\alias{runComparisonGUI}
\title{A GUI to the main function for running the performance comparison between differential expression methods.}
\usage{
runComparisonGUI(
  input.directories,
  output.directory,
  recursive,
  out.width = NULL,
  upper.limits = NULL,
  lower.limits = NULL
)
}
\arguments{
\item{input.directories}{A list of directories containing the result files (\code{*.rds}). All results in the provided directories will be available for inclusion in the comparison, and the selection is performed through a graphical user interface. All result objects saved in the files should be of the \code{compData} class, although list objects created by earlier versions of \code{compcodeR} are supported.}

\item{output.directory}{The directory where the results should be written. The subdirectory structure will be created automatically. If the directory already exists, it will be overwritten.}

\item{recursive}{A logical parameter indicating whether or not the search should be extended recursively to subfolders of the \code{input.directories}.}

\item{out.width}{The width of the figures in the final report. Will be passed on to \code{knitr} when the HTML is generated. Can be for example "800px" (see \code{knitr} documentation for more information)}

\item{upper.limits, lower.limits}{Lists that can be used to manually set upper and lower limits for boxplots of fdr, tpr, auc, mcc, fracsign, nbrtpfp, nbrsign and typeIerror.}
}
\value{
The function will create a comparison report, named \strong{compcodeR_report<timestamp>.html}, in the \code{output.directory}. It will also create subfolders named \code{compcodeR_code} and \code{compcodeR_figure}, where the code used to perform the differential expression analysis and the figures contained in the report, respectively, will be saved. Note that if these directories already exist they will be overwritten.
}
\description{
This function provides a GUI to the main function for performing comparisons among differential expression methods and generating a report in HTML format (\code{\link{runComparison}}). It is assumed that all differential expression results have been generated in advance (using e.g. the function \code{\link{runDiffExp}}) and that the result \code{compData} object for each data set and each differential expression method is saved separately in files with the extension \code{.rds}. The function opens a graphical user interface where the user can set parameter values and choose the files to be used as the basis of the comparison. It is, however, possible to circumvent the GUI and call the comparison function \code{\link{runComparison}} directly.
}
\details{
This function requires that the \code{rpanel} package is installed. If this package can not be installed, please use the \code{\link{runComparison}} function directly.
}
\examples{
if (interactive()) {
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 12500,
                                    samples.per.cond = 5, n.diffexp = 1250,
                                    output.file = "mydata.rds")
runDiffExp(data.file = "mydata.rds", result.extent = "voom.limma",
           Rmdfunction = "voom.limma.createRmd", output.directory = ".",
           norm.method = "TMM")
runDiffExp(data.file = "mydata.rds", result.extent = "ttest",
           Rmdfunction = "ttest.createRmd", output.directory = ".",
           norm.method = "TMM")
runComparisonGUI(input.directories = ".", output.directory = ".", recursive = FALSE)
}
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{convertListTocompData}
\alias{convertListTocompData}
\title{Convert a list with data and results to a \code{compData} object}
\usage{
convertListTocompData(inp.list)
}
\arguments{
\item{inp.list}{A list with data and results, e.g. generated by \code{compcodeR} version 0.1.0.}
}
\description{
Given a list with data and results (resulting e.g. from \code{compcodeR} version 0.1.0), convert it to a \code{compData} object.
}
\examples{
convertListTocompData(list(count.matrix = matrix(round(1000*runif(4000)), 1000),
                           sample.annotations = data.frame(condition = c(1,1,2,2)),
                           info.parameters = list(dataset = "mydata", 
                           uID = "123456")))
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phylolmMethods.R
\name{phylolm_analysis}
\alias{phylolm_analysis}
\title{Perform the phylolm analysis}
\usage{
phylolm_analysis(
  dat,
  design_data,
  design_formula,
  tree,
  model,
  measurement_error,
  ...
)
}
\arguments{
\item{dat}{the data associated with a gene}

\item{design_data}{design matrix}

\item{design_formula}{design formula}

\item{tree}{phylogenetic tree}

\item{model}{the model to be used in phylolm}

\item{measurement_error}{boolean}
}
\value{
A list, with:
\describe{
\item{pvalue}{the p value of the differential expression.}
\item{logFC}{the log fold change of the differential expression.}
\item{score}{1 - pvalue.}
}
}
\description{
Perform the phylolm analysis for a given gene.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateSyntheticData.R
\name{getNegativeBinomialParameters}
\alias{getNegativeBinomialParameters}
\title{Get all parameters of the NB at once}
\usage{
getNegativeBinomialParameters(
  n.vars,
  S1,
  prob.S1,
  sum.S1,
  truedispersions.S1,
  nfact_length.S1,
  S2,
  prob.S2,
  sum.S2,
  truedispersions.S2,
  nfact_length.S2,
  seq.depths
)
}
\arguments{
\item{n.vars}{The initial number of genes in the simulated data set. Based on the filtering conditions (\code{filter.threshold.total} and \code{filter.threshold.mediancpm}), the number of genes in the final data set may be lower than this number.}

\item{S1}{Indices in condition 1.}

\item{prob.S1}{Vector of means for condition 1.}

\item{sum.S1}{Sum of means for condition 1.}

\item{truedispersions.S1}{Vector of dispersions for condition 1.}

\item{nfact_length.S1}{Matrix of length factors for condition 1.}

\item{S2}{Indices in condition 2.}

\item{prob.S2}{Vector of means for condition 2.}

\item{sum.S2}{Sum of means for condition 2.}

\item{truedispersions.S2}{Vector of dispersions for condition 2.}

\item{nfact_length.S2}{Matrix of length factors for condition 2.}
}
\value{
A list of parameters for each entry of the count matrix:
\describe{
\item{count_means}{a matrix of mean for each gene and sample.}
\item{count_dispersions}{a matrix of dispersions for each gene and sample.}
}
}
\description{
Get both the mean and the dispersions of the NB as matrices for all indices.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/show-methods.R
\name{show_compData}
\alias{show_compData}
\title{Show function for \code{compData} object}
\usage{
show_compData(object)
}
\arguments{
\item{object}{A \code{compData} object}
}
\description{
Show function for \code{compData} object.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{convertcompDataToList}
\alias{convertcompDataToList}
\title{Convert a \code{compData} object to a list}
\usage{
convertcompDataToList(cpd)
}
\arguments{
\item{cpd}{A \code{compData} object}
}
\description{
Given a \code{compData} object, convert it to a list.
}
\examples{
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 12500,
                                    samples.per.cond = 5, n.diffexp = 1250)
mydata.list <- convertcompDataToList(mydata.obj)
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateSyntheticData.R
\name{generateSyntheticData}
\alias{generateSyntheticData}
\title{Generate synthetic count data sets}
\usage{
generateSyntheticData(
  dataset,
  n.vars,
  samples.per.cond,
  n.diffexp,
  repl.id = 1,
  seqdepth = 1e+07,
  minfact = 0.7,
  maxfact = 1.4,
  relmeans = "auto",
  dispersions = "auto",
  fraction.upregulated = 1,
  between.group.diffdisp = FALSE,
  filter.threshold.total = 1,
  filter.threshold.mediancpm = 0,
  fraction.non.overdispersed = 0,
  random.outlier.high.prob = 0,
  random.outlier.low.prob = 0,
  single.outlier.high.prob = 0,
  single.outlier.low.prob = 0,
  effect.size = 1.5,
  output.file = NULL,
  tree = NULL,
  prop.var.tree = 1,
  model.process = c("BM", "OU"),
  selection.strength = 0,
  id.condition = NULL,
  id.species = as.factor(rep(1, 2 * samples.per.cond)),
  check.id.species = TRUE,
  lengths.relmeans = NULL,
  lengths.dispersions = NULL,
  lengths.phylo = TRUE
)
}
\arguments{
\item{dataset}{A name or identifier for the data set/simulation settings.}

\item{n.vars}{The initial number of genes in the simulated data set. Based on the filtering conditions (\code{filter.threshold.total} and \code{filter.threshold.mediancpm}), the number of genes in the final data set may be lower than this number.}

\item{samples.per.cond}{The number of samples in each of the two conditions.}

\item{n.diffexp}{The number of genes simulated to be differentially expressed between the two conditions.}

\item{repl.id}{A replicate ID for the specific simulation instance. Useful for example when generating multiple count matrices with the same simulation settings.}

\item{seqdepth}{The base sequencing depth (total number of mapped reads). This number is multiplied by a value drawn uniformly between \code{minfact} and \code{maxfact} for each sample to generate data with different actual sequencing depths.}

\item{minfact, maxfact}{The minimum and maximum for the uniform distribution used to generate factors that are multiplied with \code{seqdepth} to generate individual sequencing depths for the simulated samples.}

\item{relmeans}{A vector of mean values to use in the simulation of data from the Negative Binomial distribution, or \code{"auto"}. Note that these values may be scaled in order to comply with the given sequencing depth. With the default value (\code{"auto"}), the mean values are sampled from values estimated from the Pickrell and Cheung data sets. If \code{relmeans} is a vector, the provided values will be used as mean values in the simulation for the samples in the first condition. The mean values for the samples in the second condition are generated by combining the \code{relmeans} and \code{effect.size} arguments.}

\item{dispersions}{A vector or matrix of dispersions to use in the simulation of data from the Negative Binomial distribution, or \code{"auto"}. With the default value (\code{"auto"}), the dispersion values are sampled from values estimated from the Pickrell and Cheung data sets. If both \code{relmeans} and \code{dispersions} are set to \code{"auto"}, the means and dispersion values are sampled in pairs from the values in these data sets. If \code{dispersions} is a single vector, the provided dispersions will be used for simulating data from both conditions. If it is a matrix with two columns, the values in the first column are used for condition 1, and the values in the second column are used for condition 2.}

\item{fraction.upregulated}{The fraction of the differentially expressed genes that is upregulated in condition 2 compared to condition 1.}

\item{between.group.diffdisp}{Whether or not the dispersion should be allowed to be different between the conditions. Only applicable if \code{dispersions} is \code{"auto"}.}

\item{filter.threshold.total}{The filter threshold on the total count for a gene across all samples. All genes for which the total count across all samples is less than the threshold will be filtered out.}

\item{filter.threshold.mediancpm}{The filter threshold on the median count per million (cpm) for a gene across all samples. All genes for which the median cpm across all samples is less than the threshold will be filtered out.}

\item{fraction.non.overdispersed}{The fraction of the genes that should be simulated according to a Poisson distribution, without overdispersion. The non-overdispersed genes will be divided proportionally between the upregulated, downregulated and non-differentially expressed genes.}

\item{random.outlier.high.prob}{The fraction of 'random' outliers with unusually high counts.}

\item{random.outlier.low.prob}{The fraction of 'random' outliers with unusually low counts.}

\item{single.outlier.high.prob}{The fraction of 'single' outliers with unusually high counts.}

\item{single.outlier.low.prob}{The fraction of 'single' outliers with unusually low counts.}

\item{effect.size}{The strength of the differential expression, i.e., the effect size, between the two conditions. If this is a single number, the effect sizes will be obtained by simulating numbers from an exponential distribution (with rate 1) and adding the results to the \code{effect.size}. For genes that are upregulated in the second condition, the mean in the first condition is multiplied by the effect size. For genes that are downregulated in the second condition, the mean in the first condition is divided by the effect size. It is also possible to provide a vector of effect sizes (one for each gene), which will be used as provided. In this case, the \code{fraction.upregulated} and \code{n.diffexp} arguments will be ignored and the values will be derived from the \code{effect.size} vector.}

\item{output.file}{If not \code{NULL}, the path to the file where the data object should be saved. The extension should be \code{.rds}, if not it will be changed.}

\item{tree}{a dated phylogenetic tree of class \code{\link[ape]{phylo}} with `samples.per.cond * 2` species.}

\item{prop.var.tree}{the proportion of the common variance explained by the tree for each gene. It can be a scalar, in which case the same parameter is used for all genes. Otherwise it needs to be a vector with length \code{n.vars}. Default to 1.}

\item{model.process}{the process to be used for phylogenetic simulations. One of "BM" or "OU", default to "BM".}

\item{selection.strength}{if the process is "OU", the selection strength parameter.}

\item{id.condition}{A named vector, indicating which species is in each condition. Default to first `samples.per.cond` species in condition `1` and others in condition `2`.}

\item{id.species}{A factor giving the species for each sample. If a tree is used, should be a named vector with names matching the taxa of the tree. Default to \code{rep(1, 2*samples.per.cond)}, i.e. all the samples come from the same species.}

\item{check.id.species}{Should the species vector be checked against the tree lengths (if provided) ? If TRUE, the function checks that all the samples that share a factor value in \code{id.species} that their distance on the tree is zero, i.e. that they are on the same tip of the tree. Default to TRUE.}

\item{lengths.relmeans}{An optional vector of mean values to use in the simulation of lengths from the Negative Binomial distribution. Should be of length n.vars. Default to \code{NULL}: the lengths are not taken into account for the simulation. If set to \code{"auto"}, the mean length values are sampled from values estimated from the Stern & Crandall (2018) data set.}

\item{lengths.dispersions}{An optional vector of dispersions to use in the simulation of data from the Negative Binomial distribution. Should be of length n.vars. Default to \code{NULL}: the lengths are not taken into account for the simulation. If set to \code{"auto"}, the dispersion length values are sampled from values estimated from the Stern & Crandall (2018) data set.}

\item{lengths.phylo}{If TRUE, the lengths are simulated according to a phylogenetic Poisson Log-Normal model on the tree, with a BM process. If FALSE, they are simulated according to an iid negative binomial distribution. In both cases, \code{lengths.relmeans} and \code{lengths.dispersions} are used. Default to TRUE if a tree is provided.}
}
\value{
A \code{\link{compData}} object. If \code{output.file} is not \code{NULL}, the object is saved in the given \code{output.file} (which should have an \code{.rds} extension).
}
\description{
Generate synthetic count data sets, following the simulation strategy detailed in Soneson and Delorenzi (2013).
}
\details{
In the comparison function, only results obtained for data sets with the same value of the \code{dataset} parameter will be compared. Hence, it is important to give the same value of this parameter e.g. to different replicates generated with the same simulation settings.

For more detailed information regarding the different types of outliers, see Soneson and Delorenzi (2013).

Mean and dispersion parameters (if \code{relmeans} and/or \code{dispersions} is set to \code{"auto"}) are sampled from values estimated from the data sets by Pickrell et al (2010) and Cheung et al (2010). The data sets were downloaded from the ReCount web page (Frazee et al (2011)) and processed as detailed by Soneson and Delorenzi (2013).

To get the actual mean value for the Negative Binomial distribution used for the simulation of counts for a given sample, take the column \code{truemeans.S1} (or \code{truemeans.S2}, if the sample is in condition S2) of the \code{variable.annotations} slot, divide by the sum of the same column and multiply with the base sequencing depth (provided in the \code{info.parameters} list) and the depth factor for the sample (given in the \code{sample.annotations} data frame). Thus, if you have a vector of mean values that you want to provide as the \code{relmeans} argument and make sure to use it 'as-is' in the simulation (for condition S1), make sure to set the \code{seqdepth} argument to the sum of the values in the \code{relmeans} vector, and to set \code{minfact} and \code{maxfact} equal to 1.

When the \code{tree} argument is provided (not \code{NULL}),
then the "phylogenetic Poisson log-Normal" model is used for the simulations,
possibly with varying gene lengths across species
(both \code{lengths.relmeans} and \code{lengths.dispersions} must be specified
or set to \code{"auto"}.)
Phylogenetic simulations use the \code{\link[phylolm]{rTrait}} function
from package \code{phylolm}.
}
\examples{
## RNA-Seq data
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100)

## Inter-species RNA-Seq data
library(ape)
tree <- read.tree(text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);")
id.species <- factor(c("A", "A", "A", "B", "C", "C", "D", "D"))
names(id.species) <- tree$tip.label
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 4, n.diffexp = 100,
                                    tree = tree,
                                    id.species = id.species,
                                    lengths.relmeans = "auto",
                                    lengths.dispersions = "auto")
}
\references{
Soneson C and Delorenzi M (2013): A comparison of methods for differential expression analysis of RNA-seq data. BMC Bioinformatics 14:91

Cheung VG, Nayak RR, Wang IX, Elwyn S, Cousins SM, Morley M and Spielman RS (2010): Polymorphic cis- and trans-regulation of human gene expression. PLoS Biology 8(9):e1000480

Frazee AC, Langmead B and Leek JT (2011): ReCount: a multi-experiment resource of analysis-ready RNA-seq gene count datasets. BMC Bioinformatics 12:449

Pickrell JK, Marioni JC, Pai AA, Degner JF, Engelhardt BE, Nkadori E, Veyrieras JB, Stephens M, Gilad Y and Pritchard JK (2010): Understanding mechanisms underlying human gene expression variation with RNA sequencing. Nature 464, 768-772

Robles JA, Qureshi SE, Stephen SJ, Wilson SR, Burden CJ and Taylor JM (2012): Efficient experimental design and analysis strategies for the detection of differential expression using RNA-sequencing. BMC Genomics 13:484

Stern DB and Crandall KA (2018): The Evolution of Gene Expression Underlying Vision Loss in Cave Animals. Molecular Biology and Evolution. 35:2005–2014.
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExp.R
\name{edgeR.GLM.createRmd}
\alias{edgeR.GLM.createRmd}
\title{Generate a \code{.Rmd} file containing code to perform differential expression analysis with the edgeR GLM approach}
\usage{
edgeR.GLM.createRmd(
  data.path,
  result.path,
  codefile,
  norm.method,
  disp.type,
  disp.method,
  trended
)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{norm.method}{The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}.}

\item{disp.type}{The type of dispersion estimate used. Possible values are \code{"common"}, \code{"trended"} and \code{"tagwise"}.}

\item{disp.method}{The method used to estimate the dispersion. Possible values are \code{"CoxReid"}, \code{"Pearson"} and \code{"deviance"}.}

\item{trended}{Logical parameter indicating whether or not a trended dispersion estimate should be used.}
}
\value{
The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the GLM functionality from the edgeR package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the interpretation of the parameters, see the \code{edgeR} package and the corresponding publications.
}
\examples{
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "edgeR.GLM",
           Rmdfunction = "edgeR.GLM.createRmd",
           output.directory = tmpdir, norm.method = "TMM",
           disp.type = "tagwise", disp.method = "CoxReid",
           trended = TRUE)
}
\references{
Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{compData-class}
\alias{compData-class}
\title{Class compData}
\description{
The \code{compData} class is used to store information about the experiment, such as the count matrix, sample and variable annotations, information regarding the generation of the data and results from applying a differential expression analysis to the data.
}
\section{Slots}{

\describe{
\item{\code{count.matrix}:}{The read count matrix, with genes as rows and samples as columns.  Class \code{matrix}}
\item{\code{sample.annotations}:}{A data frame containing sample annotation information for all samples in the data set. Must contain at least a column named \code{condition}, encoding the division of the samples into two classes. The row names should be the same as the column names of \code{count.matrix}. Class \code{data.frame}}
\item{\code{info.parameters}:}{A list of parameters detailing the simulation process used to generate the data. Must contain at least two entries, named \code{dataset} (an informative name for the data set/simulation setting) and \code{uID} (a unique ID for the specific data set instance). Class \code{list}}
\item{\code{filtering}:}{A character string detailing the filtering process that has been applied to the data. Class \code{character}}
\item{\code{variable.annotations}:}{Contains information regarding the variables, such as the differential expression status, the true mean, dispersion and effect sizes. If present, the row names should be the same as those of \code{count.matrix}. Class \code{data.frame}}
\item{\code{analysis.date}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). Gives the date when the differential expression analysis was performed. Class \code{character}}
\item{\code{package.version}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). Gives the version numbers of the package(s) used for the differential expression analysis. Class \code{character}}
\item{\code{method.names}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). A list, containing the name of the method used for the differential expression analysis. The list should have two entries: \code{full.name} and \code{short.name}, where the \code{full.name} is the full (potentially long) name identifying the method, and \code{short.name} may be an abbreviation. Class \code{list}}
\item{\code{code}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). A character string containing the code that was used to run the differential expression analysis. The code should be in R markdown format. Class \code{character}}
\item{\code{result.table}:}{(If a differential expression analysis has been performed and the results are included in the \code{compData} object). Contains the results of the differential expression analysis, in the form of a data frame with one row per gene. Must contain at least one column named \code{score}, where a higher value corresponds to 'more strongly differentially expressed genes'. Class \code{data.frame}}
}
}

\section{Methods}{

\describe{
\item{count.matrix}{\code{signature(x="compData")}}
\item{count.matrix<-}{\code{signature(x="compData",value="matrix")}:
Get or set the count matrix in a \code{compData} object. \code{value} should be a numeric matrix.}
\item{sample.annotations}{\code{signature(x="compData")}}
\item{sample.annotations<-}{\code{signature(x="compData",value="data.frame")}:
Get or set the sample annotations data frame in a \code{compData} object. \code{value} should be a data frame with at least a column named 'condition'.}
\item{info.parameters}{\code{signature(x="compData")}}
\item{info.parameters<-}{\code{signature(x="compData",value="list")}:
Get or set the list with info parameters in a \code{compData} object. \code{value} should be a list with at least elements named 'dataset' and 'uID'.}
\item{filtering}{\code{signature(x="compData")}}
\item{filtering<-}{\code{signature(x="compData",value="character")}:
Get or set the information about the filtering in a \code{compData} object. \code{value} should be a character string describing the filtering that has been performed.}
\item{variable.annotations}{\code{signature(x="compData")}}
\item{variable.annotations<-}{\code{signature(x="compData",value="data.frame")}:
Get or set the variable annotations data frame in a \code{compData} object. \code{value} should be a data frame.}
\item{analysis.date}{\code{signature(x="compData")}}
\item{analysis.date<-}{\code{signature(x="compData",value="character")}:
Get or set the analysis date in a \code{compData} object. \code{value} should be a character string describing when the differential expression analysis of the data was performed.}
\item{package.version}{\code{signature(x="compData")}}
\item{package.version<-}{\code{signature(x="compData",value="character")}:
Get or set the information about the package version in a \code{compData} object. \code{value} should be a character string detailing which packages and versions were used to perform the differential expression analysis of the data.}
\item{method.names}{\code{signature(x="compData")}}
\item{method.names<-}{\code{signature(x="compData",value="list")}:
Get or set the method names in a \code{compData} object. \code{value} should be a list with slots \code{full.name} and \code{short.name}, giving the full name and an abbreviation for the method that was used to perform the analysis of the data.}
\item{code}{\code{signature(x="compData")}}
\item{code<-}{\code{signature(x="compData",value="character")}:
Get or set the code slot in a \code{compData} object. \code{value} should be a character string in R markdown format, giving the code that was run to obtain the results from the differential expression analysis.}
\item{result.table}{\code{signature(x="compData")}}
\item{result.table<-}{\code{signature(x="compData",value="data.frame")}:
Get or set the result table in a \code{compData} object. \code{value} should be a data frame with one row per gene, and at least a column named 'score'.}
}
}

\section{Construction}{

An object of the class \code{compData} can be constructed using the \code{\link{compData}} function.
}

\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExp.R
\name{TCC.createRmd}
\alias{TCC.createRmd}
\title{Generate a \code{.Rmd} file containing code to perform differential expression analysis with TCC}
\usage{
TCC.createRmd(
  data.path,
  result.path,
  codefile,
  norm.method,
  test.method,
  iteration = 3,
  normFDR = 0.1,
  floorPDEG = 0.05
)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{norm.method}{The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"tmm"}, and \code{"deseq"}.}

\item{test.method}{The method used in TCC to find differentially expressed genes. Possible values are \code{"edger"}, \code{"deseq"} and \code{"bayseq"}.}

\item{iteration}{The number of iterations used to find the normalization factors. Default value is 3.}

\item{normFDR}{The FDR cutoff for calling differentially expressed genes in the computation of the normalization factors. Default value is 0.1.}

\item{floorPDEG}{The minimum value to be eliminated as potential differentially expressed genes before performing step 3 in the TCC algorithm. Default value is 0.05.}
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the TCC package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the interpretation of the parameters, see the \code{TCC} package and the corresponding publications.
}
\examples{
try(
if (require(TCC)) {
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "TCC",
           Rmdfunction = "TCC.createRmd",
           output.directory = tmpdir, norm.method = "tmm",
           test.method = "edger")
})
}
\references{
Kadota K, Nishiyama T, and Shimizu K. A normalization strategy for comparing tag count data. Algorithms Mol Biol. 7:5, 2012.

Sun J, Nishiyama T, Shimizu K, and Kadota K. TCC: an R package for comparing tag count data with robust normalization strategies. BMC Bioinformatics 14:219, 2013.
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phylolmMethods.R
\name{writeNormalization}
\alias{writeNormalization}
\title{Generate a \code{.Rmd} file containing code to normalize data.}
\usage{
writeNormalization(
  norm.method,
  length.normalization,
  data.transformation,
  codefile
)
}
\arguments{
\item{norm.method}{The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} of the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}}

\item{length.normalization}{one of "none" (no correction), "TPM", "RPKM" (default). See details.}

\item{data.transformation}{one of "log2", "asin(sqrt)" or "sqrt." Data transformation to apply to the normalized data.}

\item{codefile}{}
}
\description{
Generate a \code{.Rmd} file containing code to normalize data.
}
\details{
The \code{length.matrix} field of the \code{phyloCompData}
object is used to normalize the counts. 
\describe{
\item{\code{none}:}{No length normalization.}
\item{\code{TPM}:}{The raw counts are divided by the length of their associated genes before normalization by \code{voom}.}
\item{\code{RPKM}:}{The log2 length is substracted to the log2 CPM computed by \code{voom} for each gene and sample.}
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{nEffRatio}
\alias{nEffRatio}
\title{Effective Sample Size Ratio}
\usage{
nEffRatio(tree, id.condition, model, selection.strength)
}
\arguments{
\item{tree}{A phylogenetic tree. If \code{NULL}, samples are assumed to be iid.}

\item{id.condition}{A named vector giving the state of each tip (sample).}

\item{model}{The trait evolution model. One of "BM" or "OU".}

\item{selection.strength}{If \code{model="OU"}, the selection strength parameter.}
}
\value{
The ratio of sample sizes.
}
\description{
Ratio between the tree sample size and the sample size of the equivalent problem
with independent measures. A result larger than one indicates a problem that is
made "easier" by the tree structure. Note that it strongly depends on the 
tip conditions (see examples).
}
\examples{
set.seed(1289)
## Ballanced tree
ntips <- 2^5
tree <- ape::compute.brlen(ape::stree(ntips, "balanced"))
## Alt cond : nEff greater than 1
id_cond <- rep(rep(0:1, each = 2), ntips / 4)
names(id_cond) <- tree$tip.label
plot(tree); ape::tiplabels(pch = 21, col = id_cond, bg = id_cond)
compcodeR:::nEffRatio(tree, id_cond, "BM", 0)
## Bloc cond : nEff smaller than 1
id_cond <- rep(0:1, each = ntips / 2)
names(id_cond) <- tree$tip.label
plot(tree); ape::tiplabels(pch = 21, col = id_cond, bg = id_cond)
compcodeR:::nEffRatio(tree, id_cond, "BM", 0)

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExpPhylo.R
\name{lengthNorm.sva.limma.createRmd}
\alias{lengthNorm.sva.limma.createRmd}
\title{Generate a \code{.Rmd} file containing code to perform differential expression analysis with length normalized counts + SVA + limma}
\usage{
lengthNorm.sva.limma.createRmd(
  data.path,
  result.path,
  codefile,
  norm.method,
  extra.design.covariates = NULL,
  length.normalization = "RPKM",
  data.transformation = "log2",
  trend = FALSE,
  n.sv = "auto"
)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{phyloCompData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{norm.method}{The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} of the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}}

\item{extra.design.covariates}{A vector containing the names of extra control variables to be passed to the design matrix of \code{limma}. All the covariates need to be a column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object, with a matching column name. The covariates can be a numeric vector, or a factor. Note that "condition" factor column is always included, and should not be added here. See Details.}

\item{length.normalization}{one of "none" (no length correction), "TPM", or "RPKM" (default). See details.}

\item{data.transformation}{one of "log2", "asin(sqrt)" or "sqrt". Data transformation to apply to the normalized data.}

\item{trend}{should an intensity-trend be allowed for the prior variance? Default to \code{FALSE}.}

\item{n.sv}{The number of surrogate variables to estimate (see \code{\link[sva]{sva}}). Default to \code{"auto"}: will be estimated with \code{\link[sva]{num.sv}}.}
}
\value{
The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) by applying a length normalizing transformation, followed by a surrogate variable analysis (SVA), and then a differential expression analysis with limma. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the interpretation of the parameters, see the \code{sva} and \code{limma} packages and the corresponding publications.

See the \code{details} section of \code{\link{lengthNorm.limma.createRmd}} for details
on the normalization and the extra design covariates.
}
\examples{
try(
if (require(limma) && require(sva)) {
tmpdir <- normalizePath(tempdir(), winslash = "/")
## Simulate data
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
                                    samples.per.cond = 5, n.diffexp = 100, 
                                    id.species = factor(1:10),
                                    lengths.relmeans = rpois(1000, 1000),
                                    lengths.dispersions = rgamma(1000, 1, 1),
                                    output.file = file.path(tmpdir, "mydata.rds"))
## Add covariates
## Model fitted is count.matrix ~ condition + test_factor + test_reg
sample.annotations(mydata.obj)$test_factor <- factor(rep(1:2, each = 5))
sample.annotations(mydata.obj)$test_reg <- rnorm(10, 0, 1)
saveRDS(mydata.obj, file.path(tmpdir, "mydata.rds"))
## Diff Exp
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "lengthNorm.sva.limma", 
           Rmdfunction = "lengthNorm.sva.limma.createRmd", 
           output.directory = tmpdir, norm.method = "TMM",
           extra.design.covariates = c("test_factor", "test_reg"))
})

}
\references{
Smyth GK (2005): Limma: linear models for microarray data. In: 'Bioinformatics and Computational Biology Solutions using R and Bioconductor'. R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W. Huber (eds), Springer, New York, pages 397-420

Smyth, G. K., Michaud, J., and Scott, H. (2005). The use of within-array replicate spots for assessing differential expression in microarray experiments. Bioinformatics 21(9), 2067-2075.

Law, C.W., Chen, Y., Shi, W. et al. (2014) voom: precision weights unlock linear model analysis tools for RNA-seq read counts. Genome Biol 15, R29.

Musser, JM, Wagner, GP. (2015): Character trees from transcriptome data: Origin and individuation of morphological characters and the so‐called “species signal”. J. Exp. Zool. (Mol. Dev. Evol.) 324B: 588– 604.

Leek JT, Johnson WE, Parker HS, Jaffe AE, and Storey JD. (2012) The sva package for removing batch effects and other unwanted variation in high-throughput experiments. Bioinformatics DOI:10.1093/bioinformatics/bts034
}
\author{
Charlotte Soneson, Paul Bastide, Mélina Gallopin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phylolmMethods.R
\name{getTree}
\alias{getTree}
\title{Get the tree from a phyloCompData object}
\usage{
getTree(cdata)
}
\arguments{
\item{cdata}{a phyloCompData object.}
}
\value{
A tree of class \code{phylo}
}
\description{
Return the tree of a \code{phyloCompData} object.
If no tree, return a star tree with unit height, and throw a warning.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phylolmMethods.R
\name{extract_results_phylolm}
\alias{extract_results_phylolm}
\title{Extract phylolm results}
\usage{
extract_results_phylolm(phylo_lm_obj)
}
\arguments{
\item{phylo_lm_obj}{a phylolm object.}
}
\value{
A list, with:
\describe{
\item{pvalue}{the p value of the differential expression.}
\item{logFC}{the log fold change of the differential expression.}
\item{score}{1 - pvalue.}
}
}
\description{
Extract results from a phylolm object.
The coefficient of interest must be named "condition".
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{checkParamMatrix}
\alias{checkParamMatrix}
\title{Check Matrix Parameter}
\usage{
checkParamMatrix(x, name, tree)
}
\arguments{
\item{x}{matrix of parameters being tested.}

\item{name}{name of the parameter.}

\item{tree}{A phylogenetic tree with n tips.}
}
\description{
Check that the parameters are compatible with the tree. Throws an error if not.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateCodeHTMLs.R
\name{generateCodeHTMLs}
\alias{generateCodeHTMLs}
\title{Generate HTML file(s) containing code used to run differential expression analysis.}
\usage{
generateCodeHTMLs(input.files, output.directory)
}
\arguments{
\item{input.files}{A vector with paths to one or several \code{.rds} files containing \code{compData} objects with the results from differential expression analysis. One code HTML file is generated for each file in the vector.}

\item{output.directory}{The path to the directory where the code HTML files will be saved.}
}
\description{
A function to extract the code used to generate differential expression results from saved \code{compData} result objects (typically obtained by \code{\link{runDiffExp}}), and to write the code to HTML files. This requires that the code was saved as a character string in R markdown format in the \code{code} slot of the result object, which is done automatically by \code{\link{runDiffExp}}. If the differential expression analysis was performed with functions outside \code{compcodeR}, the code has to be added manually to the result object.
}
\examples{
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.limma",
           Rmdfunction = "voom.limma.createRmd", output.directory = tmpdir,
           norm.method = "TMM")
generateCodeHTMLs(file.path(tmpdir, "mydata_voom.limma.rds"), tmpdir)
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{scale_variance_process}
\alias{scale_variance_process}
\title{Scale the variances}
\usage{
scale_variance_process(
  log_variance_phylo,
  tree,
  model.process,
  selection.strength
)
}
\arguments{
\item{tree}{a dated phylogenetic tree of class \code{\link[ape]{phylo}} with `samples.per.cond * 2` species.}

\item{model.process}{the process to be used for phylogenetic simulations. One of "BM" or "OU", default to "BM".}

\item{selection.strength}{if the process is "OU", the selection strength parameter.}
}
\value{
A matrix N * P of factors to multiply the simulated phylogenetic residuals.
}
\description{
Scale the variances of the process simulation so that they are equal to log_variance_phylo.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExp.R
\name{NBPSeq.createRmd}
\alias{NBPSeq.createRmd}
\title{Generate a \code{.Rmd} file containing code to perform differential expression analysis with NBPSeq}
\usage{
NBPSeq.createRmd(data.path, result.path, codefile, norm.method, disp.method)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{norm.method}{The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} function from the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}.}

\item{disp.method}{The method to use to estimate the dispersion values. Possible values are \code{"NBP"} and \code{"NB2"}.}
}
\value{
The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using \code{NBPSeq}. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the interpretation of the parameters, see the \code{NBPSeq} and \code{edgeR} packages and the corresponding publications.
}
\examples{
try(
if (require(NBPSeq)) {
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "NBPSeq",
           Rmdfunction = "NBPSeq.createRmd",
           output.directory = tmpdir, norm.method = "TMM", disp.method = "NBP")
})
}
\references{
Robinson MD, McCarthy DJ and Smyth GK (2010): edgeR: a Bioconductor package for differential expression analysis of digital gene expression data. Bioinformatics 26, 139-140

Robinson MD and Oshlack A (2010): A scaling normalization method for differential expression analysis of RNA-seq data. Genome Biology 11:R25

Di Y, Schafer DW, Cumbie JS, and Chang JH (2011): The NBP Negative Binomial Model for Assessing Differential Gene Expression from RNA-Seq. Statistical Applications in Genetics and Molecular Biology 10(1), 1-28
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phylolmMethods.R
\name{phylolm.createRmd}
\alias{phylolm.createRmd}
\title{Generate a \code{.Rmd} file containing code to perform differential expression analysis with \code{\link[phylolm]{phylolm}}.}
\usage{
phylolm.createRmd(
  data.path,
  result.path,
  codefile,
  norm.method,
  model = "BM",
  measurement_error = TRUE,
  extra.design.covariates = NULL,
  length.normalization = "RPKM",
  data.transformation = "log2",
  ...
)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{phyloCompData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{norm.method}{The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. The normalization factors are calculated using the \code{calcNormFactors} of the \code{edgeR} package. Possible values are \code{"TMM"}, \code{"RLE"}, \code{"upperquartile"} and \code{"none"}}

\item{model}{The model for trait evolution on the tree. Default to "BM".}

\item{measurement_error}{A logical value indicating whether there is measurement error. Default to TRUE.}

\item{extra.design.covariates}{A vector containing the names of extra control variables to be passed to the design matrix of \code{phyolm}. All the covariates need to be a column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object, with a matching column name. The covariates can be a numeric vector, or a factor. Note that "condition" factor column is always included, and should not be added here. See Details.}

\item{length.normalization}{one of "none" (no correction), "TPM" or "RPKM" (default). See details.}

\item{data.transformation}{one of "log2", "asin(sqrt)" or "sqrt". Data transformation to apply to the normalized data.}

\item{...}{Further arguments to be passed to function \code{\link[phylolm]{phylolm}}.}
}
\value{
The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the phylolm package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the interpretation of the parameters, see the \code{\link[phylolm]{phylolm}} package and the corresponding publications.


The \code{length.matrix} field of the \code{phyloCompData} object 
is used to normalize the counts, using one of the following formulas:
* \code{length.normalization="none"} : \eqn{CPM_{gi} = \frac{N_{gi} + 0.5}{NF_i \times \sum_{g} N_{gi} + 1} \times 10^6}
* \code{length.normalization="TPM"} : \eqn{TPM_{gi} = \frac{(N_{gi} + 0.5) / L_{gi}}{NF_i \times \sum_{g} N_{gi}/L_{gi} + 1} \times 10^6}
* \code{length.normalization="RPKM"} : \eqn{RPKM_{gi} = \frac{(N_{gi} + 0.5) / L_{gi}}{NF_i \times \sum_{g} N_{gi} + 1} \times 10^9}

where \eqn{N_{gi}} is the count for gene g and sample i,
where \eqn{L_{gi}} is the length of gene g in sample i,
and \eqn{NF_i} is the normalization for sample i,
normalized using \code{calcNormFactors} of the \code{edgeR} package.

The function specified by the \code{data.transformation} is then applied
to the normalized count matrix.

The "\eqn{+0.5}" and "\eqn{+1}" are taken from Law et al 2014,
and dropped from the normalization 
when the transformation is something else than \code{log2}.

The "\eqn{\times 10^6}" and "\eqn{\times 10^9}" factors are omitted when
the \code{asin(sqrt)} transformation is taken, as \eqn{asin} can only
be applied to real numbers smaller than 1.

The \code{design} model used in the \code{\link[phylolm]{phylolm}}
uses the "condition" column of the \code{sample.annotations} data frame from the \code{\link{phyloCompData}} object
as well as all the covariates named in \code{extra.design.covariates}.
For example, if \code{extra.design.covariates = c("var1", "var2")}, then
\code{sample.annotations} must have two columns named "var1" and "var2", and the design formula
in the \code{\link[phylolm]{phylolm}} function will be:
\code{~ condition + var1 + var2}.
}
\examples{
try(
if (require(ape) && require(phylolm)) {
tmpdir <- normalizePath(tempdir(), winslash = "/")
set.seed(20200317)
tree <- rphylo(10, 0.1, 0)
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
                                    samples.per.cond = 5, n.diffexp = 100, 
                                    tree = tree,
                                    id.species = 1:10,
                                    lengths.relmeans = rpois(1000, 1000),
                                    lengths.dispersions = rgamma(1000, 1, 1),
                                    output.file = file.path(tmpdir, "mydata.rds"))
## Add covariates
## Model fitted is count.matrix ~ condition + test_factor + test_reg
sample.annotations(mydata.obj)$test_factor <- factor(rep(1:2, each = 5))
sample.annotations(mydata.obj)$test_reg <- rnorm(10, 0, 1)
saveRDS(mydata.obj, file.path(tmpdir, "mydata.rds"))
## Diff Exp
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "DESeq2", 
           Rmdfunction = "phylolm.createRmd", 
           output.directory = tmpdir,
           norm.method = "TMM",
           extra.design.covariates = c("test_factor", "test_reg"),
           length.normalization = "RPKM")
})
}
\references{
Ho, L. S. T. and Ane, C. 2014. "A linear-time algorithm for Gaussian and non-Gaussian trait evolution models". Systematic Biology 63(3):397-408.

Law, C.W., Chen, Y., Shi, W. et al. (2014) voom: precision weights unlock linear model analysis tools for RNA-seq read counts. Genome Biol 15, R29.

Musser, JM, Wagner, GP. (2015): Character trees from transcriptome data: Origin and individuation of morphological characters and the so‐called “species signal”. J. Exp. Zool. (Mol. Dev. Evol.) 324B: 588– 604.
}
\author{
Charlotte Soneson, Paul Bastide, Mélina Gallopin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/show-methods.R
\name{show,compData-method}
\alias{show,compData-method}
\title{Show method for \code{compData} object}
\usage{
\S4method{show}{compData}(object)
}
\arguments{
\item{object}{A \code{compData} object}
}
\description{
Show method for \code{compData} object.
}
\examples{
mydata <- generateSyntheticData(dataset = "mydata", n.vars = 12500, 
                                samples.per.cond = 5, n.diffexp = 1250)
mydata
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{phyloCompData-class}
\alias{phyloCompData-class}
\title{Class phyloCompData}
\description{
The \code{phyloCompData} class extends the \code{\linkS4class{compData}} class
with sequence length and phylogeny related information.
}
\section{Slots}{

\describe{
\item{\code{tree}:}{The phylogenetic tree describing the relationships between samples. The taxa names of the \code{tree} should be the same as the column names of the \code{count.matrix}. Class \code{phylo}.}
\item{\code{length.matrix}:}{The length matrix, with genes as rows and samples as columns. The column names of the \code{length.matrix} should be the same as the column names of the \code{count.matrix}. Class \code{matrix}.}
\item{\code{sample.annotations}:}{In addition to the columns described in the \code{\linkS4class{compData}} class, if the tree is specified, it should contain an extra column named \code{id.species} of factors giving the species for each sample. The row names should be the same as the column names of count.matrix. Class \code{data.frame}.}
}
}

\section{Methods}{

\describe{
\item{phylo.tree}{\code{signature(x="phyloCompData")}}
\item{phylo.tree<-}{\code{signature(x="phyloCompData",value="phylo")}:
Get or set the tree in a \code{phyloCompData} object. \code{value} should be a phylo object.}
\item{length.matrix}{\code{signature(x="phyloCompData")}}
\item{length.matrix<-}{\code{signature(x="phyloCompData",value="matrix")}:
Get or set the length matrix in a \code{phyloCompData} object. \code{value} should be a numeric matrix.}
}
}

\section{Construction}{

An object of the class \code{phyloCompData} can be constructed using the \code{\link{phyloCompData}} function.
}

\author{
Charlotte Soneson, Paul Bastide
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compcodeR-package.R
\docType{package}
\name{compcodeR-package}
\alias{compcodeR-package}
\alias{compcodeR}
\title{RNAseq data simulation, differential expression analysis and
performance comparison of differential expression methods}
\description{
RNAseq data simulation, differential expression analysis and
performance comparison of differential expression methods
}
\details{
This package provides extensive functionality for comparing
results obtained by different methods for differential expression analysis
of RNAseq data. It also contains functions for simulating count data and
interfaces to several packages for performing the differential expression analysis.
}
\author{
Charlotte Soneson
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{convertListTophyloCompData}
\alias{convertListTophyloCompData}
\title{Convert a list with data and results to a \code{phyloCompData} object}
\usage{
convertListTophyloCompData(inp.list)
}
\arguments{
\item{inp.list}{A list with data and results, e.g. generated by \code{compcodeR} version 0.1.0.}
}
\description{
Given a list with data and results (resulting e.g. from \code{compcodeR} version 0.1.0), convert it to a \code{phyloCompData} object.
}
\examples{
tree <- ape::read.tree(
  text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);"
  )
count.matrix <- round(matrix(1000*runif(8000), 1000))
sample.annotations <- data.frame(condition = c(1, 1, 1, 1, 2, 2, 2, 2),
                                 id.species = c("A", "A", "A", "B", "C", "C", "D", "D"))
info.parameters <- list(dataset = "mydata", uID = "123456")
length.matrix <- round(matrix(1000*runif(8000), 1000))
colnames(count.matrix) <- colnames(length.matrix) <- rownames(sample.annotations) <- tree$tip.label
convertListTophyloCompData(list(count.matrix = count.matrix,
                                sample.annotations = sample.annotations,
                                info.parameters = list(dataset = "mydata", 
                                                       uID = "123456"),
                                tree = tree,
                                length.matrix = length.matrix))
                                 
}
\author{
Charlotte Soneson, Paul Bastide
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{get_model_factor}
\alias{get_model_factor}
\title{Get the scaling factor}
\usage{
get_model_factor(model.process, selection.strength, tree)
}
\arguments{
\item{model.process}{the process to be used for phylogenetic simulations. One of "BM" or "OU", default to "BM".}

\item{selection.strength}{if the process is "OU", the selection strength parameter.}

\item{tree}{a dated phylogenetic tree of class \code{\link[ape]{phylo}} with `samples.per.cond * 2` species.}
}
\value{
A vector N of factors.
}
\description{
Get the scaling factors.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{check_compData_results}
\alias{check_compData_results}
\title{Check the validity of a \code{compData} result object}
\usage{
check_compData_results(object)
}
\arguments{
\item{object}{A \code{compData} object}
}
\description{
Check the validity of a \code{compData} object containing differential expression results. An object that passes the check can be used as the input for the method comparison functions in \code{compcodeR}.
}
\examples{
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
                                samples.per.cond = 5, n.diffexp = 100,
                                output.file = file.path(tmpdir, "mydata.rds"))
## Check an object without differential expression results
check_compData_results(mydata)

runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), 
           result.extent = "voom.limma", 
           Rmdfunction = "voom.limma.createRmd", 
           output.directory = tmpdir, norm.method = "TMM")
resdata <- readRDS(file.path(tmpdir, "mydata_voom.limma.rds"))
## Check an object containing differential expression results
check_compData_results(resdata)
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runComparisonShiny.R
\name{runComparisonShiny}
\alias{runComparisonShiny}
\title{A shiny-based GUI to the main function for running the performance
comparison between differential expression methods.}
\usage{
runComparisonShiny(
  input.directories,
  output.directory,
  recursive,
  out.width = NULL,
  upper.limits = NULL,
  lower.limits = NULL
)
}
\arguments{
\item{input.directories}{A list of directories containing the result files
(\code{*.rds}). All results in the provided directories will be available
for inclusion in the comparison, and the selection is performed through
a graphical user interface. All result objects saved in the files should
 be of the \code{compData} class, although list objects created by
 earlier versions of \code{compcodeR} are supported.}

\item{output.directory}{The directory where the results should be written.
The subdirectory structure will be created automatically. If the
directory already exists, it will be overwritten.}

\item{recursive}{A logical parameter indicating whether or not the search
should be extended recursively to subfolders of the
\code{input.directories}.}

\item{out.width}{The width of the figures in the final report. Will be
passed on to \code{knitr} when the HTML is generated. Can be for
example "800px" (see \code{knitr} documentation for more information).}

\item{upper.limits, lower.limits}{Lists that can be used to manually set
upper and lower limits for boxplots of fdr, tpr, auc, mcc, fracsign,
nbrtpfp, nbrsign and typeIerror.}
}
\value{
The function will create a comparison report, named
\strong{compcodeR_report<timestamp>.html}, in the \code{output.directory}.
It will also create subfolders named \code{compcodeR_code} and
\code{compcodeR_figure}, where the code used to perform the differential
expression analysis and the figures contained in the report, respectively,
will be saved. Note that if these directories already exist they will be
overwritten.
}
\description{
This function provides a GUI to the main function for performing comparisons
among differential expression methods and generating a report in HTML format
(\code{\link{runComparison}}). It is assumed that all differential
expression results have been generated in advance (using e.g. the function
\code{\link{runDiffExp}}) and that the result \code{compData} object for
each data set and each differential expression method is saved separately in
files with the extension \code{.rds}. The function opens a graphical user
interface where the user can set parameter values and choose the files to be
used as the basis of the comparison. It is, however, possible to circumvent
the GUI and call the comparison function \code{\link{runComparison}} directly.
}
\examples{
if (interactive()) {
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 12500,
                                    samples.per.cond = 5, n.diffexp = 1250,
                                    output.file = "mydata.rds")
runDiffExp(data.file = "mydata.rds", result.extent = "voom.limma",
           Rmdfunction = "voom.limma.createRmd", output.directory = ".",
           norm.method = "TMM")
runDiffExp(data.file = "mydata.rds", result.extent = "ttest",
           Rmdfunction = "ttest.createRmd", output.directory = ".",
           norm.method = "TMM")
runComparisonShiny(input.directories = ".", output.directory = ".", recursive = FALSE)
}

}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{phyloCompDataFromCompData}
\alias{phyloCompDataFromCompData}
\title{Create a \code{phyloCompData} object}
\usage{
phyloCompDataFromCompData(
  compDataObject,
  tree = list(),
  length.matrix = matrix(NA_integer_, 0, 0)
)
}
\arguments{
\item{compDataObject}{An object of class \code{\link{compData}}.}

\item{tree}{A phylogenetic tree describing the relationships between samples.}

\item{length.matrix}{A length matrix, with genes as rows and observations as columns.}
}
\value{
A \code{phyloCompData} object.
}
\description{
The \code{phyloCompData} class extends the \code{\link{compData}} class
with sequence length and phylogeny related information.
}
\author{
Charlotte Soneson, Paul Bastide
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExp.R
\name{DESeq2.createRmd}
\alias{DESeq2.createRmd}
\title{Generate a \code{.Rmd} file containing code to perform differential expression analysis with DESeq2}
\usage{
DESeq2.createRmd(
  data.path,
  result.path,
  codefile,
  fit.type,
  test,
  beta.prior = TRUE,
  independent.filtering = TRUE,
  cooks.cutoff = TRUE,
  impute.outliers = TRUE,
  nas.as.ones = FALSE
)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{fit.type}{The fitting method used to get the dispersion-mean relationship. Possible values are \code{"parametric"}, \code{"local"} and \code{"mean"}.}

\item{test}{The test to use. Possible values are \code{"Wald"} and \code{"LRT"}.}

\item{beta.prior}{Whether or not to put a zero-mean normal prior on the non-intercept coefficients. Default is \code{TRUE}.}

\item{independent.filtering}{Whether or not to perform independent filtering of the data. With independent filtering=TRUE, the adjusted p-values for genes not passing the filter threshold are set to NA.}

\item{cooks.cutoff}{The cutoff value for the Cook's distance to consider a value to be an outlier. Set to Inf or FALSE to disable outlier detection. For genes with detected outliers, the p-value and adjusted p-value will be set to NA.}

\item{impute.outliers}{Whether or not the outliers should be replaced by a trimmed mean and the analysis rerun.}

\item{nas.as.ones}{Whether or not adjusted p values that are returned as \code{NA} by \code{DESeq2} should be set to \code{1}. This option is useful for comparisons with other methods. For more details, see section "I want to benchmark DESeq2 comparing to other DE tools" from the \code{DESeq2} vignette (available by running \code{vignette("DESeq2", package = "DESeq2")}). Default to \code{FALSE}.}
}
\value{
The function generates a \code{.Rmd} file containing the code for performing the differential expression analysis. This file can be executed using e.g. the \code{knitr} package.
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the DESeq2 package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the interpretation of the parameters, see the \code{DESeq2} package and the corresponding publications.
}
\examples{
try(
if (require(DESeq2)) {
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "DESeq2",
           Rmdfunction = "DESeq2.createRmd",
           output.directory = tmpdir, fit.type = "parametric",
           test = "Wald")
})
}
\references{
Anders S and Huber W (2010): Differential expression analysis for sequence count data. Genome Biology 11:R106
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runComparison.R
\name{runComparison}
\alias{runComparison}
\title{Run the performance comparison between differential expression methods.}
\usage{
runComparison(
  file.table,
  parameters,
  output.directory,
  check.table = TRUE,
  out.width = NULL,
  save.result.table = FALSE,
  knit.results = TRUE
)
}
\arguments{
\item{file.table}{A data frame with at least a column \code{input.files}, potentially also columns named \code{datasets}, \code{nbr.samples}, \code{repl} and \code{de.methods}.}

\item{parameters}{A list containing parameters for the comparison study. The following entries are supported, and used by different comparison methods:
\itemize{
\item \code{incl.nbr.samples} An array with sample sizes (number of samples per condition) to consider in the comparison. If set to \code{NULL}, all sample sizes will be included.
\item \code{incl.dataset} A dataset name (corresponding to the \code{dataset} slot of the results or data objects), indicating the dataset that will be used for the comparison. Only one dataset can be chosen.
\item \code{incl.replicates} An array with replicate numbers to consider in the comparison. If set to \code{NULL}, all replicates will be included.
\item \code{incl.de.methods} An array with differential expression methods to be compared. If set to \code{NULL}, all differential expression methods will be included.
\item \code{fdr.threshold} The adjusted p-value threshold for FDR calculations. Default 0.05.
\item \code{tpr.threshold} The adjusted p-value threshold for TPR calculations. Default 0.05.
\item \code{mcc.threshold} The adjusted p-value threshold for MCC calculations. Default 0.05.
\item \code{typeI.threshold} The nominal p-value threshold for type I error calculations. Default 0.05.
\item \code{fdc.maxvar} The maximal number of variables to include in false discovery curve plots. Default 1500.
\item \code{overlap.threshold} The adjusted p-value for overlap analysis. Default 0.05.
\item \code{fracsign.threshold} The adjusted p-value for calculation of the fraction/number of genes called significant. Default 0.05.
\item \code{nbrtpfp.threshold} The adjusted p-value for calculation of the number of TP, FP, TN, FN genes. Default 0.05.
\item \code{ma.threshold} The adjusted p-value threshold for coloring genes in MA plots. Default 0.05.
\item \code{signal.measure} Either \code{'mean'} or \code{'snr'}, determining how to define the signal strength for a gene which is expressed in only one condition.
\item \code{upper.limits,lower.limits} Lists that can be used to manually set the upper and lower plot limits for boxplots of fdr, tpr, auc, mcc, fracsign, nbrtpfp and typeIerror.
\item \code{comparisons} Array containing the comparison methods to be applied. The entries must be chosen among the following abbreviations:
\itemize{
\item \code{"auc"} - Compute the area under the ROC curve
\item \code{"mcc"} - Compute Matthew's correlation coefficient
\item \code{"tpr"} - Compute the true positive rate at a given adjusted p-value threshold (\code{tpr.threshold})
\item \code{"fdr"} - Compute the false discovery rate at a given adjusted p-value threshold (\code{fdr.threshold})
\item \code{"fdrvsexpr"} - Compute the false discovery rate as a function of the expression level.
\item \code{"typeIerror"} - Compute the type I error rate at a given nominal p-value threshold (\code{typeI.threshold})
\item \code{"fracsign"} - Compute the fraction of genes called significant at a given adjusted p-value threshold (\code{fracsign.threshold}).
\item \code{"nbrsign"} - Compute the number of genes called significant at a given adjusted p-value threshold (\code{fracsign.threshold}).
\item \code{"nbrtpfp"} - Compute the number of true positives, false positives, true negatives and false negatives at a given adjusted p-value threshold (\code{nbrtpfp.threshold}).
\item \code{"maplot"} - Construct MA plots, depicting the average expression level and the log fold change for the genes and indicating the genes called differential expressed at a given adjusted p-value threshold (\code{ma.threshold}).
\item \code{"fdcurvesall"} - Construct false discovery curves for each of the included replicates.
\item \code{"fdcurvesone"} - Construct false discovery curves for a single replicate only
\item \code{"rocall"} - Construct ROC curves for each of the included replicates
\item \code{"rocone"} - Construct ROC curves for a single replicate only
\item \code{"overlap"} - Compute the overlap between collections of genes called differentially expressed by the different methods at a given adjusted p-value threshold (\code{overlap.threshold})
\item \code{"sorensen"} - Compute the Sorensen index, quantifying the overlap between collections of genes called differentially expressed by the different methods, at a given adjusted p-value threshold (\code{overlap.threshold})
\item \code{"correlation"} - Compute the Spearman correlation between gene scores assigned by different methods
\item \code{"scorevsoutlier"} - Visualize the distribution of the gene scores as a function of the number of outlier counts introduced for the genes
\item \code{"scorevsexpr"} - Visualize the gene scores as a function of the average expression level of the genes
\item \code{"scorevssignal"} - Visualize the gene score as a function of the 'signal strength' (see the \code{signal.measure} parameter above) for genes that are expressed in only one condition
}
}}

\item{output.directory}{The directory where the results should be written. The subdirectory structure will be created automatically. If the directory already exists, it will be overwritten.}

\item{check.table}{Logical, should the input table be checked for consistency. Default \code{TRUE}.}

\item{out.width}{The width of the figures in the final report. Will be passed on to \code{knitr} when the HTML is generated.}

\item{save.result.table}{Logical, should the intermediate result table be saved for future use ? Default to \code{FALSE}.}

\item{knit.results}{Logical, should the Rmd be generated and knitted ? Default to \code{TRUE}. If \code{FALSE}, no comparison report is generated, and only the intermediate result table is saved (if \code{save.result.table=TRUE}).}
}
\value{
If \code{knit.results=TRUE}, the function will create a comparison report, named \strong{compcodeR_report<timestamp>.html}, in the \code{output.directory}. It will also create subfolders named \code{compcodeR_code} and \code{compcodeR_figure}, where the code used to perform the differential expression analysis and the figures contained in the report, respectively, will be stored. Note that if these directories already exists, they will be overwritten.
If \code{save.result.table=TRUE}, the function will also create a comparison report, named \strong{compcodeR_result_table_<timestamp>.rds} in the \code{output.directory}, containing the result table.
}
\description{
The main function for performing comparisons among differential expression methods and generating a report in HTML format. It is assumed that all differential expression results have been generated in advance (using e.g. the function \code{\link{runDiffExp}}) and that the result \code{compData} object for each data set and each differential expression method is saved separately in files with the extension \code{.rds}. Note that the function can also be called via the \code{\link{runComparisonGUI}} function, which lets the user set parameters and select input files using a graphical user interface.
}
\details{
The input to \code{\link{runComparison}} is a data frame with at least a column named \code{input.files}, containing paths to \code{.rds} files containing result objects (of the class \code{compData}), such as those generated by \code{\link{runDiffExp}}. Other columns that can be included in the data frame are \code{datasets}, \code{nbr.samples}, \code{repl} and \code{de.methods}. They have to match the information contained in the corresponding result objects. If these columns are not present, they will be added to the data frame automatically.
}
\examples{
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "voom.limma",
           Rmdfunction = "voom.limma.createRmd", output.directory = tmpdir,
           norm.method = "TMM")
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "edgeR.exact",
           Rmdfunction = "edgeR.exact.createRmd", output.directory = tmpdir,
           norm.method = "TMM",
           trend.method = "movingave", disp.type = "tagwise")
file.table <- data.frame(input.files = file.path(tmpdir,
                         c("mydata_voom.limma.rds", "mydata_edgeR.exact.rds")),
                         stringsAsFactors = FALSE)
parameters <- list(incl.nbr.samples = 5, incl.replicates = 1, incl.dataset = "mydata",
                   incl.de.methods = NULL,
                   fdr.threshold = 0.05, tpr.threshold = 0.05, typeI.threshold = 0.05,
                   ma.threshold = 0.05, fdc.maxvar = 1500, overlap.threshold = 0.05,
                   fracsign.threshold = 0.05, mcc.threshold = 0.05,
                   nbrtpfp.threshold = 0.05,
                   comparisons = c("auc", "fdr", "tpr", "ma", "correlation"))
if (interactive()) {
  runComparison(file.table = file.table, parameters = parameters, output.directory = tmpdir)
}
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExp.R
\name{DSS.createRmd}
\alias{DSS.createRmd}
\title{Generate a \code{.Rmd} file containing code to perform differential expression analysis with DSS}
\usage{
DSS.createRmd(data.path, result.path, codefile, norm.method, disp.trend)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{norm.method}{The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"quantile"}, \code{"total"} and \code{"median"}.}

\item{disp.trend}{A logical parameter indicating whether or not to include a trend in the dispersion estimation.}
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the DSS package. The code is written to a \code{.Rmd} file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the interpretation of the parameters, see the \code{DSS} package and the corresponding publications.
}
\examples{
try(
if (require(DSS)) {
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "DSS",
           Rmdfunction = "DSS.createRmd",
           output.directory = tmpdir, norm.method = "quantile",
           disp.trend = TRUE)
})
}
\references{
Wu H, Wang C and Wu Z (2013): A new shrinkage estimator for dispersion improves differential expression detection in RNA-seq data. Biostatistics 14(2), 232-243
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/checkObjects.R
\name{checkDataObject}
\alias{checkDataObject}
\title{Check a list or a \code{compData} object for compatibility with the differential expression functions interfaced by \code{compcodeR}}
\usage{
checkDataObject(data.obj)
}
\arguments{
\item{data.obj}{A list containing data and condition information, or a \code{compData} object.}
}
\description{
Check if a list or a \code{compData} object contains the necessary slots for applying the differential expression functions interfaced by the \code{compcodeR} package. This function is provided for backward compatibility, see also \code{\link{check_compData}} and \code{\link{check_compData_results}}.
}
\examples{
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
                                    samples.per.cond = 5, n.diffexp = 100)
checkDataObject(mydata.obj)
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{NB_to_PLN}
\alias{NB_to_PLN}
\title{Negative Binomial to Poisson Log-Normal}
\usage{
NB_to_PLN(mean, dispersion)
}
\arguments{
\item{mean}{mean of the negative binomial.}

\item{dispersion}{dispersion of the negative binomial.}
}
\value{
A list, with:
\describe{
\item{log_means_pln}{Mean of the Poisson log normal in the log space.}
\item{log_variances_pln}{Variance of the Poisson log normal in the log space.}
}
}
\description{
From the parameters of a negative binomial (mean and dispersion),
compute the parameters of a Poisson log-normal with the
same expectation and variance.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{generateLengthsPhylo}
\alias{generateLengthsPhylo}
\title{Simulate a length matrix with a phylo model}
\usage{
generateLengthsPhylo(tree, id.species, lengths.relmeans, lengths.dispersions)
}
\arguments{
\item{tree}{The phylogeneti tree.}

\item{id.species}{An n.sample vector, indicating the species of each sample.}

\item{lengths.relmeans}{A vector of mean values to use in the simulation of
lengths from the Negative Binomial distribution.}

\item{lengths.dispersions}{A vector or matrix of dispersions to use in the
simulation of data from the Negative Binomial distribution.}

\item{lengths.lambda}{A vector of heritability parameters to use in the
simulation of data from the lambda model.}
}
\value{
A matrix of the same size as 'length_matrix', with normalization
factors to be applied for each sample and each gene.
}
\description{
Simulate a length matrix of size n.vars times n.sample, with the length of
each gene in each sample.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateSyntheticData.R
\name{generateLengths}
\alias{generateLengths}
\title{Simulate a length matrix}
\usage{
generateLengths(id.species, lengths.relmeans, lengths.dispersions)
}
\arguments{
\item{id.species}{An n.sample vector, indicating the species of each sample.}

\item{lengths.relmeans}{A vector of mean values to use in the simulation of
lengths from the Negative Binomial distribution.}

\item{lengths.dispersions}{A vector or matrix of dispersions to use in the
simulation of data from the Negative Binomial distribution.}
}
\value{
A matrix of lengths, with as many columns as the number of species (length of id.species)
and as many rows as the number of parameters in lengths.relmeans.
}
\description{
Simulate a length matrix of size n.vars times n.sample, with the length of
each gene in each sample.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{convertphyloCompDataToList}
\alias{convertphyloCompDataToList}
\title{Convert a \code{phyloCompData} object to a list}
\usage{
convertphyloCompDataToList(cpd)
}
\arguments{
\item{cpd}{A \code{phyloCompData} object}
}
\description{
Given a \code{phyloCompData} object, convert it to a list.
}
\examples{
tree <- ape::read.tree(
  text = "(((A1:0,A2:0,A3:0):1,B1:1):1,((C1:0,C2:0):1.5,(D1:0,D2:0):1.5):0.5);"
  )
id.species <- factor(c("A", "A", "A", "B", "C", "C", "D", "D"))
names(id.species) <- tree$tip.label
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
                                    samples.per.cond = 4, n.diffexp = 100,
                                    tree = tree,
                                    id.species = id.species)
mydata.list <- convertcompDataToList(mydata.obj)

}
\author{
Charlotte Soneson, Paul Bastide
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExp.R
\name{listcreateRmd}
\alias{listcreateRmd}
\title{List available *.createRmd functions}
\usage{
listcreateRmd()
}
\description{
Print a list of all \code{*.createRmd} functions that are available in the search path. These functions can be used together with the \code{\link{runDiffExp}} function to perform differential expression analysis. Consult the help pages for the respective functions for more information.
}
\examples{
listcreateRmd()

}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/show-methods.R
\name{show,phyloCompData-method}
\alias{show,phyloCompData-method}
\title{Show method for \code{phyloCompData} object}
\usage{
\S4method{show}{phyloCompData}(object)
}
\arguments{
\item{object}{A \code{phyloCompData} object}
}
\description{
Show method for \code{phyloCompData} object.
}
\examples{
mydata <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
                                samples.per.cond = 5, n.diffexp = 100,
                                id.species = factor(1:10),
                                tree = ape::rphylo(10, 1, 0),
                                lengths.relmeans = "auto", lengths.dispersions = "auto")
mydata
}
\author{
Charlotte Soneson, Paul Bastide
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateSyntheticData.R
\name{computeFactorLengths}
\alias{computeFactorLengths}
\title{Compute Length Normalization Factors}
\usage{
computeFactorLengths(length_matrix, prob.S1, sum.S1)
}
\arguments{
\item{length_matrix}{An n.vars times n.sample matrix of lengths of each gene in each sample.}

\item{prob.S1}{Vector of means for condition 1.}

\item{sum.S1}{Sum of means for condition 1.}
}
\value{
A matrix of the same size as 'length_matrix', with normalization factors
to be applied for each sample and each gene.
}
\description{
Compute the factor to be applied for length normalization.
Each column of the matrix (samples) is normalized by the weighted average of
the column, with weights corresponding to the true probabilities of each gene.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateRmdCodeDiffExp.R
\name{EBSeq.createRmd}
\alias{EBSeq.createRmd}
\title{Generate a .Rmd file containing code to perform differential expression analysis with EBSeq}
\usage{
EBSeq.createRmd(data.path, result.path, codefile, norm.method)
}
\arguments{
\item{data.path}{The path to a .rds file containing the \code{compData} object that will be used for the differential expression analysis.}

\item{result.path}{The path to the file where the result object will be saved.}

\item{codefile}{The path to the file where the code will be written.}

\item{norm.method}{The between-sample normalization method used to compensate for varying library sizes and composition in the differential expression analysis. Possible values are \code{"median"} and \code{"quantile"}.}
}
\value{
The function generates a .Rmd file containing the differential expression code. This file can be executed using e.g. the \code{knitr} package.
}
\description{
A function to generate code that can be run to perform differential expression analysis of RNAseq data (comparing two conditions) using the \code{EBSeq} package. The code is written to a .Rmd file. This function is generally not called by the user, the main interface for performing differential expression analysis is the \code{\link{runDiffExp}} function.
}
\details{
For more information about the methods and the meaning of the parameters, see the \code{EBSeq} package and the corresponding publications.
}
\examples{
try(
if (require(EBSeq)) {
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
runDiffExp(data.file = file.path(tmpdir, "mydata.rds"), result.extent = "EBSeq",
           Rmdfunction = "EBSeq.createRmd",
           output.directory = tmpdir, norm.method = "median")
}
)
}
\references{
Leng N, Dawson JA, Thomson JA, Ruotti V, Rissman AI, Smits BMG, Haag JD, Gould MN, Stewart RM and Kendziorski C (2013): EBSeq: An empirical Bayes hierarchical model for inference in RNA-seq experiments. Bioinformatics
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{get_poisson_log_normal_parameters}
\alias{get_poisson_log_normal_parameters}
\title{Compute log means and variances}
\usage{
get_poisson_log_normal_parameters(
  count_means,
  count_dispersions,
  prop.var.tree
)
}
\arguments{
\item{count_means}{a matrix with the number of genes p rows and the number of
species n columns. Column names should match the tree taxa names.}

\item{count_dispersions}{a matrix of size p x n, for each gene and species.
Column names should match the tree taxa names.}
}
\value{
A list, with:
\describe{
\item{log_means}{the p x n matrix of log-means for Poisson-lognormal simulations.}
\item{log_variance_phylo}{the p vector of phylogenetic log-variances for Poisson-lognormal simulations.}
\item{log_variance_sample}{the p x n matrix of environmental log-variances for Poisson-lognormal simulations.}
}
}
\description{
From the parameters of a negative binomial (count_means and count_dispersions),
compute the parameters of a phylogenetic Poisson log-normal with the
same expectations and variances.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{check_phyloCompData}
\alias{check_phyloCompData}
\title{Check the validity of a \code{phyloCompData} object}
\usage{
check_phyloCompData(object)
}
\arguments{
\item{object}{A \code{phyloCompData} object}
}
\description{
Check the validity of a \code{phyloCompData} object.
An object that passes the check can be used as the input for the differential expression analysis methods interfaced by \code{compcodeR}.
}
\examples{
mydata <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
                                samples.per.cond = 5, n.diffexp = 100,
                                id.species = factor(1:10),
                                tree = ape::rphylo(10, 1, 0),
                                lengths.relmeans = "auto", lengths.dispersions = "auto")
check_phyloCompData(mydata)

}
\author{
Charlotte Soneson, Paul Bastide
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateSyntheticData.R
\name{summarizeSyntheticDataSet}
\alias{summarizeSyntheticDataSet}
\title{Summarize a synthetic data set by some diagnostic plots}
\usage{
summarizeSyntheticDataSet(data.set, output.filename)
}
\arguments{
\item{data.set}{A data set, either a \code{\link{compData}} object or a path to an \code{.rds} file where such an object is stored.}

\item{output.filename}{The filename of the resulting html report (including the path).}
}
\description{
Summarize a synthetic data set (generated by \code{\link{generateSyntheticData}}) by some diagnostic plots.
}
\examples{
tmpdir <- normalizePath(tempdir(), winslash = "/")
mydata.obj <- generateSyntheticData(dataset = "mydata", n.vars = 1000,
                                    samples.per.cond = 5, n.diffexp = 100,
                                    output.file = file.path(tmpdir, "mydata.rds"))
if (interactive()) {
  summarizeSyntheticDataSet(data.set = file.path(tmpdir, "mydata.rds"),
                            output.filename = file.path(tmpdir, "mydata_check.html"))
}
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{check_compData}
\alias{check_compData}
\title{Check the validity of a \code{compData} object}
\usage{
check_compData(object)
}
\arguments{
\item{object}{A \code{compData} object}
}
\description{
Check the validity of a \code{compData} object. An object that passes the check can be used as the input for the differential expression analysis methods interfaced by \code{compcodeR}.
}
\examples{
mydata <- generateSyntheticData(dataset = "mydata", n.vars = 1000, 
                                samples.per.cond = 5, n.diffexp = 100)
check_compData(mydata)
}
\author{
Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{simulatePhyloPoissonLogNormal}
\alias{simulatePhyloPoissonLogNormal}
\title{Simulate Tree Structured Counts}
\usage{
simulatePhyloPoissonLogNormal(
  tree,
  log_means,
  log_variance_phylo,
  log_variance_sample,
  model.process = "BM",
  selection.strength = 0
)
}
\arguments{
\item{tree}{A phylogenetic tree with n tips.}

\item{log_means}{a matrix with the number of genes p rows and the number of
species n columns. Column names should match the tree taxa names.}

\item{log_variance_phylo}{a vector of length p of phylogenetic variances for 
the BM in the log space for each gene.}

\item{log_variance_sample}{a matrix of size p x n of environmental variances
for individual variations in the log space, for each gene and species.
Column names should match the tree taxa names.}
}
\value{
A list, with:
\describe{
\item{log_lambda}{the p x n matrix of log-lambda simulated by the BM on the tree.}
\item{counts}{the p x n matrix of counts with corresponding Poisson draws.}
}
}
\description{
Simulate a tree structured matrix of counts according to a Poisson-lognormal
model, with the log parameter of the poisson following a Brownian Motion (BM)
on the tree with noise.
}
\details{
For each gene, the log-lambda parameter evolves like a BM on the tree,
with an extra independent variance noise that can depend on the species.
Each gene has its own tree variance for the BM.
Each gene and each species has its own mean.
The counts for each gene and each species are then obtained as a Poisson draw
with a different lambda parameter, as generated by the BM.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulatePhyloPoissonLogNormal.R
\name{nEffNaive}
\alias{nEffNaive}
\title{Effective Sample Size}
\usage{
nEffNaive(tree, id.condition, model, selection.strength)
}
\arguments{
\item{tree}{A phylogenetic tree. If \code{NULL}, samples are assumed to be iid.}

\item{id.condition}{A named vector giving the state of each tip (sample).}

\item{model}{The trait evolution model. One of "BM" or "OU".}

\item{selection.strength}{If \code{model="OU"}, the selection strength parameter.}
}
\value{
The effective sample size.
}
\description{
Sample size so that the variance of the estimator is sigma^2 / nEff.
}
\keyword{internal}
